
//
// @(#)btyaccpar, based on byacc 1.8 (Berkeley)
// Parser skeleton modified for use in the Firebird project by Nickolay Samofatov
//
#define YYBTYACC 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dsql.tab.h"

#define YYERROR_DETAILED

typedef int Yshort;

/* 
*	PROGRAM:	Dynamic SQL runtime support
*	MODULE:		parse.y
*	DESCRIPTION:	Dynamic SQL parser
*
* The contents of this file are subject to the Interbase Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy
* of the License at http://www.Inprise.com/IPL.html
*
* Software distributed under the License is distributed on an
* "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
* or implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The Original Code was created by Inprise Corporation
* and its predecessors. Portions created by Inprise Corporation are
* Copyright (C) Inprise Corporation.
*
* All Rights Reserved.
* Contributor(s): ______________________________________.
*
* 2002-02-24 Sean Leyne - Code Cleanup of old Win 3.1 port (WINDOWS_ONLY)
* 2001.05.20 Neil McCalden: Allow a udf to be used in a 'group by' clause.
* 2001.05.30 Claudio Valderrama: DROP TABLE and DROP VIEW lead now to two
*   different node types so DDL can tell which is which.
* 2001.06.13 Claudio Valderrama: SUBSTRING is being surfaced.
* 2001.06.30 Claudio valderrama: Feed (line,column) for each node. See node.h.
* 2001.07.10 Claudio Valderrama: Better (line,column) report and "--" for comments.
* 2001.07.28 John Bellardo: Changes to support parsing LIMIT and FIRST
* 2001.08.03 John Bellardo: Finalized syntax for LIMIT, change LIMIT to SKIP
* 2001.08.05 Claudio Valderrama: closed Bug #448062 and other spaces that appear
*   in rdb$*_source fields when altering domains plus one unexpected null pointer.
* 2001.08.12 Claudio Valderrama: adjust SUBSTRING's starting pos argument here
*   and not in gen.c; this closes Bug #450301.
* 2001.10.01 Claudio Valderrama: enable explicit GRANT...to ROLE role_name.
* 2001.10.06 Claudio Valderrama: Honor explicit USER keyword in GRANTs and REVOKEs.
* 2002.07.05 Mark O'Donohue: change keyword DEBUG to KW_DEBUG to avoid
*			clashes with normal DEBUG macro.
* 2002.07.30 Arno Brinkman:  
* 2002.07.30 	Let IN predicate handle value_expressions
* 2002.07.30 	tokens CASE, NULLIF, COALESCE added
* 2002.07.30 	See block < CASE expression > what is added to value as case_expression
* 2002.07.30 	function is split up into aggregate_function, numeric_value_function, string_value_function, generate_value_function
* 2002.07.30 	new group_by_function and added to grp_column_elem
* 2002.07.30 	cast removed from function and added as cast_specification to value
* 2002.08.04 Claudio Valderrama: allow declaring and defining variables at the same time
* 2002.08.04 Dmitry Yemanov: ALTER VIEW
* 2002.08.06 Arno Brinkman: ordinal added to grp_column_elem for using positions in group by
* 2002.08.07 Dmitry Yemanov: INT64/LARGEINT are replaced with BIGINT and available in dialect 3 only
* 2002.08.31 Dmitry Yemanov: allowed user-defined index names for PK/FK/UK constraints
* 2002.09.01 Dmitry Yemanov: RECREATE VIEW
* 2002.09.28 Dmitry Yemanov: Reworked internal_info stuff, enhanced
*							exception handling in SPs/triggers,
*							implemented ROWS_AFFECTED system variable
* 2002.10.21 Nickolay Samofatov: Added support for explicit pessimistic locks
* 2002.10.29 Nickolay Samofatov: Added support for savepoints
* 2002.12.03 Dmitry Yemanov: Implemented ORDER BY clause in subqueries.
* 2002.12.18 Dmitry Yemanov: Added support for SQL-compliant labels and LEAVE statement
* 2002.12.28 Dmitry Yemanov: Added support for parametrized events.
* 2003.01.14 Dmitry Yemanov: Fixed bug with cursors in triggers.
* 2003.01.15 Dmitry Yemanov: Added support for runtime trigger action checks.
* 2003.02.10 Mike Nordell  : Undefined Microsoft introduced macros to get a clean compile.
* 2003.05.24 Nickolay Samofatov: Make SKIP and FIRST non-reserved keywords
* 2003.06.13 Nickolay Samofatov: Make INSERTING/UPDATING/DELETING non-reserved keywords
* 2003.07.01 Blas Rodriguez Somoza: Change DEBUG and IN to avoid conflicts in win32 build/bison
* 2003.08.11 Arno Brinkman: Changed GROUP BY to support all expressions and added "AS" support
*						   with table alias. Also removed group_by_function and ordinal.
* 2003.08.14 Arno Brinkman: Added support for derived tables.
* 2003.10.05 Dmitry Yemanov: Added support for explicit cursors in PSQL.
* 2004.01.16 Vlad Horsun: added support for default parameters and 
*   EXECUTE BLOCK statement
* Adriano dos Santos Fernandes
*/

#include "firebird.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include <stdarg.h>

#include "gen/iberror.h"
#include "../dsql/dsql.h"
#include "../jrd/ibase.h"
#include "../jrd/flags.h"
#include "../dsql/errd_proto.h"
#include "../dsql/hsh_proto.h"
#include "../dsql/make_proto.h"
#include "../dsql/keywords.h"
#include "../dsql/misc_func.h"
#include "../jrd/gds_proto.h"
#include "../jrd/thd.h"
#include "../jrd/err_proto.h"
#include "../jrd/intlobj_new.h"

/* since UNIX isn't standard, we have to define
  stuff which is in <limits.h> (which isn't available
  on all UNIXes... */

const long SHRT_POS_MAX			= 32767;
const long SHRT_UNSIGNED_MAX	= 65535;
const long SHRT_NEG_MAX			= 32768;
const long LONG_POS_MAX			= 2147483647;
const int POSITIVE	= 0;
const int NEGATIVE	= 1;
const int UNSIGNED	= 2;

/*const int MIN_CACHE_BUFFERS	= 250;*/
/*const int DEF_CACHE_BUFFERS	= 1000;*/

/* Fix 69th procedure problem - solution from Oleg Loa */
#define YYSTACKSIZE	2048
#define YYMAXDEPTH	2048

/* Make bison allocate static stack */
#define YYINITDEPTH 2048

/* Using this option causes build problems on Win32 with bison 1.28*/
/*#define YYSTACK_USE_ALLOCA 1*/

typedef dsql_nod* YYSTYPE;
#define YYSTYPE YYSTYPE
#if defined(DEBUG) || defined(DEV_BUILD)
#define YYDEBUG		1
#endif

#define YYMALLOC gds__alloc
#define YYFREE gds__free

static const char INTERNAL_FIELD_NAME[] = "DSQL internal"; /* NTX: placeholder */

inline SLONG trigger_type_suffix(const int slot1, const int slot2, const int slot3)
{
	return ((slot1 << 1) | (slot2 << 3) | (slot3 << 5));
}


dsql_nod* DSQL_parse;


#define YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous

#include "../dsql/chars.h"

const int MAX_TOKEN_LEN = 256;

static const TEXT* lex_position();
#ifdef NOT_USED_OR_REPLACED
static bool		long_int(dsql_nod*, SLONG*);
#endif
static dsql_fld*	make_field (dsql_nod*);
static dsql_fil*	make_file();
static dsql_nod*	make_list (dsql_nod*);
static dsql_nod*	make_node (NOD_TYPE, int, ...);
static dsql_nod*	make_parameter (void);
static dsql_nod*	make_flag_node (NOD_TYPE, SSHORT, int, ...);
static void	prepare_console_debug (int, int  *);
#ifdef NOT_USED_OR_REPLACED
static bool	short_int(dsql_nod*, SLONG*, SSHORT);
#endif
static void	stack_nodes (dsql_nod*, DsqlNodStack&);
inline static int	yylex (USHORT, USHORT, USHORT, bool*);

static void	yyerror(const TEXT*);
static void	yyabandon (SLONG, ISC_STATUS);

inline void check_bound(const char* const to, const char* const string)
{
	if ((to - string) >= MAX_TOKEN_LEN)
		yyabandon (-104, isc_token_too_long);
}

inline void check_copy_incr(char*& to, const char ch, const char* const string)
{
	check_bound(to, string); 
	*to++ = ch;
}

struct LexerState {
	/* This is, in fact, parser state. Not used in lexer itself */
	dsql_fld* g_field;
	dsql_fil* g_file;
	dsql_nod* g_field_name;
	int dsql_debug;
	
	/* Actual lexer state begins from here */
	const TEXT* beginning;
	const TEXT* ptr;
	const TEXT* end;
	const TEXT* last_token;
	const TEXT* line_start;
	const TEXT* last_token_bk;
	const TEXT* line_start_bk;
	SSHORT	lines, att_charset;
	SSHORT	lines_bk;
	int  prev_keyword;
	USHORT	param_number;
	
	int yylex (
		USHORT	client_dialect,
		USHORT	db_dialect,
		USHORT	parser_version,
		bool* stmt_ambiguous);
};

/* Get ready for thread-safety. Move this to BISON object pointer when we 
  switch to generating "pure" reenterant parser. */
static LexerState lex;

static int yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,   11,   11,   11,   26,   26,
   25,   25,   25,   35,   35,   30,   36,   36,   36,   36,
   36,   29,   29,   34,   34,   31,   17,   17,   17,   39,
   39,   40,   40,   28,   28,   41,   41,   41,   41,   43,
   43,   43,   43,   42,   42,   44,   44,   44,   32,   32,
   49,   33,   33,   50,   50,    8,   51,   51,   53,   58,
   58,   58,   55,   55,   55,   62,   62,   63,   65,   65,
   65,   65,   56,   56,   66,   66,   67,   67,   67,   67,
   67,   52,   69,   69,    6,   71,   71,   71,   71,   71,
   71,   71,   71,   71,   71,   71,   71,   71,   71,   16,
   88,   88,   88,   88,   88,   88,    7,   95,   95,   95,
   72,   94,   98,  100,   73,   73,   76,   76,   76,   85,
  107,  107,  107,  108,  108,  109,  109,  110,  110,  114,
  114,   84,  117,  117,  123,  119,  119,  121,  121,  125,
  125,  126,  127,  127,  128,  129,   82,   86,   87,  134,
  134,  134,  135,  135,  137,  137,  138,  138,  138,  139,
  139,  140,  140,  141,  141,  136,  136,   83,  111,  111,
  142,  143,  143,  145,  145,  146,  146,  146,  146,  146,
  144,  144,  147,  147,  148,  148,  148,  115,  149,  150,
  150,  151,  151,  152,  152,  153,  153,  153,  113,  113,
  113,   78,   90,   79,   91,  156,  156,  156,  154,  154,
  154,  155,  155,  157,  157,  158,  158,  158,  163,  164,
  164,  103,  103,  160,  160,  122,  122,  116,  167,  168,
  168,  168,   64,  124,  124,  124,  124,  124,  124,  161,
  161,  175,  175,  176,  178,  178,  178,  178,  178,  159,
  177,  177,  181,  181,  181,  181,  183,  184,  185,  180,
  180,  179,  179,  179,  179,  179,  186,  187,  188,  188,
  188,  188,   77,   89,   96,  193,  189,  189,  190,  190,
  194,  194,  196,  195,  195,  199,  198,  198,  198,  191,
  191,  200,  200,  201,  205,  205,  206,  204,  204,  208,
  208,  208,  207,  210,  210,  192,  212,  212,  212,  213,
  213,  211,  211,  202,  203,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  216,  216,  216,  216,  222,  222,  223,
  219,  229,  230,  220,  227,  227,  224,  234,  218,  235,
  232,  232,  232,  232,  228,  231,  231,  226,  226,  226,
  233,  233,  214,  214,  239,  240,  240,  241,  241,  241,
  241,  225,  225,  225,  243,  245,  244,  246,   14,  247,
  247,  247,  248,  248,  248,   15,  250,  250,  251,  251,
  252,   81,   92,  166,  104,  106,  120,  255,  255,   80,
   80,   80,   93,   93,   93,   97,   97,   97,  256,  256,
  256,  257,  257,  262,  262,  262,  262,  262,  260,  260,
  261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
  261,  261,  261,  261,  261,  258,  258,  259,    2,  264,
  264,  264,  264,  264,  264,  264,  264,  264,  270,  270,
  274,  274,  274,  274,  274,  274,  274,  265,  265,  275,
  275,  275,  275,  275,  275,  275,  275,  275,  269,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  277,  277,  279,
  279,  278,  276,  276,  276,  271,  271,  272,  272,  272,
  273,  283,  283,  284,  284,  267,  268,  268,  285,  285,
  285,  285,  285,  266,  286,  286,  287,  287,   10,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  118,  118,  197,  197,  292,  292,  293,
  293,  162,  162,  291,  291,  297,  297,  299,  299,   59,
   59,  296,  296,  296,  296,  296,  296,  296,  296,  296,
  303,  303,  295,  295,  295,  295,  305,  305,  304,  304,
  304,   61,   61,  300,  300,  300,  298,  298,  298,  309,
  309,  309,  308,  308,  307,  307,  307,  301,  301,  310,
  310,  310,  311,  311,  302,  302,  302,  302,  312,  312,
   21,   21,   21,  314,  314,  314,   19,   19,   19,  316,
  317,  320,  320,  318,  322,  322,    5,   18,  321,  321,
  323,  323,  324,  324,  313,  325,  325,  326,  326,  327,
  327,  327,  327,  327,  327,  328,  328,  329,  329,  330,
  330,  334,  334,  334,  335,  335,  335,  336,  336,  336,
  331,  331,  331,  332,  333,  338,  338,  338,  339,  339,
  337,  337,  340,  342,  342,  341,  341,  315,    4,    4,
    4,  343,  345,  345,  345,  345,  345,  345,  345,  345,
  345,  345,  345,  345,  345,  345,  347,  347,  348,  344,
  344,   20,  349,  349,  351,  351,  350,  350,  254,  352,
  352,  352,  356,  356,  357,  360,  361,  353,  353,  353,
  362,  364,  365,  365,  365,  365,  373,  373,  373,  374,
  374,  374,  366,  366,  367,  367,  376,  376,  377,  377,
  378,  378,  368,  380,  380,  381,  381,  383,  383,  383,
  385,  386,  386,  359,  359,  387,  387,  382,  382,  382,
  388,  389,  390,  392,  392,  393,  394,  384,  384,  395,
  395,  396,  396,   27,  391,  391,  391,  391,  391,  397,
  397,  370,  370,  398,  398,  399,  371,  371,  369,  369,
  372,  372,  400,  401,  401,  401,  401,  401,  402,  402,
  403,  403,  404,  404,  405,  405,  405,  406,  406,  407,
  407,  354,  354,  408,  408,  409,   74,   74,   74,  410,
  410,  411,  411,  355,  355,  355,   12,   12,   12,   13,
  414,  414,  414,  414,  415,  416,  417,  418,    9,    9,
  420,  421,   22,   22,  423,  424,   23,  425,  425,  413,
  413,  413,  422,  419,  419,  217,  221,  221,    3,    3,
  430,  430,  430,  432,  432,  433,  431,  431,  434,  434,
   37,   37,  102,  101,  101,  412,  412,  426,  435,  435,
  237,  237,  237,  165,  427,  427,  130,  130,  130,  130,
  436,  436,  436,  436,  436,  436,  436,  436,  436,  436,
  436,  436,  436,  437,  437,  437,  437,  437,  437,  437,
  437,  443,  443,  443,  443,  443,  443,  443,  443,  443,
  443,  443,  443,  443,  443,  443,  443,  449,  449,  438,
  438,  439,  439,  440,  440,  440,  440,  441,  441,  445,
  445,  446,  446,  446,  446,  444,  447,  442,  442,  448,
  448,  448,  450,  450,  451,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  174,  174,  174,  458,  458,  452,  459,
  459,  249,  249,  169,  169,  460,  460,  460,  460,  460,
  454,  454,  454,  454,  454,  253,  170,  170,  171,  172,
  172,  172,  172,  172,   57,   57,   24,   24,  263,  461,
   60,  306,  282,  282,  112,  453,  453,  429,  429,  429,
  462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
  462,  462,  462,  466,  466,  467,  467,  467,  463,  463,
  468,  469,  469,  469,  471,  472,  472,  473,  465,  465,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  475,  475,  475,  475,  475,  475,
  475,  464,  464,  464,  464,  476,  478,  478,  477,  477,
  477,  477,  479,  479,  479,  428,  428,  455,  456,  456,
  481,  481,  481,  481,  481,  482,  482,  484,  484,  487,
  487,  485,  485,  490,  490,  489,  486,  488,  483,  483,
  457,  457,  470,  470,  470,  470,  470,  470,  470,  470,
  470,  470,  375,  375,  363,  363,  173,  480,   54,   70,
  133,  132,  294,  182,  209,  290,   99,   68,  242,  131,
   75,  379,  238,  346,   38,   47,  358,  289,   45,   48,
  236,   46,  319,  281,  281,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,
  491,
};
static int yylen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,    8,    8,    5,    1,    0,
    1,    2,    1,    1,    3,    1,    1,    1,    1,    2,
    2,    3,    0,    3,    0,    1,    8,    8,    5,    3,
    0,    3,    0,    1,    1,    1,    3,    3,    3,    2,
    2,    2,    2,    1,    3,    1,    2,    2,    1,    3,
    1,    1,    3,    1,    2,    2,    2,    3,    8,    1,
    1,    5,    0,    1,    3,    1,    3,    3,    0,    2,
    2,    1,    1,    3,    3,    2,    0,    2,    2,    1,
    3,    9,    1,    1,    2,    2,    7,    2,    2,    4,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    4,    2,    2,    2,    4,    2,    2,    2,
    2,    2,    2,    2,    1,    0,    1,    1,    6,    6,
    1,    1,    0,    0,    1,    0,    4,    0,    1,    1,
    2,    8,    1,    0,    3,    1,    0,    1,    0,    1,
    2,    1,    1,    1,    2,    6,    1,    1,    6,    2,
    5,    0,    0,    1,    1,    2,    1,    1,    1,    2,
    2,    2,    2,    2,    2,    0,    1,    3,    0,    1,
    1,    0,    1,    1,    2,    3,    4,    2,    2,    3,
    0,    1,    1,    2,    1,    4,    3,    3,    1,    0,
    1,    1,    2,    3,    4,    0,    1,    2,    0,    1,
    1,    5,    5,    5,    5,    4,    4,    0,    3,    2,
    0,    1,    3,    1,    1,    6,    3,    2,    6,    1,
    3,    2,    1,    2,    2,    2,    0,    1,    1,    2,
    3,    1,    0,    1,    1,    1,    1,    1,    1,    0,
    1,    1,    2,    2,    1,    1,    5,    2,    3,    2,
    2,    0,    1,    1,    1,    1,    3,    4,    8,    4,
    0,    1,    1,    2,    2,    0,    3,    3,    1,    2,
    2,    2,    8,    8,    8,    8,    3,    0,    4,    0,
    1,    3,    6,    1,    3,    3,    3,    3,    0,    1,
    0,    1,    2,    6,    1,    1,    4,    1,    0,    2,
    2,    0,    6,    1,    1,    5,    1,    2,    0,    1,
    2,    4,    3,    0,    0,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    3,    1,
    3,    8,    9,    5,    8,    6,    3,    0,    3,    2,
    1,    1,    3,    3,    7,    2,    0,    1,    1,    2,
    3,    0,    1,    2,    4,    1,    3,    2,    2,    2,
    1,    1,    1,    1,    2,    2,    5,    0,    5,    1,
    3,    0,    2,    4,    0,    7,    3,    0,    1,    3,
    3,    7,    7,    0,    0,    0,    0,    3,    0,    6,
    8,    8,    6,    8,    8,    6,    8,    8,    1,    1,
    0,    2,    2,    1,    1,    2,    2,    2,    1,    1,
    1,    1,    1,    3,    3,    3,    3,    3,    3,    5,
    5,    5,    5,    5,    5,    2,    0,    4,    2,    2,
    3,    2,    2,    3,    3,    2,    2,    3,    1,    2,
    3,    3,    2,    2,    2,    2,    3,    1,    3,    3,
    3,    2,    2,    4,    4,    4,    5,    4,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
    1,    1,    1,    1,    0,    2,    2,    4,    4,    5,
    3,    2,    0,    2,    0,    0,    1,    2,    2,    4,
    3,    2,    2,    7,    1,    0,    1,    0,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    3,    2,    2,
    2,    2,    2,    1,    1,    1,    3,    1,    1,    3,
    1,    1,    1,    4,    5,    1,    3,    1,    3,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    4,    6,    5,    3,    0,    2,    2,
    0,    3,    0,    4,    1,    5,    4,    1,    4,    1,
    2,    2,    1,    1,    1,    2,    2,    2,    2,    0,
    3,    5,    1,    1,    2,    3,    1,    2,    3,    0,
    1,    1,    1,    5,    5,    6,    1,    1,    1,    2,
    4,    1,    0,    5,    1,    0,    3,    3,    1,    0,
    2,    0,    1,    0,    3,    1,    0,    1,    2,    1,
    1,    1,    1,    1,    1,    2,    2,    1,    2,    3,
    1,    1,    3,    3,    1,    2,    3,    1,    2,    0,
    3,    2,    2,    3,    2,    1,    1,    0,    1,    1,
    1,    3,    2,    3,    0,    1,    3,    4,    5,    6,
    7,    1,    1,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    1,    2,    1,    1,    1,    2,    1,
    1,    3,    3,    0,    2,    0,    2,    0,    4,    3,
    2,    0,    1,    3,    6,    4,    4,    1,    4,    4,
    1,    9,    2,    1,    1,    0,    2,    4,    2,    2,
    4,    2,    1,    1,    1,    1,    1,    3,    1,    3,
    1,    0,    2,    1,    3,    1,    1,    1,    1,    3,
    6,    1,    0,    3,    0,    1,    3,    1,    1,    1,
    4,    5,    5,    1,    1,    2,    4,    4,    2,    3,
    0,    1,    3,    1,    1,    2,    2,    2,    0,    1,
    0,    3,    0,    1,    3,    1,    2,    0,    2,    0,
    2,    0,    4,    1,    2,    1,    1,    0,    1,    3,
    2,    1,    1,    2,    1,    4,    3,    1,    3,    4,
    0,    3,    0,    1,    3,    3,    1,    1,    0,    2,
    0,    1,    1,    2,    4,    0,    9,    6,    6,    8,
    2,    2,    1,    1,    4,    5,    3,    6,    1,    1,
    8,    4,    1,    1,    9,    5,   12,    2,    0,    2,
    4,    0,    4,    1,    3,    3,    1,    1,    7,    7,
    5,    3,    0,    1,    1,    1,    2,    0,    1,    1,
    1,    0,    3,    1,    3,    1,    0,    3,    1,    3,
    1,    3,    3,    1,    1,    3,    1,    3,    3,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    1,    1,    5,
    6,    5,    6,    3,    4,    5,    6,    3,    4,    3,
    4,    3,    4,    4,    5,    4,    4,    3,    4,    1,
    1,    1,    1,    3,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    1,    1,    1,    3,
    1,    1,    1,    1,    2,    2,    3,    0,    4,    1,
    0,    1,    3,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    2,    2,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    1,    2,    1,    1,
    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,
    4,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    6,    6,    2,    0,    1,    1,    1,    1,    1,
    6,    1,    1,    1,    4,    4,    4,    4,    4,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    7,    8,    8,    8,   10,    8,
    6,    1,    1,    4,    4,    7,    2,    0,    7,    6,
    6,    4,    1,    1,    1,    4,    3,    6,    1,    1,
    6,    8,    6,    6,    8,    1,    1,    4,    6,    4,
    5,    3,    5,    4,    5,    1,    1,    1,    3,    5,
    4,    6,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    0,    1,    0,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,
};
static int yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    7,    8,    9,
   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,    0,  651,  652,  653,  657,
  658,  659,    0,  879,  880,  883,  884,  556,    0,    0,
    0,    0,    0,    0,    0,    0,  459,  669,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  135,    0,
    0,    0,    0,    0,  105,    0, 1059,    0,   25, 1057,
    0,    0,   76,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  569,    0,
    0,    0,   39,   36,   38,    0,   37,    0, 1234, 1236,
 1237, 1238, 1239, 1240, 1241, 1262, 1263, 1242, 1244, 1243,
 1255, 1256, 1249, 1245, 1250, 1246, 1248, 1251, 1247, 1252,
 1253, 1254, 1258, 1259, 1257, 1260, 1261, 1265, 1264, 1266,
 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276,
 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286,
 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296,
 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306,
 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315, 1316,
 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326,
 1327, 1328, 1329, 1330, 1331,    0,    0,    0,    0,   34,
   71,   69, 1226, 1235,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  812, 1228,    0,
    0,    0, 1227,  751,    0,    0,    0,    0,    0,    0,
    0,    0,  120, 1233,  660,    0,    0,    2,    0,    0,
    0,    0,  758,  761,    0,  491,  492,  493,  494,  495,
  496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
  506,  507,  508,  509,  510,  511,  519,  513,  514,  512,
  515,  516,  517,  518,  520,  522,  525,  521,  523,  524,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,    0,  489,  490,    0,  460, 1217,    0,    0,
  466, 1221,    0,  463, 1225,    0,  814,    0,  462, 1229,
    0,  467, 1220,    0,  667, 1055,    0,  191,  115,    0,
  116,    0,  248, 1213,  924,  106,    0,  113,  167,    0,
    0,  108,    0,  117, 1061,    0,  109,    0,  111,    0,
  112, 1232,  168,  118,  114,  119,    0, 1212,    0,  857,
  858,    0, 1060, 1058,    0,   77,    0, 1218,    0, 1216,
  577,  570,    0,  576,  581,  571,  572,  579,  573,  574,
  575,  580,  582,  583,    0,    0,    0,   32,    0,   41,
  911,   40,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  668,    0,    0,
    0,    0,    0,    0,    0,  688,    0,    0,    0,  675,
    0,  678,  680,  681,  682,  683,  684,  685,  691,  692,
    0,  781,    0,    0,  750,    0,    0,    0,  126,    0,
    0,  121,    0,  122,    0,  125,    0,  124,    0,    0,
    0,  722,  723,  730,    0,  729,  731,  733,  738,  726,
  724,  727,  725,  734,  737,  732,  736,    0,    0,    0,
    0,    0,  742,    0,    0,    0,    0,  765,    0,    0,
    0,    0,    0,    0,    0,    0,  557,    0,    0,    0,
    0,  253,    0,  469,  134,    0,  468, 1209,  546,  547,
    0,    0,    0,    0,    0,    0,  478,    0,  429,  430,
    0,    0,  673,  671, 1056,    0,    0,    0,    0,    0,
    0,    0,  194,  153,    0,  131,    0,    0,    0,  127,
    0,  142,  141,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   78,    0,    0,    0,    0,  882,  578,    0,
    0,    0,    0, 1019, 1052,    0, 1207,    0, 1021, 1121,
    0,    0,    0, 1135, 1053,    0, 1047, 1038, 1037, 1036,
    0,    0,    0,    0, 1024,    0,    0, 1039, 1040, 1048,
 1049,    0, 1050, 1051,    0,    0,    0, 1054,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1046, 1042,    0,  921,
 1016, 1017, 1018, 1023, 1022, 1001,    0,    0,    0, 1000,
    0,    0, 1005, 1067,  997,  998,  999, 1002, 1003, 1004,
 1041, 1066, 1068, 1069, 1070, 1089, 1090, 1092, 1093, 1094,
    0, 1100, 1152, 1153,    0, 1169, 1170, 1176, 1177,  249,
    0,    0,    0,  409,    0,    0,    0,  914,   29,    0,
    0,    0,    0,   74,   72, 1230,   70,   35,    0,    0,
    0,    0,  916,    0,    0,   50,   52,    0,    0,    0,
  665,    0,    0,  718,    0,    0,  689,    0,  686,    0,
  687,  716,    0,  711,    0,    0,    0,  703,  702,  679,
    0,  813,  925,  894,    0,    0,    0,  754, 1222,  796,
    0,    0,  132,    0,    0,    0,    0,    0,    0,  662,
  661,  735,  728,    0, 1224,    0,    0,    0,  743,  747,
 1065,    0,  767,  769,    0,  770,  772, 1203,  773,    0,
  774,  763,    0,    0, 1205,    0,    0,  749,  209,    0,
    0,  150,    0,  562,    0,  563,  558,  415,    0,  473,
  475,  474,  415,  416,  476,    0,  470,    0,    0,    0,
    0,  301,    0,    0,    0,  482,  483,    0,  539,    0,
    0,    0,    0,    0,    0,    0,  440,  439,    0,  565,
    0,    0,    0,  190,    0,    0,  199,    0,  198,    0,
    0,  205,  188,    0,  203,  195,    0,    0,  608,  643,
  611,    0,  644,    0,    0,  612,    0,    0,    0,  635,
  647,  607,  630,  609,  610,  605,  592,  415,  584,  585,
  593,    0,    0,  602,  603,  604,  606,    0,    0,    0,
    0,  130,    0,    0,  128,    0,  129,    0,  145,    0,
    0,  230,    0,    0,    0,  414,    0, 1211,    0,  110,
    0,  253,    0,    0,   86,    0,  104,    0,  103, 1210,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  927,  931,  932,  933,  934,  935,  936,  937,  938,  939,
  940,  941,  942,    0,    0,    0,    0,    0, 1043,    0,
    0,    0,    0,    0,    0,    0, 1044, 1045,    0, 1025,
 1026,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  370, 1231,
    0,    0,    0,    0,    0,    0,    0,    0,  399,    0,
    0,    0,    0,    0,  588,    0,    0,  589,  591,  600,
    0,    0,    0,  407,    0,    0,    0,  913,    0,    0,
   46,   75,    0,    0,   28,    0,    0,  919,    0,    0,
    0,    0,    0,    0,  786,  787,  788,  789,  798,  799,
  800,    0,    0,    0,    0,  664,  655,    0, 1063,  654,
    0,  690,  701,    0,  698,  694,  693,    0,    0,    0,
  713,  697,  704,    0,    0,    0,    0,  886,    0,    0,
  794,    0,    0,    0,    0,    0,  414,    0,  123,  741,
  740,  719,    0,    0,    0,    0,    0,    0,  776,    0,
    0,    0,  777,    0,    0,  854,  760,  759,    0,    0,
  151,    0,  561,    0,  472,    0,  471,  477,  552,    0,
  551,    0,    0,  297,  414,  271, 1214,    0,    0,  240,
  415,    0,    0,  238,    0,  414,    0,    0,    0,  276,
  270,  273,  274,  275,  481,  544,  543,  480,  479,    0,
    0,    0,    0,    0,    0,  434,  435,  433,    0,    0,
    0,  432,    0,  415,  549,    0,  548,    0,  196,  200,
    0,    0,  204,    0,    0,    0,  631,  632,  648,    0,
  645,    0,    0,  638,  636,  637,    0,    0,    0,    0,
  601,    0,    0,    0,    0,  639,  133,    0,    0,    0,
  414,    0,  229,    0,  232,  234,  235,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  253,   81,    0,    0,
   80,    0,    0,    0,  930,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  834,  836,    0,  831,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1193, 1194, 1195, 1196,
 1197, 1198, 1201, 1202, 1199, 1200,    0,    0,    0,    0,
    0,    0,    0,    0, 1182,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1163, 1165, 1164,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1014,  401,    0, 1015, 1010,    0,    0,    0,    0,
    0,    0,    0,    0,  371,  372,    0,    0, 1020,  923,
  922,    0,    0, 1167,    0,    0,    0,  306,    0,  411,
  410,    0,  304,  334,    0,  312,  335,  915,    0,    0,
    0,   73,    0,    0,    0,  869,    0,  918,    0,  868,
    0,    0,    0,    0,    0,    0,  815,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  656, 1064,  699,  712,
  707,  706,    0,  717,    0,  926,  895,    0,    0,  797,
    0,  414,    0,    0,    0,    0,    0,  720,  739,    0,
  768,  771,    0,    0,    0,    0,    0,    0,    0,  560,
    0,    0,  208,    0,  212,    0,    0,  155,  254,  255,
  256,  257,  258,  259, 1034,  554,  415,  302,    0,  242,
    0,  244,  417,  156,    0,  237,  415,  245,    0,    0,
    0,  484,  485,  488,  416,  540,  541,  486,  437,  438,
  436,    0,    0,    0,  456,    0,  550,  220,  221,  197,
    0,  207,  619,  620, 1062,    0,    0,    0,    0,    0,
  646,    0,    0,  417,    0,    0,  596,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  222,    0,  415,    0,  416,    0,    0,  170,    0,    0,
    0,    0,    0,    0,  175,  177,  178,  179,    0,    0,
   85,    0,    0,    0,    0,   93,   87,    0,    0,   92,
   88,    0,  893, 1215,    0,    0,  943,    0,    0,    0,
  969,  968,    0,    0,    0,  978,  993,    0,  988,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  929,
    0,  835,    0,    0,    0,    0,    0,    0, 1071,    0,
    0, 1154,    0,    0,    0,    0,    0,    0,    0,    0,
 1027,    0,    0,    0,    0,    0, 1178,    0,    0,    0,
    0,    0,    0,    0, 1191, 1095, 1096, 1097, 1155, 1098,
    0, 1162,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1029,    0,    0,    0, 1099, 1166,  590,
  246,  587,    0,  299,  406,  335,  313,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   56,   64,   66,
    0,   44,    0,    0,    0,  900,    0,  920,    0,    0,
  790,    0,    0,  820,  818,  816,    0,    0,  817,    0,
    0,  899,    0,    0,  709,  710,  714,    0,    0,  755,
    0,  223,    0,    0,  416,    0,    0,  721,  780,    0,
    0,    0,    0,  778,    0,  856,  855,    0,    0,    0,
    0,  213,    0, 1035,    0,  334,  241,    0,    0,    0,
    0,    0,  277,  487,    0,    0,    0,    0,    0,    0,
  567,  416,  206,    0,    0,  614,    0,  613,  649,    0,
  641,    0,    0,    0,  594,  622,    0,    0,  624,  627,
  629,  414,    0,    0,  334,    0,  140,    0,  233,    0,
    0,    0,  420,    0,  416,    0,  180,  183,  182,  185,
  184,  181,  187,  169,  176,    0,  107,    0,  138,    0,
   96,    0,    0,    0,    0,   90,   91,    0,  986,  987,
    0,    0,    0,    0,    0,    0,    0,    0,  989,    0,
    0,    0,    0,    0,    0,    0,  979,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  842,    0,    0,    0,  881, 1077, 1076,    0,
    0,  252,    0, 1073, 1072,    0, 1081, 1080, 1079, 1078,
    0, 1075, 1074,    0,    0, 1184,    0,    0,    0, 1183,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  757,  404,  374,
  373,  305,    0,    0,   68,   60,   61,   67,   62,   63,
    0,   26,    0,    0,   27,  906,  905,    0,  904,  902,
  910,  909,  907,    0,    0,    0,  810,  808,    0,    0,
  870,    0,    0,  801,    0,   47,   48,    0,    0,  334,
    0,    0,  423,  416,    0,    0,    0,    0,  862,  863,
  860,    0,  218,  214,  416,  415,  415,  417,  416,    0,
    0,  262,    0,    0,    0,  278,    0,    0,    0,    0,
    0,    0,    0,  564,  616,    0,  617,    0,    0,    0,
    0,  160,  162,  163,  164,  599,  597,  595,  626,    0,
    0,    0,  416,  416,    0,  416,  334,  416,    0,  412,
    0,    0,  224,  415,   94,    0,    0,  100,   95,    0,
    0,    0,    0,    0,  994,    0,  995,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  844,  833,    0,
    0,  845,    0,  841,    0,  250, 1168, 1192, 1151, 1091,
    0,    0, 1180, 1179,    0, 1185, 1171, 1173,    0, 1160,
 1161,    0,    0,    0,    0,    0,    0,    0, 1174, 1086,
 1088, 1087, 1084, 1083, 1082,    0,    0,  318,    0,    0,
   57,   58,   59,   65,    0,    0,  867,  792,    0,  802,
    0,    0,    0,  871,    0,  872,    0,    0,  803,  804,
  805,    0,  885,  416,  416,  416,  413,  225,    0,    0,
    0,    0,  215,  166,    0,    0,  303,  296,  236,  263,
    0,    0,    0,  265,  266,  264,    0,    0,    0,  454,
  455,  451,  450,  453,  452,  615,  642,  165,  152,  161,
  334,    0,    0,  426,  293,  147,  421,  458,  422,  418,
  171,    0,    0,    0,   98,    0,   82,    0,  955,  963,
    0,    0,  956,  964,  959,  967,    0,    0,  957,  965,
  958,  966,  952,  960,  953,  961,  954,  962,  840,    0,
    0,  251,    0, 1156, 1181,    0, 1159, 1145,    0,    0,
    0,    0,    0,    0,  325,  335,  330,  324,    0,    0,
    0,    0,  315,  316,    0,    0,   42,  901,  791,    0,
    0,    0,    0,    0,  294,  424,  425,    0,    0,  824,
    0,  762,  307,  308,    0,    0,  268,  239,    0,  280,
  416,  416,  416,    0,    0,    0,   79,  101,  102,  756,
    0,    0,    0,  847, 1172, 1146, 1147, 1148,    0, 1175,
    0, 1150,    0,  326,    0,  331,    0,  383,    0,  314,
    0,    0,    0,  875,    0,    0,    0,    0,  269,    0,
    0,    0,    0,    0,  295,  427,  428,  227,  226,    0,
    0,  846,    0,    0,    0,    0,    0,  353,    0,    0,
    0,  352,    0,    0,    0,    0,  398,  341,  337,  338,
  343,    0,  339,  340,    0,  333,  336,  342,  344,  345,
  346,  347,  348,  349,  350,  351,  354,  355,  356,  357,
    0,    0,  392,  393,  394,    0,  897,  898,  391,    0,
    0,    0,    0,  386,  384,    0,    0,    0,  876,    0,
  807,  888,  887,  825,    0,    0,    0,  279,    0,  285,
    0,  284,  139,  849,    0, 1149,    0,    0,    0,    0,
  380, 1223,  395,  396,    0,    0,  332,    0,    0,  376,
  390,  389, 1219,  388,  334,    0,    0,    0,  317,    0,
    0,    0,  267,    0,    0,  289,  288,  287,  850,    0,
    0,    0,  367,    0,    0,    0,    0,    0,  385,  387,
  320,  321,    0,    0,  292,  290,  291,    0,    0,    0,
    0,    0,    0,  323,    0,    0,  334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  334,  878,  334,    0,
    0,  334,  375,  365,  334,  381,  362,  363,
};
static int yydgoto[] = {                                      22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45, 1866,  216,  710,  238, 1635, 1862,  217,
 1020,  218,  713, 1025,  219,  220,  400, 1033,  231,  232,
 1636, 1637, 1638, 1639,  328,  360,  221, 1640,  222,  715,
   93,  376,  553,  506,  913, 1504,  658, 1210,  877,  353,
 1181,  914,  915,  916, 1511, 1506, 1959,  377,  918,  919,
   85,  346,   86,  372, 2191, 1757,  352,  357,  910,  359,
  361,  348,  339,  341,  354,  364,  366,  253,  452,  454,
 1079,  458,  456,  449,  540,  895,  897,  892,  316,  317,
  707,  401, 1120, 1104,  929, 1107,  544,  900, 1479, 1737,
  845, 1049, 1450,  801,  802,  825,  535,  878, 1423, 1698,
 1930, 1328, 1424, 1408, 1931, 1932, 1933, 1934, 1935,  930,
  349,  367,  907, 1202, 1493, 1754, 1494, 1495, 1496, 1497,
 1498,  340,  531,  853,  532,  533,  854,  855,  803, 1403,
 1404, 1405, 1691,  546, 1194, 1953, 1195, 1196, 1197, 1122,
 1910, 1005, 1124, 1125,  660, 1200,  701, 1813, 1409,  661,
  662,  663,  664,  665, 1911, 1912,  828, 2076, 2222, 1703,
 1131, 1116, 1132, 1133, 1134, 2223, 2224, 2337,  512,  706,
 1334, 2145,  324,  821, 1332,  822, 1006, 1908,  702, 1335,
 1336, 2146, 1628, 2029, 2152, 2153, 2154, 2329, 1513, 2147,
 2148, 2149, 2150, 2207, 2255, 2256,  754, 2258, 2259, 2260,
 2261, 2262, 2263, 2264, 2265, 2266, 2267, 2268, 2269, 2270,
 2271, 1314, 2376, 2343,  666,  989,  667, 2272, 2208, 2283,
 2284, 2322, 2273, 2274, 2275, 2315,  668,  999,  669,  397,
  703,  704,  670,   46, 1745,  521,  840, 1154, 1485,  841,
 1152, 1148,   90,   67,  516,  329,  265,  496,  313,  503,
  321,  332,  507,  504,  517, 1138,  518,  835, 1438,  314,
  671, 1465,  819, 1111,  497,  842, 1712,  109,  327,  381,
  880, 1007, 1008,  345,  881, 1010, 1466, 1011, 1467,  884,
  885,  886,  887, 1166, 1459, 1457,  888,  889,  890, 1174,
  891, 1171,   47,   48,   49,   50,   51,   52,  255,  771,
   69,  732,  335,  524,  430,  431,  432,  433,  434,  435,
  436,  437,  438,  439,  440, 1056,  743, 1373, 1667,  744,
  745, 1061,  478, 1082,  479,  776,  480, 1085,  260,  483,
  779, 1775,  262,  491,  798,  244,  245,  672,  448, 1776,
  988,  263,  796,  264,  486,  790, 1091, 1395,  557, 1898,
 2062,  945,  487,  488,  791, 1092, 1093,  443,  760, 1680,
 1034, 1035, 1036, 1037, 1038, 2039,  761, 1039, 1040, 1041,
 1363, 2049, 2050, 2051, 1355,  241, 1655, 2169, 2170, 1803,
 1240, 1804, 1805, 1806, 1994, 2192, 2194, 1095, 1096, 1686,
 1901,  722, 1346, 1881, 1882, 1883, 2214, 2289,  756,   54,
   55,  558,   56,   57, 2217,  723,  757,  673,  674, 1344,
 1646, 1868, 1869, 1873, 1029,  931,  932,  933,  934,  935,
  936,  937,  938,  939,  940,  941,  942,  943, 1524, 1526,
 1527,  675,  676,  677,  678,  679,  680,  960, 1323,  681,
  374,  682,  683,  684,  685, 1845, 2023,  686,  687, 1267,
  688,  689,  690,  691,  692,  693,  694, 2002, 1290,  695,
  696,  697, 1843,  698,  699,  966, 1273, 1590, 1585,  967,
  224,
};
static int yysindex[] = {                                  36104,
 3080, -112, 2336,  105, 1372,   50,25653, -104,38581,  471,
  284,  268,  339, -112,  482,42322,43057, 1567,43205,  197,
  460,    0,  764,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  604,    0,    0,    0,    0,
    0,    0,  599,    0,    0,    0,    0,    0,42761,43205,
  717,43205,43205,43205,43205,43205,    0,    0,  648,  936,
43205,43205,43205,  828,43205,  652,43205,43205,    0,43205,
43205,43205,43205,  551,    0,   77,    0,  730,    0,    0,
  925,43205,    0,43205,43205,43205,  943,43205,43205,43205,
43205,  652,43205,43205,43205,43205,43205,43205,    0,43205,
 1127,  927,    0,    0,    0, 1298,    0, 1298,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  893, 1002,  138, 1366,    0,
    0,    0,    0,    0,43205,43205,43205,43205, 1056, 1081,
 1271,43205,  523,43205, 1152, 2661, 1138,    0,    0, 1244,
 1129,43205,    0,    0, 1521, 1542,43205,43205,43205,43205,
43205, 1019,    0,    0,    0,43205,25722,    0, 1207, 1213,
    0,  -52,    0,    0, 1377,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  544,    0,    0,  936,    0,    0,43205,   84,
    0,    0, 1632,    0,    0, 1058,    0,  629,    0,    0,
 1162,    0,    0, 1295,    0,    0, 1277,    0,    0, 1399,
    0, 1490,    0,    0,    0,    0,  936,    0,    0,  676,
 1632,    0,  520,    0,    0, 1444,    0,   63,    0, 1298,
    0,    0,    0,    0,    0,    0, 1450,    0, 1375,    0,
    0, 1480,    0,    0,43205,    0, 1495,    0, 1391,    0,
    0,    0,43205,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,33670,43205, 1451,    0,43205,    0,
    0,    0, 1427, 1464,42613,43205, 1503, 1523,  253, 1380,
 1572, 1579, 1585, 1529, 1530,  207, 1416,    0, 1496,43205,
 1574,   56,  475,43205, 1515,    0, 1413, 1424, 1428,    0,
 2661,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1636,    0,43205,43205,    0,43205,43205, 1704,    0,  936,
 1632,    0, 1444,    0,  640,    0, 1298,    0, 1548, 1626,
 1594,    0,    0,    0, 1691,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1685,43205,43205,
 1655, 1534,    0,  218,  234,  530,    0,    0, 1762, 1012,
 1536,  -69, 1535, 1547, 1590, 1377,    0,  536, 1170, 1774,
43205,    0,  544,    0,    0, 1776,    0,    0,    0,    0,
43205, 1451,41500, 1623,41650, 2044,    0,42761,    0,    0,
  611, 1644,    0,    0,    0, 2035, 2035,  936, 1752,  936,
  461, 1399,    0,    0,36494,    0,43205,43205,43205,    0,
 1451,    0,    0, 1836,  677, 2084,43205,  611, 1867,43205,
43205,43205,    0, 2093,35603,26308, 1748,    0,    0, 2105,
 2112, 2117, 1688,    0,    0, 2120,    0, 2121,    0,    0,
 2127, 2128,    0,    0,    0, 2131,    0,    0,    0,    0,
    0, 2136, 1707, 1728,    0, 2141, 2141,    0,    0,    0,
    0, 2143,    0,    0,30681, 2146, 2147,    0, 2152, 1845,
 2158, 2159, 2160, 2163, 2164, 2165,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2166, 2167, 2169,    0,    0,    0,    0, 2171,
    0,    0,    0,    0,    0,    0,    0, 2174,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,34002,34002,31013,43205,    0,    0, 2724,    0,
    0,    0,    0,    0,    0,    0, 2125, 1817, 2175,    0,
    0, 2177,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2180,    0,    0,    0, 2181,    0,    0,    0,    0,    0,
41025, 2173, 1560,    0, 2185, 1962, 1605,    0,    0,43205,
43205,43205,  108,    0,    0,    0,    0,    0,43205, 1803,
43205, 1051,    0,34999,43205,    0,    0, 1427, 1847,42613,
    0,43205,  128,    0,  930, 1708,    0, 1806,    0, 1806,
    0,    0, 2198,    0, 1935, 1833,  652,    0,    0,    0,
43205,    0,    0,    0, 2207,  115, 2193,    0,    0,    0,
 1690, 2215,    0, 1451, 2217,43205,  611, 1994,43205,    0,
    0,    0,    0,  788,    0, 1923, 2216,43205,    0,    0,
    0,34002,    0,    0,34002,    0,    0,    0,    0,31345,
    0,    0,34002,  599,    0,  599,34002,    0,    0, 1919,
 1920,    0,  936,    0, 1921,    0,    0,    0, 1990,    0,
    0,    0,    0,    0,    0,36494,    0,  936, 1910,41025,
 1692,    0, 2011,43205,40371,    0,    0,  595,    0,43205,
 1074, 1058, 1892, 1855,  -26,    0,    0,    0,  389,    0,
  440, 1895,  142,    0, 1838,  652,    0,  936,    0, 2010,
 1944,    0,    0,  461,    0,    0,  129, 1851,    0,    0,
    0, 1854,    0, 1902, 2254,    0, 1955, 2258,  739,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2210,  204,    0,    0,    0,    0,  124, 2263, 2264,
 2258,    0,  936, 1632,    0,  843,    0, 2041,    0,  936,
  936,    0,41500,  629, 1895,    0, 1992,    0, 2277,    0,
 1946,    0, 1917, 2283,    0,36109,    0, 1956,    0,    0,
 1960, 2296,26972, 2298,    0,    0,    0,26640,25028,  514,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   -4, 1963, 1103,34002,  481,    0,43205,
34002, 1139, 1155,34002, 1332, 3530,    0,    0,  652,    0,
    0,34002,26972,31013, 2724, 1899,  620,34002,34002,26972,
 2024,34002,34002,34002,34002,34002,27304,25976, 3530,34002,
 1336,34002,  658,  658, 2724, 1741,  599, 2302,    0,    0,
43205,34002,34002,34002,34002,34002,34002,34544,    0,34002,
35156,34002,31677, 1973,    0, 2073, 1980,    0,    0,    0,
 2077, 2290,43205,    0,43205,    0,43205,    0, 1927, 1928,
    0,    0, 1901,42613,    0, 2047, 1829,    0, 1750, 2318,
 1829,34692, 2324, 2119,    0,    0,    0,    0,    0,    0,
    0, 2047,43205,43205, 2322,    0,    0,  766,    0,    0,
    3,    0,    0, 1929,    0,    0,    0,43205,  448,43205,
    0,    0,    0, 2327,43205,43205, 1748,    0,34002,43205,
    0, 1925, 2107,41500,  629, 1895,    0, 2335,    0,    0,
    0,    0,  788,43205, 2039, 2333, 2269, 2627,    0, 2877,
 2061, 2337,    0, 2455, 2338,    0,    0,    0, 1382,  936,
    0,  205,    0, 2343,    0,25623,    0,    0,    0,  936,
    0, 2073,43205,    0,    0,    0,    0, 2111, 1856,    0,
    0, 1774, -102,    0, 2348,    0, 2051, 2052, 1298,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  652,
43205, 2097, 1774,41352,  -78,    0,    0,    0, 2018, 2020,
 2021,    0,  652,    0,    0,  839,    0,  592,    0,    0,
 1986,  936,    0,35603,   88, 1993,    0,    0,    0,  652,
    0, 2254,  120,    0,    0,    0, 1774,  120, 1999,  120,
    0, 2361,  652,  652,  652,    0,    0, 1451,43205,  611,
    0, 2050,    0, 1788,    0,    0,    0,  611,   42, 1925,
41799,  426,41500,43205, 1794,  159,    0,    0, 2370,  616,
    0,35603,43205, 1925,    0, 1925,24725,  140,34002,34002,
27643, 2371,  881,27982,34002,28321,  966,28660,28999,32009,
29338,29677,30016,26972,26972,    0,    0, 2053,    0, 2372,
 1536,34002,34002, 3622,34002, 2375,34002, 2369, 2686,34002,
34002,34002,34002, 1713,34002,34002,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2101, 2376, 2001,   38,
 2791,34002,  632,34002,    0,26972, 3662, 4026,  252,43205,
 2801, 2837, 2890, 2897, 2935,    0,    0,    0, 1974,32341,
    0,    0,    0,    0,  901, 2379,  216, 4379,34002,34002,
  104,    0,    0,  -52,    0,    0, 2150,  658,  658, 1175,
 1175,  929,35753, 2380,    0,    0, 2386, 2724,    0,    0,
    0, 2175, 2392,    0, 1842,43205,43205,    0, 2090,    0,
    0, 1849,    0,    0,    0,    0,    0,    0,41987,41987,
 2062,    0,   55, 2085,34002,    0,43205,    0,34002,    0,
 2404, 1196, 2412,34002, 1244, 2079,    0, 2079,  978,26972,
 2079, 2126, 2142, 2085, 2149, 2153,    0,    0,    0,    0,
    0,    0,  525,    0, 2032,    0,    0, 1963, 2724,    0,
 2434,    0, 1880,  611,   65, 1925,41500,    0,    0,  788,
    0,    0,43205,34999, 2045,34002, 1997,34002,34002,    0,
 2035, 2223,    0,  205,    0,26972, 1701,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2227,    0,    0,    0, 1856,    0,    0,    0, 1298, 1298,
 2000,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  430,  -13,  769,    0, 2229,    0,    0,    0,    0,
43205,    0,    0,    0,    0,  105, 1881, 2086, 2077, 2460,
    0, 1838, 1887,    0, 2445,  950,    0,43205, 1075,  652,
 2463, 2464, 2467, 2248,  629, 1895,    0, 2035, 1920,41500,
    0, 1895,    0,43205,    0, 2068, 2474,    0, 1945, -233,
  621, 1924,  936,  426,    0,    0,    0,    0, 1897,34850,
    0,  652, 2138, 2226,36109,    0,    0,  652,  581,    0,
    0, 2228,    0,    0, 2492, 2498,    0, 4368, 2724, 2503,
    0,    0, 2724, 2505,31013,    0,    0, 2231,    0,  662,
 2509, 2724, 2510, 1991, 2512, 2724, 2513,34002,34002, 2371,
34002,32673, 2514, 2724, 2535, 2542, 2724, 2549,34002, 2724,
 2568, 2724, 2573, 2586, 2724, 2589, 2593, 2724, 2594,    0,
 2373,    0,42174, 1829, 2943, 3043,43353, 3217,    0, 3309,
34002,    0, 3336, 3381, 3399, 3439,34002, 3493, 3643,34002,
    0,34002,34002, 2724, 2213,34002,    0,34002, 2724, 2331,
  552,34002,34002,34002,    0,    0,    0,    0,    0,    0,
34002,    0,34002, 2063, 2214,34002,34002,34002,34002, 4437,
 4437,34002, 1536,    0, 1909,35753,35305,    0,    0,    0,
    0,    0,43205,    0,    0,    0,    0, 2344,43205,43205,
43205,43205,43205,43205, 2197, 2599, 2600,    0,    0,    0,
 2197,    0,  121,  121,   99,    0,  151,    0, 1933, 1244,
    0, 1939,43205,    0,    0,    0, 2309,   74,    0,34999,
34999,    0,41987,41987,    0,    0,    0, 2617, 1536,    0,
    0,    0, 1895,43205,    0, 2068, 1953,    0,    0, 2620,
 1196,26972, 2341,    0, 1090,    0,    0, 2724, 1838, 2284,
 1838,    0,  161,    0,  188,    0,    0, 2387,34002, 2275,
 2000,   77,    0,    0, 2303, 2304, 2305, 2306, 2313, 2314,
    0,    0,    0, 2635,  105,    0, 2244,    0,    0,  120,
    0,  524,  120,  120,    0,    0, 2077, 2639,    0,    0,
    0,    0,  611,  521,    0, 1838,    0, 1920,    0, 2229,
    0, 2229,    0, 2418,    0,  936,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2320,    0, 2333,    0, 2665,
    0, 2666,  936,  -11, 2667,    0,    0,  936,    0,    0,
34002, 1925, 1925, 1970,  599, 2668,34002, 2396,    0, 1925,
 1925,34002, 1925, 1925, 4483, 2724,    0, 2170,34002, 2724,
 1925, 1925, 1925, 1925, 2724, 1925, 1925, 1925, 1925, 1925,
 1925,43205,    0, 2674, 2675, 1310,    0,    0,    0, 2349,
36494,    0, 2681,    0,    0, 3686,    0,    0,    0,    0,
 3731,    0,    0, 3777, 2429,    0,34002, 2421, 2299,    0,
34002, 3975, 1983, 4663, 3991, 4039,34002,34002, 4697, 1437,
 4732, 4748, 1996,  397, 2693, 2694, 2092,    0,    0,    0,
    0,    0, 2470, 2308,    0,    0,    0,    0,    0,    0,
 2419,    0,41987,41987,    0,    0,    0, 2321,    0,    0,
    0,    0,    0,35753, 1829,43945,    0,    0,34999, -103,
    0, 2307, 2311,    0, 3083,    0,    0,34002, 1829,    0,
 2229, 2229,    0,    0, 2320,34999, 2482, 2430,    0,    0,
    0,  592,    0,    0,    0,    0,    0,    0,    0, 2073,
 2387,    0,  714, 2724,43205,    0, 2414, 2323, 2428, 2339,
 2472, 2440, 2477,    0,    0, 2737,    0, 2745, 2439, 2073,
  524,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1895,43205,    0,    0,  592,    0,    0,    0, 2411,    0,
 2749, 2517,    0,    0,    0, 2437,   22,    0,    0, 2077,
 2438, 2724, 2751, 2762,    0,  -52,    0, 2724,34002, 2763,
 2768, 2724, 2769, 2772,34002,34002, 2724, 2773, 2774, 2778,
 2779, 2780, 2781, 2784, 2785, 2788, 2794,    0,    0,42174,
 2797,    0,43205,    0,43205,    0,    0,    0,    0,    0,
34002, 2798,    0,    0,34002,    0,    0,    0,34002,    0,
    0, 4084, 4130,34002,34002,34002,34002,34002,    0,    0,
    0,    0,    0,    0,    0,34002,    0,    0,43205, 2468,
    0,    0,    0,    0,  121, 2380,    0,    0, 1542,    0,
 2271, 2415, 2476,    0, 2281,    0,26972, 2815,    0,    0,
    0, 2006,    0,    0,    0,    0,    0,    0, 1196,34002,
26972, 1748,    0,    0,25623,25623,    0,    0,    0,    0,
 2516,43205, 2000,    0,    0,    0, 2817, 1298,43205,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2229, 2229,    0,    0,    0,    0,    0,    0,    0,
    0,  -67,34002,  936,    0, 2402,    0,  936,    0,    0,
 1536, 2724,    0,    0,    0,    0, 2724, 2724,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,43205,
 2527,    0, 2724,    0,    0, 4250,    0,    0, 4310, 4328,
 4344, 2724, 2618, 1736,    0,    0,    0,    0, 2556, 2425,
41025, 2809,    0,    0, 2579,    0,    0,    0,    0, 2444,
 2442,  514,43205, 2315,    0,    0,    0, 2724, 2829,    0,
  514,    0,    0,    0, 2000, 1298,    0,    0, 2501,    0,
    0,    0,    0, 2374, 2377, 2724,    0,    0,    0,    0,
 2843, 2840, 2848,    0,    0,    0,    0,    0,34002,    0,
34002,    0,40044,    0,   35,    0, 2425,    0, 2073,    0,
 2574, 2558, 2484,    0, 2015, 2327, 1829,34002,    0, 2501,
  -12, 2000, 2521, 2524,    0,    0,    0,    0,    0, 2860,
43205,    0,43205, 2724, 4392,43205, -107,    0, 2863, 2570,
34002,    0,    0,43205,43205,43205,    0,    0,    0,    0,
    0, 2571,    0,    0, 2851,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   -1, 2853,    0,    0,    0,    0,    0,    0,    0,43205,
43205,  105,  327,    0,    0,  238, 2875, 2327,    0,43205,
    0,    0,    0,    0, 2000,  830,  830,    0, 2619,    0,
 2483,    0,    0,    0, 2880,    0,34002,34002,26972, 2724,
    0,    0,    0,    0,43205,35753,    0,  365, 2885,    0,
    0,    0,    0,    0,    0,   35,25623,25623,    0, 1925,
 2493, 2883,    0, 2475,  790,    0,    0,    0,    0, 2724,
 1584,  183,    0, 2598, 2380, 2431, 2607,26972,    0,    0,
    0,    0, 2895, 2905,    0,    0,    0,35753, 2520,35753,
34002,35753,  239,    0,34002, 2380,    0, 2380, 1705,  190,
 2646, 2016, 2644,35753, 2659, 2649,    0,    0,    0,  336,
43205,    0,    0,    0,    0,    0,    0,    0,
};
static int yyrindex[] = {                                   2544,
    0,  167,  933,    0,    0,    0,    0,    0,    0,    0,
    0,    0,38796,  206,    0,    0,    0,    0,    0,    0,
    0,    0, 2953,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  155,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  353,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2622,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   37, 2581,    0,    0,    0,  211,    0,  211,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2582,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  353,    0,    0,  888,    0,    0,    0, 2026,
    0,    0,    0,    0, 2551, 2696,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  291,
33006,  801,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   47,    0,    0,    0,    0, 1025,    0,    0,
    0,    0,    0, 1092,    0,    0,    0,    0,    0,  229,
    0,37268,    0,    0,    0,    0,    0,    0,    0,    0,
   47,    0,  404,    0,    0, 2921,    0,  875,    0, 2700,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  168,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  208,    0, 2703,    0,    0,    0,
    0,    0,43501,    0,    0,    0,    0,    0, 1411,    0,
    0,    0,    0,    0,    0,    0,43649,    0,    0,    0,
    0,    0,    0,    0,  254,    0,    0,    0,    0,    0,
 1186,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   47,    0, 2921,    0,  875,    0, 2700,    0,    0, 1189,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  163,    0,    0,    0,    0,33338,30349,    0,    0, 2561,
  613,    0,    0,    0,    0, 1210,    0,    0,    0,    0,
    0,    0, 1211,    0,    0,  250,    0,    0,    0,    0,
    0, 2703, 1086,42909,    0, 1222,    0,    0,    0,    0,
  351,    0,    0,    0,    0, 2523, 2523,    0,    0,    0,
 1290,  263,    0,    0,    0,    0,    0,    0,    0,    0,
 2703,    0,    0, 1154,    0,    0,    0,    0,    0,    0,
    0,    0,    0,33002,    0,    0,  243,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3299,    0,    0,    0,    0, 2738, 2738,    0,    0,    0,
    0,18120,    0,    0,    0,19860,20208,    0,20556,20904,
    0,    0,    0,    0,    0,    0, 3652, 4005, 4358, 4711,
 5064, 5417, 5770, 6123, 6476, 6829, 7182, 7535, 7888, 8241,
 8594, 8947,18468,18816,21252, 9300, 9653,10006,10359,21600,
10712,11065,11418,11771,12124,12477,12830,19164,13183,13536,
13889,14242,14595,14948,15301,15654,16007,16360,16713,17066,
17419,17772,    0,    0, 2544,    0,    0,    0,  824,    0,
    0,    0,    0,    0,    0,    0,21948, 1293,  210,    0,
19512,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1328,    0,    0,    0,    0,    0,    0,    0,
    0, 2544,    0,    0,    0,    0,    0,43501,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  960,    0,  960,
    0,    0,  517,    0,  818, 1469,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  168,    0,    0,    0,    0,
    0,    0,    0, 2703,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1885,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1346,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1172,    0,  443,    0,    0, 1022,    0,    0,    0,    0,
    0,  590,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1373,    0,    0, 1888, 1313,    0,    0,
    0, 3091,    0,    0,25613,    0,    0,25847,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  522,  585,    0,    0,    0,    0,25861,25601,    0,
25847,    0,    0,   47,    0,  875,    0,    0,    0,    0,
    0,    0, 1086,  875,  533,    0,  130,    0,    0,    0,
    0,    0,    0, 2572,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,36314,36443,36618, 2544,    0, 1739,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2930,  256,34334,    0,34334,    0,    0,
    0,34334,34334,    0,34334,    0,    0,    0,    0,    0,
    0,    0,    0, 2544, 2531,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
34334,    0,23338,23684, 2937,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2942,    0, 1731,    0, 1612, 1622,    0,    0,    0,
25883,    0,    0,    0,    0,  672,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  244, 1381,    0,    0,    0,
 1381, 2544,24673, 2648,    0,    0,    0,    0,    0,    0,
    0,  244,    0,    0, 1435,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  718,    0,
    0,    0,    0, 2554,    0,    0,  243,    0,    0,    0,
    0, 2544,    0, 1086,  875,  533,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  248,    0,    0,    0,35453,
    0, 2676,    0,  316,  898,    0,    0,    0,  673,    0,
    0, 1190,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  692,    0,    0,    0,    0,    0, 2952, 2420,    0,
    0,21614,20222,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  391,  831,
 1072,    0,    0,    0,    0,    0,    0, 1462,    0,    0,
    0,    0,    0,    0,    0, 1898,    0,    0,    0,    0,
    0,25613,    0,    0,    0,    0,  822,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2703,    0,    0,
    0,  245,    0,    0,    0,    0,    0,    0,    0, 2544,
    0,  141, 1086,    0,    0,36740,    0,    0,    0,  232,
    0,    0,    0, 2544,    0, 2544,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2955,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  953, 1078, 1233, 2186,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   86,    0,    0,22296,24030,24376,22644,
22992,    0,    0, 1441,    0,    0,    0, 1907,    0,    0,
    0, 2956,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  847,    0,    0,    0,    0,    0,
    0,    0,    0, 1446,    0,    0,    0,    0,    0,    0,
    0, 2648, 2640,    0,25260, 2669,    0, 2669, 2648,    0,
 2669,    0,    0, 1446,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  256,  398,    0,
    0,    0,    0,    0,    0, 2544, 1086,    0,    0,    0,
    0,    0,    0,    0,24670,    0,  363,    0,    0,    0,
 2523, 2555,    0, 1657,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  672,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1339,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1463,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1465,    0,
    0,    0,    0,    0, 1143,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  875,  533,  672, 2523, 1470, 1086,
    0, 2734,    0,    0,    0, 1477,    0,    0,    0,    0,
    0,    0, 1497,  144,    0,    0,    0,    0,    0,    0,
    0,    0,36740,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2385,    0,
    0,    0,36737,    0, 2544,    0,    0,    0,    0,    0,
    0,36817,    0,36960,    0,36980,    0,    0,    0,    0,
    0,    0,    0,37099,    0,    0,37197,    0,    0,37333,
    0,37455,    0,    0,37490,    0,    0,37548,    0,    0,
 2587,    0, 2930, 1381,    0,    0,42649,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2584,    0,    0,    0,    0,  749,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2964,
 2964,    0, 2970,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  154, 1539,  171,  176,    0,    0,    0,
 1539,    0,    0,    0,    0,    0, 1553,    0,    0,24975,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  134,    0,
  672,    0, 2734,    0,    0, 1477,    0,    0,    0, 3134,
 2362,    0,  754,    0,    0,    0,    0,  991,    0, 2563,
    0,    0,    0,    0, 2017,    0,    0, 1511,    0,    0,
 1339, 2622,    0,    0, 1115, 1148, 1202, 1224, 1228, 1285,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  272,    0,    0,    0,    0,20918,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1559,    0,    0,
  672,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1578,    0, 1609,    0,    0,
    0,    0,    0,  225,    0,    0,    0,    0,    0,    0,
    0, 2544, 2544,    0,    0,    0,    0,    0,    0, 2544,
 2544,    0, 2544, 2544,    0,37692,    0,37724,    0,37754,
 2544, 2544, 2544, 2544,37899, 2544, 2544, 2544, 2544, 2544,
 2544, 1394,    0,    0, 2975,    0,    0,    0,    0, 2976,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2978,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,43797,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1381,30300,    0,    0,    0,    0,
    0, 1648, 1662,    0, 2648,    0,    0,    0, 1381,    0,
    0,    0,    0,    0, 1578,    0,    0,  403,    0,    0,
    0, 1611,    0,    0,    0,    0,    0,    0,    0, 1516,
 1694,    0,    0, 2980,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1667,
  278,    0,    0,    0,    0,    0,    0,    0,    0,  672,
 2734,    0,    0,    0,  279,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  645,
    0,37929,    0,    0,    0,   86,    0,37961,    0,    0,
    0,38104,    0,    0,    0,    0,38198,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2930,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,39420,    0,    0,    0,
    0,    0,    0,    0,    0, 1671,    0,    0, 3081,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2363,    0,
    0,  133,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,21994,    0,    0,    0,    0,  264,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  230,    0,    0,    0,    0,
 2970,38291,    0,    0,    0,    0,38337,38459,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2043,    0, 2983,    0,    0,    0,    0,    0,    0,    0,
    0, 2070,    0,    0,    0,    0,    0,    0,    0,39732,
    0,    0,    0,    0,    0,40698,    0,    0,    0,    0,
    0,38539,    0,  148,    0,    0,    0, 1934, 2718,    0,
 1197,    0,    0,    0,21994, 1520,    0,    0,  153,    0,
    0,    0,    0,    0,    0, 2980,    0,    0,    0,    0,
 2984,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  420,    0,    0,    0, 2721,    0,  223,    0,
    0,    0,    0,    0,    0,    0, 1381,    0,    0, 3127,
    0, 1339, 3510,19526,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2100,    0, 2968,    0,    0,    0,    0,
    0,    0, 1629, 1930,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1757,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2969,    0, 2554,    0,    0,
    0,    0,    0,    0,21994,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2977,    0,    0, 2979,
    0,    0,    0,    0,    0,    0,    0, 2544,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2544,
    0,  156,    0,    0,    0,    0,    0,    0,    0, 2981,
 2989,    0,    0,    0, 2991,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2992,    0, 2993,    0, 2733,
    0,    0,39108,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yycindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2507,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1208,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2999,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2688,    0, 2692,
    0,    0,    0,    0, 3020,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3029, 3030, 3031,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3039,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2559,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2566,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,  879,    0,
    0,  895,  896,  900,    0,    0,    0,    0,    0,-1491,
    0,  905,  909,   -3, 2870, 2390,  -40,-1170, 1479, 2873,
 2080, 2889, 2393,    0,    0, 2722, -114,  -43,    0,    0,
    0,    0, -120, -100,  -65,  -93,  -72, -365, 2727, 2104,
    0,    0,    0,  967,    0,    0,  -55, 1633, -796,  -74,
-1319, 2225, 1936, -427,    0, 1641,    0, 3047, 1948, 1982,
    0,    0,    0, -980,  -56,    0,    0,    0,    0,    0,
    0, 3066,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -70,    0,
 -755, -941, 1651, -736,  848, -177,    0,    0,    0,    0,
 -421, -436,-1576, 1682, -484,  -60,    0, -723, 1985,-1333,
    0,-1052, -392,-1165,    0, 1235,    0, 1260, -476, -835,
  -23,  -62,   13,    0,    0,    0,    0, 1684,    0,    0,
    0,    0,    0,    0,    0, 2652,    0, 2334,    0,    0,
    0, 1772,    0, 2732, -815, 1292, 1711, 2685, 2687,    0,
    0, -504, 2087,    0,  -50, -954, -389,    0,    0,-1054,
-1036,-1026,-1024,-1006,    0, 1300,-1428,    0,  994,-1565,
    0, 2394,    0,    0,    0,  992, 1003,  918, -230, -396,
-1294,-1216,    0,    0,    0, 2122, -793,    0, -898,    0,
 1922, -909,-1488,    0,    0,    0,    0,    0,-1548, -270,
    0,    0,    0,    0,    0,    0,-1007,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,-1208,    0,    0, -968,    0, -965,  989, 1029,    0,
  919,    0,    0,    0,    0,    0,    0,    0, -641,    0,
    0, 2242, -468, -613, 1568, -316, -510, -844,-1256,    0,
    0,    0,  -57,    0,    0,    0,    0,    0, 2743,    0,
    0,    0,    0, 2760, 2433,    0,    0,    0,    0,    0,
   -9, -652,    0,    0, 2805,    0,    0,    0,    9,    0,
    0,    0,    0, -683,    0, -506, 2114, -500, 1563,    0,
    0,    0,    0,    0,    0,-1286,    0,    0,    0, 2446,
    0, 2176,    0,    0,    0,    0,    0,    0, -130,    0,
 3317,    0, 3105,    0,    0,    0, 2916,    0,    0,    0,
    0,    0,    0, 2628,    0, 2613,    0,    0,    0, 2297,
    0,    0,    0, -863,    0, -367,    0,    0,    0,    0,
    0,    5, -908, -880,-1137,   10,    0,  -14, 1323, 3559,
    0,  799,    0,    0,    0,    0,    0,    0, -646,    0,
    0, -989,    0, 2878, 1177,    0, 1977, -966, -890,    0,
 -917, 2342,-1407,    0,    0,    0,    0,    0,    0,    0,
 2025,    0,    0,    0,    0,  200,  222,    0, 1151, 2426,
    0, 1386,    0, 1583,    0, -513,    0,    0, 1988,    0,
    0,-1028, -990,    0, 1504, 1498,    0,    0, 1101,    0,
    0, 2642,    0,    0,    0, 1179, -610, 1199, 1204, 2358,
 2046,-1501,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1100, 1865,
    0,    0,    0, -987,    0,    0,    0, 2822,    0, 2008,
    0,    0,    0,    0,    0, 1805,    0,    0,    0, -639,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,-1426, 1830,    0,
    0,
};
#define YYTABLESIZE 44543
static int yytable[] = {                                     223,
   89,  347,  246,  402,   53,  320,  239,  243,  363,  254,
  342,  391,  358,  986,  338,  784,  787, 1009,  355,  323,
  343,  810, 1086,  326,  240,  382, 1112,  388,  882, 1315,
  879,  351, 1316,  392,  883, 1375,  356,  905,  390,  714,
 1350,  548,  331,  386,  355,  394,  852,  783,  786,  315,
  318, 1410,  322,  325,  239,  330,  333,  387, 1377, 1417,
 1199,  344,  318,  333, 1241,  325,  395,  239,  330, 1411,
  362,  223,  333,  368,  816,  385, 1106, 1378, 1304, 1412,
 1050, 1413,  378,  393,  239,  380,  318, 1215,  378,  333,
  322,  325, 1218,  239,  330,  362,  223,  333,  368, 1414,
  325, 1121,  240, 1564, 1615,  846, 1337,  814, 1031, 1067,
 1028,  389,  777, 1397, 1352,  823, 1333, 1625, 1415, 1211,
  541,  820, 1386, 1393, 1696,  460,  853, 1270, 1675,  172,
 1722, 1456,  832,  866, 1279, 1916, 1009, 1853,  767, 1718,
  173, 1177, 1870,  174,  898,  995,  993,  889,  994,   88,
  996, 1024,  286, 1240,  744,  877, 1826,  457, 1066, 1828,
 1419,  657,  746, 1183, 1462,   88,  670,  830, 1165, 1641,
   54, 1428, 1048,  832,  408,   55,  450,  411, 1118, 1380,
 1517,  406, 1735,  657,  455,  409, 1156, 1431,  172, 1711,
 1157,  832,  866,  286, 1000,  744,  286, 1240, 1503,  173,
 1439, 1905,  174,  746,  451,  670,  889,  402,  453,  400,
  419,  286, 1240,  744,  877,  344,  239,  239,  344, 1388,
  764,  746,  223, 2359,  333,  670,  830,  246,  192,   54,
 2184, 1385,  243, 1616,   55,  240, 1477,  318,  325,  239,
  330,  362,  832,  903,  146,  549,  254,  745, 1907,  553,
  406,  445, 1884,  695,  912,  853, 1076,  782, 1383, 1608,
  505, 1957,  193,  912,  670,   97,  402, 2041,  400, 1913,
   99,  159,   89,  785,  799,   89, 1142,  158,  219, 2371,
  657,  247,  738,  247, 1707, 2296,  110,  192,  745,  110,
  748,  536,  721,  379, 1180, 1594,  657, 2279, 2328, 1234,
  408,  832,  903,  146,  912, 1483,  745,  912,  553,  508,
  298, 1108,  695, 2318,  853,  859, 1101, 1321,  882,  519,
 1123,  193,  912,  736,  883, 2063,  489, 1440, 1483, 1748,
  159,  748, 1105,   68, 1236, 1234,  158,  219, 1296, 1297,
  509,  370,  768, 2280, 1315,  700, 1022, 1316,  708,  748,
  566, 1130,  672, 1749, 2281, 1312,  859, 1237, 1872,  859,
 1322, 1325,  861,  734,  714,  508,   94, 1073, 2096,  852,
 2326, 1643, 2105,  508,  859,  371, 1890,  547,  490, 1616,
  991, 1376, 1143,  742, 1422,  992,  344, 1499, 1653,  344,
  443, 2308,  520,  753,  763,  716,  223,  896, 1560, 1561,
 2003, 1234,  828,  861, 2006,  111,  861, 1938, 1158,  566,
  322,  672, 1238,  510,  239, 1235, 1484, 1446, 1351, 1708,
 2297,  861, 1234, 1613, 1626, 1337,  410, 1671,  752,  755,
 1927,  246,  740,  243, 1144,  800,  243,  759,  408, 1674,
 1591,  896, 2319,  828, 1234, 1958, 1947,  832,  298,  443,
  815, 1235, 2282, 2375,  656,  758,  896, 1425, 1381,  657,
  700,  828,  343, 1583,  831, 2042,  893,  833,  832,  775,
  775, 2040,  847,  896,  849, 1848, 1681, 1943, 1179, 1909,
 2155, 1644, 1913, 1946, 1906, 1948, 1874, 1700, 1701,  902,
  744,  344, 1886, 1887,  894,  911,  737, 1669,  746,  172,
 1234,  344, 1679,  344, 2106,  344,  904, 2177,  836, 1337,
  909,  832, 2185, 1234, 1441, 1880,  705, 1235, 1944,  247,
 1463,  600, 1246,  730, 1658,  192, 1678,  318,  325,  330,
   97, 1889, 1607, 2158, 2327,   99, 1455,  239, 1235,  228,
  908,  239,  322, 1330, 1502,  920,  830, 1455,  159,  720,
 1164,  917, 1023,   87,  158,  830, 1401,  556, 1759,  193,
 1235, 1182,  600,  832,  405,  600,  670, 1337,  781,   87,
 1693, 1677,  192, 1807, 2067,  705,  781,  832, 2135, 1190,
  600,  172,  172,  745,  623,  912, 1486, 1198,  146,  457,
  781,  695,  173,  173,  853,  174,  174,  877, 1240,  744,
 1515, 1046, 1516, 1047,  903,  670,  193,  746,  402, 2219,
  400, 1368,  866,  553,  566,   54, 1235, 1155,  172,  227,
   55,  832,  219,  695, 1402,  623,  748, 2325,  623, 1235,
  859, 1734,  670,   89, 2055, 2056, 2385, 1740,  912, 1436,
 2107,  832, 1620,  623,  286, 2091,  990, 1850,  457,  695,
 1851,  859,  695,  866,  443, 1605, 2298, 2203,  714,  987,
  832,  866,  229, 1188,  172, 2036,  781, 1021,  695, 1019,
  753,  866,  864, 2054, 2346,  889,  830,  861, 1026, 1476,
 1695, 1612,  781, 1876, 1042,  623,  143, 1482,  623, 1063,
 1699,  344,  745,  256,  695,  830, 2313, 2314,  861,  995,
  239,  325,  716, 1647,  996,  172,  755, 1649, 1211,  239,
 1064, 2252, 1652,  864,  325,  239, 1389,  828, 1081, 1368,
  716, 1917,  254,  820, 1852, 1075,   53,  708, 1078, 2333,
 2098,  864,  247,  192,  377,  247, 1648, 1149,  828,  566,
  788,  239,  225, 1885, 1758,  542, 1741, 1102, 1683,  695,
 1435,  832,  247,  823,  738,  912,  239,  850, 1384,  239,
  859, 1337, 1109, 1705,  853,  443, 2344,  193,  344,  695,
  832, 1159, 1676, 1150, 1126, 1234,  896, 1940, 1505,  443,
 1245,  828,  695,  853, 1483,  896, 1626,  542,  355,  788,
  828, 1474, 1160,  230,  823, 1489,  457,  600,  600,  808,
  853,  498,  600,  234,  799,  600,  226,  861,  859,   17,
  344,  808,  823, 1234, 1117,  344, 1145,  715,  600,  809,
 1117,  157,  258, 1032,  859, 1626, 2347,  752, 1891,  789,
  441, 1337, 2386,  828,  257, 2182, 2183, 1187, 2353,  896,
  896,  853, 1371,  859, 1192, 1193,  499,  828,  336,  337,
  739,  542,  343,  457,  705,  143,  143, 2069, 1372,  853,
  623,  623, 1706,  377, 1032,  623, 1966, 1032,  623,  837,
  808,  861, 1151, 1673, 2181, 2021,  715, 2089,  543,  838,
  157,  623, 1032, 1774, 2037,  519,  705,  677, 1509,  441,
  861, 1235,  600,  344, 1929, 1942,  519,  852, 2053, 2173,
 2174, 1268,  235,  542,  740, 1315,  896,  457, 1316,  236,
 1127,  828,  705,  600, 1490,  705, 1032,  623,  259,  600,
 1665,  741,  334, 1274, 1275,  896, 1248,  866, 1306, 1235,
  828,  705,  987, 1321,  991, 1586, 1587, 1146,  852,  992,
  333,  311,  995,  993, 1147,  994,  677,  996,  866,  417,
  623, 1833,  500,  600,  766,  623,  852,  705,  520,  700,
 1491, 1778,  700, 1510,  700,  851, 1338,  334,  987,  520,
  501, 1666, 1000, 2190, 1448, 1449,  623, 1831, 2059, 1689,
 1626,  368,  623, 1317,  537,  839, 1128,  864,  247,  808,
  865,  344,  623, 1724, 1262, 1262, 1201, 1262, 1262, 1262,
 1021, 1492, 1365,  344,  502,  344,  261,  344,  864, 1779,
 1410, 1410,  705, 1175,  716,  753,  623,  742,  700, 1374,
  901, 1614,  325,  343,  431, 1368, 1129, 1081, 1411, 1411,
 1337,  865,  705,  239,  325,  319,   53, 1626, 1412, 1412,
 1413, 1413, 1725, 1262, 1400,  705,  623,  334,  239,  865,
  239,  755, 1188, 1188, 1416,  344, 1736,  866, 1414, 1414,
  759, 1276,  700, 1766,  344, 1432, 1709, 1928,  823,  538,
 1936,  442, 2172, 1588,  775, 1505,   53, 1415, 1415, 1176,
  823,  600,  355,  431, 1929, 2111, 2356, 1996,  350,  823,
 1433,  674, 1767, 1437,  441, 1445, 2092,  157,  157,  519,
   87,  623, 1710,  344,  539, 2071, 1452, 2345, 1471, 1472,
 1473, 2072, 1460,  708,  448,  853,  310,  864, 1724, 1263,
 1263, 1202, 1263, 1263, 1263,  355,  355,  355,  336,  337,
  442,  344,  823,  431,  344, 1080,  853, 2357, 1488, 1811,
  866,  823,  334,  431,  623, 2073,  369,  449, 1475, 2366,
  674, 2368,  343, 2370,  920,  715, 2286, 1189, 1733, 1032,
 1453, 2351, 2352, 1500,  708, 2380,  396, 1727, 1263, 2065,
 2066,  545,  520,  448, 1867, 1867, 1871,  991,  373,  239,
 1528, 1626,  992, 1750,  823,  676,  598,  715,  663,  210,
 1188,  368,  157,  344,  239, 2257,  827,  136,  823, 2334,
  864,  445,  920, 1514,   53,  441,  449, 1751,  917,  464,
  465, 2162,  852,  715,  781,  545,  715, 2103,   53,  441,
   53,  461, 1941,  444, 1032, 2171, 2293,  447, 1529, 1262,
  545,  136,  715,  852, 1262,  598, 1538,  827, 2335,  336,
  337, 1367,  659,  375,  676,  853, 2052,  663,  210,  431,
 1539, 1530, 1902, 1101, 1904,  827, 1595, 1704,  715, 2331,
  445,  383,  823, 1855, 1621,  136, 1858,  403,  464,  465,
  333,  794, 1410, 1410, 1308, 1308, 1199, 1308, 1308, 1308,
  461,  823,  444,  431,  446, 2336,  447,  781,  431,  201,
 1411, 1411,  405,  431, 1540, 1356,  753,  700, 1317, 1945,
 1412, 1412, 1413, 1413,  882,  865,  879, 1743, 1357,  853,
  883,  795,  633,  715, 1447,  513,  344,  368,  514,  398,
 1414, 1414, 1541, 1308, 1213, 1051,  865,   45,  853,  716,
  716, 1358,  755,  715, 1081,  442,  343,  399,  281, 1415,
 1415,  554,  852,  446,  425,  555,  715, 1315,  201,  559,
 1316,  405,  633,  633, 1263,  700,  633, 2209,  700, 1263,
  515,  272,  788, 1257, 1258, 1259, 1260, 1261, 1262, 1263,
 1264,  633,  202,  633,  700, 2022,  404,  344,  448,  281,
  892, 1361,  281,  759,  325, 1542,   45,  336,  337, 1315,
   53, 1315, 1316, 1315, 1316, 1728, 1316,  281,  788,  431,
  700,  272, 1242,  633,  555, 1315,  852, 2215, 1316,  407,
 1213,  449,  355,  431,  788, 1262, 1262, 1262, 1262, 1262,
 1262, 1262, 1262,  995,  993,  852,  994, 1761,  996,  343,
 1213,  202,  412, 1765,   49,  865, 2075, 1753, 1250,  892,
  403,  908,  965, 1742,  355,  908,  442,  210,  490,  708,
  355,  991, 1714,  811, 1252,  700,  992,  413,  908,  210,
  442,  219,  568, 1713,  623,  445,  812, 1009,  696,  148,
  344,  441, 1265, 2342,  239,  700,  419,  272,  995,  993,
 1726,  994, 1213,  996,  420, 1030,  210,  444,  700,  448,
  344,  447,  210,   49,  210,   17,  186, 1893, 1266,  403,
  983,  984,  985,  448,  908,  623, 1812,  442,  623, 1308,
  260,  827, 2363, 1356, 1308,  247,  343,  272,  865,  912,
  219,  568,  449,  623, 1262,  623, 1357,  696,  148, 1136,
  112, 1137,  827,  210, 1924,  419,  449,  444,   43, 1859,
 1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263,  446, 1358,
 1262,  260,  890,  239,  260,  186,  247,  344,  149,  247,
  912, 1860, 1359,  912,  446, 1857, 1867, 1950,  113,  260,
  633, 1802,  700, 1899,  247,  827,  445,  228,  912, 1656,
  114,  447, 1659, 1900,  827,  633, 1856,  633,  633,  633,
  445,  788, 1097,  633, 1098,  788,  633,   43,  444, 1361,
 1014, 1317,  447, 1013,  115,  144,  144,  344,  137,  633,
  219,  890,  444,  344,  459,  633,  447,  149,  633,  716,
  325,  330,  716,  362,  223,  995,  993,  827,  994, 1087,
  996, 1255, 1088, 1892,  492, 1299,  228, 1090, 1878,  481,
 1094,  827, 1991,  243, 1099, 1018,  493,  873, 1017, 1263,
  325,  325,  247,  716,  716,  247,  211,  482,  991,  446,
  633,  874,  586,  992,  239,  586,  247,  137,  116,  219,
  891,  511,  247,  446, 1242, 1263, 1992,  522,  117,  494,
  586,  495,  586,  633,   91,   92, 1242,  378, 1993, 1242,
 1951,    4,    7,  261,  210, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308,  118,  633,  827,  873, 1956, 1362,  523,
  633, 1926, 1961,  991,  633,  211, 2057, 2304,  992, 2305,
  874,  633,  623, 2372,  827,  247,  843, 2064,  525,  891,
 1071, 2068, 1114, 1070,  261, 1113, 2077,  261,  829,  633,
  623,  623, 2031, 2033,  633,  623,  995,  993,  623,  994,
  526,  996,  261,  534,  995,  993,  545,  994,  219,  996,
  843,  623, 2032, 2034,  550, 2094, 2095,  623, 2097,  633,
 2099, 1241,  843,  633, 1241, 1217, 2202,  995,  993,  829,
  994, 1303,  996,  527, 1000,  528,  272,  260, 2020, 1241,
 1348, 1241,  239, 1347, 1244,  912,  912,  829, 1249,  551,
  113, 1254, 1227,  912, 1308,  219,  696,  529, 1399, 1269,
 1802, 1271,  552,  219, 1223, 1277, 1278, 1213,  917, 1281,
 1282, 1283, 1284, 1285, 1289, 1295,  555, 1298, 1481, 1301,
 1308, 1480,  530,  556, 1501,  623,  115, 1207,  696, 1307,
 1308, 1309, 1310, 1311,  659,  917,  219, 1318,  219,  659,
  659,  709,  705,  716,  716,  917,  623,  711,  719, 1317,
  991, 2038,  623, 2015,  696,  992,  243,  696,  219,  325,
  219,  724,  633,  623, 2078,  247, 2165, 2166, 2167, 2206,
  219,  272, 1619,  696,  559, 1000,  325,  621,  725, 1624,
  912,  623, 1623,  726,  912,  219,  623,  618,  586,  727,
  116, 2093,  272,  728,  729,  239, 1033,  219,  272,  696,
  117,  912,  731,  219,  211,  219, 1379,  912,  586, 2358,
 1672, 1716,  733, 1480, 1715,  623,  211, 1721,  621,  735,
 1720,  621,  239,  826, 2132,  118, 2131, 1756,  618,  746,
 1480,  618,  272,  559,  343,  747,  621, 1033,  621, 1849,
 1033,  912, 1616,  211,  219,  748,  618,  749,  618,  211,
  248,  211,  219, 2179,  696, 1033,  219,  762, 2151,  272,
  261,  751,  769, 1875,  826, 1247, 1000,  826,  343, 1877,
  239,  991, 1000,  322,  696,  344,  992, 1247,  379,  991,
 1247,  249,  826, 1895,  992,  250, 1480,  696, 1802, 1033,
  211,  770,  772, 2225, 2226, 2227,  251, 1241, 2230,  773,
 1965,  912,  991, 1000, 1602,  995,  993,  992,  994, 2156,
  996,  774, 2180, 2008,  623,  814, 1000, 1241,  778,  780,
  219, 2176,  995,  993,  793,  994, 2019,  996,  804, 2018,
 2374, 1577,  995,  993,  797,  994, 2164,  996, 2187, 1000,
 2201,  805, 2189,  829, 2349, 2291, 2378,  309, 1017, 1000,
  309, 2220,  239,  829,  272,  829, 1518, 1519, 1523,  322,
  813, 1532, 1534, 1536,  829, 1544, 1547, 1550, 1552, 1555,
 1558,  818,  829,  851,  814,  272,  851,  832,  843, 1565,
 1566,  272, 1568,  806, 1570,  844, 2373, 1573, 1574, 1575,
 1576, 1241, 1578, 1579,  995,  993, 2383,  994, 2384,  996,
 1189, 2387,  708, 1189, 2388,  219,  848,  829,  899, 1584,
  322, 1589, 1243,  903, 1247,  272,  829,  252, 1251, 1253,
  906, 1256,  912,  995,  993,  944,  994, 1604,  996,  949,
 1190,  344,  559, 1190,  946,  621, 1610, 1611,  578,  579,
  580,  947,  753,  344,  559,  618,  948, 1300,  957,  950,
  951,  211,  621,  621,  621, 2307,  952,  953,  621,  829,
  955,  621,  618,  618,  618,  956,  588,  589,  618,  958,
  959,  618,  962,  829,  621,  968,  969,  559,  755,  559,
  621,  970,  659, 2276,  618,  971,  659,  972,  973,  974,
  618,  659,  975,  976,  977,  978,  979,   53,  980, 2321,
  981,  995,  993,  982,  994,  997,  996,  998, 1000, 1002,
 1003,  322, 1001,  322, 1015, 1016,  318, 1331, 1331, 1200,
 1331, 1331, 1331, 1012, 2312, 1514, 1514, 1027, 1053,  753,
 1044, 1058, 1033, 1090, 1055, 1094, 1688,  829,  826, 1059,
  991, 1062, 1065, 1069, 1072,  992, 1074, 1077,  621, 1083,
  826, 1084, 1100,  799, 1103,  808,  829,  991,  618,  826,
  318, 2323,  992, 1110, 1115,  755, 1331,  991, 2324,  621,
 1140, 1141,  992, 1153, 1161,  621,  781, 1162, 1167,  618,
 1601, 1168, 1169, 1170,  621,  618,  621, 1173, 1782, 1172,
 1178, 1317, 1184, 1185, 1191, 1514,  618, 1033, 1201, 1391,
  995,  993,  826,  994,  621,  996, 1203, 1582, 1206,  621,
 1204,  826,   53, 1533,  618, 1537, 1207, 1545, 1548,  618,
 1553, 1556, 1559, 1213,   53, 1214, 1212, 1216, 1280,  991,
 1272,  489, 1305, 1317,  992, 1317, 1326, 1317,  621, 1327,
 1329, 1179,  657, 1339, 1340, 1341, 1345, 1349,  618, 1317,
 1343,  784,  785, 1354,  826, 1024,  721, 1369,  991,   17,
 1382, 1514,  659,  992, 1387, 1390, 1017, 1394,  826, 1837,
 1396, 1398, 1406, 1420,  980, 1785, 1786, 1427, 1788, 1790,
 1429, 1430, 1421, 1434, 1451, 1442, 1795, 1443, 1444, 1458,
 1470, 1478,  784,  785,  814,  784,  785, 1468, 2026, 1508,
 1525, 1563, 1571,  814, 1562, 1569, 1581, 1580, 1816, 1298,
  784,  785, 1606, 1616, 1821,  980,  991, 1824,  980, 1825,
 1589, 1617, 1618, 1589,  814, 1584, 1356, 1622, 1642, 1832,
  659, 1834,  826,  980, 1650, 1645,  991,  621, 1835, 1357,
 1836,  992, 1651, 1839, 1840, 1841, 1842,  618, 1654, 1847,
 1298,  826, 1331, 1298, 1660, 1663, 1668, 1331,  814, 1664,
  995,  993, 1358,  994, 1670,  996,  782, 1976, 1298,  782,
 1661,  782,  782,  782,  782, 1359,  782, 1682, 1690, 1685,
 1697, 1702, 1483, 1360,  782,  782,  995,  993, 1717,  994,
 1719,  996, 1723, 1729, 1730,  782,  782, 1731,  782,  782,
  782, 1732, 1744, 1746, 1752,  782,  782,  814,  782,  782,
 1747,  782, 1361, 1502,  782,  782,  782,  782,  782,  782,
  782, 1763, 1769, 1768,  814,  782,  782,  782, 1770,  782,
  782,  782, 1772,  782, 1773,  991, 1914, 1777, 1780, 1781,
  992, 1783, 1784, 1791,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782, 1792,  782,  782,  782,  782,  782,
  782, 1793,  782,  782,  782,  782,  928,  782, 1794,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782, 1796,  782,  782,
  782,  782, 1797,  782,  782,  782,  782,  782, 1962,  782,
  782,  782,  782,  782, 1968, 1798,   70,  928, 1799, 1972,
  928, 1362, 1800, 1801, 1234, 1830, 1977,   71, 1827, 1854,
 1838, 1861, 1863, 1864,   72,  928,  980, 1879, 1331, 1331,
 1331, 1331, 1331, 1331, 1331, 1331, 1888,   73, 2200,  995,
  993, 2199,  994, 1896,  996, 1897, 1903, 1392,  995,  993,
  824,  994, 1915,  996, 1589, 1925,  784,  785, 1589, 1939,
 1918, 1919, 1920, 1921, 2012, 2013,  784,  785,  784,  785,
 1922, 1923, 1455, 1949, 1952, 1298, 1298,  784,  785,  980,
  819,  819,  980, 1298, 1954,  991, 1955, 1960, 1967,  980,
  992,  980, 1969,   74, 1989,  980, 1298,  822, 1990,  370,
  980, 1997, 1995,  980, 2005, 2004, 1572,  995,  993,   75,
  994,  991,  996, 2024, 2025,  659,  992, 1028,  980, 2027,
  784,  785, 2030, 2001, 2028,   76, 2079, 2035, 2043,  784,
  785,  980, 2045,  371, 2060, 2080, 2061, 1331,  822,  980,
   77, 2081,  980,  980,   78,  995,  993,   79,  994, 2083,
  996, 2082,  980, 2084, 2085,   80,  822, 2086, 1028, 1028,
 1028, 1028, 1028, 1331, 1028, 2087, 2088, 2100,  980, 2101,
 1298, 2109,  784,  785,   81, 2102, 1028, 1028, 1028, 1028,
 2104, 2108, 2110, 2113,  784,  785,  784,  785, 2114, 2115,
  980, 1298, 2116, 2119, 2120,  980, 2112, 1298, 2121, 2122,
 2123, 2124, 2117, 2118, 2125, 2126,  980,  980, 2127,  980,
 1028, 1302,  995,  993, 2128,  994, 2130,  996, 2134, 2160,
 2161, 1596,  995,  993, 2157,  994, 2041,  996, 2133, 2042,
   82, 1298, 1589,   83, 2163, 2175, 2136, 2178, 2188, 2193,
 2204, 2139, 2140, 2141, 2142, 2143, 2205, 2210, 2211, 2212,
  784,  785, 2218, 2144, 2213, 2221,  980, 1597,  995,  993,
 2232,  994, 2228,  996, 2216, 2229, 2231, 2233, 2287,  784,
  785, 2288, 2290,  980,  991, 2299,   84,  980, 2301,  992,
 2303,  928, 2309,  991,  928,  226, 2316, 2168,  992, 2317,
 2320,  928,  980,  928, 2330, 2297, 2296,  928,  995,  993,
 2339,  994,  928,  996, 2348,  928, 1066, 2354, 2355, 2361,
 1598,  995,  993, 2360,  994, 2364,  996, 1599,  995,  993,
  928,  994, 2362,  996, 2365, 2367, 2377, 2379, 2381, 2382,
 2186,  752,    1,  928,  859,   31,   33,  786,  753,  795,
  231,  928,  991,  912,  928,  928,  300,  992, 1206,  838,
  786,  189, 1187,   84,  928, 1600,  995,  993,  786,  994,
 1032,  996, 1031, 1808,  995,  993,  819,  994,  917,  996,
  928,  243,  775,  786,  837, 1028, 1030,  457,  421, 1028,
  991, 1028, 1028,  216, 1085,  992,  786,  821, 1028, 1186,
  866,  217,  928, 1028, 1028,  839, 1241,  928, 1158, 1028,
  416, 1028, 1028, 1157,  848,  328,  360,  322,  928,  928,
  422,  928,  822,  382,    0,  358, 1028,  368,   13,  359,
 1028, 1028, 1028,  786,  822, 1028, 2234,  361, 2235,  369,
  364,  397, 1028,  822, 1028, 1028,  423,   16, 1028,  424,
   10,   16, 1028,   19, 1028, 2168, 1028,  991, 1028,   21,
   24,   27,  992, 1028, 1028,  425, 1028,  991,  928,   31,
  795, 2248,  992, 1809,  995,  993,   33,  994, 2310,  996,
  634, 1028, 1028,   37, 1028,  928,  822, 2249, 2250,  928,
  414,  426, 2251,  415, 1028,  822, 1028, 2253, 1028, 1028,
 1028, 2254, 1028,  991,  928, 1028, 1028, 1043,  992, 1865,
  416,  795, 1045, 1366,  795, 1028,  286, 1342,  718, 1028,
  634,  634,  717,  783,  634, 1028, 1205, 1764, 1028,  795,
  442, 1028, 1507, 1762,  384, 1454, 1028,  365,  822,  634,
 1760,  634,  786,  991, 2340, 2341,  427, 1028,  992, 1512,
 1738, 1464,  822, 1028, 1028, 2090,  991,  286, 1028, 1028,
  286,  992, 2074,  991,  783, 1692,  428, 1755,  992, 1028,
 1028,  634, 1028,  856,  765,  286, 2058, 1163, 1028,  429,
 1739, 1028,  783, 1028, 1028, 1028, 1028,  826, 1028,  827,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 2369, 1426,
 2070,  991,  659, 2295, 2338, 2302,  992, 1028, 1028,  991,
 1028, 1028, 1028, 1135,  992, 2300,  822, 1028, 1028, 1028,
 1028, 1028, 2311, 1028, 1418, 2285, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1894, 2350,  822, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1331, 1028, 1627, 1814,  995,  993,
  834,  994,  817,  996, 1139, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1937, 1028, 1028, 1028,
 1028, 1028, 1028, 1469, 1028, 1028, 1028, 1028, 1234, 1028,
  807, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,  991,
 1028, 1028, 1028, 1028,  992, 1028, 1028, 1028, 1028, 1028,
  233, 1028, 1028, 1028, 1028, 1028, 1186,  418, 1208, 1234,
 1234, 1234, 1234, 1234, 1234, 1234,  750, 1461,  634, 1815,
  995,  993, 1057,  994, 1370,  996, 1234, 1234, 1234, 1234,
 1234, 2159, 1052,  634,  792,  634,  634,  634, 2294, 1239,
   58,  634, 1684, 1353,  634, 2129, 1817,  995,  993, 2044,
  994,   59,  996, 1657, 1988, 1687, 2046,  634,   60, 1234,
 2332, 1234,   61,  634, 2292,  795,  634, 1068,  795, 1364,
 1356, 2277,  286,  286, 1787,  795, 2278,  795,  961, 1662,
  286,  795,   62, 1357, 1694, 1846,  795, 1829,    0,  795,
    0, 1818,  995,  993,    0,  994,    0,  996,    0,    0,
    0,    0,    0,    0,  795,    0, 1358,    0,  634, 1819,
  995,  993,    0,  994,    0,  996,    0,  795,  783, 1359,
    0,    0,    0,    0,    0,  795,    0, 2047,  783,  795,
  783,  634,    0,    0,    0,    0,    0,    0,  795,  783,
    0,    0,    0,   63,    0,    0,    0,    0,    0, 1820,
  995,  993,  634,  994,  795,  996, 1361,    0,  634,    0,
    0,    0,  634,  991,    0,    0,    0,  286,  992,  634,
    0,    0,    0,    0,   64,    0,    0,    0,   65,  282,
    0,  795,  783,    0,    0,    0,    0,  634,  286,    0,
    0,  783,  634,  795,  286,  795,    0,    0,    0,    0,
    0,    0,    0, 1822,  995,  993,    0,  994,    0,  996,
    0,    0,    0,    0,    0,    0,    0,  634,    0,    0,
  282,  634,    0,  282,    0,    0,    0,    0,  286,    0,
 1234,    0, 1234, 1234,  783,    0,    0,    0,  282, 1234,
    0,    0,  795,    0, 2048, 1234,  783,    0,  783,    0,
 1234,    0,    0, 1234,    0,  991,    0,    0,    0,  795,
  992,    0,    0,  795,   66, 1362,    0, 1234,    0,    0,
    0,    0, 1234, 1234,    0,    0, 1234,    0,  795,    0,
    0,    0,  991, 1234,    0, 1234, 1234,  992,  286, 1234,
    0,    0,    0, 1234,    0, 1234,    0, 1234,    0, 1234,
    0,    0,    0,    0, 1234, 1234,    0, 1234,    0,    0,
    0,    0,  783,    0,    0,    0,    0,    0,    0,    0,
  634, 1274, 1234, 1234,    0, 1234,    0,  991,    0,    0,
    0,  783,  992,  995,  993, 1234,  994, 1234,  996, 1234,
 1234, 1234,    0, 1234,    0,  991, 1234, 1234,    0,    0,
  992,    0,    0, 1823,  995,  993, 1234,  994,    0,  996,
    0, 1101, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1234,
    0,    0, 1234,  995,  993, 1592,  994,    0,  996, 1274,
 1274, 1274, 1274, 1274,    0,  991,    0,    0, 1234,    0,
  992,    0,    0,    0, 1234, 1234, 1998,  995,  993, 1234,
  994,    0,  996,    0,    0,    0,    0,    0,    0,    0,
 1234, 1234, 1274, 1234, 1274,    0,    0,    0,    0, 1234,
    0,    0, 1234,    0, 1234, 1234, 1234, 1234,    0, 1234,
    0, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,  991,
    0, 1999,  995,  993,  992,  994,    0,  996, 1234, 1234,
    0, 1234, 1234, 1234,    0,  282,  282,    0, 1234, 1234,
 1234, 1234, 1234,  282, 1234,    0,    0, 1234, 1234, 1234,
 1234, 1234, 1234, 1234,    0,    0,    0, 1234, 1234, 1234,
 1234, 1234, 1234, 1234, 1234,    0, 1234, 2000,  995,  993,
    0,  994,    0,  996,    0,    0, 1234, 1234, 1234, 1234,
 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
 1234, 1234, 1234, 1234, 1234, 1234, 1234,    0, 1234, 1234,
 1234, 1234, 1234, 1234,    0, 1234, 1234, 1234, 1234,    0,
 1234,    0, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234, 1234,
  282, 1234, 1234, 1234, 1234, 1567, 1234, 1234, 1234, 1234,
 1234,    0, 1234, 1234, 1234, 1234, 1234,    0,  991,    0,
    0,  282,    0,  992,    0,    0,    0,  282,    0,    0,
    0,    0,    0, 1274,    0, 1274, 1274,    0,    0,  991,
    0,    0, 1274,    0,  992,    0,    0,    0, 1274,    0,
    0,    0,    0, 1274,    0,    0, 1274,    0,  991,    0,
    0,  282,    0,  992,    0,    0,    0,    0,    0,    0,
 1274,    0,    0,    0,    0, 1274, 1274,    0,    0, 1274,
    0,    0,  991,    0,    0,    0, 1274,  992, 1274, 1274,
    0,    0, 1274,    0,    0,    0, 1274,    0, 1274,    0,
 1274,    0, 1274,    0,    0,    0,    0, 1274, 1274,    0,
 1274,    0, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264,
    0,  282,    0,    0, 1276, 1274, 1274,  991, 1274,    0,
    0,    0,  992,    0,    0, 2007,  995,  993, 1274,  994,
 1274,  996, 1274, 1274, 1274,    0, 1274,    0,    0, 1274,
 1274, 2010,  995,  993,    0,  994,    0,  996,    0, 1274,
    0,    0,    0,    0, 1102, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1274,  991,    0, 1274,    0,    0,  992,    0,
    0,    0, 1276, 1276, 1276, 1276, 1276,  995,  993, 1593,
  994, 1274,  996,    0,    0,    0,    0, 1274, 1274, 2011,
  995,  993, 1274,  994,    0,  996,    0,    0,    0,    0,
    0,    0,    0, 1274, 1274, 1276, 1274, 1276,    0,    0,
    0, 1265, 1274,    0,    0, 1274,    0, 1274, 1274, 1274,
 1274,    0, 1274,    0, 1274, 1274, 1274, 1274, 1274, 1274,
 1274, 1274,    0,    0, 2137,  995,  993, 1266,  994,    0,
  996, 1274, 1274,    0, 1274, 1274, 1274,    0,    0,    0,
    0, 1274, 1274, 1274, 1274, 1274,    0, 1274,    0,    0,
 1274, 1274, 1274, 1274, 1274, 1274, 1274,    0,    0,    0,
 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,    0, 1274,
 2138,  995,  993,    0,  994,    0,  996,    0,    0, 1274,
 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
    0, 1274, 1274, 1274, 1274, 1274, 1274,    0, 1274, 1274,
 1274, 1274,    0, 1274,    0, 1274, 1274, 1274, 1274, 1274,
 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274, 1274,
 1274, 1274, 1274,    0, 1274, 1274, 1274, 1274,    0, 1274,
 1274, 1274, 1274, 1274,    0, 1274, 1274, 1274, 1274, 1274,
    0,  991,    0,    0,    0,    0,  992,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1276,  991, 1276, 1276,
    0,    0,  992,    0,    0, 1276,    0,    0,    0,    0,
    0, 1276,    0,    0,    0,    0, 1276,    0,    0, 1276,
 2195,  995,  993,    0,  994,    0,  996,    0,    0,    0,
    0,    0,  991, 1276,    0,    0,    0,  992, 1276, 1276,
    0,    0, 1276,    0,    0,  991,    0,    0,    0, 1276,
  992, 1276, 1276,    0,    0, 1276,    0,    0,    0, 1276,
    0, 1276,    0, 1276,    0, 1276,    0,    0,    0,    0,
 1276, 1276,    0, 1276,    0,    0,    0,    0,    0,    0,
 2196,  995,  993,    0,  994,    0,  996, 1278, 1276, 1276,
  991, 1276,    0,    0,    0,  992,    0,    0, 2197,  995,
  993, 1276,  994, 1276,  996, 1276, 1276, 1276,    0, 1276,
    0,    0, 1276, 1276, 2198,  995,  993,    0,  994,    0,
  996,    0, 1276,    0,    0,    0,    0, 1103, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1276,  991,    0, 1276,  995,
  993,  992,  994,    0,  996, 1278, 1278, 1278, 1278, 1278,
  995,  993, 1609,  994, 1276,  996,    0,    0,    0,    0,
 1276, 1276, 2306,  995,  993, 1276,  994,    0,  996,    0,
    0,    0,    0,    0,    0,    0, 1276, 1276, 1278, 1276,
 1278,    0,    0,    0,    0, 1276,    0,    0, 1276,    0,
 1276, 1276, 1276, 1276,    0, 1276,    0, 1276, 1276, 1276,
 1276, 1276, 1276, 1276, 1276,    0,    0,    0,  995,  993,
 1844,  994,    0,  996, 1276, 1276,    0, 1276, 1276, 1276,
    0,    0,    0,    0, 1276, 1276, 1276, 1276, 1276,    0,
 1276,    0,    0, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
    0,    0,    0, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276,    0, 1276,    0,  995,  993,  991,  994,    0,  996,
    0,  992, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1276,    0, 1276, 1276, 1276, 1276, 1276, 1276,
    0, 1276, 1276, 1276, 1276,    0, 1276,    0, 1276, 1276,
 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1276, 1276, 1276, 1276,  991, 1276, 1276, 1276,
 1276,  992, 1276, 1276, 1276, 1276, 1276,    0, 1276, 1276,
 1276, 1276, 1276,    0,  991,    0,    0,    0,    0,  992,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1278,
  991, 1278, 1278,    0,    0,  992,    0,    0, 1278, 1771,
    0,    0,    0,    0, 1278,    0,    0,    0,    0, 1278,
    0,    0, 1278,    0,  991,    0,    0,    0,    0,  992,
    0,    0,    0,    0,    0,  991, 1278,    0,    0,    0,
  992, 1278, 1278,    0,    0, 1278,    0,    0,  991,    0,
    0,    0, 1278,  992, 1278, 1278,    0,    0, 1278,    0,
    0,    0, 1278,    0, 1278,    0, 1278,    0, 1278,    0,
    0,    0,    0, 1278, 1278,    0, 1278,    0,    0,    0,
    0,    0,    0,    0,  995,  993, 2009,  994,    0,  996,
 1279, 1278, 1278,  991, 1278,    0,    0,    0,  992,    0,
    0,    0,    0,    0, 1278,    0, 1278,    0, 1278, 1278,
 1278,    0, 1278,    0,    0, 1278, 1278,    0,  995,  993,
 2014,  994,    0,  996, 1975, 1278,    0,    0,    0,    0,
 1104, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1278,  991,
    0, 1278,    0,    0,  992,    0,    0,    0, 1279, 1279,
 1279, 1279, 1279,  995,  993, 2016,  994, 1278,  996,    0,
    0,    0,    0, 1278, 1278,    0,    0,    0, 1278,  995,
  993, 2017,  994,    0,  996,    0,    0,    0,    0, 1278,
 1278, 1279, 1278, 1279,    0,    0,    0,    0, 1278,    0,
    0, 1278,    0, 1278, 1278, 1278, 1278,    0, 1278,    0,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1278, 1278,    0,
 1278, 1278, 1278,    0,    0,    0,    0, 1278, 1278, 1278,
 1278, 1278,    0, 1278,    0,    0, 1278, 1278, 1278, 1278,
 1278, 1278, 1278,    0,    0,    0, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278,    0, 1278,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1278, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278,    0, 1278, 1278, 1278,
 1278, 1278, 1278,    0, 1278, 1278, 1278, 1278,    0, 1278,
    0, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,  991,
 1278, 1278, 1278, 1278,  992, 1278, 1278, 1278, 1278, 1278,
    0, 1278, 1278, 1278, 1278, 1278,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1279,  991, 1279, 1279,    0,    0,  992,    0,
    0, 1279,    0,    0,    0,    0,    0, 1279,    0,    0,
    0,    0, 1279,    0,    0, 1279,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  991, 1279,
    0,    0,    0,  992, 1279, 1279,    0,    0, 1279,    0,
    0,    0,    0,    0,  991, 1279,    0, 1279, 1279,  992,
    0, 1279,    0,    0,    0, 1279,    0, 1279,    0, 1279,
    0, 1279,    0,    0,    0,    0, 1279, 1279,    0, 1279,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1280, 1279, 1279,    0, 1279,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1279,    0, 1279,
    0, 1279, 1279, 1279,    0, 1279,    0,    0, 1279, 1279,
    0,    0,    0,    0,    0,    0,    0,    0, 1279,    0,
    0,    0,    0, 1105, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1279,    0,    0, 1279,    0,    0,    0,    0,    0,
    0, 1280, 1280, 1280, 1280, 1280,    0,    0,    0,    0,
 1279,    0,    0,    0,    0,    0, 1279, 1279,    0,    0,
    0, 1279,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1279, 1279, 1280, 1279, 1280,    0,    0,    0,
    0, 1279,    0,    0, 1279,    0, 1279, 1279, 1279, 1279,
    0, 1279,    0, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1279, 1279,    0, 1279, 1279, 1279,    0,    0,    0,    0,
 1279, 1279, 1279, 1279, 1279,    0, 1279,    0,    0, 1279,
 1279, 1279, 1279, 1279, 1279, 1279,    0,    0,    0, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0, 1279,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0,
 1279, 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279,
 1279,    0, 1279,    0, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279,    0, 1279, 1279, 1279, 1279,    0, 1279, 1279,
 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279, 1279,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1280,    0, 1280, 1280,    0,
 1963, 1964,    0,    0, 1280,    0,    0,    0, 1970, 1971,
 1280, 1973, 1974,    0,    0, 1280,    0,    0, 1280, 1978,
 1979, 1980, 1981,    0, 1982, 1983, 1984, 1985, 1986, 1987,
    0,    0, 1280,    0,    0,    0,    0, 1280, 1280,    0,
    0, 1280,    0,    0,    0,    0,    0,    0, 1280,    0,
 1280, 1280,    0,    0, 1280,    0,    0,    0, 1280,    0,
 1280,    0, 1280,    0, 1280,    0,    0,    0,    0, 1280,
 1280,    0, 1280,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1281, 1280, 1280,    0,
 1280,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1280,    0, 1280,    0, 1280, 1280, 1280,    0, 1280,    0,
    0, 1280, 1280,    0,    0,    0,    0,    0,    0,    0,
    0, 1280,    0,    0,    0,    0, 1106, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1280,    0,    0, 1280,    0,    0,
    0,    0,    0,    0, 1281, 1281, 1281, 1281, 1281,    0,
    0,    0,    0, 1280,    0,    0,    0,    0,    0, 1280,
 1280,    0,    0,    0, 1280,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1280, 1280, 1281, 1280, 1281,
    0,    0,    0,    0, 1280,    0,    0, 1280,    0, 1280,
 1280, 1280, 1280,    0, 1280,    0, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1280, 1280,    0, 1280, 1280, 1280,    0,
    0,    0,    0, 1280, 1280, 1280, 1280, 1280,    0, 1280,
    0,    0, 1280, 1280, 1280, 1280, 1280, 1280, 1280,    0,
    0,    0, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
    0, 1280,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280,    0, 1280, 1280, 1280, 1280, 1280, 1280,    0,
 1280, 1280, 1280, 1280,    0, 1280,    0, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280,    0, 1280, 1280, 1280, 1280,
    0, 1280, 1280, 1280, 1280, 1280,    0, 1280, 1280, 1280,
 1280, 1280,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1281,    0,
 1281, 1281,    0,    0,    0,    0,    0, 1281,    0,    0,
    0,    0,    0, 1281,    0,    0,    0,    0, 1281,    0,
    0, 1281,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1281,    0,    0,    0,    0,
 1281, 1281,    0,    0, 1281,    0,    0,    0,    0,    0,
    0, 1281,    0, 1281, 1281,    0,    0, 1281,    0,    0,
    0, 1281,    0, 1281,    0, 1281,    0, 1281,    0,    0,
    0,    0, 1281, 1281,    0, 1281,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1282,
 1281, 1281,    0, 1281,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1281,    0, 1281,    0, 1281, 1281, 1281,
    0, 1281,    0,    0, 1281, 1281,    0,    0,    0,    0,
    0,    0,    0,    0, 1281,    0,    0,    0,    0, 1107,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1281,    0,    0,
 1281,    0,    0,    0,    0,    0,    0, 1282, 1282, 1282,
 1282, 1282,    0,    0,    0,    0, 1281,    0,    0,    0,
    0,    0, 1281, 1281,    0,    0,    0, 1281,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1281, 1281,
 1282, 1281, 1282,    0,    0,    0,    0, 1281,    0,    0,
 1281,    0, 1281, 1281, 1281, 1281,    0, 1281,    0, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1281, 1281,    0, 1281,
 1281, 1281,    0,    0,    0,    0, 1281, 1281, 1281, 1281,
 1281,    0, 1281,    0,    0, 1281, 1281, 1281, 1281, 1281,
 1281, 1281,    0,    0,    0, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281,    0, 1281,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1281, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281,    0, 1281, 1281, 1281, 1281,
 1281, 1281,    0, 1281, 1281, 1281, 1281,    0, 1281,    0,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,    0, 1281,
 1281, 1281, 1281,    0, 1281, 1281, 1281, 1281, 1281,    0,
 1281, 1281, 1281, 1281, 1281,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1282,    0, 1282, 1282,    0,    0,    0,    0,    0,
 1282,    0,    0,    0,    0,    0, 1282,    0,    0,    0,
    0, 1282,    0,    0, 1282,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1282,    0,
    0,    0,    0, 1282, 1282,    0,    0, 1282,    0,    0,
    0,    0,    0,    0, 1282,    0, 1282, 1282,    0,    0,
 1282,    0,    0,    0, 1282,    0, 1282,    0, 1282,    0,
 1282,    0,    0,    0,    0, 1282, 1282,    0, 1282,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1283, 1282, 1282,    0, 1282,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1282,    0, 1282,    0,
 1282, 1282, 1282,    0, 1282,    0,    0, 1282, 1282,    0,
    0,    0,    0,    0,    0,    0,    0, 1282,    0,    0,
    0,    0, 1108, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1282,    0,    0, 1282,    0,    0,    0,    0,    0,    0,
 1283, 1283, 1283, 1283, 1283,    0,    0,    0,    0, 1282,
    0,    0,    0,    0,    0, 1282, 1282,    0,    0,    0,
 1282,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1282, 1282, 1283, 1282, 1283,    0,    0,    0,    0,
 1282,    0,    0, 1282,    0, 1282, 1282, 1282, 1282,    0,
 1282,    0, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1282,
 1282,    0, 1282, 1282, 1282,    0,    0,    0,    0, 1282,
 1282, 1282, 1282, 1282,    0, 1282,    0,    0, 1282, 1282,
 1282, 1282, 1282, 1282, 1282,    0,    0,    0, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282,    0, 1282,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1282, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,    0, 1282,
 1282, 1282, 1282, 1282, 1282,    0, 1282, 1282, 1282, 1282,
    0, 1282,    0, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282,    0, 1282, 1282, 1282, 1282,    0, 1282, 1282, 1282,
 1282, 1282,    0, 1282, 1282, 1282, 1282, 1282,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1283,    0, 1283, 1283,    0,    0,
    0,    0,    0, 1283,    0,    0,    0,    0,    0, 1283,
    0,    0,    0,    0, 1283,    0,    0, 1283,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1283,    0,    0,    0,    0, 1283, 1283,    0,    0,
 1283,    0,    0,    0,    0,    0,    0, 1283,    0, 1283,
 1283,    0,    0, 1283,    0,    0,    0, 1283,    0, 1283,
    0, 1283,    0, 1283,    0,    0,    0,    0, 1283, 1283,
    0, 1283,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1284, 1283, 1283,    0, 1283,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1283,
    0, 1283,    0, 1283, 1283, 1283,    0, 1283,    0,    0,
 1283, 1283,    0,    0,    0,    0,    0,    0,    0,    0,
 1283,    0,    0,    0,    0, 1109, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1283,    0,    0, 1283,    0,    0,    0,
    0,    0,    0, 1284, 1284, 1284, 1284, 1284,    0,    0,
    0,    0, 1283,    0,    0,    0,    0,    0, 1283, 1283,
    0,    0,    0, 1283,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1283, 1283, 1284, 1283, 1284,    0,
    0,    0,    0, 1283,    0,    0, 1283,    0, 1283, 1283,
 1283, 1283,    0, 1283,    0, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1283, 1283,    0, 1283, 1283, 1283,    0,    0,
    0,    0, 1283, 1283, 1283, 1283, 1283,    0, 1283,    0,
    0, 1283, 1283, 1283, 1283, 1283, 1283, 1283,    0,    0,
    0, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,    0,
 1283,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283,    0, 1283, 1283, 1283, 1283, 1283, 1283,    0, 1283,
 1283, 1283, 1283,    0, 1283,    0, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283,    0, 1283, 1283, 1283, 1283,    0,
 1283, 1283, 1283, 1283, 1283,    0, 1283, 1283, 1283, 1283,
 1283,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1284,    0, 1284,
 1284,    0,    0,    0,    0,    0, 1284,    0,    0,    0,
    0,    0, 1284,    0,    0,    0,    0, 1284,    0,    0,
 1284,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1284,    0,    0,    0,    0, 1284,
 1284,    0,    0, 1284,    0,    0,    0,    0,    0,    0,
 1284,    0, 1284, 1284,    0,    0, 1284,    0,    0,    0,
 1284,    0, 1284,    0, 1284,    0, 1284,    0,    0,    0,
    0, 1284, 1284,    0, 1284,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1285, 1284,
 1284,    0, 1284,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1284,    0, 1284,    0, 1284, 1284, 1284,    0,
 1284,    0,    0, 1284, 1284,    0,    0,    0,    0,    0,
    0,    0,    0, 1284,    0,    0,    0,    0, 1110, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1284,    0,    0, 1284,
    0,    0,    0,    0,    0,    0, 1285, 1285, 1285, 1285,
 1285,    0,    0,    0,    0, 1284,    0,    0,    0,    0,
    0, 1284, 1284,    0,    0,    0, 1284,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1284, 1284, 1285,
 1284, 1285,    0,    0,    0,    0, 1284,    0,    0, 1284,
    0, 1284, 1284, 1284, 1284,    0, 1284,    0, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1284, 1284,    0, 1284, 1284,
 1284,    0,    0,    0,    0, 1284, 1284, 1284, 1284, 1284,
    0, 1284,    0,    0, 1284, 1284, 1284, 1284, 1284, 1284,
 1284,    0,    0,    0, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284,    0, 1284,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284,    0, 1284, 1284, 1284, 1284, 1284,
 1284,    0, 1284, 1284, 1284, 1284,    0, 1284,    0, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284,    0, 1284, 1284,
 1284, 1284,    0, 1284, 1284, 1284, 1284, 1284,    0, 1284,
 1284, 1284, 1284, 1284,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1285,    0, 1285, 1285,    0,    0,    0,    0,    0, 1285,
    0,    0,    0,    0,    0, 1285,    0,    0,    0,    0,
 1285,    0,    0, 1285,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1285,    0,    0,
    0,    0, 1285, 1285,    0,    0, 1285,    0,    0,    0,
    0,    0,    0, 1285,    0, 1285, 1285,    0,    0, 1285,
    0,    0,    0, 1285,    0, 1285,    0, 1285,    0, 1285,
    0,    0,    0,    0, 1285, 1285,    0, 1285,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1286, 1285, 1285,    0, 1285,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1285,    0, 1285,    0, 1285,
 1285, 1285,    0, 1285,    0,    0, 1285, 1285,    0,    0,
    0,    0,    0,    0,    0,    0, 1285,    0,    0,    0,
    0, 1111, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1285,
    0,    0, 1285,    0,    0,    0,    0,    0,    0, 1286,
 1286, 1286, 1286, 1286,    0,    0,    0,    0, 1285,    0,
    0,    0,    0,    0, 1285, 1285,    0,    0,    0, 1285,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1285, 1285, 1286, 1285, 1286,    0,    0,    0,    0, 1285,
    0,    0, 1285,    0, 1285, 1285, 1285, 1285,    0, 1285,
    0, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1285, 1285,
    0, 1285, 1285, 1285,    0,    0,    0,    0, 1285, 1285,
 1285, 1285, 1285,    0, 1285,    0,    0, 1285, 1285, 1285,
 1285, 1285, 1285, 1285,    0,    0,    0, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285,    0, 1285,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1285, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285,    0, 1285, 1285,
 1285, 1285, 1285, 1285,    0, 1285, 1285, 1285, 1285,    0,
 1285,    0, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
    0, 1285, 1285, 1285, 1285,    0, 1285, 1285, 1285, 1285,
 1285,    0, 1285, 1285, 1285, 1285, 1285,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1286,    0, 1286, 1286,    0,    0,    0,
    0,    0, 1286,    0,    0,    0,    0,    0, 1286,    0,
    0,    0,    0, 1286,    0,    0, 1286,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1286,    0,    0,    0,    0, 1286, 1286,    0,    0, 1286,
    0,    0,    0,    0,    0,    0, 1286,    0, 1286, 1286,
    0,    0, 1286,    0,    0,    0, 1286,    0, 1286,    0,
 1286,    0, 1286,    0,    0,    0,    0, 1286, 1286,    0,
 1286,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1287, 1286, 1286,    0, 1286,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1286,    0,
 1286,    0, 1286, 1286, 1286,    0, 1286,    0,    0, 1286,
 1286,    0,    0,    0,    0,    0,    0,    0,    0, 1286,
    0,    0,    0,    0, 1112, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1286,    0,    0, 1286,    0,    0,    0,    0,
    0,    0, 1287, 1287, 1287, 1287, 1287,    0,    0,    0,
    0, 1286,    0,    0,    0,    0,    0, 1286, 1286,    0,
    0,    0, 1286,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1286, 1286, 1287, 1286, 1287,    0,    0,
    0,    0, 1286,    0,    0, 1286,    0, 1286, 1286, 1286,
 1286,    0, 1286,    0, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1286, 1286,    0, 1286, 1286, 1286,    0,    0,    0,
    0, 1286, 1286, 1286, 1286, 1286,    0, 1286,    0,    0,
 1286, 1286, 1286, 1286, 1286, 1286, 1286,    0,    0,    0,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,    0, 1286,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1286,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
    0, 1286, 1286, 1286, 1286, 1286, 1286,    0, 1286, 1286,
 1286, 1286,    0, 1286,    0, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286,    0, 1286, 1286, 1286, 1286,    0, 1286,
 1286, 1286, 1286, 1286,    0, 1286, 1286, 1286, 1286, 1286,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1287,    0, 1287, 1287,
    0,    0,    0,    0,    0, 1287,    0,    0,    0,    0,
    0, 1287,    0,    0,    0,    0, 1287,    0,    0, 1287,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1287,    0,    0,    0,    0, 1287, 1287,
    0,    0, 1287,    0,    0,    0,    0,    0,    0, 1287,
    0, 1287, 1287,    0,    0, 1287,    0,    0,    0, 1287,
    0, 1287,    0, 1287,    0, 1287,    0,    0,    0,    0,
 1287, 1287,    0, 1287,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1288, 1287, 1287,
    0, 1287,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1287,    0, 1287,    0, 1287, 1287, 1287,    0, 1287,
    0,    0, 1287, 1287,    0,    0,    0,    0,    0,    0,
    0,    0, 1287,    0,    0,    0,    0, 1113, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1287,    0,    0, 1287,    0,
    0,    0,    0,    0,    0, 1288, 1288, 1288, 1288, 1288,
    0,    0,    0,    0, 1287,    0,    0,    0,    0,    0,
 1287, 1287,    0,    0,    0, 1287,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1287, 1287, 1288, 1287,
 1288,    0,    0,    0,    0, 1287,    0,    0, 1287,    0,
 1287, 1287, 1287, 1287,    0, 1287,    0, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1287, 1287,    0, 1287, 1287, 1287,
    0,    0,    0,    0, 1287, 1287, 1287, 1287, 1287,    0,
 1287,    0,    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
    0,    0,    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287,    0, 1287,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287, 1287, 1287,
    0, 1287, 1287, 1287, 1287,    0, 1287,    0, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287,
 1287,    0, 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287,
 1287, 1287, 1287,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1288,
    0, 1288, 1288,    0,    0,    0,    0,    0, 1288,    0,
    0,    0,    0,    0, 1288,    0,    0,    0,    0, 1288,
    0,    0, 1288,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1288,    0,    0,    0,
    0, 1288, 1288,    0,    0, 1288,    0,    0,    0,    0,
    0,    0, 1288,    0, 1288, 1288,    0,    0, 1288,    0,
    0,    0, 1288,    0, 1288,    0, 1288,    0, 1288,    0,
    0,    0,    0, 1288, 1288,    0, 1288,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1289, 1288, 1288,    0, 1288,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1288,    0, 1288,    0, 1288, 1288,
 1288,    0, 1288,    0,    0, 1288, 1288,    0,    0,    0,
    0,    0,    0,    0,    0, 1288,    0,    0,    0,    0,
 1114, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1288,    0,
    0, 1288,    0,    0,    0,    0,    0,    0, 1289, 1289,
 1289, 1289, 1289,    0,    0,    0,    0, 1288,    0,    0,
    0,    0,    0, 1288, 1288,    0,    0,    0, 1288,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1288,
 1288, 1289, 1288, 1289,    0,    0,    0,    0, 1288,    0,
    0, 1288,    0, 1288, 1288, 1288, 1288,    0, 1288,    0,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1288, 1288,    0,
 1288, 1288, 1288,    0,    0,    0,    0, 1288, 1288, 1288,
 1288, 1288,    0, 1288,    0,    0, 1288, 1288, 1288, 1288,
 1288, 1288, 1288,    0,    0,    0, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288,    0, 1288,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288,    0, 1288, 1288, 1288,
 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288,    0, 1288,
    0, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0,
 1288, 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288, 1288,
    0, 1288, 1288, 1288, 1288, 1288,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1289,    0, 1289, 1289,    0,    0,    0,    0,
    0, 1289,    0,    0,    0,    0,    0, 1289,    0,    0,
    0,    0, 1289,    0,    0, 1289,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1289,
    0,    0,    0,    0, 1289, 1289,    0,    0, 1289,    0,
    0,    0,    0,    0,    0, 1289,    0, 1289, 1289,    0,
    0, 1289,    0,    0,    0, 1289,    0, 1289,    0, 1289,
    0, 1289,    0,    0,    0,    0, 1289, 1289,    0, 1289,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1290, 1289, 1289,    0, 1289,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1289,    0, 1289,
    0, 1289, 1289, 1289,    0, 1289,    0,    0, 1289, 1289,
    0,    0,    0,    0,    0,    0,    0,    0, 1289,    0,
    0,    0,    0, 1115, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1289,    0,    0, 1289,    0,    0,    0,    0,    0,
    0, 1290, 1290, 1290, 1290, 1290,    0,    0,    0,    0,
 1289,    0,    0,    0,    0,    0, 1289, 1289,    0,    0,
    0, 1289,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1289, 1289, 1290, 1289, 1290,    0,    0,    0,
    0, 1289,    0,    0, 1289,    0, 1289, 1289, 1289, 1289,
    0, 1289,    0, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1289, 1289,    0, 1289, 1289, 1289,    0,    0,    0,    0,
 1289, 1289, 1289, 1289, 1289,    0, 1289,    0,    0, 1289,
 1289, 1289, 1289, 1289, 1289, 1289,    0,    0,    0, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289,    0, 1289,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1289, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,    0,
 1289, 1289, 1289, 1289, 1289, 1289,    0, 1289, 1289, 1289,
 1289,    0, 1289,    0, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289,    0, 1289, 1289, 1289, 1289,    0, 1289, 1289,
 1289, 1289, 1289,    0, 1289, 1289, 1289, 1289, 1289,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1290,    0, 1290, 1290,    0,
    0,    0,    0,    0, 1290,    0,    0,    0,    0,    0,
 1290,    0,    0,    0,    0, 1290,    0,    0, 1290,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1290,    0,    0,    0,    0, 1290, 1290,    0,
    0, 1290,    0,    0,    0,    0,    0,    0, 1290,    0,
 1290, 1290,    0,    0, 1290,    0,    0,    0, 1290,    0,
 1290,    0, 1290,    0, 1290,    0,    0,    0,    0, 1290,
 1290,    0, 1290,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1291, 1290, 1290,    0,
 1290,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1290,    0, 1290,    0, 1290, 1290, 1290,    0, 1290,    0,
    0, 1290, 1290,    0,    0,    0,    0,    0,    0,    0,
    0, 1290,    0,    0,    0,    0, 1116, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1290,    0,    0, 1290,    0,    0,
    0,    0,    0,    0, 1291, 1291, 1291, 1291, 1291,    0,
    0,    0,    0, 1290,    0,    0,    0,    0,    0, 1290,
 1290,    0,    0,    0, 1290,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1290, 1290, 1291, 1290, 1291,
    0,    0,    0,    0, 1290,    0,    0, 1290,    0, 1290,
 1290, 1290, 1290,    0, 1290,    0, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1290, 1290,    0, 1290, 1290, 1290,    0,
    0,    0,    0, 1290, 1290, 1290, 1290, 1290,    0, 1290,
    0,    0, 1290, 1290, 1290, 1290, 1290, 1290, 1290,    0,
    0,    0, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
    0, 1290,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290,    0, 1290, 1290, 1290, 1290, 1290, 1290,    0,
 1290, 1290, 1290, 1290,    0, 1290,    0, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290,    0, 1290, 1290, 1290, 1290,
    0, 1290, 1290, 1290, 1290, 1290,    0, 1290, 1290, 1290,
 1290, 1290,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1291,    0,
 1291, 1291,    0,    0,    0,    0,    0, 1291,    0,    0,
    0,    0,    0, 1291,    0,    0,    0,    0, 1291,    0,
    0, 1291,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1291,    0,    0,    0,    0,
 1291, 1291,    0,    0, 1291,    0,    0,    0,    0,    0,
    0, 1291,    0, 1291, 1291,    0,    0, 1291,    0,    0,
    0, 1291,    0, 1291,    0, 1291,    0, 1291,    0,    0,
    0,    0, 1291, 1291,    0, 1291,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1295,
 1291, 1291,    0, 1291,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1291,    0, 1291,    0, 1291, 1291, 1291,
    0, 1291,    0,    0, 1291, 1291,    0,    0,    0,    0,
    0,    0,    0,    0, 1291,    0,    0,    0,    0, 1117,
 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1291,    0,    0,
 1291,    0,    0,    0,    0,    0,    0, 1295, 1295, 1295,
 1295, 1295,    0,    0,    0,    0, 1291,    0,    0,    0,
    0,    0, 1291, 1291,    0,    0,    0, 1291,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1291, 1291,
 1295, 1291, 1295,    0,    0,    0,    0, 1291,    0,    0,
 1291,    0, 1291, 1291, 1291, 1291,    0, 1291,    0, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1291, 1291,    0, 1291,
 1291, 1291,    0,    0,    0,    0, 1291, 1291, 1291, 1291,
 1291,    0, 1291,    0,    0, 1291, 1291, 1291, 1291, 1291,
 1291, 1291,    0,    0,    0, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291,    0, 1291,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291,    0, 1291, 1291, 1291, 1291,
 1291, 1291,    0, 1291, 1291, 1291, 1291,    0, 1291,    0,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,    0, 1291,
 1291, 1291, 1291,    0, 1291, 1291, 1291, 1291, 1291,    0,
 1291, 1291, 1291, 1291, 1291,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1295,    0, 1295, 1295,    0,    0,    0,    0,    0,
 1295,    0,    0,    0,    0,    0, 1295,    0,    0,    0,
    0, 1295,    0,    0, 1295,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1295,    0,
    0,    0,    0, 1295, 1295,    0,    0, 1295,    0,    0,
    0,    0,    0,    0, 1295,    0, 1295, 1295,    0,    0,
 1295,    0,    0,    0, 1295,    0, 1295,    0, 1295,    0,
 1295,    0,    0,    0,    0, 1295, 1295,    0, 1295,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1296, 1295, 1295,    0, 1295,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1295,    0, 1295,    0,
 1295, 1295, 1295,    0, 1295,    0,    0, 1295, 1295,    0,
    0,    0,    0,    0,    0,    0,    0, 1295,    0,    0,
    0,    0, 1118, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1295,    0,    0, 1295,    0,    0,    0,    0,    0,    0,
 1296, 1296, 1296, 1296, 1296,    0,    0,    0,    0, 1295,
    0,    0,    0,    0,    0, 1295, 1295,    0,    0,    0,
 1295,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1295, 1295, 1296, 1295, 1296,    0,    0,    0,    0,
 1295,    0,    0, 1295,    0, 1295, 1295, 1295, 1295,    0,
 1295,    0, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1295,
 1295,    0, 1295, 1295, 1295,    0,    0,    0,    0, 1295,
 1295, 1295, 1295, 1295,    0, 1295,    0,    0, 1295, 1295,
 1295, 1295, 1295, 1295, 1295,    0,    0,    0, 1295, 1295,
 1295, 1295, 1295, 1295, 1295, 1295,    0, 1295,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1295, 1295, 1295,
 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,    0, 1295,
 1295, 1295, 1295, 1295, 1295,    0, 1295, 1295, 1295, 1295,
    0, 1295,    0, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
 1295,    0, 1295, 1295, 1295, 1295,    0, 1295, 1295, 1295,
 1295, 1295,    0, 1295, 1295, 1295, 1295, 1295,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296,    0, 1296, 1296,    0,    0,
    0,    0,    0, 1296,    0,    0,    0,    0,    0, 1296,
    0,    0,    0,    0, 1296,    0,    0, 1296,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1296,    0,    0,    0,    0, 1296, 1296,    0,    0,
 1296,    0,    0,    0,    0,    0,    0, 1296,    0, 1296,
 1296,    0,    0, 1296,    0,    0,    0, 1296,    0, 1296,
    0, 1296,    0, 1296,    0,    0,    0,    0, 1296, 1296,
    0, 1296,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1297, 1296, 1296,    0, 1296,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1296,
    0, 1296,    0, 1296, 1296, 1296,    0, 1296,    0,    0,
 1296, 1296,    0,    0,    0,    0,    0,    0,    0,    0,
 1296,    0,    0,    0,    0, 1119, 1297, 1297, 1297, 1297,
 1297, 1297, 1297, 1296,    0,    0, 1296,    0,    0,    0,
    0,    0,    0, 1297, 1297, 1297, 1297, 1297,    0,    0,
    0,    0, 1296,    0,    0,    0,    0,    0, 1296, 1296,
    0,    0,    0, 1296,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296, 1296, 1297, 1296, 1297,    0,
    0,    0,    0, 1296,    0,    0, 1296,    0, 1296, 1296,
 1296, 1296,    0, 1296,    0, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1296, 1296,    0, 1296, 1296, 1296,    0,    0,
    0,    0, 1296, 1296, 1296, 1296, 1296,    0, 1296,    0,
    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296,    0,    0,
    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,    0,
 1296,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296,    0, 1296, 1296, 1296, 1296, 1296, 1296,    0, 1296,
 1296, 1296, 1296,    0, 1296,    0, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296,    0,
 1296, 1296, 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296,
 1296,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1297,    0, 1297,
 1297,    0,    0,    0,    0,    0, 1297,    0,    0,    0,
    0,    0, 1297,    0,    0,    0,    0, 1297,    0,    0,
 1297,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1297,    0,    0,    0,    0, 1297,
 1297,    0,    0, 1297,    0,    0,    0,    0,    0,    0,
 1297,    0, 1297, 1297,    0,    0, 1297,    0,    0,    0,
 1297,    0, 1297,    0, 1297,    0, 1297,    0,    0,    0,
    0, 1297, 1297,    0, 1297,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1299, 1297,
 1297,    0, 1297,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1297,    0, 1297,    0, 1297, 1297, 1297,    0,
 1297,    0,    0, 1297, 1297,    0,    0,    0,    0,    0,
    0,    0,    0, 1297,    0,    0,    0,    0, 1120, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1297,    0,    0, 1297,
    0,    0,    0,    0,    0,    0, 1299, 1299, 1299, 1299,
 1299,    0,    0,    0,    0, 1297,    0,    0,    0,    0,
    0, 1297, 1297,    0,    0,    0, 1297,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1297, 1297, 1299,
 1297, 1299,    0,    0,    0,    0, 1297,    0,    0, 1297,
    0, 1297, 1297, 1297, 1297,    0, 1297,    0, 1297, 1297,
 1297, 1297, 1297, 1297, 1297, 1297,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1297, 1297,    0, 1297, 1297,
 1297,    0,    0,    0,    0, 1297, 1297, 1297, 1297, 1297,
    0, 1297,    0,    0, 1297, 1297, 1297, 1297, 1297, 1297,
 1297,    0,    0,    0, 1297, 1297, 1297, 1297, 1297, 1297,
 1297, 1297,    0, 1297,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1297, 1297, 1297, 1297, 1297, 1297, 1297,
 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297,
 1297, 1297, 1297, 1297,    0, 1297, 1297, 1297, 1297, 1297,
 1297,    0, 1297, 1297, 1297, 1297,    0, 1297,    0, 1297,
 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297,
 1297, 1297, 1297, 1297, 1297, 1297, 1297,    0, 1297, 1297,
 1297, 1297,    0, 1297, 1297, 1297, 1297, 1297,    0, 1297,
 1297, 1297, 1297, 1297,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1299,    0, 1299, 1299,    0,    0,    0,    0,    0, 1299,
    0,    0,    0,    0,    0, 1299,    0,    0,    0,    0,
 1299,    0,    0, 1299,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1299,    0,    0,
    0,    0, 1299, 1299,    0,    0, 1299,    0,    0,    0,
    0,    0,    0, 1299,    0, 1299, 1299,    0,    0, 1299,
    0,    0,    0, 1299,    0, 1299,    0, 1299,    0, 1299,
    0,    0,    0,    0, 1299, 1299,    0, 1299,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1301, 1299, 1299,    0, 1299,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1299,    0, 1299,    0, 1299,
 1299, 1299,    0, 1299,    0,    0, 1299, 1299,    0,    0,
    0,    0,    0,    0,    0,    0, 1299,    0,    0,    0,
    0, 1122, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1299,
    0,    0, 1299,    0,    0,    0,    0,    0,    0, 1301,
 1301, 1301, 1301, 1301,    0,    0,    0,    0, 1299,    0,
    0,    0,    0,    0, 1299, 1299,    0,    0,    0, 1299,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1299, 1299, 1301, 1299, 1301,    0,    0,    0,    0, 1299,
    0,    0, 1299,    0, 1299, 1299, 1299, 1299,    0, 1299,
    0, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1299, 1299,
    0, 1299, 1299, 1299,    0,    0,    0,    0, 1299, 1299,
 1299, 1299, 1299,    0, 1299,    0,    0, 1299, 1299, 1299,
 1299, 1299, 1299, 1299,    0,    0,    0, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299,    0, 1299,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299,    0, 1299, 1299,
 1299, 1299, 1299, 1299,    0, 1299, 1299, 1299, 1299,    0,
 1299,    0, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
    0, 1299, 1299, 1299, 1299,    0, 1299, 1299, 1299, 1299,
 1299,    0, 1299, 1299, 1299, 1299, 1299,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1301,    0, 1301, 1301,    0,    0,    0,
    0,    0, 1301,    0,    0,    0,    0,    0, 1301,    0,
    0,    0,    0, 1301,    0,    0, 1301,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1301,    0,    0,    0,    0, 1301, 1301,    0,    0, 1301,
    0,    0,    0,    0,    0,    0, 1301,    0, 1301, 1301,
    0,    0, 1301,    0,    0,    0, 1301,    0, 1301,    0,
 1301,    0, 1301,    0,    0,    0,    0, 1301, 1301,    0,
 1301,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1302, 1301, 1301,    0, 1301,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1301,    0,
 1301,    0, 1301, 1301, 1301,    0, 1301,    0,    0, 1301,
 1301,    0,    0,    0,    0,    0,    0,    0,    0, 1301,
    0,    0,    0,    0, 1123, 1302, 1302, 1302, 1302, 1302,
 1302, 1302, 1301,    0,    0, 1301,    0,    0,    0,    0,
    0,    0, 1302, 1302, 1302, 1302, 1302,    0,    0,    0,
    0, 1301,    0,    0,    0,    0,    0, 1301, 1301,    0,
    0,    0, 1301,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1301, 1301, 1302, 1301, 1302,    0,    0,
    0,    0, 1301,    0,    0, 1301,    0, 1301, 1301, 1301,
 1301,    0, 1301,    0, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1301, 1301,    0, 1301, 1301, 1301,    0,    0,    0,
    0, 1301, 1301, 1301, 1301, 1301,    0, 1301,    0,    0,
 1301, 1301, 1301, 1301, 1301, 1301, 1301,    0,    0,    0,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,    0, 1301,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1301,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
    0, 1301, 1301, 1301, 1301, 1301, 1301,    0, 1301, 1301,
 1301, 1301,    0, 1301,    0, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301,    0, 1301, 1301, 1301, 1301,    0, 1301,
 1301, 1301, 1301, 1301,    0, 1301, 1301, 1301, 1301, 1301,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1302,    0, 1302, 1302,
    0,    0,    0,    0,    0, 1302,    0,    0,    0,    0,
    0, 1302,    0,    0,    0,    0, 1302,    0,    0, 1302,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1302,    0,    0,    0,    0, 1302, 1302,
    0,    0, 1302,    0,    0,    0,    0,    0,    0, 1302,
    0, 1302, 1302,    0,    0, 1302,    0,    0,    0, 1302,
    0, 1302,    0, 1302,    0, 1302,    0,    0,    0,    0,
 1302, 1302,    0, 1302,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1303, 1302, 1302,
    0, 1302,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1302,    0, 1302,    0, 1302, 1302, 1302,    0, 1302,
    0,    0, 1302, 1302,    0,    0,    0,    0,    0,    0,
    0,    0, 1302,    0,    0,    0,    0, 1124, 1303, 1303,
 1303, 1303, 1303, 1303, 1303, 1302,    0,    0, 1302,    0,
    0,    0,    0,    0,    0, 1303, 1303, 1303, 1303, 1303,
    0,    0,    0,    0, 1302,    0,    0,    0,    0,    0,
 1302, 1302,    0,    0,    0, 1302,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1302, 1302, 1303, 1302,
 1303,    0,    0,    0,    0, 1302,    0,    0, 1302,    0,
 1302, 1302, 1302, 1302,    0, 1302,    0, 1302, 1302, 1302,
 1302, 1302, 1302, 1302, 1302,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1302, 1302,    0, 1302, 1302, 1302,
    0,    0,    0,    0, 1302, 1302, 1302, 1302, 1302,    0,
 1302,    0,    0, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
    0,    0,    0, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
 1302,    0, 1302,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
 1302, 1302, 1302,    0, 1302, 1302, 1302, 1302, 1302, 1302,
    0, 1302, 1302, 1302, 1302,    0, 1302,    0, 1302, 1302,
 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
 1302, 1302, 1302, 1302, 1302, 1302,    0, 1302, 1302, 1302,
 1302,    0, 1302, 1302, 1302, 1302, 1302,    0, 1302, 1302,
 1302, 1302, 1302,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1303,
    0, 1303, 1303,    0,    0,    0,    0,    0, 1303,    0,
    0,    0,    0,    0, 1303,    0,    0,    0,    0, 1303,
    0,    0, 1303,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1303,    0,    0,    0,
    0, 1303, 1303,    0,    0, 1303,    0,    0,    0,    0,
    0,    0, 1303,    0, 1303, 1303,    0,    0, 1303,    0,
    0,    0, 1303,    0, 1303,    0, 1303,    0, 1303,    0,
    0,    0,    0, 1303, 1303,    0, 1303,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1304, 1303, 1303,    0, 1303,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1303,    0, 1303,    0, 1303, 1303,
 1303,    0, 1303,    0,    0, 1303, 1303,    0,    0,    0,
    0,    0,    0,    0,    0, 1303,    0,    0,    0,    0,
 1125, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1303,    0,
    0, 1303,    0,    0,    0,    0,    0,    0, 1304, 1304,
 1304, 1304, 1304,    0,    0,    0,    0, 1303,    0,    0,
    0,    0,    0, 1303, 1303,    0,    0,    0, 1303,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1303,
 1303, 1304, 1303, 1304,    0,    0,    0,    0, 1303,    0,
    0, 1303,    0, 1303, 1303, 1303, 1303,    0, 1303,    0,
 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1303, 1303,    0,
 1303, 1303, 1303,    0,    0,    0,    0, 1303, 1303, 1303,
 1303, 1303,    0, 1303,    0,    0, 1303, 1303, 1303, 1303,
 1303, 1303, 1303,    0,    0,    0, 1303, 1303, 1303, 1303,
 1303, 1303, 1303, 1303,    0, 1303,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1303, 1303, 1303, 1303, 1303,
 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303,
 1303, 1303, 1303, 1303, 1303, 1303,    0, 1303, 1303, 1303,
 1303, 1303, 1303,    0, 1303, 1303, 1303, 1303,    0, 1303,
    0, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303,
 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303,    0,
 1303, 1303, 1303, 1303,    0, 1303, 1303, 1303, 1303, 1303,
    0, 1303, 1303, 1303, 1303, 1303,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1304,    0, 1304, 1304,    0,    0,    0,    0,
    0, 1304,    0,    0,    0,    0,    0, 1304,    0,    0,
    0,    0, 1304,    0,    0, 1304,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1304,
    0,    0,    0,    0, 1304, 1304,    0,    0, 1304,    0,
    0,    0,    0,    0,    0, 1304,    0, 1304, 1304,    0,
    0, 1304,    0,    0,    0, 1304,    0, 1304,    0, 1304,
    0, 1304,    0,    0,    0,    0, 1304, 1304,    0, 1304,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1307, 1304, 1304,    0, 1304,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1304,    0, 1304,
    0, 1304, 1304, 1304,    0, 1304,    0,    0, 1304, 1304,
    0,    0,    0,    0,    0,    0,    0,    0, 1304,    0,
    0,    0,    0, 1126, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1304,    0,    0, 1304,    0,    0,    0,    0,    0,
    0, 1307, 1307, 1307, 1307, 1307,    0,    0,    0,    0,
 1304,    0,    0,    0,    0,    0, 1304, 1304,    0,    0,
    0, 1304,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1304, 1304, 1307, 1304, 1307,    0,    0,    0,
    0, 1304,    0,    0, 1304,    0, 1304, 1304, 1304, 1304,
    0, 1304,    0, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
 1304,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1304, 1304,    0, 1304, 1304, 1304,    0,    0,    0,    0,
 1304, 1304, 1304, 1304, 1304,    0, 1304,    0,    0, 1304,
 1304, 1304, 1304, 1304, 1304, 1304,    0,    0,    0, 1304,
 1304, 1304, 1304, 1304, 1304, 1304, 1304,    0, 1304,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1304, 1304,
 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,    0,
 1304, 1304, 1304, 1304, 1304, 1304,    0, 1304, 1304, 1304,
 1304,    0, 1304,    0, 1304, 1304, 1304, 1304, 1304, 1304,
 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
 1304, 1304,    0, 1304, 1304, 1304, 1304,    0, 1304, 1304,
 1304, 1304, 1304,    0, 1304, 1304, 1304, 1304, 1304,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1307,    0, 1307, 1307,    0,
    0,    0,    0,    0, 1307,    0,    0,    0,    0,    0,
 1307,    0,    0,    0,    0, 1307,    0,    0, 1307,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1307,    0,    0,    0,    0, 1307, 1307,    0,
    0, 1307,    0,    0,    0,    0,    0,    0, 1307,    0,
 1307, 1307,    0,    0, 1307,    0,    0,    0, 1307,    0,
 1307,    0, 1307,    0, 1307,    0,    0,    0,    0, 1307,
 1307,    0, 1307,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1309, 1307, 1307,    0,
 1307,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1307,    0, 1307,    0, 1307, 1307, 1307,    0, 1307,    0,
    0, 1307, 1307,    0,    0,    0,    0,    0,    0,    0,
    0, 1307,    0,    0,    0,    0, 1127, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1307,    0,    0, 1307,    0,    0,
    0,    0,    0,    0, 1309, 1309, 1309, 1309, 1309,    0,
    0,    0,    0, 1307,    0,    0,    0,    0,    0, 1307,
 1307,    0,    0,    0, 1307,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1307, 1307, 1309, 1307, 1309,
    0,    0,    0,    0, 1307,    0,    0, 1307,    0, 1307,
 1307, 1307, 1307,    0, 1307,    0, 1307, 1307, 1307, 1307,
 1307, 1307, 1307, 1307,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1307, 1307,    0, 1307, 1307, 1307,    0,
    0,    0,    0, 1307, 1307, 1307, 1307, 1307,    0, 1307,
    0,    0, 1307, 1307, 1307, 1307, 1307, 1307, 1307,    0,
    0,    0, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
    0, 1307,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1307,    0, 1307, 1307, 1307, 1307, 1307, 1307,    0,
 1307, 1307, 1307, 1307,    0, 1307,    0, 1307, 1307, 1307,
 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1307, 1307, 1307, 1307,    0, 1307, 1307, 1307, 1307,
    0, 1307, 1307, 1307, 1307, 1307,    0, 1307, 1307, 1307,
 1307, 1307,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1309,    0,
 1309, 1309,    0,    0,    0,    0,    0, 1309,    0,    0,
    0,    0,    0, 1309,    0,    0,    0,    0, 1309,    0,
    0, 1309,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1309,    0,    0,    0,    0,
 1309, 1309,    0,    0, 1309,    0,    0,    0,    0,    0,
    0, 1309,    0, 1309, 1309,    0,    0, 1309,    0,    0,
    0, 1309,    0, 1309,    0, 1309,    0, 1309,    0,    0,
    0,    0, 1309, 1309,    0, 1309,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1310,
 1309, 1309,    0, 1309,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1309,    0, 1309,    0, 1309, 1309, 1309,
    0, 1309,    0,    0, 1309, 1309,    0,    0,    0,    0,
    0,    0,    0,    0, 1309,    0,    0,    0,    0, 1128,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1309,    0,    0,
 1309,    0,    0,    0,    0,    0,    0, 1310, 1310, 1310,
 1310, 1310,    0,    0,    0,    0, 1309,    0,    0,    0,
    0,    0, 1309, 1309,    0,    0,    0, 1309,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1309, 1309,
 1310, 1309, 1310,    0,    0,    0,    0, 1309,    0,    0,
 1309,    0, 1309, 1309, 1309, 1309,    0, 1309,    0, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1309, 1309,    0, 1309,
 1309, 1309,    0,    0,    0,    0, 1309, 1309, 1309, 1309,
 1309,    0, 1309,    0,    0, 1309, 1309, 1309, 1309, 1309,
 1309, 1309,    0,    0,    0, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309,    0, 1309,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309,    0, 1309, 1309, 1309, 1309,
 1309, 1309,    0, 1309, 1309, 1309, 1309,    0, 1309,    0,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,    0, 1309,
 1309, 1309, 1309,    0, 1309, 1309, 1309, 1309, 1309,    0,
 1309, 1309, 1309, 1309, 1309,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1310,    0, 1310, 1310,    0,    0,    0,    0,    0,
 1310,    0,    0,    0,    0,    0, 1310,    0,    0,    0,
    0, 1310,    0,    0, 1310,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1310,    0,
    0,    0,    0, 1310, 1310,    0,    0, 1310,    0,    0,
    0,    0,    0,    0, 1310,    0, 1310, 1310,    0,    0,
 1310,    0,    0,    0, 1310,    0, 1310,    0, 1310,    0,
 1310,    0,    0,    0,    0, 1310, 1310,    0, 1310,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1313, 1310, 1310,    0, 1310,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1310,    0, 1310,    0,
 1310, 1310, 1310,    0, 1310,    0,    0, 1310, 1310,    0,
    0,    0,    0,    0,    0,    0,    0, 1310,    0,    0,
    0,    0, 1129, 1313, 1313, 1313, 1313, 1313, 1313, 1313,
 1310,    0,    0, 1310,    0,    0,    0,    0,    0,    0,
 1313, 1313, 1313, 1313, 1313,    0,    0,    0,    0, 1310,
    0,    0,    0,    0,    0, 1310, 1310,    0,    0,    0,
 1310,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1310, 1310, 1313, 1310, 1313,    0,    0,    0,    0,
 1310,    0,    0, 1310,    0, 1310, 1310, 1310, 1310,    0,
 1310,    0, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1310,
 1310,    0, 1310, 1310, 1310,    0,    0,    0,    0, 1310,
 1310, 1310, 1310, 1310,    0, 1310,    0,    0, 1310, 1310,
 1310, 1310, 1310, 1310, 1310,    0,    0,    0, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310,    0, 1310,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,    0, 1310,
 1310, 1310, 1310, 1310, 1310,    0, 1310, 1310, 1310, 1310,
    0, 1310,    0, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310,    0, 1310, 1310, 1310, 1310,    0, 1310, 1310, 1310,
 1310, 1310,    0, 1310, 1310, 1310, 1310, 1310,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1313,    0, 1313, 1313,    0,    0,
    0,    0,    0, 1313,    0,    0,    0,    0,    0, 1313,
    0,    0,    0,    0, 1313,    0,    0, 1313,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1313,    0,    0,    0,    0, 1313, 1313,    0,    0,
 1313,    0,    0,    0,    0,    0,    0, 1313,    0, 1313,
 1313,    0,    0, 1313,    0,    0,    0, 1313,    0, 1313,
    0, 1313,    0, 1313,    0,    0,    0,    0, 1313, 1313,
    0, 1313,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1315, 1313, 1313,    0, 1313,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1313,
    0, 1313,    0, 1313, 1313, 1313,    0, 1313,    0,    0,
 1313, 1313,    0,    0,    0,    0,    0,    0,    0,    0,
 1313,    0,    0,    0,    0, 1131, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1313,    0,    0, 1313,    0,    0,    0,
    0,    0,    0, 1315, 1315, 1315, 1315, 1315,    0,    0,
    0,    0, 1313,    0,    0,    0,    0,    0, 1313, 1313,
    0,    0,    0, 1313,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1313, 1313, 1315, 1313, 1315,    0,
    0,    0,    0, 1313,    0,    0, 1313,    0, 1313, 1313,
 1313, 1313,    0, 1313,    0, 1313, 1313, 1313, 1313, 1313,
 1313, 1313, 1313,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1313, 1313,    0, 1313, 1313, 1313,    0,    0,
    0,    0, 1313, 1313, 1313, 1313, 1313,    0, 1313,    0,
    0, 1313, 1313, 1313, 1313, 1313, 1313, 1313,    0,    0,
    0, 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313,    0,
 1313,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313,
 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313,
 1313,    0, 1313, 1313, 1313, 1313, 1313, 1313,    0, 1313,
 1313, 1313, 1313,    0, 1313,    0, 1313, 1313, 1313, 1313,
 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313, 1313,
 1313, 1313, 1313, 1313,    0, 1313, 1313, 1313, 1313,    0,
 1313, 1313, 1313, 1313, 1313,    0, 1313, 1313, 1313, 1313,
 1313,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1315,    0, 1315,
 1315,    0,    0,    0,    0,    0, 1315,    0,    0,    0,
    0,    0, 1315,    0,    0,    0,    0, 1315,    0,    0,
 1315,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1315,    0,    0,    0,    0, 1315,
 1315,    0,    0, 1315,    0,    0,    0,    0,    0,    0,
 1315,    0, 1315, 1315,    0,    0, 1315,    0,    0,    0,
 1315,    0, 1315,    0, 1315,    0, 1315,    0,    0,    0,
    0, 1315, 1315,    0, 1315,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1317, 1315,
 1315,    0, 1315,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1315,    0, 1315,    0, 1315, 1315, 1315,    0,
 1315,    0,    0, 1315, 1315,    0,    0,    0,    0,    0,
    0,    0,    0, 1315,    0,    0,    0,    0, 1132, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1315,    0,    0, 1315,
    0,    0,    0,    0,    0,    0, 1317, 1317, 1317, 1317,
 1317,    0,    0,    0,    0, 1315,    0,    0,    0,    0,
    0, 1315, 1315,    0,    0,    0, 1315,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1315, 1315, 1317,
 1315, 1317,    0,    0,    0,    0, 1315,    0,    0, 1315,
    0, 1315, 1315, 1315, 1315,    0, 1315,    0, 1315, 1315,
 1315, 1315, 1315, 1315, 1315, 1315,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1315, 1315,    0, 1315, 1315,
 1315,    0,    0,    0,    0, 1315, 1315, 1315, 1315, 1315,
    0, 1315,    0,    0, 1315, 1315, 1315, 1315, 1315, 1315,
 1315,    0,    0,    0, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315,    0, 1315,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1315,    0, 1315, 1315, 1315, 1315, 1315,
 1315,    0, 1315, 1315, 1315, 1315,    0, 1315,    0, 1315,
 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1315, 1315, 1315, 1315,    0, 1315, 1315,
 1315, 1315,    0, 1315, 1315, 1315, 1315, 1315,    0, 1315,
 1315, 1315, 1315, 1315,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1317,    0, 1317, 1317,    0,    0,    0,    0,    0, 1317,
    0,    0,    0,    0,    0, 1317,    0,    0,    0,    0,
 1317,    0,    0, 1317,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1317,    0,    0,
    0,    0, 1317, 1317,    0,    0, 1317,    0,    0,    0,
    0,    0,    0, 1317,    0, 1317, 1317,    0,    0, 1317,
    0,    0,    0, 1317,    0, 1317,    0, 1317,    0, 1317,
    0,    0,    0,    0, 1317, 1317,    0, 1317,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1318, 1317, 1317,    0, 1317,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1317,    0, 1317,    0, 1317,
 1317, 1317,    0, 1317,    0,    0, 1317, 1317,    0,    0,
    0,    0,    0,    0,    0,    0, 1317,    0,    0,    0,
    0, 1133, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1317,
    0,    0, 1317,    0,    0,    0,    0,    0,    0, 1318,
 1318, 1318, 1318, 1318,    0,    0,    0,    0, 1317,    0,
    0,    0,    0,    0, 1317, 1317,    0,    0,    0, 1317,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1317, 1317, 1318, 1317, 1318,    0,    0,    0,    0, 1317,
    0,    0, 1317,    0, 1317, 1317, 1317, 1317,    0, 1317,
    0, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1317, 1317,
    0, 1317, 1317, 1317,    0,    0,    0,    0, 1317, 1317,
 1317, 1317, 1317,    0, 1317,    0,    0, 1317, 1317, 1317,
 1317, 1317, 1317, 1317,    0,    0,    0, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317,    0, 1317,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0, 1317, 1317,
 1317, 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317,    0,
 1317,    0, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
    0, 1317, 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317,
 1317,    0, 1317, 1317, 1317, 1317, 1317,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1318,    0, 1318, 1318,    0,    0,    0,
    0,    0, 1318,    0,    0,    0,    0,    0, 1318,    0,
    0,    0,    0, 1318,    0,    0, 1318,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1318,    0,    0,    0,    0, 1318, 1318,    0,    0, 1318,
    0,    0,    0,    0,    0,    0, 1318,    0, 1318, 1318,
    0,    0, 1318,    0,    0,    0, 1318,    0, 1318,    0,
 1318,    0, 1318,    0,    0,    0,    0, 1318, 1318,    0,
 1318,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1319, 1318, 1318,    0, 1318,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1318,    0,
 1318,    0, 1318, 1318, 1318,    0, 1318,    0,    0, 1318,
 1318,    0,    0,    0,    0,    0,    0,    0,    0, 1318,
    0,    0,    0,    0, 1134, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1318,    0,    0, 1318,    0,    0,    0,    0,
    0,    0, 1319, 1319, 1319, 1319, 1319,    0,    0,    0,
    0, 1318,    0,    0,    0,    0,    0, 1318, 1318,    0,
    0,    0, 1318,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1318, 1318, 1319, 1318, 1319,    0,    0,
    0,    0, 1318,    0,    0, 1318,    0, 1318, 1318, 1318,
 1318,    0, 1318,    0, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1318, 1318,    0, 1318, 1318, 1318,    0,    0,    0,
    0, 1318, 1318, 1318, 1318, 1318,    0, 1318,    0,    0,
 1318, 1318, 1318, 1318, 1318, 1318, 1318,    0,    0,    0,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,    0, 1318,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1318,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
    0, 1318, 1318, 1318, 1318, 1318, 1318,    0, 1318, 1318,
 1318, 1318,    0, 1318,    0, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318,    0, 1318, 1318, 1318, 1318,    0, 1318,
 1318, 1318, 1318, 1318,    0, 1318, 1318, 1318, 1318, 1318,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1319,    0, 1319, 1319,
    0,    0,    0,    0,    0, 1319,    0,    0,    0,    0,
    0, 1319,    0,    0,    0,    0, 1319,    0,    0, 1319,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1319,    0,    0,    0,    0, 1319, 1319,
    0,    0, 1319,    0,    0,    0,    0,    0,    0, 1319,
    0, 1319, 1319,    0,    0, 1319,    0,    0,    0, 1319,
    0, 1319,    0, 1319,    0, 1319,    0,    0,    0,    0,
 1319, 1319,    0, 1319,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1320, 1319, 1319,
    0, 1319,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1319,    0, 1319,    0, 1319, 1319, 1319,    0, 1319,
    0,    0, 1319, 1319,    0,    0,    0,    0,    0,    0,
    0,    0, 1319,    0,    0,    0,    0, 1136, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1319,    0,    0, 1319,    0,
    0,    0,    0,    0,    0, 1320, 1320, 1320, 1320, 1320,
    0,    0,    0,    0, 1319,    0,    0,    0,    0,    0,
 1319, 1319,    0,    0,    0, 1319,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1319, 1319, 1320, 1319,
 1320,    0,    0,    0,    0, 1319,    0,    0, 1319,    0,
 1319, 1319, 1319, 1319,    0, 1319,    0, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1319, 1319,    0, 1319, 1319, 1319,
    0,    0,    0,    0, 1319, 1319, 1319, 1319, 1319,    0,
 1319,    0,    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
    0,    0,    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319,    0, 1319,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319,    0, 1319, 1319, 1319, 1319, 1319, 1319,
    0, 1319, 1319, 1319, 1319,    0, 1319,    0, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319,    0, 1319, 1319, 1319,
 1319,    0, 1319, 1319, 1319, 1319, 1319,    0, 1319, 1319,
 1319, 1319, 1319,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1320,
    0, 1320, 1320,    0,    0,    0,    0,    0, 1320,    0,
    0,    0,    0,    0, 1320,    0,    0,    0,    0, 1320,
    0,    0, 1320,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1320,    0,    0,    0,
    0, 1320, 1320,    0,    0, 1320,    0,    0,    0,    0,
    0,    0, 1320,    0, 1320, 1320,    0,    0, 1320,    0,
    0,    0, 1320,    0, 1320,    0, 1320,    0, 1320,    0,
    0,    0,    0, 1320, 1320,    0, 1320,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1321, 1320, 1320,    0, 1320,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1320,    0, 1320,    0, 1320, 1320,
 1320,    0, 1320,    0,    0, 1320, 1320,    0,    0,    0,
    0,    0,    0,    0,    0, 1320,    0,    0,    0,    0,
 1137, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1320,    0,
    0, 1320,    0,    0,    0,    0,    0,    0, 1321, 1321,
 1321, 1321, 1321,    0,    0,    0,    0, 1320,    0,    0,
    0,    0,    0, 1320, 1320,    0,    0,    0, 1320,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1320,
 1320, 1321, 1320, 1321,    0,    0,    0,    0, 1320,    0,
    0, 1320,    0, 1320, 1320, 1320, 1320,    0, 1320,    0,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1320, 1320,    0,
 1320, 1320, 1320,    0,    0,    0,    0, 1320, 1320, 1320,
 1320, 1320,    0, 1320,    0,    0, 1320, 1320, 1320, 1320,
 1320, 1320, 1320,    0,    0,    0, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320,    0, 1320,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320,    0, 1320, 1320, 1320,
 1320, 1320, 1320,    0, 1320, 1320, 1320, 1320,    0, 1320,
    0, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0,
 1320, 1320, 1320, 1320,    0, 1320, 1320, 1320, 1320, 1320,
    0, 1320, 1320, 1320, 1320, 1320,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1321,    0, 1321, 1321,    0,    0,    0,    0,
    0, 1321,    0,    0,    0,    0,    0, 1321,    0,    0,
    0,    0, 1321,    0,    0, 1321,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1321,
    0,    0,    0,    0, 1321, 1321,    0,    0, 1321,    0,
    0,    0,    0,    0,    0, 1321,    0, 1321, 1321,    0,
    0, 1321,    0,    0,    0, 1321,    0, 1321,    0, 1321,
    0, 1321,    0,    0,    0,    0, 1321, 1321,    0, 1321,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1322, 1321, 1321,    0, 1321,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1321,    0, 1321,
    0, 1321, 1321, 1321,    0, 1321,    0,    0, 1321, 1321,
    0,    0,    0,    0,    0,    0,    0,    0, 1321,    0,
    0,    0,    0, 1138, 1322, 1322, 1322, 1322, 1322, 1322,
 1322, 1321,    0,    0, 1321,    0,    0,    0,    0,    0,
    0, 1322, 1322, 1322, 1322, 1322,    0,    0,    0,    0,
 1321,    0,    0,    0,    0,    0, 1321, 1321,    0,    0,
    0, 1321,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1321, 1321, 1322, 1321, 1322,    0,    0,    0,
    0, 1321,    0,    0, 1321,    0, 1321, 1321, 1321, 1321,
    0, 1321,    0, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1321, 1321,    0, 1321, 1321, 1321,    0,    0,    0,    0,
 1321, 1321, 1321, 1321, 1321,    0, 1321,    0,    0, 1321,
 1321, 1321, 1321, 1321, 1321, 1321,    0,    0,    0, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321,    0, 1321,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1321, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,    0,
 1321, 1321, 1321, 1321, 1321, 1321,    0, 1321, 1321, 1321,
 1321,    0, 1321,    0, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321,    0, 1321, 1321, 1321, 1321,    0, 1321, 1321,
 1321, 1321, 1321,    0, 1321, 1321, 1321, 1321, 1321,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1322,    0, 1322, 1322,    0,
    0,    0,    0,    0, 1322,    0,    0,    0,    0,    0,
 1322,    0,    0,    0,    0, 1322,    0,    0, 1322,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1322,    0,    0,    0,    0, 1322, 1322,    0,
    0, 1322,    0,    0,    0,    0,    0,    0, 1322,    0,
 1322, 1322,    0,    0, 1322,    0,    0,    0, 1322,    0,
 1322,    0, 1322,    0, 1322,    0,    0,    0,    0, 1322,
 1322,    0, 1322,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1323, 1322, 1322,    0,
 1322,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1322,    0, 1322,    0, 1322, 1322, 1322,    0, 1322,    0,
    0, 1322, 1322,    0,    0,    0,    0,    0,    0,    0,
    0, 1322,    0,    0,    0,    0, 1139, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1322,    0,    0, 1322,    0,    0,
    0,    0,    0,    0, 1323, 1323, 1323, 1323, 1323,    0,
    0,    0,    0, 1322,    0,    0,    0,    0,    0, 1322,
 1322,    0,    0,    0, 1322,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1322, 1322, 1323, 1322, 1323,
    0,    0,    0,    0, 1322,    0,    0, 1322,    0, 1322,
 1322, 1322, 1322,    0, 1322,    0, 1322, 1322, 1322, 1322,
 1322, 1322, 1322, 1322,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1322, 1322,    0, 1322, 1322, 1322,    0,
    0,    0,    0, 1322, 1322, 1322, 1322, 1322,    0, 1322,
    0,    0, 1322, 1322, 1322, 1322, 1322, 1322, 1322,    0,
    0,    0, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
    0, 1322,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
 1322, 1322,    0, 1322, 1322, 1322, 1322, 1322, 1322,    0,
 1322, 1322, 1322, 1322,    0, 1322,    0, 1322, 1322, 1322,
 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
 1322, 1322, 1322, 1322, 1322,    0, 1322, 1322, 1322, 1322,
    0, 1322, 1322, 1322, 1322, 1322,    0, 1322, 1322, 1322,
 1322, 1322,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1323,    0,
 1323, 1323,    0,    0,    0,    0,    0, 1323,    0,    0,
    0,    0,    0, 1323,    0,    0,    0,    0, 1323,    0,
    0, 1323,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1323,    0,    0,    0,    0,
 1323, 1323,    0,    0, 1323,    0,    0,    0,    0,    0,
    0, 1323,    0, 1323, 1323,    0,    0, 1323,    0,    0,
    0, 1323,    0, 1323,    0, 1323,    0, 1323,    0,    0,
    0,    0, 1323, 1323,    0, 1323,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1324,
 1323, 1323,    0, 1323,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1323,    0, 1323,    0, 1323, 1323, 1323,
    0, 1323,    0,    0, 1323, 1323,    0,    0,    0,    0,
    0,    0,    0,    0, 1323,    0,    0,    0,    0, 1140,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1323,    0,    0,
 1323,    0,    0,    0,    0,    0,    0, 1324, 1324, 1324,
 1324, 1324,    0,    0,    0,    0, 1323,    0,    0,    0,
    0,    0, 1323, 1323,    0,    0,    0, 1323,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1323, 1323,
 1324, 1323, 1324,    0,    0,    0,    0, 1323,    0,    0,
 1323,    0, 1323, 1323, 1323, 1323,    0, 1323,    0, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1323, 1323,    0, 1323,
 1323, 1323,    0,    0,    0,    0, 1323, 1323, 1323, 1323,
 1323,    0, 1323,    0,    0, 1323, 1323, 1323, 1323, 1323,
 1323, 1323,    0,    0,    0, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323,    0, 1323,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323,    0, 1323, 1323, 1323, 1323,
 1323, 1323,    0, 1323, 1323, 1323, 1323,    0, 1323,    0,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,    0, 1323,
 1323, 1323, 1323,    0, 1323, 1323, 1323, 1323, 1323,    0,
 1323, 1323, 1323, 1323, 1323,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1324,    0, 1324, 1324,    0,    0,    0,    0,    0,
 1324,    0,    0,    0,    0,    0, 1324,    0,    0,    0,
    0, 1324,    0,    0, 1324,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1324,    0,
    0,    0,    0, 1324, 1324,    0,    0, 1324,    0,    0,
    0,    0,    0,    0, 1324,    0, 1324, 1324,    0,    0,
 1324,    0,    0,    0, 1324,    0, 1324,    0, 1324,    0,
 1324,    0,    0,    0,    0, 1324, 1324,    0, 1324,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1326, 1324, 1324,    0, 1324,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1324,    0, 1324,    0,
 1324, 1324, 1324,    0, 1324,    0,    0, 1324, 1324,    0,
    0,    0,    0,    0,    0,    0,    0, 1324,    0,    0,
    0,    0, 1141, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
 1324,    0,    0, 1324,    0,    0,    0,    0,    0,    0,
 1326, 1326, 1326, 1326, 1326,    0,    0,    0,    0, 1324,
    0,    0,    0,    0,    0, 1324, 1324,    0,    0,    0,
 1324,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1324, 1324, 1326, 1324, 1326,    0,    0,    0,    0,
 1324,    0,    0, 1324,    0, 1324, 1324, 1324, 1324,    0,
 1324,    0, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1324,
 1324,    0, 1324, 1324, 1324,    0,    0,    0,    0, 1324,
 1324, 1324, 1324, 1324,    0, 1324,    0,    0, 1324, 1324,
 1324, 1324, 1324, 1324, 1324,    0,    0,    0, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324,    0, 1324,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,    0, 1324,
 1324, 1324, 1324, 1324, 1324,    0, 1324, 1324, 1324, 1324,
    0, 1324,    0, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324,    0, 1324, 1324, 1324, 1324,    0, 1324, 1324, 1324,
 1324, 1324,    0, 1324, 1324, 1324, 1324, 1324,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1326,    0, 1326, 1326,    0,    0,
    0,    0,    0, 1326,    0,    0,    0,    0,    0, 1326,
    0,    0,    0,    0, 1326,    0,    0, 1326,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1326,    0,    0,    0,    0, 1326, 1326,    0,    0,
 1326,    0,    0,    0,    0,    0,    0, 1326,    0, 1326,
 1326,    0,    0, 1326,    0,    0,    0, 1326,    0, 1326,
    0, 1326,    0, 1326,    0,    0,    0,    0, 1326, 1326,
    0, 1326,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1327, 1326, 1326,    0, 1326,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1326,
    0, 1326,    0, 1326, 1326, 1326,    0, 1326,    0,    0,
 1326, 1326,    0,    0,    0,    0,    0,    0,    0,    0,
 1326,    0,    0,    0,    0, 1142, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1326,    0,    0, 1326,    0,    0,    0,
    0,    0,    0, 1327, 1327, 1327, 1327, 1327,    0,    0,
    0,    0, 1326,    0,    0,    0,    0,    0, 1326, 1326,
    0,    0,    0, 1326,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1326, 1326, 1327, 1326, 1327,    0,
    0,    0,    0, 1326,    0,    0, 1326,    0, 1326, 1326,
 1326, 1326,    0, 1326,    0, 1326, 1326, 1326, 1326, 1326,
 1326, 1326, 1326,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1326, 1326,    0, 1326, 1326, 1326,    0,    0,
    0,    0, 1326, 1326, 1326, 1326, 1326,    0, 1326,    0,
    0, 1326, 1326, 1326, 1326, 1326, 1326, 1326,    0,    0,
    0, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,    0,
 1326,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
 1326,    0, 1326, 1326, 1326, 1326, 1326, 1326,    0, 1326,
 1326, 1326, 1326,    0, 1326,    0, 1326, 1326, 1326, 1326,
 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
 1326, 1326, 1326, 1326,    0, 1326, 1326, 1326, 1326,    0,
 1326, 1326, 1326, 1326, 1326,    0, 1326, 1326, 1326, 1326,
 1326,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1327,    0, 1327,
 1327,    0,    0,    0,    0,    0, 1327,    0,    0,    0,
    0,    0, 1327,    0,    0,    0,    0, 1327,    0,    0,
 1327,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1327,    0,    0,    0,    0, 1327,
 1327,    0,    0, 1327,    0,    0,    0,    0,    0,    0,
 1327,    0, 1327, 1327,    0,    0, 1327,    0,    0,    0,
 1327,    0, 1327,    0, 1327,    0, 1327,    0,    0,    0,
    0, 1327, 1327,    0, 1327,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1328, 1327,
 1327,    0, 1327,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1327,    0, 1327,    0, 1327, 1327, 1327,    0,
 1327,    0,    0, 1327, 1327,    0,    0,    0,    0,    0,
    0,    0,    0, 1327,    0,    0,    0,    0, 1143, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1327,    0,    0, 1327,
    0,    0,    0,    0,    0,    0, 1328, 1328, 1328, 1328,
 1328,    0,    0,    0,    0, 1327,    0,    0,    0,    0,
    0, 1327, 1327,    0,    0,    0, 1327,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1327, 1327, 1328,
 1327, 1328,    0,    0,    0,    0, 1327,    0,    0, 1327,
    0, 1327, 1327, 1327, 1327,    0, 1327,    0, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1327, 1327,    0, 1327, 1327,
 1327,    0,    0,    0,    0, 1327, 1327, 1327, 1327, 1327,
    0, 1327,    0,    0, 1327, 1327, 1327, 1327, 1327, 1327,
 1327,    0,    0,    0, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327,    0, 1327,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327,    0, 1327, 1327, 1327, 1327, 1327,
 1327,    0, 1327, 1327, 1327, 1327,    0, 1327,    0, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327,    0, 1327, 1327,
 1327, 1327,    0, 1327, 1327, 1327, 1327, 1327,    0, 1327,
 1327, 1327, 1327, 1327,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1328,    0, 1328, 1328,    0,    0,    0,    0,    0, 1328,
    0,    0,    0,    0,    0, 1328,    0,    0,    0,    0,
 1328,    0,    0, 1328,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1328,    0,    0,
    0,    0, 1328, 1328,    0,    0, 1328,    0,    0,    0,
    0,    0,    0, 1328,    0, 1328, 1328,    0,    0, 1328,
    0,    0,    0, 1328,    0, 1328,    0, 1328,    0, 1328,
    0,    0,    0,    0, 1328, 1328,    0, 1328,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1330, 1328, 1328,    0, 1328,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1328,    0, 1328,    0, 1328,
 1328, 1328,    0, 1328,    0,    0, 1328, 1328,    0,    0,
    0,    0,    0,    0,    0,    0, 1328,    0,    0,    0,
    0, 1144, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1328,
    0,    0, 1328,    0,    0,    0,    0,    0,    0, 1330,
 1330, 1330, 1330, 1330,    0,    0,    0,    0, 1328,    0,
    0,    0,    0,    0, 1328, 1328,    0,    0,    0, 1328,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1328, 1328, 1330, 1328, 1330,    0,    0,    0,    0, 1328,
    0,    0, 1328,    0, 1328, 1328, 1328, 1328,    0, 1328,
    0, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1328, 1328,
    0, 1328, 1328, 1328,    0,    0,    0,    0, 1328, 1328,
 1328, 1328, 1328,    0, 1328,    0,    0, 1328, 1328, 1328,
 1328, 1328, 1328, 1328,    0,    0,    0, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328,    0, 1328,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1328, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1328,    0, 1328, 1328,
 1328, 1328, 1328, 1328,    0, 1328, 1328, 1328, 1328,    0,
 1328,    0, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
    0, 1328, 1328, 1328, 1328,    0, 1328, 1328, 1328, 1328,
 1328,    0, 1328, 1328, 1328, 1328, 1328,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1330,    0, 1330, 1330,    0,    0,    0,
    0,    0, 1330,    0,    0,    0,    0,    0, 1330,    0,
    0,    0,    0, 1330,    0,    0, 1330,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1330,    0,    0,    0,    0, 1330, 1330,    0,    0, 1330,
    0,    0,    0,    0,    0,    0, 1330,    0, 1330, 1330,
    0,    0, 1330,    0,    0,    0, 1330,    0, 1330,    0,
 1330,    0, 1330,    0,    0,    0,    0, 1330, 1330,    0,
 1330,    0,    0,    0,    0,    0,    0,    0,    0, 1244,
    0,    0,    0,    0,    0, 1330, 1330,    0, 1330,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1330,    0,
 1330,    0, 1330, 1330, 1330,    0, 1330,    0,    0, 1330,
 1330,    0,    0,    0,    0,    0,    0,    0,    0, 1330,
 1244, 1244, 1244, 1244, 1244, 1244, 1244,    0,    0,    0,
    0,    0, 1330,    0,    0, 1330,    0, 1244, 1244, 1244,
 1244, 1244,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1330,    0,    0,    0,    0,    0, 1330, 1330,    0,
    0,    0, 1330,    0,    0,    0,    0,    0,    0,    0,
 1244,    0, 1244, 1330, 1330,    0, 1330,    0,    0,    0,
    0,    0, 1330,    0,    0, 1330,    0, 1330, 1330, 1330,
 1330,    0, 1330,    0, 1330, 1330, 1330, 1330, 1330, 1330,
 1330, 1330,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1330, 1330,    0, 1330, 1330, 1330,    0,    0,    0,
    0, 1330, 1330, 1330, 1330, 1330,    0, 1330,    0,    0,
 1330, 1330, 1330, 1330, 1330, 1330, 1330,    0,    0,    0,
 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,    0, 1330,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1330,
 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
    0, 1330, 1330, 1330, 1330, 1330, 1330,    0, 1330, 1330,
 1330, 1330,    0, 1330,    0, 1330, 1330, 1330, 1330, 1330,
 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
 1330, 1330, 1330,    0, 1330, 1330, 1330, 1330,    0, 1330,
 1330, 1330, 1330, 1330,    0, 1330, 1330, 1330, 1330, 1330,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1244,    0, 1244, 1244,    0,    0,    0,    0,    0,
 1244,    0,    0,    0,    0,    0, 1244,    0,    0,    0,
    0, 1244,    0,    0, 1244,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1244,    0,
    0,    0,    0, 1244, 1244,    0,    0, 1244,    0,    0,
    0,    0,    0,    0, 1244,    0, 1244, 1244,    0,    0,
 1244,    0,    0,    0, 1244,    0, 1244,    0, 1244,    0,
 1244,    0,    0,    0,    0, 1244, 1244,    0, 1244,    0,
    0,    0,    0,    0,    0,    0,    0, 1292,    0,    0,
    0,    0,    0, 1244, 1244,    0, 1244,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1244,    0, 1244,    0,
 1244, 1244, 1244,    0, 1244,    0,    0, 1244, 1244,    0,
    0,    0,    0,    0,    0,    0,    0, 1244, 1292, 1292,
 1292, 1292, 1292, 1292, 1292,    0,    0,    0,    0,    0,
 1244,    0,    0, 1244,    0, 1292, 1292, 1292, 1292, 1292,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1244,
    0,    0,    0,    0,    0, 1244, 1244,    0,    0,    0,
 1244,    0,    0,    0,    0,    0,    0,    0, 1292,    0,
 1292, 1244, 1244,    0, 1244,    0,    0,    0,    0,    0,
 1244,    0,    0, 1244,    0, 1244, 1244, 1244, 1244,    0,
 1244,    0, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1244,
 1244,    0, 1244, 1244, 1244,    0,    0,    0,    0, 1244,
 1244, 1244, 1244, 1244,    0, 1244,    0,    0, 1244, 1244,
 1244, 1244, 1244, 1244, 1244,    0,    0,    0, 1244, 1244,
 1244, 1244, 1244, 1244, 1244, 1244,    0, 1244,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1244, 1244, 1244,
 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,    0, 1244,
 1244, 1244, 1244, 1244, 1244,    0, 1244, 1244, 1244, 1244,
    0, 1244,    0, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
 1244,    0, 1244, 1244, 1244, 1244,    0, 1244, 1244, 1244,
 1244, 1244,    0, 1244, 1244, 1244, 1244, 1244,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1292,
    0, 1292, 1292,    0,    0,    0,    0,    0, 1292,    0,
    0,    0,    0,    0, 1292,    0,    0,    0,    0, 1292,
    0,    0, 1292,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1292,    0,    0,    0,
    0, 1292, 1292,    0,    0, 1292,    0,    0,    0,    0,
    0,    0, 1292,    0, 1292, 1292,    0,    0, 1292,    0,
    0,    0, 1292,    0, 1292,    0, 1292,    0, 1292,    0,
    0,    0,    0, 1292, 1292,    0, 1292,    0,    0,    0,
    0,    0,    0,    0,    0, 1293,    0,    0,    0,    0,
    0, 1292, 1292,    0, 1292,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1292,    0, 1292,    0, 1292, 1292,
 1292,    0, 1292,    0,    0, 1292, 1292,    0,    0,    0,
    0,    0,    0,    0,    0, 1292, 1293, 1293, 1293, 1293,
 1293, 1293, 1293,    0,    0,    0,    0,    0, 1292,    0,
    0, 1292,    0, 1293, 1293, 1293, 1293, 1293,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1292,    0,    0,
    0,    0,    0, 1292, 1292,    0,    0,    0, 1292,    0,
    0,    0,    0,    0,    0,    0, 1293,    0, 1293, 1292,
 1292,    0, 1292,    0,    0,    0,    0,    0, 1292,    0,
    0, 1292,    0, 1292, 1292, 1292, 1292,    0, 1292,    0,
 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1292, 1292,    0,
 1292, 1292, 1292,    0,    0,    0,    0, 1292, 1292, 1292,
 1292, 1292,    0, 1292,    0,    0, 1292, 1292, 1292, 1292,
 1292, 1292, 1292,    0,    0,    0, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292,    0, 1292,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292,    0, 1292, 1292, 1292,
 1292, 1292, 1292,    0, 1292, 1292, 1292, 1292,    0, 1292,
    0, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,    0,
 1292, 1292, 1292, 1292,    0, 1292, 1292, 1292, 1292, 1292,
    0, 1292, 1292, 1292, 1292, 1292,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1293,    0, 1293,
 1293,    0,    0,    0,    0,    0, 1293,    0,    0,    0,
    0,    0, 1293,    0,    0,    0,    0, 1293,    0,    0,
 1293,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1293,    0,    0,    0,    0, 1293,
 1293,    0,    0, 1293,    0,    0,    0,    0,    0,    0,
 1293,    0, 1293, 1293,    0,    0, 1293,    0,    0,    0,
 1293,    0, 1293,    0, 1293,    0, 1293,    0,    0,    0,
    0, 1293, 1293,    0, 1293,    0,    0,    0,    0,    0,
    0,    0,    0, 1311,    0,    0,    0,    0,    0, 1293,
 1293,    0, 1293,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1293,    0, 1293,    0, 1293, 1293, 1293,    0,
 1293,    0,    0, 1293, 1293,    0,    0,    0,    0,    0,
    0,    0,    0, 1293, 1311, 1311, 1311, 1311, 1311, 1311,
 1311,    0,    0,    0,    0,    0, 1293,    0,    0, 1293,
    0, 1311, 1311, 1311, 1311, 1311,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1293,    0,    0,    0,    0,
    0, 1293, 1293,    0,    0,    0, 1293,    0,    0,    0,
    0,    0,    0,    0, 1311,    0, 1311, 1293, 1293,    0,
 1293,    0,    0,    0,    0,    0, 1293,    0,    0, 1293,
    0, 1293, 1293, 1293, 1293,    0, 1293,    0, 1293, 1293,
 1293, 1293, 1293, 1293, 1293, 1293,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1293, 1293,    0, 1293, 1293,
 1293,    0,    0,    0,    0, 1293, 1293, 1293, 1293, 1293,
    0, 1293,    0,    0, 1293, 1293, 1293, 1293, 1293, 1293,
 1293,    0,    0,    0, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293,    0, 1293,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293,    0, 1293, 1293, 1293, 1293, 1293,
 1293,    0, 1293, 1293, 1293, 1293,    0, 1293,    0, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293,    0, 1293, 1293,
 1293, 1293,    0, 1293, 1293, 1293, 1293, 1293,    0, 1293,
 1293, 1293, 1293, 1293,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1311,    0, 1311, 1311,    0,
    0,    0,    0,    0, 1311,    0,    0,    0,    0,    0,
 1311,    0,    0,    0,    0, 1311,    0,    0, 1311,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1311,    0,    0,    0,    0, 1311, 1311,    0,
    0, 1311,    0,    0,    0,    0,    0,    0, 1311,    0,
 1311, 1311,    0,    0, 1311,    0,    0,    0, 1311,    0,
 1311,    0, 1311,    0, 1311,    0,    0,    0,    0, 1311,
 1311,    0, 1311,    0,    0,    0,    0,    0,    0,    0,
    0, 1213,    0,    0,    0,    0,    0, 1311, 1311,    0,
 1311,    0,    0,    0,    0,  283,    0,    0,    0,    0,
 1311,    0, 1311,    0, 1311, 1311, 1311,    0, 1311,    0,
    0, 1311, 1311,    0,    0,    0,    0,    0,    0,    0,
    0, 1311, 1213, 1213, 1213, 1213, 1213, 1227, 1213,    0,
    0,    0,    0,    0, 1311,    0,  283, 1311,    0,  283,
 1213, 1213, 1213, 1213,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1311,  283,    0,    0,    0,    0, 1311,
 1311,    0,    0,    0, 1311,    0,    0,    0,    0,    0,
    0,    0, 1213,    0, 1213, 1311, 1311,    0, 1311,    0,
    0,    0,    0,    0, 1311,    0,    0, 1311,    0, 1311,
 1311, 1311, 1311,    0, 1311,    0, 1311, 1311, 1311, 1311,
 1311, 1311, 1311, 1311,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1311, 1311,    0, 1311, 1311, 1311,    0,
    0,    0,    0, 1311, 1311, 1311, 1311, 1311,    0, 1311,
    0,    0, 1311, 1311, 1311, 1311, 1311, 1311, 1311,    0,
    0,    0, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311,
    0, 1311,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311,
 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311,
 1311, 1311,    0, 1311, 1311, 1311, 1311, 1311, 1311,    0,
 1311, 1311, 1311, 1311,    0, 1311,    0, 1311, 1311, 1311,
 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311,
 1311, 1311, 1311, 1311, 1311,    0, 1311, 1311, 1311, 1311,
    0, 1311, 1311, 1311, 1311, 1311,    0, 1311, 1311, 1311,
 1311, 1311,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1213,    0, 1213, 1213,    0,    0,    0,
    0,    0, 1213,    0,    0,    0,    0,    0, 1213,    0,
    0,    0,    0, 1213,    0,    0, 1213,    0,    0,    0,
    0,  283,  283,    0,    0,    0,    0,    0,    0,  283,
 1213,    0, 1213,    0,    0, 1213, 1213,    0,    0, 1213,
    0,    0,    0,    0,    0,    0, 1213,    0, 1213, 1213,
    0,    0, 1213,    0,    0,    0, 1213,    0, 1213,    0,
 1213,    0, 1213,    0,    0,    0,    0, 1213, 1213,    0,
 1213,    0,    0,    0,    0,    0,    0,    0,    0, 1249,
    0,    0,    0,    0,    0, 1213, 1213,    0, 1213,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1213,    0,
 1213,    0, 1213, 1213, 1213,    0, 1213,    0,    0, 1213,
 1213,    0,    0,    0,    0,    0,  283,    0,    0, 1213,
 1249, 1249, 1249, 1249, 1249, 1249, 1249,    0,    0,    0,
    0,    0, 1213,    0,    0, 1213,    0,  283, 1249, 1249,
 1249, 1249,    0,  283,    0,    0,    0,    0,    0,    0,
    0, 1213,    0,    0,    0,    0,    0, 1213, 1213,    0,
    0,    0, 1213,    0,    0,    0,    0,    0,    0,    0,
 1249,    0, 1249, 1213, 1213,    0, 1213,  283,    0,    0,
    0,    0, 1213,    0,    0, 1213,    0, 1213, 1213, 1213,
 1213,    0, 1213,    0, 1213, 1213, 1213, 1213, 1213, 1213,
 1213, 1213,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1213, 1213,    0, 1213, 1213, 1213,    0,    0,    0,
    0, 1213, 1213, 1213, 1213, 1213,    0, 1213,    0,    0,
 1213, 1213, 1213, 1213, 1213, 1213, 1213,  283,    0,    0,
 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,    0, 1213,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1213,
 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
    0, 1213, 1213, 1213, 1213, 1213, 1213,    0, 1213, 1213,
 1213, 1213,    0, 1213,    0, 1213, 1213, 1213, 1213, 1213,
 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
 1213, 1213, 1213,    0, 1213, 1213, 1213, 1213,    0, 1213,
 1213, 1213, 1213, 1213,    0, 1213, 1213, 1213, 1213, 1213,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1249,    0, 1249, 1249,    0,    0,    0,    0,    0,
 1249,    0,    0,    0,    0,    0, 1249,    0,    0,    0,
    0, 1249,    0,    0, 1249,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1249,    0,
    0,    0,    0, 1249, 1249,    0,    0, 1249,    0,    0,
    0,    0,    0,    0, 1249,    0, 1249, 1249,    0,    0,
 1249,    0,    0,    0, 1249,    0, 1249,    0, 1249,    0,
 1249,    0,    0,    0,    0, 1249, 1249,    0, 1249,    0,
    0,    0,    0,    0,    0,    0,    0, 1245,    0,    0,
    0,    0,    0, 1249, 1249,    0, 1249,    0,    0,    0,
    0,  584,    0,    0,    0,    0, 1249,    0, 1249,    0,
 1249, 1249, 1249,    0, 1249,    0,    0, 1249, 1249,    0,
    0,    0,    0,    0,    0,    0,    0, 1249, 1245, 1245,
 1245, 1245, 1245, 1245, 1245,    0,    0,    0,    0,    0,
 1249,    0,  584, 1249,    0,  584, 1245, 1245, 1245, 1245,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1249,
  584,    0,    0,    0,    0, 1249, 1249,    0,    0,    0,
 1249,    0,    0,    0,    0,    0,    0,    0, 1245,    0,
 1245, 1249, 1249,    0, 1249,    0,    0,    0,    0,    0,
 1249,    0,    0, 1249,    0, 1249, 1249, 1249, 1249,    0,
 1249,    0, 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1249,
 1249,    0, 1249, 1249, 1249,    0,    0,    0,    0, 1249,
 1249, 1249, 1249, 1249,    0, 1249,    0,    0, 1249, 1249,
 1249, 1249, 1249, 1249, 1249,    0,    0,    0, 1249, 1249,
 1249, 1249, 1249, 1249, 1249, 1249,    0, 1249,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1249, 1249, 1249,
 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249,
 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249,    0, 1249,
 1249, 1249, 1249, 1249, 1249,    0, 1249, 1249, 1249, 1249,
    0, 1249,    0, 1249, 1249, 1249, 1249, 1249, 1249, 1249,
 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249, 1249,
 1249,    0, 1249, 1249, 1249, 1249,    0, 1249, 1249, 1249,
 1249, 1249,    0, 1249, 1249, 1249, 1249, 1249,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1245,
    0, 1245, 1245,    0,    0,    0,    0,    0, 1245,    0,
    0,    0,    0,    0, 1245,    0,    0,    0,    0, 1245,
    0,    0, 1245,    0,    0,    0,    0,  584,  584,    0,
    0,    0,    0,    0,    0,  584, 1245,    0,    0,    0,
    0, 1245, 1245,    0,    0, 1245,    0,    0,  584,    0,
    0,    0, 1245,    0, 1245, 1245,    0,    0, 1245,    0,
    0,    0, 1245,    0, 1245,    0, 1245,    0, 1245,    0,
    0,    0,    0, 1245, 1245,    0, 1245,    0,    0,    0,
    0,    0,    0,    0,    0, 1260,    0,    0,    0,    0,
    0, 1245, 1245,    0, 1245,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1245,    0, 1245,    0, 1245, 1245,
 1245,    0, 1245,    0,    0, 1245, 1245,    0,    0,    0,
    0,    0,  584,    0,    0, 1245, 1260, 1260, 1260, 1260,
 1260, 1260, 1260,    0,    0,    0,    0,    0, 1245,    0,
    0, 1245,    0,  584, 1260, 1260, 1260, 1260,    0,  584,
    0,    0,    0,    0,    0,    0,    0, 1245,    0,    0,
    0,    0,    0, 1245, 1245,    0,    0,    0, 1245,    0,
    0,    0,    0,    0,    0,    0, 1260,    0, 1260, 1245,
 1245,    0, 1245,  584,    0,    0,    0,    0, 1245,    0,
    0, 1245,    0, 1245, 1245, 1245, 1245,    0, 1245,    0,
 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1245, 1245,    0,
 1245, 1245, 1245,    0,    0,    0,    0, 1245, 1245, 1245,
 1245, 1245,    0, 1245,    0,    0, 1245, 1245, 1245, 1245,
 1245, 1245, 1245,    0,    0,    0, 1245, 1245, 1245, 1245,
 1245, 1245, 1245, 1245,    0, 1245,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1245, 1245, 1245, 1245, 1245,
 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245,
 1245, 1245, 1245, 1245, 1245, 1245,    0, 1245, 1245, 1245,
 1245, 1245, 1245,    0, 1245, 1245, 1245, 1245,    0, 1245,
    0, 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245,
 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245,    0,
 1245, 1245, 1245, 1245,    0, 1245, 1245, 1245, 1245, 1245,
    0, 1245, 1245, 1245, 1245, 1245,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1260,    0, 1260,
 1260,    0,    0,    0,    0,    0, 1260,    0,    0,    0,
    0,    0, 1260,    0,    0,    0,    0, 1260,    0,    0,
 1260,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1260,    0,    0,    0,    0, 1260,
 1260,    0,    0, 1260,    0,    0,    0,    0,    0,    0,
 1260,    0, 1260, 1260,    0,    0, 1260,    0,    0,    0,
 1260,    0, 1260,    0, 1260,    0, 1260,    0,    0,    0,
    0, 1260, 1260,    0, 1260,    0,    0,    0,    0,    0,
    0,    0,    0, 1265,    0,    0,    0,    0,    0, 1260,
 1260,    0, 1260,    0,    0,    0,    0,  623,    0,    0,
    0,    0, 1260,    0, 1260,    0, 1260, 1260, 1260,    0,
 1260,    0,    0, 1260, 1260,    0,    0,    0,    0,    0,
    0,    0,    0, 1260, 1265, 1265, 1265, 1265, 1265, 1265,
 1265,    0,    0,    0,    0,    0, 1260,    0,  623, 1260,
    0,  623, 1265, 1265, 1265, 1265,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1260,  623,    0,    0,    0,
    0, 1260, 1260,    0,    0,    0, 1260,    0,    0,    0,
    0,    0,    0,    0, 1265,    0, 1265, 1260, 1260,    0,
 1260,    0,    0,    0,    0,    0, 1260,    0,    0, 1260,
    0, 1260, 1260, 1260, 1260,    0, 1260,    0, 1260, 1260,
 1260, 1260, 1260, 1260, 1260, 1260,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1260, 1260,    0, 1260, 1260,
 1260,    0,    0,    0,    0, 1260, 1260, 1260, 1260, 1260,
    0, 1260,    0,    0, 1260, 1260, 1260, 1260, 1260, 1260,
 1260,    0,    0,    0, 1260, 1260, 1260, 1260, 1260, 1260,
 1260, 1260,    0, 1260,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
 1260, 1260, 1260, 1260,    0, 1260, 1260, 1260, 1260, 1260,
 1260,    0, 1260, 1260, 1260, 1260,    0, 1260,    0, 1260,
 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
 1260, 1260, 1260, 1260, 1260, 1260, 1260,    0, 1260, 1260,
 1260, 1260,    0, 1260, 1260, 1260, 1260, 1260,    0, 1260,
 1260, 1260, 1260, 1260,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1265,    0, 1265, 1265,    0,
    0,    0,    0,    0, 1265,    0,    0,    0,    0,    0,
 1265,    0,    0,    0,    0, 1265,    0,    0, 1265,    0,
    0,    0,    0,  623,  623,    0,    0,    0,    0,    0,
    0,  623, 1265,    0,    0,    0,    0, 1265, 1265,    0,
    0, 1265,    0,    0,  623,    0,    0,    0, 1265,    0,
 1265, 1265,    0,    0, 1265,    0,    0,    0, 1265,    0,
 1265,    0, 1265,    0, 1265,    0,    0,    0,    0, 1265,
 1265,    0, 1265,    0,    0,    0,    0,    0,    0,    0,
    0, 1294,    0,    0,    0,    0,    0, 1265, 1265,    0,
 1265,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1265,    0, 1265,    0, 1265, 1265, 1265,    0, 1265,    0,
    0, 1265, 1265,    0,    0,    0,    0,    0,  623,    0,
    0, 1265, 1294, 1294, 1294, 1294, 1294, 1294, 1294,    0,
    0,    0,    0,    0, 1265,    0,    0, 1265,    0,  623,
 1294, 1294, 1294, 1294,    0,  623,    0,    0,    0,    0,
    0,    0,    0, 1265,    0,    0,    0,    0,    0, 1265,
 1265,    0,    0,    0, 1265,    0,    0,    0,    0,    0,
    0,    0, 1294,    0, 1294, 1265, 1265,    0, 1265,  623,
    0,    0,    0,    0, 1265,    0,    0, 1265,    0, 1265,
 1265, 1265, 1265,    0, 1265,    0, 1265, 1265, 1265, 1265,
 1265, 1265, 1265, 1265,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1265, 1265,    0, 1265, 1265, 1265,    0,
    0,    0,    0, 1265, 1265, 1265, 1265, 1265,    0, 1265,
    0,    0, 1265, 1265, 1265, 1265, 1265, 1265, 1265,    0,
    0,    0, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
    0, 1265,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
 1265, 1265,    0, 1265, 1265, 1265, 1265, 1265, 1265,    0,
 1265, 1265, 1265, 1265,    0, 1265,    0, 1265, 1265, 1265,
 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
 1265, 1265, 1265, 1265, 1265,    0, 1265, 1265, 1265, 1265,
    0, 1265, 1265, 1265, 1265, 1265,    0, 1265, 1265, 1265,
 1265, 1265,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1294,    0, 1294, 1294,    0,    0,    0,
    0,    0, 1294,    0,    0,    0,    0,    0, 1294,    0,
    0,    0,    0, 1294,    0,    0, 1294,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1294,    0,    0,    0,    0, 1294, 1294,    0,    0, 1294,
    0,    0,    0,    0,    0,    0, 1294,    0, 1294, 1294,
    0,    0, 1294,    0,    0,    0, 1294,    0, 1294,    0,
 1294,    0, 1294,    0,    0,    0,    0, 1294, 1294,    0,
 1294,    0,    0,    0,    0,    0,    0,    0,    0, 1300,
    0,    0,    0,    0,    0, 1294, 1294,    0, 1294,    0,
    0,    0,    0,  157,    0,    0,    0,    0, 1294,    0,
 1294,    0, 1294, 1294, 1294,    0, 1294,    0,    0, 1294,
 1294,    0,    0,    0,    0,    0,    0,    0,    0, 1294,
 1300, 1300, 1300, 1300, 1300, 1300, 1300,    0,    0,    0,
    0,    0, 1294,    0,  157, 1294,    0,  157, 1300, 1300,
 1300, 1300,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1294,  157,    0,    0,    0,    0, 1294, 1294,    0,
    0,    0, 1294,    0,    0,    0,    0,    0,    0,    0,
 1300,    0, 1300, 1294, 1294,    0, 1294,    0,    0,    0,
    0,    0, 1294,    0,    0, 1294,    0, 1294, 1294, 1294,
 1294,    0, 1294,    0, 1294, 1294, 1294, 1294, 1294, 1294,
 1294, 1294,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1294, 1294,    0, 1294, 1294, 1294,    0,    0,    0,
    0, 1294, 1294, 1294, 1294, 1294,    0, 1294,    0,    0,
 1294, 1294, 1294, 1294, 1294, 1294, 1294,    0,    0,    0,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,    0, 1294,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
    0, 1294, 1294, 1294, 1294, 1294, 1294,    0, 1294, 1294,
 1294, 1294,    0, 1294,    0, 1294, 1294, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294, 1294, 1294,    0, 1294, 1294, 1294, 1294,    0, 1294,
 1294, 1294, 1294, 1294,    0, 1294, 1294, 1294, 1294, 1294,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1300,    0, 1300, 1300,    0,    0,    0,    0,    0,
 1300,    0,    0,    0,    0,    0, 1300,    0,    0,    0,
    0, 1300,    0,    0, 1300,    0,    0,    0,    0,  157,
  157,    0,    0,    0,    0,    0,    0,  157, 1300,    0,
    0,    0,    0, 1300, 1300,    0,    0, 1300,    0,    0,
    0,    0,    0,    0, 1300,    0, 1300, 1300,    0,    0,
 1300,    0,    0,    0, 1300,    0, 1300,    0, 1300,    0,
 1300,    0,    0,    0,    0, 1300, 1300,    0, 1300,    0,
    0,    0,    0,    0,    0,    0,    0,  996,    0,    0,
    0,    0,    0, 1300, 1300,    0, 1300,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1300,    0, 1300,    0,
 1300, 1300, 1300,    0, 1300,    0,    0, 1300, 1300,    0,
    0,    0,    0,    0,  157,    0,    0, 1300,  996,  996,
  996,  996,  996,  281,  996,    0,    0,    0,    0,    0,
 1300,    0,    0, 1300,    0,  157,  996,  996,  996,  996,
    0,  157,    0,    0,    0,    0,    0,    0,    0, 1300,
    0,    0,    0,    0,    0, 1300, 1300,    0,    0,    0,
 1300,    0,    0,    0,  281,    0,    0,  281,    0,    0,
  996, 1300, 1300,    0, 1300,  157,    0,    0,    0,    0,
 1300,    0,  281, 1300,    0, 1300, 1300, 1300, 1300,    0,
 1300,    0, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1300,
 1300,    0, 1300, 1300, 1300,    0,    0,    0,    0, 1300,
 1300, 1300, 1300, 1300,    0, 1300,    0,    0, 1300, 1300,
 1300, 1300, 1300, 1300, 1300,    0,    0,    0, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300,    0, 1300,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1300, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,    0, 1300,
 1300, 1300, 1300, 1300, 1300,    0, 1300, 1300, 1300, 1300,
    0, 1300,    0, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
 1300,    0, 1300, 1300, 1300, 1300,    0, 1300, 1300, 1300,
 1300, 1300,    0, 1300, 1300, 1300, 1300, 1300,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  996,
    0,  996,  996,    0,    0,    0,    0,    0,  996,    0,
    0,    0,    0,    0,  996,    0,    0,    0,    0,  996,
    0,    0,  996,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  996,    0,    0,    0,
    0,  996,  996,    0,    0,  996,    0,    0,    0,    0,
    0,    0,  996,    0,  996,  996,    0,    0,  996,  281,
  281,    0,  996,    0,  996,    0,  996,  281,  996,    0,
    0,    0,    0,  996,  996,    0,  996,    0,    0,    0,
    0,    0,    0,    0,    0, 1009,    0,    0,    0,    0,
    0,  996,  996,    0,  996,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  996,    0,  996,    0,  996,  996,
  996,    0,  996,    0,    0,  996,  996,    0,    0,    0,
    0,    0,    0,    0,    0,  996, 1009, 1009, 1009, 1009,
 1009,    0, 1009,    0,    0,    0,    0,    0,  996,    0,
    0,  996,    0,    0, 1009, 1009, 1009, 1009,    0,    0,
    0,    0,    0,    0,  281,    0,    0,  996,    0,    0,
    0,    0,    0,  996,  996,    0,    0,    0,  996,    0,
    0,    0,    0,    0,    0,  281,    0,    0, 1009,  996,
  996,  281,  996,    0,    0,    0,    0,    0,  996,    0,
    0,  996,    0,  996,  996,  996,  996,    0,  996,    0,
  996,  996,  996,  996,  996,  996,  996,  996,    0,    0,
    0,    0,    0,    0,    0,  281,    0,  996,  996,    0,
  996,  996,  996,    0,    0,    0,    0,  996,  996,  996,
  996,  996,    0,  996,    0,    0,  996,  996,  996,  996,
  996,  996,  996,    0,    0,    0,  996,  996,  996,  996,
  996,  996,  996,  996,    0,  996,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,    0,  996,  996,  996,
  996,  996,  996,    0,  996,  996,  996,  996,    0,  996,
    0,  996,  996,  996,  996,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,  996,  996,  996,    0,
  996,  996,  996,  996,    0,  996,  996,  996,  996,  996,
    0,  996,  996,  996,  996,  996,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1009,    0, 1009,
 1009,    0,    0,    0,    0,    0, 1009,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1009,    0,    0,
 1009,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1009,    0,    0,    0,    0, 1009,
 1009,    0,    0, 1009,    0,    0,    0,    0,    0,    0,
 1009,    0, 1009, 1009,    0,    0, 1009,    0,    0,    0,
 1009,    0, 1009,    0, 1009,    0, 1009,    0,    0,    0,
    0, 1009, 1009,    0, 1009,    0,    0,    0,    0,    0,
    0,    0,    0, 1012,    0,    0,    0,    0,    0, 1009,
 1009,    0, 1009,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1009,    0, 1009,    0, 1009, 1009, 1009,    0,
 1009,    0,    0, 1009, 1009,    0,    0,    0,    0,    0,
    0,    0,    0, 1009, 1012, 1012, 1012, 1012, 1012,    0,
 1012,    0,    0,    0,    0,    0, 1009,    0,    0, 1009,
    0,    0, 1012, 1012, 1012, 1012,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1009,    0,    0,    0,    0,
    0, 1009, 1009,    0,    0,    0, 1009,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1012, 1009, 1009,    0,
 1009,    0,    0,    0,    0,    0, 1009,    0,    0, 1009,
    0, 1009, 1009, 1009, 1009,    0, 1009,    0, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1009, 1009,    0, 1009, 1009,
 1009,    0,    0,    0,    0, 1009, 1009, 1009, 1009, 1009,
    0, 1009,    0,    0, 1009, 1009, 1009, 1009, 1009, 1009,
 1009,    0,    0,    0, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009,    0, 1009,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009,    0, 1009, 1009, 1009, 1009, 1009,
 1009,    0, 1009, 1009, 1009, 1009,    0, 1009,    0, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009,    0, 1009, 1009,
 1009, 1009,    0, 1009, 1009, 1009, 1009, 1009,    0, 1009,
 1009, 1009, 1009, 1009,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1012,    0, 1012, 1012,    0,
    0,    0,    0,    0, 1012,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1012,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1012,    0,    0,    0,    0, 1012, 1012,    0,
    0, 1012,    0,    0,    0,    0,    0,    0, 1012,    0,
 1012, 1012,    0,    0, 1012,    0,    0,    0, 1012,    0,
 1012,    0, 1012,    0, 1012,    0,    0,    0,    0, 1012,
 1012,    0, 1012,    0,    0,    0,    0,    0,    0,    0,
    0, 1013,    0,    0,    0,    0,    0, 1012, 1012,    0,
 1012,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1012,    0, 1012,    0, 1012, 1012, 1012,    0, 1012,    0,
    0, 1012, 1012,    0,    0,    0,    0,    0,    0,    0,
    0, 1012, 1013, 1013, 1013, 1013, 1013,    0, 1013,    0,
    0,    0,    0,    0, 1012,    0,    0, 1012,    0,    0,
 1013, 1013, 1013, 1013,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1012,    0,    0,    0,    0,    0, 1012,
 1012,    0,    0,    0, 1012,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1013, 1012, 1012,    0, 1012,    0,
    0,    0,    0,    0, 1012,    0,    0, 1012,    0, 1012,
 1012, 1012, 1012,    0, 1012,    0, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1012, 1012,    0, 1012, 1012, 1012,    0,
    0,    0,    0, 1012, 1012, 1012, 1012, 1012,    0, 1012,
    0,    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012,    0,
    0,    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
    0, 1012,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012,    0, 1012, 1012, 1012, 1012, 1012, 1012,    0,
 1012, 1012, 1012, 1012,    0, 1012,    0, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012,    0, 1012, 1012, 1012, 1012,
    0, 1012, 1012, 1012, 1012, 1012,    0, 1012, 1012, 1012,
 1012, 1012,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1013,    0, 1013, 1013,    0,    0,    0,
    0,    0, 1013,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1013,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1013,    0,    0,    0,    0, 1013, 1013,    0,    0, 1013,
    0,    0,    0,    0,    0,    0, 1013,    0, 1013, 1013,
    0,    0, 1013,    0,    0,    0, 1013,    0, 1013,    0,
 1013,    0, 1013,    0,    0,    0,    0, 1013, 1013,    0,
 1013,    0,    0,    0,    0,    0,    0, 1007,    0,    0,
    0,    0,    0,    0,    0, 1013, 1013,    0, 1013,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1013,    0,
 1013,    0, 1013, 1013, 1013,    0, 1013,    0,    0, 1013,
 1013,    0,    0,    0,    0,    0,    0,    0, 1007, 1013,
 1007, 1007, 1007,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1013,    0,    0, 1013, 1007, 1007, 1007, 1007,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1013,    0,    0,    0,    0,    0, 1013, 1013,    0,
    0,    0, 1013,    0,    0,    0,    0,    0,    0,    0,
 1007,    0,    0, 1013, 1013,    0, 1013,    0,    0,    0,
    0,    0, 1013,    0,    0, 1013,    0, 1013, 1013, 1013,
 1013,    0, 1013,    0, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1013, 1013,    0, 1013, 1013, 1013,    0,    0,    0,
    0, 1013, 1013, 1013, 1013, 1013,    0, 1013,    0,    0,
 1013, 1013, 1013, 1013, 1013, 1013, 1013,    0,    0,    0,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,    0, 1013,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
    0, 1013, 1013, 1013, 1013, 1013, 1013,    0, 1013, 1013,
 1013, 1013,    0, 1013,    0, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013,    0, 1013, 1013, 1013, 1013,    0, 1013,
 1013, 1013, 1013, 1013,    0, 1013, 1013, 1013, 1013, 1013,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1007,
    0, 1007, 1007,    0,    0,    0,    0,    0, 1007,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1007,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1007,    0,    0,    0,
    0, 1007, 1007,    0,    0, 1007,    0,    0,    0,    0,
    0,    0, 1007,    0, 1007, 1007,    0,    0, 1007,    0,
    0,    0, 1007,    0, 1007,    0, 1007,    0, 1007,    0,
    0,    0,    0, 1007, 1007,    0, 1007,    0,    0,    0,
    0,    0,    0, 1006,    0,    0,    0,    0,    0,    0,
    0, 1007, 1007,    0, 1007,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1007,    0, 1007,    0, 1007, 1007,
 1007,    0, 1007,    0,    0, 1007, 1007,    0,    0,    0,
    0,    0,    0,    0, 1006, 1007, 1006, 1006, 1006,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1007,    0,
    0, 1007, 1006, 1006, 1006, 1006,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1007,    0,    0,
    0,    0,    0, 1007, 1007,    0,    0,    0, 1007,    0,
    0,    0,    0,    0,    0,    0, 1006,    0,    0, 1007,
 1007,    0, 1007,    0,    0,    0,    0,    0, 1007,    0,
    0, 1007,    0, 1007, 1007, 1007, 1007,    0, 1007,    0,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1007, 1007,    0,
 1007, 1007, 1007,    0,    0,    0,    0, 1007, 1007, 1007,
 1007, 1007,    0, 1007,    0,    0, 1007, 1007, 1007, 1007,
 1007, 1007, 1007,    0,    0,    0, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007,    0, 1007,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007,    0, 1007, 1007, 1007,
 1007, 1007, 1007,    0, 1007, 1007, 1007, 1007,    0, 1007,
    0, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,    0,
 1007, 1007, 1007, 1007,    0, 1007, 1007, 1007, 1007, 1007,
    0, 1007, 1007, 1007, 1007, 1007,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1006,    0, 1006, 1006,    0,
    0,    0,    0,    0, 1006,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1006,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1006,    0,    0,    0,    0, 1006, 1006,    0,
    0, 1006,    0,    0,    0,    0,    0,    0, 1006,    0,
 1006, 1006,    0,    0, 1006,    0,    0,    0, 1006,    0,
 1006,    0, 1006,    0, 1006,    0,    0,    0,    0, 1006,
 1006,    0, 1006,    0,    0,    0,    0,    0,    0, 1008,
    0,    0,    0,    0,    0,    0,    0, 1006, 1006,    0,
 1006,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1006,    0, 1006,    0, 1006, 1006, 1006,    0, 1006,    0,
    0, 1006, 1006,    0,    0,    0,    0,    0,    0,    0,
 1008, 1006, 1008, 1008, 1008,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1006,    0,    0, 1006, 1008, 1008,
 1008, 1008,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1006,    0,    0,    0,    0,    0, 1006,
 1006,    0,    0,    0, 1006,    0,    0,    0,    0,    0,
    0,    0, 1008,    0,    0, 1006, 1006,    0, 1006,    0,
    0,    0,    0,    0, 1006,    0,    0, 1006,    0, 1006,
 1006, 1006, 1006,    0, 1006,    0, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1006, 1006,    0, 1006, 1006, 1006,    0,
    0,    0,    0, 1006, 1006, 1006, 1006, 1006,    0, 1006,
    0,    0, 1006, 1006, 1006, 1006, 1006, 1006, 1006,    0,
    0,    0, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
    0, 1006,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006,    0, 1006, 1006, 1006, 1006, 1006, 1006,    0,
 1006, 1006, 1006, 1006,    0, 1006,    0, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006,    0, 1006, 1006, 1006, 1006,
    0, 1006, 1006, 1006, 1006, 1006,    0, 1006, 1006, 1006,
 1006, 1006,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1008,    0, 1008, 1008,    0,    0,    0,    0,    0,
 1008,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1008,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1008,    0,
    0,    0,    0, 1008, 1008,    0,    0, 1008,    0,    0,
    0,    0,    0,    0, 1008,    0, 1008, 1008,    0,    0,
 1008,    0,    0,    0, 1008,    0, 1008,    0, 1008,    0,
 1008,    0,    0,    0,    0, 1008, 1008,    0, 1008,    0,
    0,    0,    0,    0,    0, 1011,    0,    0,    0,    0,
    0,    0,    0, 1008, 1008,    0, 1008,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1008,    0, 1008,    0,
 1008, 1008, 1008,    0, 1008,    0,    0, 1008, 1008,    0,
    0,    0,    0,    0,    0,    0, 1011, 1008, 1011, 1011,
 1011,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1008,    0,    0, 1008, 1011, 1011, 1011, 1011,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1008,
    0,    0,    0,    0,    0, 1008, 1008,    0,    0,    0,
 1008,    0,    0,    0,    0,    0,    0,    0, 1011,    0,
    0, 1008, 1008,    0, 1008,    0,    0,    0,    0,    0,
 1008,    0,    0, 1008,    0, 1008, 1008, 1008, 1008,    0,
 1008,    0, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1008,
 1008,    0, 1008, 1008, 1008,    0,    0,    0,    0, 1008,
 1008, 1008, 1008, 1008,    0, 1008,    0,    0, 1008, 1008,
 1008, 1008, 1008, 1008, 1008,    0,    0,    0, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008,    0, 1008,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,    0, 1008,
 1008, 1008, 1008, 1008, 1008,    0, 1008, 1008, 1008, 1008,
    0, 1008,    0, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008,    0, 1008, 1008, 1008, 1008,    0, 1008, 1008, 1008,
 1008, 1008,    0, 1008, 1008, 1008, 1008, 1008,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1011,    0, 1011,
 1011,    0,    0,    0,    0,    0, 1011,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1011,    0,    0,    0,    0,    0,    0,    0,    0,  830,
    0,    0,  811,    0, 1011,    0,    0,    0,    0, 1011,
 1011,    0,    0, 1011,    0,    0,    0,    0,    0,    0,
 1011,    0, 1011, 1011,    0,    0, 1011,    0,    0,    0,
 1011,    0, 1011,    0, 1011,    0, 1011,    0,    0,    0,
  830, 1011, 1011,  811, 1011,    0,  811,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  830, 1011,
 1011,  811, 1011,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1011,    0, 1011,    0, 1011, 1011, 1011,    0,
 1011,    0,    0, 1011, 1011,    0,    0,    0,    0,    0,
    0,    0,    0, 1011,    0, 1302,  995,  993,    0,  994,
    0,  996,    0,    0,    0,    0, 1011,    0,    0, 1011,
    0,    0,    0,    0, 1232, 1231, 1233,    0,    0,    0,
    0,    0,    0,    0,    0, 1011,    0,    0,    0,    0,
    0, 1011, 1011,    0,    0,    0, 1011,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1011, 1011,    0,
 1011,    0,    0,    0,    0,    0, 1011,    0,    0, 1011,
    0, 1011, 1011, 1011, 1011,    0, 1011,    0, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1011, 1011,    0, 1011, 1011,
 1011,    0,    0,    0,    0, 1011, 1011, 1011, 1011, 1011,
    0, 1011,    0,    0, 1011, 1011, 1011, 1011, 1011, 1011,
 1011,    0,    0,    0, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011,    0, 1011,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011,    0, 1011, 1011, 1011, 1011, 1011,
 1011,    0, 1011, 1011, 1011, 1011,  811, 1011,    0, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011,    0, 1011, 1011,
 1011, 1011,    0, 1011, 1011, 1011, 1011, 1011,    0, 1011,
 1011, 1011, 1011, 1011,  782,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  830,    0,    0,  811,    0,    0,
  811,    0,    0,    0,  830, 1219,  830,  811,    0,  811,
    0,  991,    0,  811,    0,  830,  992,    0,  811, 1220,
    0,  811,    0,    0,  782,  782,    0,    0,  782,    0,
    0,    0,    0,    0,    0,    0,  811,    0,    0,    0,
    0,    0,    0,  782,    0,    0,    0,    0,    0,  811,
    0,    0,    0,    0,    0, 1221,    0,  811,  830,    0,
    0,  811,    0, 1222,    0,    0,    0,  830,    0,    0,
  811, 1223,    0,    0,    0,    0,    0,    0,    0,  995,
  993,    0,  994,    0,  996,    0,  811,    0,    0, 1224,
    0, 1225,    0,    0,    0,    0,    0, 1232, 1231, 1233,
    0,    0,    0, 1226,    0, 1227, 1228, 1229,    0,    0,
  830,    0,    0,  811,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  830,  811,    0,  811,    0,    0,
    0,    0,    0,  811,    0,    0,  811,    0,  811,  811,
  811,  811,    0,  811,    0,    0,    0,    0,    0,    0,
    0,  811,  811,    0, 1230,    0,    0,    0,    0,    0,
    0,    0,  811,  811,    0,  811,  811,  811,    0,    0,
    0,    0,  811,  811,  811,  811,  811,    0,  811,    0,
    0,  811,  811,  811,  811,  811,  811,  811,  830,    0,
    0,  811,  811,  811,  811,  811,  811,  811,  811,    0,
  811,    0,    0,    0,    0,    0,    0,  830,    0,    0,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,    0,  811,  811,  811,  811,  811,  811,    0,  811,
  811,  811,  811,    0,  811,    0,  811,  811,  811,  811,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,  811,  811,  811,    0,  811,  811,  811,  811,  809,
  811,  811,  811,  811,  811,    0,  811,  811,  811,  811,
  811,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  782,
    0,    0,  782,    0,    0,    0,    0,    0, 1219,  782,
  809,  782,    0,  809,  991,  782,    0,    0,    0,  992,
  782,    0, 1220,  782,    0,    0,    0,    0,  809,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  782,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  782,    0,    0,    0,    0,    0,    0, 1221,  782,
    0,    0,    0,  782,    0,    0, 1222,    0,    0,    0,
    0,    0,  782,    0, 1223,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  782,    0,
    0,    0, 1224,    0, 1225,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1226,    0, 1227, 1228,
 1229,    0,    0,    0,    0,  782,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  782,    0,  782,
    0,    0,    0,    0,    0,  782,    0,    0,  782,    0,
  782,  782,  782,  782,    0,  782,    0,    0,    0,    0,
    0,    0,    0,  782,  782,    0,    0, 1230,    0,    0,
    0,    0,    0,    0,  782,  782,    0,  782,  782,  782,
    0,    0,    0,    0,  782,  782,  782,  782,  782,    0,
  782,    0,    0,  782,  782,  782,  782,  782,  782,  782,
    0,    0,    0,  782,  782,  782,  782,  782,  782,  782,
  782,    0,  782,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,    0,  782,  782,  782,  782,  782,  782,
    0,  782,  782,  782,  782,    0,  782,    0,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,    0,  782,  782,  782,
  782,    0,  782,  782,  782,  782,  782,    0,  782,  782,
  782,  782,  782,    0,  809,    0,    0,  809,    0,    0,
    0,    0,    0,    0,  809,    0,  809,    0,    0,    0,
  809,    0,    0,    0,    0,  809,    0,    0,  809,    0,
  628,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  650,  809,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  809,    0,    0,    0,
    0,    0,    0,    0,  809,    0,    0,    0,  809,    0,
    0,  628,    0,    0,  628,    0,    0,  809,    0,    0,
    0,    0,    0,  650,    0,    0,  650,    0,    0,  628,
    0,  628,    0,  809,    0,    0,    0, 1407,    0,    0,
    0,  650,    0,  650,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  809,  628,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  809,  650,  809,    0,    0,    0,    0,    0,
  782,    0,    0,  782,    0,  782,  782,  782,  782,    0,
  782,    0,    0,    0,    0,    0,    0,    0,  782,  782,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  782,
  782,    0,  782,  782,  782,    0,    0,    0,    0,  782,
  782,  809,  782,  782,    0,  782,    0,    0,  782,  782,
  782,  782,  782,  782,  782,    0,    0,    0,  809,  782,
  782,  782,  809,  782,  782,  782,    0,  782,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,    0,  782,
  782,  782,  782,  782,  782,    0,  782,  782,  782,  782,
    0,  782,    0,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,    0,  782,  782,  782,  782,  640,  782,  782,  782,
  782,  782,    0,  782,  782,  782,  782,  782,  628,    0,
  625,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  650,    0,    0,  628,    0,  628,  628,  628,    0,    0,
    0,  628,  623,    0,  628,  650,    0,  640,  650,  650,
  640,    0,    0,  650,    0,    0,  650,  628,    0,    0,
    0,  625,    0,  628,  625,  640,  628,  640,    0,  650,
    0,    0,    0,    0,  563,  650,    0,    0,  650,  625,
    0,  625,    0,  623,    0,    0,  623,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  640,    0,    0,
    0,  623,  565,  623,    0,    0,    0,    0,  628,    0,
    0,  625,    0,    0,   95,    0,    0,    0,    0,    0,
  650,   96,    0,    0,    0,   97,   98,    0,    0,    0,
  567,  628,    0,    0,   99,    0,    0,    0,    0,    0,
    0,    0,    0,  650,    0,  100,    0,    0,    0,    0,
    0,    0,  628,    0,    0,    0,  461,    0,  628,    0,
    0,    0,  628,    0,  650,    0,    0,    0,    0,  628,
  650,    0,  462,    0,  650,  964,    0,    0,  653,    0,
  654,  650,    0,  463,    0,    0,    0,  628,    0,    0,
  464,    0,  628,  656,  465,  466,    0,    0,  657,  650,
  575,    0,    0,  467,  650,    0,  101,    0,    0,    0,
    0,    0,    0,    0,  468,    0,  577,  628,    0,    0,
    0,  628,  102,    0,    0,    0,    0,    0,    0,  650,
  578,  579,  580,  650,  336,  337,    0,  103,    0,    0,
    0,  104,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  105,  583,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,  640,    0,    0,  469,  593,  594,
    0,  106,    0,    0,    0,  470,    0,  598,  625,  640,
    0,    0,  640,  640,    0,    0,    0,  640,    0,    0,
  640,    0,    0,  625,    0,    0,  625,  625,    0,    0,
  623,  625,    0,  640,  625,    0,  471,    0,    0,  640,
  472,    0,  640,    0,    0,  623,    0,  625,    0,  623,
  628,  473,    0,  625,    0,    0,  625,  107,    0,    0,
  108,    0,  650,    0,    0,    0,    0,    0,    0,  623,
  474,  475,    0,    0,    0,  623,    0,    0,  623,    0,
    0,    0,    0,    0,  640,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  625,    0,
    0,    0,    0,    0,    0,    0,    0,  640,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  623,  625,    0,    0,    0,    0,  476,    0,  640,  477,
    0,    0,  560,    0,  640,    0,    0,    0,  640,  561,
    0,    0,  625,  623,    0,  640,    0,    0,  625,    0,
    0,  562,  625,    0,    0,    0,    0,  563,  564,  625,
    0,    0,    0,  640,    0,    0,    0,    0,  640,    0,
    0,    0,    0,    0,  623,    0,    0,  625,    0,    0,
    0,  623,  625,    0,    0,  565,    0,    0,  566,    0,
    0,    0,    0,  640,    0,    0,    0,  640,    0,  623,
    0,    0,    0,    0,    0,    0,    0,  625,    0,    0,
    0,  625,    0,  567,    0,  568,  569,    0,    0,  570,
    0,    0,    0,    0,    0,  571,    0,    0,  572,  623,
    0,    0,    0,  623,    0,    0,    0,  928,    0,    0,
  653,    0,  654,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  573,  656,    0,    0,    0,    0,
  657,    0,    0,    0,    0,    0,    0,    0,    0,  574,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  575,    0,    0,    0,    0,    0,  576,
    0,    0,    0,    0,    0,    0,  640,    0,    0,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  625,    0,    0,  578,  579,  580,  581,  336,  337,  120,
    0,  121,  122,  123,  124,    0,  125,  582, 1257, 1258,
 1259, 1260, 1261, 1262, 1291, 1292,  583,  584,  585,  586,
  587,  588,  589,  590,  591,  128,  592,    0,  130,  131,
  132,  593,  594,    0,  595,  596,  597,    0,  135,  136,
  598,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  599,  147,    0,  600,
  149,  150,    0,  151,    0,  601,  602,  603,    0,  604,
  605,    0,  606,  152,  153,  154,  155,  156,  157,  607,
  159,  608,  161,  609,  610,  611,  612,  613,  614,  615,
  616,  617,  618,  619,    0,  620,  621,  622,  623,  624,
  625,    0,  626,  627,  628,  182,    0,  629,    0,  630,
  631,  632,  633,  634,  189,  190,  635, 1293,  636,  637,
  638,  196,  639,  198,  640,  200,  641,    0,  642,  643,
  644,  645,    0,  646,  647,  648,  209,  649,    0,  650,
  651,  213,  652, 1294,  560,    0,    0,    0,    0,    0,
    0,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  562,    0,    0,  921,    0,    0,  563,
  564,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  922,    0,
    0,    0,    0,    0,    0,    0,    0,  565,    0,    0,
  566,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  567,    0,  568,  569,    0,
    0,  570,    0,    0,    0,    0,    0,  571,    0,    0,
  572,    0,    0,    0,    0,    0,    0,    0,  923,  928,
    0,    0,  653,    0,  654,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  573,  656,    0,    0,
    0,    0,  657,    0,    0,    0,    0,    0,    0,    0,
    0,  574,    0,    0,    0,    0,    0,    0,    0,  924,
    0,    0,    0,    0,    0,  575,    0,    0,    0,    0,
    0,  576,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  577,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  578,  579,  580,  581,  336,
  337,  120,    0,  121,  122,  123,  124,    0,  125,  582,
    0,    0,    0,    0,    0,    0,  126,  127,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  128,  592,    0,
  130,  131,  132,  593,  594,    0,  595,  596,  597,    0,
  135,  136,  598,  137,    0,    0,  138,  139,  925,  926,
  927,  143,  144,    0,    0,    0,    0,  145,  599,  147,
    0,  600,  149,  150,    0,  151,    0,  601,  602,  603,
    0,  604,  605,    0,  606,  152,  153,  154,  155,  156,
  157,  607,  159,  608,  161,  609,  610,  611,  612,  613,
  614,  615,  616,  617,  618,  619,    0,  620,  621,  622,
  623,  624,  625,    0,  626,  627,  628,  182,    0,  629,
    0,  630,  631,  632,  633,  634,  189,  190,  635,  192,
  636,  637,  638,  196,  639,  198,  640,  200,  641,    0,
  642,  643,  644,  645,    0,  646,  647,  648,  209,  649,
    0,  650,  651,  213,  652,  215,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,    0,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  922,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
  923,  928,    0,    0,  653,    0,  654,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  573,  656,
    0,    0,    0,    0,  657,    0,    0,    0,    0,    0,
    0,    0,    0,  574,    0,    0,    0,    0,    0,    0,
    0,  924,    0,    0,    0,    0,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   17,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  925,  926,  927,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,    0,  650,  651,  213,  652,  215,  560,    0,
    0,    0,    0,    0,    0,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  562,    0,    0,
    0,    0,    0,  563,  564,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  922,    0,    0,    0,    0,    0,    0,    0,
    0,  565,    0,    0,  566,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  567,
    0,  568,  569,    0,    0,  570,    0,    0,    0,    0,
    0,  571,    0,    0,  572,    0,    0,    0,    0,    0,
    0,    0,  923,  964,    0,    0,  653,    0,  654,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  573,  656,    0,    0,    0,    0,  657,    0,    0,    0,
    0,    0,    0,    0,    0,  574,    0,    0,    0,    0,
    0,    0,    0,  924,    0,    0,    0,    0,    0,  575,
    0,    0,    0,    0,    0,  576,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  578,
  579,  580,  581,  336,  337,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  128,  592,    0,  130,  131,  132,  593,  594,    0,
  595,  596,  597,    0,  135,  136,  598,  137,    0,    0,
  138,  139,  925,  926,  927,  143,  144,    0,    0,    0,
    0,  145,  599,  147,    0,  600,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  625,    0,  626,  627,
  628,  182,    0,  629,    0,  630,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641,    0,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
  560,    0,    0,    0,    0,    0,    0,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  562,
    0,    0,    0,    0,    0,  563,  564,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  565,    0,    0,  566,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  567,    0,  568,  569,    0,    0,  570,    0,    0,
    0,    0,    0,  571,    0,    0,  572,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  653,    0,  654,    0,    0,
    0,    0,  573,    0,    0,    0,    0,    0,    0,    0,
  656,    0,    0,    0,    0,  657,    0,  574,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  575,    0,    0,    0,    0,    0,  576,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  577,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  578,  579,  580,  581,  336,  337,  120,    0,  121,
  122,  123,  124,    0,  125,  582,    0,    0,    0,    0,
    0,    0,  126,  127,  583,  584,  585,  586,  587,  588,
  589,  590,  591,  128,  592,    0,  130,  131,  132,  593,
  594,    0,  595,  596,  597,    0,  135,  136,  598,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  599,  147,    0,  600,  149,  150,
 1286,  151,    0,  601,  602,  603, 1287,  604,  605, 1288,
  606,  152,  153,  154,  155,  156,  157,  607,  159,  608,
  161,  609,  610,  611,  612,  613,  614,  615,  616,  617,
  618,  619,    0,  620,  621,  622,  623,  624,  625,    0,
  626,  627,  628,  182,    0,  629,    0,  630,  631,  632,
  633,  634,  189,  190,  635,  192,  636,  637,  638,  196,
  639,  198,  640,  200,  641,    0,  642,  643,  644,  645,
    0,  646,  647,  648,  209,  649,    0,  650,  651,  213,
  652,  215, 1520,    0,    0, 1521,    0,    0,    0,  560,
    0,    0,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  562,    0,
    0,    0,    0,    0,  563,  564,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  565,    0,    0,  566,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  567,    0,  568,  569,    0,    0,  570,    0,    0,    0,
    0,    0,  571,    0,    0,  572,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  964,    0,    0,  653,    0,  654,    0,    0,    0,
    0,  573,    0,    0,    0,    0,    0,    0,    0,  656,
    0,    0,    0,    0,  657,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1522,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  577,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582,    0,    0,    0,    0,    0,
    0,  126,  127,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635,  192,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,    0,  650,  651,  213,  652,
  215, 1531,    0,    0, 1521,    0,    0,    0,  560,    0,
    0,    0,    0,    0,    0,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  562,    0,    0,
    0,    0,    0,  563,  564,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  565,    0,    0,  566,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  567,
    0,  568,  569,    0,    0,  570,    0,    0,    0,    0,
    0,  571,    0,    0,  572,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  964,    0,    0,  653,    0,  654,    0,    0,    0,    0,
  573,    0,    0,    0,    0,    0,    0,    0,  656,    0,
    0,    0,    0,  657,    0,  574,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1522,    0,  575,
    0,    0,    0,    0,    0,  576,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  578,
  579,  580,  581,  336,  337,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  128,  592,    0,  130,  131,  132,  593,  594,    0,
  595,  596,  597,    0,  135,  136,  598,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  599,  147,    0,  600,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  625,    0,  626,  627,
  628,  182,    0,  629,    0,  630,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641,    0,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
 1535,    0,    0, 1521,    0,    0,    0,  560,    0,    0,
    0,    0,    0,    0,  561,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  562,    0,    0,    0,
    0,    0,  563,  564,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  565,    0,    0,  566,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  567,    0,
  568,  569,    0,    0,  570,    0,    0,    0,    0,    0,
  571,    0,    0,  572,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  964,
    0,    0,  653,    0,  654,    0,    0,    0,    0,  573,
    0,    0,    0,    0,    0,    0,    0,  656,    0,    0,
    0,    0,  657,    0,  574,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1522,    0,  575,    0,
    0,    0,    0,    0,  576,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  577,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  578,  579,
  580,  581,  336,  337,  120,    0,  121,  122,  123,  124,
    0,  125,  582,    0,    0,    0,    0,    0,    0,  126,
  127,  583,  584,  585,  586,  587,  588,  589,  590,  591,
  128,  592,    0,  130,  131,  132,  593,  594,    0,  595,
  596,  597,    0,  135,  136,  598,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  599,  147,    0,  600,  149,  150,    0,  151,    0,
  601,  602,  603,    0,  604,  605,    0,  606,  152,  153,
  154,  155,  156,  157,  607,  159,  608,  161,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,  619,    0,
  620,  621,  622,  623,  624,  625,    0,  626,  627,  628,
  182,    0,  629,    0,  630,  631,  632,  633,  634,  189,
  190,  635,  192,  636,  637,  638,  196,  639,  198,  640,
  200,  641,    0,  642,  643,  644,  645,    0,  646,  647,
  648,  209,  649,    0,  650,  651,  213,  652,  215, 1543,
    0,    0, 1521,    0,    0,    0,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,    0,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  964,    0,
    0,  653,    0,  654,    0,    0,    0,    0,  573,    0,
    0,    0,    0,    0,    0,    0,  656,    0,    0,    0,
    0,  657,    0,  574,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1522,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,    0,  650,  651,  213,  652,  215, 1546,    0,
    0, 1521,    0,    0,    0,  560,    0,    0,    0,    0,
    0,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  562,    0,    0,    0,    0,    0,
  563,  564,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  565,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  567,    0,  568,  569,
    0,    0,  570,    0,    0,    0,    0,    0,  571,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  964,    0,    0,
  653,    0,  654,    0,    0,    0,    0,  573,    0,    0,
    0,    0,    0,    0,    0,  656,    0,    0,    0,    0,
  657,    0,  574,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1522,    0,  575,    0,    0,    0,
    0,    0,  576,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  577,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  578,  579,  580,  581,
  336,  337,  120,    0,  121,  122,  123,  124,    0,  125,
  582,    0,    0,    0,    0,    0,    0,  126,  127,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  128,  592,
    0,  130,  131,  132,  593,  594,    0,  595,  596,  597,
    0,  135,  136,  598,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  599,
  147,    0,  600,  149,  150,    0,  151,    0,  601,  602,
  603,    0,  604,  605,    0,  606,  152,  153,  154,  155,
  156,  157,  607,  159,  608,  161,  609,  610,  611,  612,
  613,  614,  615,  616,  617,  618,  619,    0,  620,  621,
  622,  623,  624,  625,    0,  626,  627,  628,  182,    0,
  629,    0,  630,  631,  632,  633,  634,  189,  190,  635,
  192,  636,  637,  638,  196,  639,  198,  640,  200,  641,
    0,  642,  643,  644,  645,    0,  646,  647,  648,  209,
  649,    0,  650,  651,  213,  652,  215, 1551,    0,    0,
 1521,    0,    0,    0,  560,    0,    0,    0,    0,    0,
    0,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  562,    0,    0,    0,    0,    0,  563,
  564,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  565,    0,    0,
  566,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  567,    0,  568,  569,    0,
    0,  570,    0,    0,    0,    0,    0,  571,    0,    0,
  572,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  964,    0,    0,  653,
    0,  654,    0,    0,    0,    0,  573,    0,    0,    0,
    0,    0,    0,    0,  656,    0,    0,    0,    0,  657,
    0,  574,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1522,    0,  575,    0,    0,    0,    0,
    0,  576,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  577,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  578,  579,  580,  581,  336,
  337,  120,    0,  121,  122,  123,  124,    0,  125,  582,
    0,    0,    0,    0,    0,    0,  126,  127,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  128,  592,    0,
  130,  131,  132,  593,  594,    0,  595,  596,  597,    0,
  135,  136,  598,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  599,  147,
    0,  600,  149,  150,    0,  151,    0,  601,  602,  603,
    0,  604,  605,    0,  606,  152,  153,  154,  155,  156,
  157,  607,  159,  608,  161,  609,  610,  611,  612,  613,
  614,  615,  616,  617,  618,  619,    0,  620,  621,  622,
  623,  624,  625,    0,  626,  627,  628,  182,    0,  629,
    0,  630,  631,  632,  633,  634,  189,  190,  635,  192,
  636,  637,  638,  196,  639,  198,  640,  200,  641,    0,
  642,  643,  644,  645,    0,  646,  647,  648,  209,  649,
    0,  650,  651,  213,  652,  215, 1554,    0,    0, 1521,
    0,    0,    0,  560,    0,    0,    0,    0,    0,    0,
  561,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  562,    0,    0,    0,    0,    0,  563,  564,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  565,    0,    0,  566,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  567,    0,  568,  569,    0,    0,
  570,    0,    0,    0,    0,    0,  571,    0,    0,  572,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  964,    0,    0,  653,    0,
  654,    0,    0,    0,    0,  573,    0,    0,    0,    0,
    0,    0,    0,  656,    0,    0,    0,    0,  657,    0,
  574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1522,    0,  575,    0,    0,    0,    0,    0,
  576,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  577,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  578,  579,  580,  581,  336,  337,
  120,    0,  121,  122,  123,  124,    0,  125,  582,    0,
    0,    0,    0,    0,    0,  126,  127,  583,  584,  585,
  586,  587,  588,  589,  590,  591,  128,  592,    0,  130,
  131,  132,  593,  594,    0,  595,  596,  597,    0,  135,
  136,  598,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  599,  147,    0,
  600,  149,  150,    0,  151,    0,  601,  602,  603,    0,
  604,  605,    0,  606,  152,  153,  154,  155,  156,  157,
  607,  159,  608,  161,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,  619,    0,  620,  621,  622,  623,
  624,  625,    0,  626,  627,  628,  182,    0,  629,    0,
  630,  631,  632,  633,  634,  189,  190,  635,  192,  636,
  637,  638,  196,  639,  198,  640,  200,  641,    0,  642,
  643,  644,  645,    0,  646,  647,  648,  209,  649,    0,
  650,  651,  213,  652,  215, 1557,    0,    0, 1521,    0,
    0,    0,  560,    0,    0,    0,    0,    0,    0,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  793,
    0,  562,    0,    0,    0,    0,    0,  563,  564,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  565,    0,    0,  566,  793,
  793,    0,    0,  793,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  793,    0,
    0,    0,    0,  567,    0,  568,  569,    0,    0,  570,
    0,    0,    0,    0,    0,  571,    0,    0,  572,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  764,    0,
  764,  764,    0,  764,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  573,    0,  764,    0,    0,    0,
    0,  764,    0,    0,    0,    0,    0,    0,    0,  574,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1522,    0,  575,    0,    0,    0,    0,    0,  576,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  578,  579,  580,  581,  336,  337,  120,
    0,  121,  122,  123,  124,    0,  125,  582,    0,    0,
    0,    0,    0,    0,  126,  127,  583,  584,  585,  586,
  587,  588,  589,  590,  591,  128,  592,    0,  130,  131,
  132,  593,  594,    0,  595,  596,  597,    0,  135,  136,
  598,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  599,  147,    0,  600,
  149,  150,    0,  151,    0,  601,  602,  603,    0,  604,
  605,    0,  606,  152,  153,  154,  155,  156,  157,  607,
  159,  608,  161,  609,  610,  611,  612,  613,  614,  615,
  616,  617,  618,  619,    0,  620,  621,  622,  623,  624,
  625,    0,  626,  627,  628,  182,    0,  629,    0,  630,
  631,  632,  633,  634,  189,  190,  635,  192,  636,  637,
  638,  196,  639,  198,  640,  200,  641,    0,  642,  643,
  644,  645,    0,  646,  647,  648,  209,  649,  764,  650,
  651,  213,  652,  215,  793,  764,    0,  793,    0,    0,
    0,    0,  764,    0,  793,    0,  793,    0,    0,    0,
  793,    0,    0,    0,  764,  793,    0,    0,  793,    0,
  764,  764,    0,    0,    0,    0,    0,    0,  764,    0,
    0,    0,    0,  793,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  793,    0,  764,    0,
    0,  764,    0,    0,  793,    0,    0,    0,  793,    0,
    0,    0,    0,    0,    0,    0,    0,  793,    0,    0,
    0,    0,    0,    0,    0,    0,  764,    0,  764,  764,
    0,    0,  764,  793,    0,    0,    0,    0,  764,    0,
    0,  764,    0,    0,    0,    0,    0,    0,    0,    0,
  964,    0,    0,  653,    0,  654,    0,    0,    0,    0,
  793,    0,    0,    0,    0,    0,    0,  764,  656,    0,
    0,    0,  793,  657,  793,    0,    0,    0,    0,    0,
    0,    0,  764,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  764,    0,    0,    0,
    0,    0,  764,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  764,    0,    0,    0,    0,    0,    0,    0,
    0,  793,    0,    0,    0,    0,  764,  764,  764,  764,
  764,  764,  764,    0,  764,  764,  764,  764,  793,  764,
  764,    0,  793,    0,    0,    0,    0,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
    0,  764,  764,    0,  764,  764,    0,  764,  764,  764,
    0,  764,  764,  764,  764,    0,    0,  764,  764,  764,
  764,  764,  764,  764,    0,    0,    0,    0,  764,  764,
  764,    0,  764,  764,  764,    0,  764,    0,  764,  764,
  764,    0,  764,  764,    0,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,    0,  764,  764,
  764,  764,  764,  764,    0,  764,  764,  764,  764,    0,
  764,    0,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
    0,  764,  764,  764,  764,    0,  764,  764,  764,  764,
  764,    0,  764,  764,  764,  764,  764,  560,    0,    0,
    0,    0,    0,    0,  561,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  562,    0,    0,    0,
    0,    0,  563,  564,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  565,    0,    0,  566,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  567,    0,
  568,  569,    0,    0,  570,    0,    0,    0,    0,    0,
  571,    0,    0,  572,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  653,    0,  654,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  573,
  656,    0,    0,    0,    0,  657,    0,    0,    0,    0,
    0,    0,    0,    0,  574,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  575,    0,
    0,    0,    0,    0,  576,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  577,    0,    0,    0,    0,    0,
    0,    0,  963,    0,    0,    0,    0,    0,  578,  579,
  580,  581,  336,  337,  120,    0,  121,  122,  123,  124,
    0,  125,  582,    0,    0,    0,    0,    0,    0,  126,
  127,  583,  584,  585,  586,  587,  588,  589,  590,  591,
  128,  592,    0,  130,  131,  132,  593,  594,    0,  595,
  596,  597,    0,  135,  136,  598,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  599,  147,    0,  600,  149,  150,    0,  151,    0,
  601,  602,  603,    0,  604,  605,    0,  606,  152,  153,
  154,  155,  156,  157,  607,  159,  608,  161,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,  619,    0,
  620,  621,  622,  623,  624,  625,    0,  626,  627,  628,
  182,    0,  629,    0,  630,  631,  632,  633,  634,  189,
  190,  635,  192,  636,  637,  638,  196,  639,  198,  640,
  200,  641,    0,  642,  643,  644,  645,    0,  646,  647,
  648,  209,  649,    0,  650,  651,  213,  652,  215,  560,
    0,    0,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  562,    0,
    0,    0,    0,    0,  563,  564,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  565,    0,    0,  566,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  567,    0,  568,  569,    0,    0,  570,    0,    0,    0,
    0,    0,  571,    0,    0,  572,    0,    0,    0,    0,
    0,    0,    0,    0,  964,    0, 1089,  653,    0,  654,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  573,  656,    0,    0,    0,    0,  657,    0,    0,
    0,    0,    0,    0,    0,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  577,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   17,    0,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582,    0,    0,    0,    0,    0,
    0,  126,  127,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635,  192,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,    0,  650,  651,  213,  652,
  215,  560,    0,    0,    0,    0,    0,    0,  561,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  562,    0,    0,    0,    0,    0,  563,  564,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  565,    0,    0,  566,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  567,    0,  568,  569,    0,    0,  570,    0,
    0,    0,    0,    0,  571,    0,    0,  572,    0,    0,
    0,    0,    0,    0,    0,    0,  964, 1324,    0,  653,
    0,  654,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  573,  656,    0,    0,    0,    0,  657,
    0,    0,    0,    0,    0,    0,    0,    0,  574,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  575,    0,    0,    0,    0,    0,  576,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  577,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  578,  579,  580,  581,  336,  337,  120,    0,
  121,  122,  123,  124,    0,  125,  582,    0,    0,    0,
    0,    0,    0,  126,  127,  583,  584,  585,  586,  587,
  588,  589,  590,  591,  128,  592,    0,  130,  131,  132,
  593,  594,    0,  595,  596,  597,    0,  135,  136,  598,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  599,  147,    0,  600,  149,
  150,    0,  151,    0,  601,  602,  603,    0,  604,  605,
    0,  606,  152,  153,  154,  155,  156,  157,  607,  159,
  608,  161,  609,  610,  611,  612,  613,  614,  615,  616,
  617,  618,  619,    0,  620,  621,  622,  623,  624,  625,
    0,  626,  627,  628,  182,    0,  629,    0,  630,  631,
  632,  633,  634,  189,  190,  635,  192,  636,  637,  638,
  196,  639,  198,  640,  200,  641,    0,  642,  643,  644,
  645,    0,  646,  647,  648,  209,  649,    0,  650,  651,
  213,  652,  215,  560,    0,    0,    0,    0,    0,    0,
  561,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  562,    0,    0,    0,    0,    0,  563,  564,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  565,    0,    0,  566,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  567,    0,  568,  569,    0,    0,
  570,    0,    0,    0,    0,    0,  571,    0,    0,  572,
    0,    0,    0,    0,    0,    0,    0,    0,  964,    0,
    0,  653,    0,  654,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  573,  656,    0,    0,    0,
    0,  657,    0,    0,    0,    0,    0,    0,    0,    0,
  574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  575,    0,    0,    0,    0,    0,
  576,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  577,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  578,  579,  580,  581,  336,  337,
  120,    0,  121,  122,  123,  124,    0,  125,  582,    0,
    0,    0,    0,    0,    0,  126,  127,  583,  584,  585,
  586,  587,  588,  589,  590,  591,  128,  592,    0,  130,
  131,  132,  593,  594,    0,  595,  596,  597,    0,  135,
  136,  598,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  599,  147,    0,
  600,  149,  150,    0,  151,    0,  601,  602,  603,    0,
  604,  605,    0,  606,  152,  153,  154,  155,  156,  157,
  607,  159,  608,  161,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,  619,    0,  620,  621,  622,  623,
  624,  625,    0,  626,  627,  628,  182,    0,  629,    0,
  630,  631,  632,  633,  634,  189,  190,  635,  192,  636,
  637,  638,  196,  639,  198,  640,  200,  641,    0,  642,
  643,  644,  645,    0,  646,  647,  648,  209,  649,    0,
  650,  651,  213,  652,  215,  560,    0,    0,    0,    0,
    0,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  562,    0,    0,    0,    0,    0,
  563,  564,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  565,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  567,    0,  568,  569,
    0,    0,  570,    0,    0,    0,    0,    0,  571,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,    0,
  964,    0,    0,  653,    0,  654,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  573,  656,    0,
    0,    0,    0,  657,    0,    0,    0,    0,    0,    0,
    0,    0,  574,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  575,    0,    0,    0,
    0,    0,  576,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  577,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1549,    0,    0,  578,  579,  580,  581,
  336,  337,  120,    0,  121,  122,  123,  124,    0,  125,
  582,    0,    0,    0,    0,    0,    0,  126,  127,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  128,  592,
    0,  130,  131,  132,  593,  594,    0,  595,  596,  597,
    0,  135,  136,  598,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  599,
  147,    0,  600,  149,  150,    0,  151,    0,  601,  602,
  603,    0,  604,  605,    0,  606,  152,  153,  154,  155,
  156,  157,  607,  159,  608,  161,  609,  610,  611,  612,
  613,  614,  615,  616,  617,  618,  619,    0,  620,  621,
  622,  623,  624,  625,    0,  626,  627,  628,  182,    0,
  629,    0,  630,  631,  632,  633,  634,  189,  190,  635,
  192,  636,  637,  638,  196,  639,  198,  640,  200,  641,
    0,  642,  643,  644,  645,    0,  646,  647,  648,  209,
  649,    0,  650,  651,  213,  652,  215,  560,    0,    0,
    0,    0,    0,    0,  561,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  562,    0,    0,    0,
    0,    0,  563,  564,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1603,    0,    0,
  565,    0,    0,  566,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  567,    0,
  568,  569,    0,    0,  570,    0,    0,    0,    0,    0,
  571,    0,    0,  572,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  653,    0,  654,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  573,
  656,    0,    0,    0,    0,  657,    0,    0,    0,    0,
    0,    0,    0,    0,  574,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  575,    0,
    0,    0,    0,    0,  576,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  577,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  578,  579,
  580,  581,  336,  337,  120,    0,  121,  122,  123,  124,
    0,  125,  582,    0,    0,    0,    0,    0,    0,  126,
  127,  583,  584,  585,  586,  587,  588,  589,  590,  591,
  128,  592,    0,  130,  131,  132,  593,  594,    0,  595,
  596,  597,    0,  135,  136,  598,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  599,  147,    0,  600,  149,  150,    0,  151,    0,
  601,  602,  603,    0,  604,  605,    0,  606,  152,  153,
  154,  155,  156,  157,  607,  159,  608,  161,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,  619,    0,
  620,  621,  622,  623,  624,  625,    0,  626,  627,  628,
  182,    0,  629,    0,  630,  631,  632,  633,  634,  189,
  190,  635,  192,  636,  637,  638,  196,  639,  198,  640,
  200,  641,    0,  642,  643,  644,  645,    0,  646,  647,
  648,  209,  649,    0,  650,  651,  213,  652,  215,  560,
    0,    0,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  562,    0,
    0,    0,    0,    0,  563,  564,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  565,    0,    0,  566,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  567,    0,  568,  569,    0,    0,  570,    0,    0,    0,
    0,    0,  571,    0,    0,  572,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  766,    0,  766,  766,    0,
  766,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  573,    0,  766,    0,    0,    0,    0,  766,    0,
    0,    0,    0,    0,    0,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  577,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1789,    0,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582,    0,    0,    0,    0,    0,
    0,  126,  127,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635,  192,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,  766,  650,  651,  213,  652,
  215,    0,  766,  253,    0,    0,  253,    0,    0,  766,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  253,
    0,  766,    0,  253,    0,    0,  253,  766,  766,    0,
    0,    0,    0,    0,    0,  766,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  766,    0,    0,  766,    0,
    0,    0,    0,    0,    0,    0,  253,    0,    0,    0,
    0,    0,  253,  253,  253,    0,  253,  253,  253,    0,
  253,    0,    0,  766,    0,  766,  766,    0,    0,  766,
    0,    0,    0,    0,    0,  766,    0,  253,  766,  253,
    0,    0,    0,    0,    0,    0,    0, 1204,    0, 1204,
 1204,    0, 1204,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  766, 1204,    0,    0,  253,    0,
 1204,    0,    0,   83,    0,    0,    0,    0,    0,  766,
    0,    0,    0,    0,    0,  253,    0,    0,    0,    0,
    0,    0,    0,  766,    0,    0,    0,    0,    0,  766,
    0,    0,    0,    0,    0,    0,    0,  253,    0,  766,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  766,  766,  766,  766,  766,  766,  766,
    0,  766,  766,  766,  766,    0,  766,  766,    0,    0,
    0,    0,  253,  253,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,    0,  766,  253,
    0,  766,  766,    0,  766,  766,  766,    0,  766,  766,
  766,  766,    0,    0,  766,  766,  766,  766,  766,  766,
  766,    0,    0,    0,    0,  766,  766,  766,    0,  766,
  766,  766,    0,  766,    0,  766,  766,  766,    0,  766,
  766,    0,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,    0,  766,  766,  766,  766,  766,
  766,    0,  766,  766,  766,  766,    0,  766,    0,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,    0,  766,  766,
  766,  766,    0,  766,  766,  766,  766,  766,    0,  766,
  766,  766,  766,  766, 1204,    0,    0,    0,    0,    0,
    0, 1204,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1204,    0,    0,    0,    0,    0, 1204,
 1204,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1204,    0,    0,
 1204,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1204,    0, 1204, 1204,    0,
    0, 1204,    0,    0,    0,    0,    0, 1204,    0,    0,
 1204,    0,    0,    0,    0,    0,    0,    0,    0,  655,
    0,    0,  653,    0,  654,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1204,  656,    0,    0,
    0,    0,  657,    0,    0,    0,    0,    0,    0,    0,
    0, 1204,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1204,    0,    0,    0,    0,
    0, 1204,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1204,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1204, 1204, 1204, 1204, 1204,
 1204, 1204,    0, 1204, 1204, 1204, 1204,    0, 1204, 1204,
    0,    0,    0,    0,    0,    0, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,    0,
 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204,    0,
 1204, 1204, 1204, 1204,    0,    0, 1204, 1204, 1204, 1204,
 1204, 1204, 1204,    0,    0,    0,    0, 1204, 1204, 1204,
    0, 1204, 1204, 1204,    0, 1204,    0, 1204, 1204, 1204,
    0, 1204, 1204,    0, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204,
 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204,    0, 1204,
    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,    0,
 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204, 1204,
    0, 1204, 1204, 1204, 1204, 1204,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,    0,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
    0,  964,    0,    0,  653,    0,  654,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  573,  656,
    0,    0,    0,    0,  657,    0,    0,    0,    0,    0,
    0,    0,    0,  574,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,    0,  650,  651,  213,  652,  215,  560,    0,
    0,    0,    0,    0,    0,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  562,    0,    0,
    0,    0,    0,  563,  564,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  565,    0,    0,  566,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  567,
    0,  568,  569,    0,    0,  570,    0,    0,    0,    0,
    0,  571,    0,    0,  572,    0,    0,    0,    0,    0,
    0,    0,    0, 1204,    0,    0, 1204,    0, 1204,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  573, 1204,    0,    0,    0,    0, 1204,    0,    0,    0,
    0,    0,    0,    0,    0,  574,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  575,
    0,    0,    0,    0,    0,  576,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  578,
  579,  580,  581,  336,  337,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  128,  592,    0,  130,  131,  132,  593,  594,    0,
  595,  596,  597,    0,  135,  136,  598,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  599,  147,    0,  600,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  625,    0,  626,  627,
  628,  182,    0,  629,    0,  630,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641, 1313,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
 1204,  656,    0,    0,    0,    0,    0, 1204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1204,
    0,    0,    0,    0,    0, 1204, 1204,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1204,    0,    0, 1204,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1204,    0, 1204, 1204,    0,    0, 1204,    0,    0,
    0,    0,    0, 1204,    0,    0, 1204,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1204,    0,    0,    0,    0,    0,    0,    0,
    0, 1032,    0,    0,    0,    0,    0, 1204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1204,    0,    0,    0,    0,    0, 1204,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204,    0, 1204,
 1204, 1204, 1204,    0, 1204, 1204,    0,    0,    0,    0,
    0,    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204,
 1204,    0, 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204,
    0,    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204,    0,
    0,    0,    0, 1204, 1204, 1204,    0, 1204, 1204, 1204,
    0, 1204,    0, 1204, 1204, 1204,    0, 1204, 1204,    0,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204,    0, 1204, 1204, 1204, 1204, 1204, 1204,  399,
 1204, 1204, 1204, 1204,    0, 1204,    0, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204,
    0, 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204,
 1204, 1204,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,    0,    0,  120,    0,  121,
  122,  123,  124,    0,  125,    0,    0,    0,    0,    0,
    0,    0,  126,  127,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  128,  129,    0,  130,  131,  132,    0,
    0,    0,    0,  133,  134,    0,  135,  136, 1032,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  146,  147,    0,  148,  149,  150,
    0,  151,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  152,  153,  154,  155,  156,  157,  158,  159,  160,
  161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
  171,  172,    0,  173,  174,  175,  176,  177,  178,    0,
  179,  180,  181,  182,    0,  183,    0,  184,  185,  186,
  187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
  197,  198,  199,  200,  201,    0,  202,  203,  204,  205,
 1118,  206,  207,  208,  209,  210,   17,  211,  212,  213,
  214,  215,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,    0,    0,    0,    0,    0,    0,    0,
  126,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,    0,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144, 1320,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,    0,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137, 1320,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,    0,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215, 1319,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0,  125,
    0,    0,    0,    0,    0,    0,    0,  126,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,    0,    0,  133,  134,
    0,  135,  136,    0,  137,    0,  779,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147,    0,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
    0,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  119,    0,    0,  120,
    0,  121,  122,  123,  124,    0,  125,    0,    0,    0,
    0,    0,    0,    0,  126,  127,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  128,  129,    0,  130,  131,
  132,    0,    0,    0,    0,  133,  134,   88,  135,  136,
    0,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  146,  147,    0,  148,
  149,  150,    0,  151,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
  169,  170,  171,  172,    0,  173,  174,  175,  176,  177,
  178,    0,  179,  180,  181,  182,    0,  183,    0,  184,
  185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
  195,  196,  197,  198,  199,  200,  201,    0,  202,  203,
  204,  205,    0,  206,  207,  208,  209,  210,    0,  211,
  212,  213,  214,  215,    0,  119,    0,    0,  120,    0,
  121,  122,  123,  124,    0,  125,    0,    0,    0,  779,
    0,    0,    0,  126,  127,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  128,  129,    0,  130,  131,  132,
    0,    0,    0,    0,  133,  134,    0,  135,  136,    0,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
  656,    0,    0,    0,  145,  146,  147,    0,  148,  149,
  150,    0,  151,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  152,  153,  154,  155,  156,  157,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
  170,  171,  172,    0,  173,  174,  175,  176,  177,  178,
    0,  179,  180,  181,  182,    0,  183,    0,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,    0,  202,  203,  204,
  205,    0,  206,  207,  208,  209,  210,    0,  211,  212,
  213,  214,  215,  782,    0,    0,  782,    0,  782,  782,
  782,  782,    0,  782,    0,    0,    0,    0,    0,    0,
    0,  782,  782,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  782,  782,    0,  782,  782,  782,    0,    0,
    0,    0,  782,  782,    0,  782,  782,    0,  782,    0,
    0,  782,  782,  782,  782,  782,  782,  782,    0,    0,
    0,    0,  782,  782,  782,    0,  782,  782,  782,    0,
  782,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,    0,  782,  782,  782,  782,  782,  782,    0,  782,
  782,  782,  782,    0,  782,    0,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,    0,  782,  782,  782,  782,    0,
  782,  782,  782,  782,  782,    0,  782,  782,  782,  782,
  782,   87,    0,  119,    0,    0,  120,    0,  121,  122,
  123,  124,    0,  125,    0,    0,    0,    0,    0,    0,
    0,  126,  127,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  128,  129,    0,  130,  131,  132,    0,    0,
    0,    0,  133,  134,    0,  135,  136,    0,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  146,  147,    0,  148,  149,  150,    0,
  151,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,    0,  173,  174,  175,  176,  177,  178,    0,  179,
  180,  181,  182,    0,  183,    0,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,    0,  202,  203,  204,  205,    0,
  206,  207,  208,  209,  210,    0,  211,  212,  213,  214,
  215,    0,    0,  119,    0,    0,  120,    0,  121,  122,
  123,  124,    0,  125,    0,    0,    0,    0,    0,    0,
    0,  126,  127,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  128,  129,    0,  130,  131,  132,    0,    0,
    0,    0,  133,  134,    0,  135,  136,    0,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  146,  147,    0,  148,  149,  150,    0,
  151,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,    0,  173,  174,  175,  176,  177,  178,    0,  179,
  180,  181,  182,  990,  183,    0,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,    0,  202,  203,  204,  205,    0,
  206,  207,  208,  209,  210,    0,  211,  212,  213,  214,
  215,    0,    0,    0,    0, 1252, 1252,  990, 1252, 1252,
 1252,    0,    0,    0,    1,    0,    0,    0,    0,    0,
    0,    0,  990, 1252, 1252, 1252,    0,    0,    0,    0,
 1208,    0,    2,  858,    0,    0,    0,    0,    0,    0,
    3,    0,    0,    0,    0,    0, 1209,    4,    0,    5,
  859,    6,    0,  860, 1252,    0,    7,    0,    0,    0,
    0,    0,    0,    8,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    9,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   10,    0,    0,
    0,    0,  991,  861,    0,    0,    0,    0,    0,  862,
  863,  864,    0,  865,  866,  867,    0,  868,    0,    0,
    0,    0,    0,    0,    0,   11,    0,    0,    0,    0,
    0,    0,    0,    0,  869,    0,  870,    0,    0,    0,
    0,    0,    0,    0, 1253, 1253,  991, 1253, 1253, 1253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   12,
    0,  991, 1253, 1253, 1253,  871,   13,    0,    0,   14,
    0,    0,   15,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  872,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1253,    0,    0,   16,    0,    0,    0,
    0,    0,    0,    0,  873,    0,    0,    0,   17,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  990,    0,    0,    0,  874,
  875,    0,    0,    0, 1252,   18,    0,    0,    0,    0,
 1252,    0,    0,    0,    0, 1252,  876,    0, 1252,    0,
   19,   20,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  992,    0,    0,
    0,    0,   21,    0,    0,    0,    0,    0,  990,    0,
    0,  990,    0,    0, 1252,    0,    0,    0,  990,    0,
  990,    0, 1252,    0,  990,    0,    0,    0,    0,  990,
 1252,    0,  990,    0,    0,    0,    0,    0,    0, 1254,
 1254,  992, 1254, 1254, 1254,    0,    0,  990, 1252,    0,
 1252,    0,    0,    0,    0,    0,  992, 1254, 1254, 1254,
  990,    0, 1252,    0, 1252, 1252, 1252,    0,  990,    0,
    0,  990,  990,    0,    0,    0,    0,    0,    0,    0,
    0,  990,    0,    0,  991,    0,    0,    0, 1254,    0,
    0,    0,    0, 1253,    0,    0,    0,  990,    0, 1253,
    0,    0,    0,    0, 1253,    0,    0, 1253,    0,    0,
    0,    0,    0, 1252,    0,    0,  947,    0,    0,  990,
    0,    0,    0,    0,  990,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  990,  990,  991,  990,    0,
  991,    0,    0, 1253,    0,  857,    0,  991,  858,  991,
    0, 1253,    0,  991,    0,    0,    0,  947,  991, 1253,
  947,  991,    0,    0,    0,  859,    0,    0,  860,    0,
    0,    0,    0,    0,    0,  947,  991, 1253,    0, 1253,
    0,    0,    0,    0,    0,  990,    0,    0,    0,  991,
    0, 1253,    0, 1253, 1253, 1253,  948,  991,    0,    0,
  991,  991,  990,    0,    0,    0,  990,    0,  861,    0,
  991,    0,    0,    0,  862,  863,  864,    0,  865,  866,
  867,  990,  868,    0,    0,    0,  991,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  948,    0,  869,
  948,  870, 1253,    0,    0,    0,    0,    0,  991,    0,
    0,    0,    0,  991,    0,  948,    0,    0,    0,  992,
    0,    0,    0,    0,  991,  991,    0,  991, 1254,    0,
  871,    0,    0,    0, 1254,    0,    0,    0,    0, 1254,
    0,    0, 1254,    0,    0,    0,    0,  872,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  873,
    0,    0,  992,    0,  991,  992,    0,    0, 1254,    0,
    0,    0,  992,    0,  992,    0, 1254,    0,  992,    0,
    0,  991,    0,  992, 1254,  991,  992,    0,    0,  974,
    0,    0,    0,    0,  874,  875,    0,    0,    0,    0,
  991,  992, 1254,    0, 1254,    0,    0,    0,    0,  951,
    0,  876,    0,    0,  992,    0, 1254,    0, 1254, 1254,
 1254,    0,  992,    0,    0,  992,  992,    0,  947,    0,
  974,    0,    0,  974,    0,  992,    0,    0,    0,    0,
    0,  253,    0,    0,  253,    0,    0,    0,  974,    0,
  951,  992,    0,  951,    0,    0,    0,  253,    0,    0,
    0,  253,    0,    0,  253,    0,    0, 1254,  951,    0,
    0,    0,    0,  992,    0,    0,    0,    0,  992,    0,
    0,  947,    0,    0,  947,    0,    0,    0,    0,  992,
  992,  947,  992,  947,    0,    0,    0,  947,    0,    0,
    0,    0,  947,    0,  253,  947,    0,    0,  948,    0,
  253,  253,  253,    0,  253,  253,  253,    0,  253,    0,
  947,    0,    0,    0,    0,    0,    0,    0,  949,    0,
    0,    0,    0,  947,    0,  253,    0,  253,    0,  992,
    0,  947,    0,    0,  947,  947,    0,    0,    0,    0,
    0,    0,    0,    0,  947,    0,  992,    0,    0,    0,
  992,  948,    0,    0,  948,    0,  253,    0,    0,  949,
  947,  948,  949,  948,    0,  992,    0,  948,    0,    0,
    0,    0,  948,  253,    0,  948,    0,  949,    0,    0,
    0,    0,  947,    0,    0,    0,    0,  947,    0,    0,
  948,    0,    0,    0,    0,  253,    0,    0,  947,  947,
    0,  947,    0,  948,    0,    0,    0,    0,    0,    0,
    0,  948,    0,    0,  948,  948,  950,    0,    0,    0,
    0,    0,    0,    0,  948,    0,    0,    0,    0,    0,
  253,  253,    0,    0,    0,    0,    0,    0,    0,    0,
  948,  974,    0,    0,    0,    0,    0,  253,  947,    0,
    0,    0,    0,    0,    0,    0,    0,  950,    0,    0,
  950,  951,  948,    0,    0,  947,    0,  948,    0,  947,
    0,    0,    0,    0,    0,  950,    0,    0,  948,  948,
    0,  948,    0,    0,  947,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  974,    0,    0,  974,    0,    0,
    0,    0,    0,    0,  974,    0,  974,    0,    0,    0,
  974,    0,    0,    0,  951,  974,    0,  951,  974,    0,
    0,    0,    0,    0,  951,    0,  951,    0,  948,    0,
  951,    0,    0,  974,    0,  951,    0,    0,  951,    0,
    0,    0,    0,    0,    0,  948,  974,    0,    0,  948,
    0,    0,  982,  951,  974,    0,    0,  974,  974,    0,
    0,    0,    0,    0,  948,    0,  951,  974,    0,    0,
    0,    0,    0,    0,  951,    0,    0,  951,  951,    0,
  949,    0,    0,  974,    0,    0,    0,  951,    0,    0,
    0,    0,    0,  982,    0,    0,  982,    0,    0,    0,
    0,    0,    0,  951,    0,  974,    0,    0,    0,    0,
  974,  982,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  974,  974,    0,  974,  951,    0,    0,    0,    0,
  951,    0,    0,  949,    0,    0,  949,    0,    0,    0,
    0,  951,  951,  949,  951,  949,    0,    0,    0,  949,
    0,    0,    0,    0,  949,    0,    0,  949,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  974,  949,    0,  944,    0,    0,    0,  950,    0,
    0,    0,    0,    0,    0,  949,    0,    0,  974,    0,
    0,  951,  974,  949,    0,    0,  949,  949,    0,    0,
    0,    0,    0,    0,    0,    0,  949,  974,  951,  945,
    0,    0,  951,    0,    0,  944,    0,    0,  944,    0,
    0,    0,  949,    0,    0,    0,    0,  951,    0,    0,
    0,  950,    0,  944,  950,    0,    0,    0,    0,    0,
    0,  950,    0,  950,  949,    0,    0,  950,    0,  949,
  945,    0,  950,  945,    0,  950,    0,    0,    0,  154,
  949,  949,  154,  949,    0,    0,    0,  946,  945,    0,
  950,    0,    0,    0,    0,    0,    0,    0,    0,  154,
    0,    0,  154,  950,    0,    0,    0,    0,    0,    0,
    0,  950,    0,    0,  950,  950,    0,    0,    0,    0,
    0,    0,    0,    0,  950,    0,    0,    0,  946,    0,
  949,  946,    0,    0,  982,    0,    0,    0,    0,    0,
  950,    0,  154,    0,    0,    0,  946,  949,  154,  154,
  154,  949,  154,  154,  154,    0,  154,    0,    0,    0,
    0,    0,  950,    0,    0,    0,  949,  950,    0,    0,
    0,    0,    0,  154,    0,  154,    0,    0,  950,  950,
    0,  950,    0,    0,    0,    0,    0,  982,    0,    0,
  982,    0,    0,    0,    0,    0,    0,  982,    0,  982,
    0,    0,    0,  982,  154,    0,    0,    0,  982,    0,
    0,  982,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  154,    0,    0,    0,    0,  982,    0,  950,    0,
    0,  981,    0,    0,    0,    0,    0,    0,    0,  982,
    0,    0,    0,  154,    0,  950,    0,  982,    0,  950,
  982,  982,    0,    0,    0,    0,  944,    0,    0,    0,
  982,    0,    0,  975,  950,    0,    0,    0,    0,    0,
    0,    0,  981,    0,    0,  981,  982,    0,  154,  154,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  981,  945,    0,  983,    0,  154,    0,    0,  982,    0,
    0,    0,    0,  982,  975,    0,    0,  975,    0,  944,
    0,    0,  944,    0,  982,  982,    0,  982,    0,  944,
    0,  944,  975,    0,    0,  944,    0,    0,    0,    0,
  944,    0,    0,  944,  983,    0,    0,  983,    0,    0,
    0,    0,    0,    0,  945,    0,    0,  945,  944,  946,
    0,    0,  983,    0,  945,    0,  945,    0,    0,    0,
  945,  944,    0,    0,  982,  945,    0,    0,  945,  944,
    0,    0,  944,  944,    0,    0,    0,    0,    0,    0,
    0,  982,  944,  945,    0,  982,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  945,    0,  944,    0,
  982,    0,  946,    0,  945,  946,    0,  945,  945,    0,
    0,    0,  946,    0,  946,    0,    0,  945,  946,    0,
  944,    0,    0,  946,    0,  944,  946,    0,    0,    0,
    0,    0,    0,  945,    0,    0,  944,  944,  984,  944,
    0,  946,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  946,  945,    0,    0,    0,    0,
  945,    0,  946,    0,    0,  946,  946,    0,  972,    0,
    0,  945,  945,    0,  945,  946,    0,    0,    0,  984,
    0,    0,  984,    0,    0,    0,  944,    0,    0,    0,
    0,  946,    0,  981,    0,    0,    0,  984,    0,    0,
  970,    0,    0,  944,    0,    0,    0,  944,    0,  972,
    0,    0,  972,  946,    0,    0,    0,    0,  946,    0,
    0,  945,  944,    0,    0,  975,    0,  972,    0,  946,
  946,    0,  946,    0,    0,    0,    0,    0,  945,    0,
    0,  970,  945,    0,  970,    0,  981,    0,    0,  981,
    0,    0,    0,    0,    0,  983,  981,  945,  981,  970,
    0,    0,  981,    0,    0,    0,    0,  981,    0,    0,
  981,    0,    0,    0,    0,    0,    0,    0,  975,  946,
    0,  975,    0,    0,    0,  981,    0,    0,  975,    0,
  975,    0,    0,    0,  975,    0,  946,    0,  981,  975,
  946,    0,  975,    0,    0,    0,  981,    0,  983,  981,
  981,  983,    0,    0,    0,  946,    0,  975,  983,  981,
  983,    0,    0,    0,  983,    0,    0,    0,    0,  983,
  975,    0,  983,    0,    0,  981,    0,    0,  975,    0,
    0,  975,  975,  976,    0,    0,    0,  983,    0,    0,
    0,  975,    0,    0,    0,    0,    0,  981,    0,    0,
  983,    0,  981,    0,    0,    0,    0,  975,  983,    0,
    0,  983,  983,  981,  981,    0,  981,    0,    0,    0,
    0,  983,    0,    0,  976,    0,    0,  976,    0,  975,
    0,    0,    0,    0,  975,    0,    0,  983,    0,    0,
  984,    0,  976,    0,    0,  975,  975,    0,  975,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  983,
    0,    0,    0,  981,  983,    0,    0,    0,    0,    0,
  972,    0,    0,    0,    0,  983,  983,  985,  983,    0,
  981,    0,    0,    0,  981,    0,    0,    0,    0,    0,
    0,    0,    0,  984,    0,  975,  984,    0,    0,  981,
    0,    0,  970,  984,    0,  984,    0,    0,    0,  984,
    0,    0,  975,    0,  984,    0,  975,  984,  985,    0,
    0,  985,    0,  972,    0,  983,  972,    0,    0,    0,
    0,  975,  984,  972,    0,  972,  985,    0,    0,  972,
    0,    0,  983,    0,  972,  984,  983,  972,    0,    0,
    0,    0,    0,  984,    0,  970,  984,  984,  970,    0,
    0,  983,  972,    0,    0,  970,  984,  970,    0,    0,
  971,  970,    0,    0,    0,  972,  970,    0,    0,  970,
    0,    0,  984,  972,    0,    0,  972,  972,    0,    0,
    0,    0,    0,    0,  970,    0,  972,    0,    0,    0,
    0,    0,    0,    0,  984,    0,    0,  970,    0,  984,
    0,  971,  972,    0,  971,  970,  973,    0,  970,  970,
  984,  984,    0,  984,    0,    0,    0,    0,  970,  971,
    0,    0,    0,    0,  972,    0,    0,    0,    0,  972,
    0,    0,    0,    0,  970,  976,    0,    0,    0,    0,
  972,  972,    0,  972,    0,    0,    0,  973,    0,    0,
  973,    0,    0,    0,    0,    0,  970,    0,    0,    0,
  984,  970,    0,    0,    0,  973,    0,    0,    0,    0,
    0,    0,  970,  970,    0,  970,    0,  984,    0,    0,
    0,  984,    0,    0,    0,    0,    0,    0,  976,    0,
  972,  976,    0,    0,    0,    0,  984,    0,  976,    0,
  976,    0,    0,    0,  976,    0,    0,  972,    0,  976,
    0,  972,  976,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  970,    0,    0,    0,  972,  976,  977,  985,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  970,
  976,    0,    0,  970,    0,    0,    0,    0,  976,    0,
    0,  976,  976,    0,    0,    0,    0,    0,  970,    0,
    0,  976,    0,    0,    0,    0,    0,    0,    0,  977,
    0,    0,  977,    0,    0,    0,    0,  976,    0,    0,
    0,    0,  985,    0,    0,  985,    0,  977,    0,    0,
    0,    0,  985,    0,  985,    0,    0,    0,  985,  976,
    0,    0,    0,  985,  976,    0,  985,    0,  806,    0,
    0,    0,    0,    0,    0,  976,  976,    0,  976,    0,
    0,  985,  971,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  985,    0,    0,    0,    0,    0,
    0,    0,  985,    0,    0,  985,  985,    0,    0,  806,
    0,    0,  806,    0,    0,  985,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  976,    0,  806,  973,    0,
    0,  985,    0,    0,    0,  971,    0,    0,  971,    0,
    0,    0,  976,    0,    0,  971,  976,  971,    0,    0,
    0,  971,    0,  985,    0,    0,  971,    0,  985,  971,
    0,  976,    0,    0,    0,    0,    0,    0,    0,  985,
  985,    0,  985,    0,  971,    0,    0,    0,    0,    0,
    0,  973,    0,    0,  973,    0,    0,  971,    0,    0,
    0,  973,    0,  973,    0,  971,    0,  973,  971,  971,
    0,    0,  973,    0,    0,  973,    0,    0,  971,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  985,
  973,    0,    0,    0,  971,    0,    0,    0,    0,    0,
    0,    0,    0,  973,    0,    0,  985,    0,    0,    0,
  985,  973,    0,    0,  973,  973,  971,    0,    0,    0,
  977,  971,    0,    0,  973,  985,    0,    0,    0,    0,
    0,    0,  971,  971,    0,  971,    0,    0,    0,    0,
  973,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  973,    0,    0,    0,    0,  973,    0,    0,
    0,    0,    0,  977,    0,    0,  977,    0,  973,  973,
    0,  973,  971,  977,    0,  977,    0,    0,    0,  977,
    0,    0,    0,    0,  977,    0,    0,  977,    0,  971,
    0,    0,    0,  971,    0,    0,    0,    0,    0,    0,
    0,    0,  977,    0,    0,    0,    0,    0,  971,    0,
    0,    0,    0,    0,    0,  977,    0,    0,  973,    0,
    0,    0,    0,  977,    0,    0,  977,  977,    0,    0,
  112,    0,    0,    0,    0,  973,  977,    0,    0,  973,
    0,    0,    0,  806,    0,    0,  806,    0,    0,    0,
    0,    0,  977,  806,  973,  806,    0,    0,    0,  806,
    0,    0,    0,    0,  806,    0,    0,  806,  113,    0,
    0,    0,    0,    0,  977,    0,    0,    0,    0,  977,
  114,    0,  806,    0,    0,    0,    0,    0,    0,    0,
  977,  977,    0,  977,    0,  806,    0,    0,    0,    0,
    0,    0,    0,  806,  115,    0,    0,  806,    0,    0,
    0,    0,    0,    0,    0,    0,  806,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  806,    0,    0,    0,    0,    0,    0,    0,
  977,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  977,    0,  806,
    0,  977,    0,    0,    0,    0,    0,    0,  116,    0,
    0,  806,    0,  806,    0,    0,  977,    0,  117,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  118,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  806,  119,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,    0,    0,    0,    0,    0,  806,    0,  126,
  127,  806,    0,    0,    0,   51,    0,    0,    0,    0,
  128,  129,    0,  130,  131,  132,  806,    0,    0,    0,
  133,  134,    0,  135,  136,    0,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  146,  147,   51,  148,  149,  150,    0,  151,    0,
    0,    0,    0,    0,    0,   51,    0,    0,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,   51,
  173,  174,  175,  176,  177,  178,    0,  179,  180,  181,
  182,    0,  183,    0,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,    0,  202,  203,  204,  205,    0,  206,  207,
  208,  209,  210,    0,  211,  212,  213,  214,  215,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   51,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   51,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   51,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   53,    0,    0,   53,
    0,   53,   53,   53,   53,    0,   53,    0,    0,    0,
    0,    0,    0,    0,   53,   53,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   53,   53,    0,   53,   53,
   53,    0,    0,    0,    0,   53,   53,    0,   53,   53,
    0,   53,    0,    0,   53,   53,   53,   53,   53,   53,
   53,    0,    0,    0,    0,   53,   53,   53,    0,   53,
   53,   53,    0,   53,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,    0,   53,   53,   53,   53,   53,
   53,    0,   53,   53,   53,   53,    0,   53,    0,   53,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,   53,   53,   53,  366,   53,   53,
   53,   53,    0,   53,   53,   53,   53,   53,    0,   53,
   53,   53,   53,   53,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  366,    0,    0,    0,    0,
    0,    0,  366,    0,    0,    0,  366,  366,    0,  366,
    0,    0,  366,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  366,    0,    0,    0,    0,
    0,  366,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  366,    0,    0,
    0,  366,    0,    0,    0,    0,    0,    0,    0,  366,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  366,  366,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  366,    0,    0,    0,  366,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  366,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  366,    0,    0,    0,    0,    0,    0,    0,    0,  366,
    0,  366,  366,    0,    0,    0,    0,    0,  366,    0,
    0,  366,    0,  366,  366,  366,  366,    0,  366,  366,
    0,    0,    0,    0,    0,    0,  366,  366,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  366,  366,    0,
  366,  366,  366,    0,    0,    0,    0,  366,  366,    0,
  366,  366,    0,  366,    0,    0,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,    0,  366,  366,  366,
    0,  366,  366,  366,    0,  366,    0,  366,  366,  366,
    0,  366,  366,    0,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,    0,  366,  366,  366,
  366,  366,  366,    0,  366,  366,  366,  366,    0,  366,
    0,  366,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,  366,  366,  366,  334,
  366,  366,  366,  366,    0,  366,  366,  366,  366,  366,
    0,  366,  366,  366,  366,  366,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  334,    0,    0,
    0,    0,    0,    0,  329,    0,    0,    0,  334,  334,
    0,  334,    0,    0,  334,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  334,    0,    0,
    0,    0,    0,  334,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,  334,    0,    0,    0,    0,    0,    0,
    0,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  334,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  334,    0,    0,    0,  334,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  334,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  334,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  334,  334,    0,    0,    0,    0,    0,
  334,    0,    0,  334,    0,  334,  334,  334,  334,    0,
  334,  334,    0,    0,    0,    0,    0,    0,  334,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
  334,    0,  334,  334,  334,    0,    0,    0,    0,  334,
  334,    0,  334,  334,    0,  334,    0,    0,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,    0,  334,
  334,  334,    0,  334,  334,  334,    0,  334,    0,  334,
  334,  334,    0,  334,  334,    0,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,    0,  334,
  334,  334,  334,  334,  334,    0,  334,  334,  334,  334,
    0,  334,    0,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,    0,  334,  334,  334,
  334,  334,    0,  334,  334,  334,  334,  334,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,    0,    0,    0,  327,    0,    0,    0,
  334,  334,    0,  334,    0,    0,  334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,    0,    0,  334,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  334,    0,    0,    0,  334,    0,    0,    0,    0,
    0,    0,    0,  334,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  334,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  334,    0,    0,    0,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  334,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  334,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  334,  334,    0,    0,    0,
    0,    0,  334,    0,    0,  334,    0,  334,  334,  334,
  334,    0,  334,  334,    0,    0,    0,    0,    0,    0,
  334,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  334,  334,    0,  334,  334,  334,    0,    0,    0,
    0,  334,  334,    0,  334,  334,    0,  334,    0,    0,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
    0,  334,  334,  334,    0,  334,  334,  334,    0,  334,
    0,  334,  334,  334,    0,  334,  334,    0,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
    0,  334,  334,  334,  334,  334,  334,    0,  334,  334,
  334,  334,    0,  334,    0,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334, 2027,  334,  334,  334,  334,    0,  334,
  334,  334,  334,  334,    0,  334,  334,  334,  334,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    6,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2236, 2237,    0, 2238,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2239,    0,    0,    0,    0,    0, 2240,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  568,    0,    0,    0,  570,    0,    0,
    0,    0,    0,    0,    0,   11,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  573, 2241,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  574,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2242,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   16,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   17,    0,
    0,    0,    0,    0,  581,    0,    0,  120,    0,  121,
  122,  123,  124,    0,  125,  582,    0,    0,    0,    0,
    0,    0,  126,  127,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2243,  592,    0,  130,  131,  132,    0,
    0,    0,    0,  133,  134,    0,  135,  136,    0,  137,
    0,    0,  138, 2244,  140,  141,  142,  143,  144, 2245,
 2246, 2247,    0,  145,  146,  147,    0,  148,  149,  150,
    0,  151,    0,  601,  602,  603,    0,  604,  605,    0,
  606,  152,  153,  154,  155,  156,  157,  607,  159,  608,
  161,  609,  610,  611,  612,  613,  614,  615,  616,  617,
  618,  619,    0,  620,  621,  622,  623,  624,  178,    0,
  626,  627,  628,  182,    0,  629,    0,  184,  631,  632,
  633,  634,  189,  190,  635,  192,  636,  637,  638,  196,
  639,  198,  640,  200,  641,    0,  642,  643,  644,  645,
    0,  646,  647,  648,  209,  649,    0,  650,  651,  213,
  652,  215,  857,    0,    0,  858,    0,    0,    0,    0,
    0, 1118,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  859,    0,    0,  860,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  861,    0,    0,    0,    0,
    0,  862,  863,  864,    0,  865,  866,  867,    0,  868,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  869,    0,  870,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  871,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  872,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  873,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,    0,    0,    0,    0,    0,    0,    0,  126,
  127,  874,  875,    0,    0,    0,    0,    0,    0,    0,
  128,  129,    0,  130,  131,  132,    0,    0,  876,    0,
  133,  134,    0,  135,  136,    0,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  146,  147,    0,  148,  149,  150,    0,  151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,    0,
  173,  174,  175,  176,  177,  178,    0,  179,  180,  181,
 1119,    0,  183,    0,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,    0,  202,  203,  204,  205,    0,  206,  207,
  208,  209,  210,    0,  211,  212,  213,  214,  215, 1213,
    0,    0, 1213,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1215,    0, 1213,
    0,    0, 1213,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1213,    0,    0,    0,    0,    0, 1213, 1213,
 1213,    0, 1213, 1213, 1213,    0, 1213,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1213,    0, 1213,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1213,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1213,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1213,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1213,    0,
    0, 1213,    0, 1213, 1213, 1213, 1213,    0, 1213,    0,
    0,    0,    0,    0,    0,    0, 1213, 1213, 1213, 1213,
    0,    0,    0,    0,    0,    0,    0, 1213, 1213,    0,
 1213, 1213, 1213,    0,    0, 1213,    0, 1213, 1213,    0,
 1213, 1213,    0, 1213,    0,    0, 1213, 1213, 1213, 1213,
 1213, 1213, 1213,    0,    0,    0,    0, 1213, 1213, 1213,
    0, 1213, 1213, 1213,    0, 1213,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1213, 1213, 1213, 1213, 1213,
 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
 1213, 1213, 1213, 1213, 1213, 1213,    0, 1213, 1213, 1213,
 1213, 1213, 1213,    0, 1213, 1213, 1213, 1213,    0, 1213,
    0, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,    0,
 1213, 1213, 1213, 1213,    0, 1213, 1213, 1213, 1213, 1213,
    0, 1213, 1213, 1213, 1213, 1213,  857,    0,    0,  858,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  859,    0,    0,  860,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  861,
    0,    0,    0,    0,    0,  862,  863,  864,    0,  865,
  866,  867,    0,  868,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  869,    0,  870,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  871,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  872,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  873,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  119,    0,    0,  120,    0,
  121,  122,  123,  124,    0, 1004,    0,    0,    0,    0,
    0,    0,    0,  126,  127,  874,  875,    0,    0,    0,
    0,    0,    0,    0,  128,  129,    0,  130,  131,  132,
    0,    0,  876,    0,  133,  134,    0,  135,  136,    0,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  146,  147,    0,  148,  149,
  150,    0,  151,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  152,  153,  154,  155,  156,  157,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
  170,  171,  172,    0,  173,  174,  175,  176,  177,  178,
    0,  179,  180,  181,  182,    0,  183,    0,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,    0,  202,  203,  204,
  205,    0,  206,  207,  208,  209,  210,    0,  211,  212,
  213,  214,  215,  857,    0,    0,  858,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  859,    0,    0,  860,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  861,    0,    0,    0,
    0,    0,  862,  863,  864,    0,  865,  866,  867,    0,
  868,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  869,    0,  870,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  871,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  872,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  824,    0,    0,    0,  873,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,    0,    0,    0,    0,    0,    0,    0,
  126,  127,  874,  875,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,  876,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,  830,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,    0,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,    0,    0,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125, 1487,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,    0,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,    0,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0,  125,
    0,    0,    0,    0,    0,    0,    0,  126,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,    0,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147, 1629,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
 1630,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1631,    0,    0,    0,    0,
 1632,    0,    0,    0,    0,    0, 1633,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,    0,    0,
  120,    0,  121,  122,  123, 1634,    0,  125,    0,    0,
    0,    0,    0,    0,    0,  126,  127,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,  129,    0,  130,
  131,  132,    0,    0,    0,    0,  133,  134,    0,  135,
  136,    0,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  146,  147,    0,
  148,  149,  150,    0,  151,    0,    0,    0,    0,    0,
    0,    0, 1236,    0,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172, 1237,  173,  174,  175,  176,
  177,  178,    0,  179,  180,  181,  182,    0,  183,    0,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201,    0,  202,
  203,  204,  205,    0,  206,  207,  208,  209,  210,    0,
  211,  212,  213,  214,  215,    0,    0,    0,    0,    0,
 1238,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,    0,    0,  120,    0,  121,
  122,  123,  124,    0,  125,    0,    0,    0,    0,    0,
    0,    0,  126,  127,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  128,  129,    0,  130,  131,  132,    0,
    0,    0,    0,  133,  134,    0,  135,  136,    0,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  146,  147,    0,  148,  149,  150,
    0,  151,    0,    0,    0,    0,    0,    0,    0,  237,
    0,  152,  153,  154,  155,  156,  157,  158,  159,  160,
  161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
  171,  172,    0,  173,  174,  175,  176,  177,  178,    0,
  179,  180,  181,  182,    0,  183,    0,  184,  185,  186,
  187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
  197,  198,  199,  200,  201,    0,  202,  203,  204,  205,
    0,  206,  207,  208,  209,  210,    0,  211,  212,  213,
  214,  215,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,    0,    0,    0,    0,    0,    0,    0,
  126,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,    0,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,    0,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
  253,    0,    0,  253,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  253,    0,    0,  253,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  253,    0,    0,    0,    0,    0,  253,
  253,  253,    0,  253,  253,  253,    0,  253,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  253,    0,  253,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  253,  712,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  253,  119,    0,    0,  120,    0,  121,  122,
  123,  124,    0,  125,    0,    0,    0,    0,    0,    0,
    0,  126,  127,    0,  253,    0,    0,    0,    0,    0,
    0,    0,  128,  129,    0,  130,  131,  132,    0,    0,
    0,    0,  133,  134,    0,  135,  136,    0,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,  253,
  253,    0,  145,  146,  147,    0,  148,  149,  150,    0,
  151,    0,    0,    0,    0,    0,  253,    0,    0,    0,
  152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,    0,  173,  174,  175,  176,  177,  178,    0,  179,
  180,  181,  182,    0,  183,    0,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,    0,  202,  203,  204,  205,    0,
  206,  207,  208,  209,  210,    0,  211,  212,  213,  214,
  215,  119,    0,    0,  120,  266,  121,  122,  123,  124,
  267,  125,  268,  269,  270,  271,  272,  273,  274,  126,
  127,  275,  276,  277,  278,  279,    0,    0,  280,  281,
  128,  129,  282,  130,  131,  132,  283,  284,  285,  286,
  133,  134,  287,  135,  136,  288,  137,  289,  290,  138,
  139,  140,  141,  142,  143,  144,  291,  292,  293,  294,
  145,  146,  147,  295,  148,  149,  150,  296,  151,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,  306,
  173,  174,  175,  176,  177,  178,  307,  179,  180,  181,
  182,  308,  183,  309,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,  310,  202,  203,  204,  205,  311,  206,  207,
  208,  209,  210,  312,  211,  212,  213,  214,  215,  538,
    0,    0,  538,  538,  538,  538,  538,  538,    0,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,    0,    0,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  119,    0,    0,
  120,    0,  121,  122,  123,  124,    0,  125,    0,    0,
    0,    0,    0,    0,    0,  126,  127,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,  129,    0,  130,
  131,  132,    0,    0,    0,    0,  133,  134,    0,  135,
  136,    0,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  146,  147,    0,
  148,  149,  150,    0,  151,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,    0,  173,  174,  175,  176,
  177,  178,    0,  179,  180,  181,  182,    0,  183,    0,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201,  242,  202,
  203,  204,  205,    0,  206,  207,  208,  209,  210,    0,
  211,  212,  213,  214,  215,  119,    0,    0,  120,    0,
  121,  122,  123,  124,    0,  125,    0,    0,    0,    0,
    0,    0,    0,  126,  127,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  128,  129,    0,  130,  131,  132,
    0,    0,    0,    0,  133,  134,    0,  135,  136,    0,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  146,  147,    0,  148,  149,
  150,    0,  151,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  152,  153,  154,  155,  156,  157,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
  170,  171,  172,    0,  173,  174,  175,  176,  177,  178,
    0,  179,  180,  181,  182,    0,  183,    0,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,    0,  202,  203,  204,
  205,    0,  206,  207,  208,  209,  210,    0,  211,  212,
  213,  214,  215,  119,    0,    0,  120,    0,  121,  122,
  123,  124,    0, 1810,    0,    0,    0,    0,    0,    0,
    0,  126,  127,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  128,  129,    0,  130,  131,  132,    0,    0,
    0,    0,  133,  134,    0,  135,  136,    0,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  146,  147,    0,  148,  149,  150,    0,
  151,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,    0,  173,  174,  175,  176,  177,  178,    0,  179,
  180,  181,  182,    0,  183,    0,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,    0,  202,  203,  204,  205,    0,
  206,  207,  208,  209,  210,    0,  211,  212,  213,  214,
  215,   30,    0,    0,   30,    0,   30,   30,   30,   30,
    0,   30,    0,    0,    0,    0,    0,    0,    0,   30,
   30,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   30,   30,    0,   30,   30,   30,    0,    0,    0,    0,
   30,   30,    0,   30,   30,    0,   30,    0,    0,   30,
   30,   30,   30,   30,   30,   30,    0,    0,    0,    0,
   30,   30,   30,    0,   30,   30,   30,    0,   30,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,    0,
   30,   30,   30,   30,   30,   30,    0,   30,   30,   30,
   30,    0,   30,    0,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,    0,   30,   30,   30,   30,    0,   30,   30,
   30,   30,   30,    0,   30,   30,   30,   30,   30,  666,
    0,    0,  666,    0,  666,  666,  666,  666,    0,  666,
    0,    0,    0,    0,    0,    0,    0,  666,  666,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  666,  666,
    0,  666,  666,  666,    0,    0,    0,    0,  666,  666,
    0,  666,  666,    0,  666,    0,    0,  666,  666,  666,
  666,  666,  666,  666,    0,    0,    0,    0,  666,  666,
  666,    0,  666,  666,  666,    0,  666,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  666,  666,  666,  666,
  666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,  666,  666,  666,  666,  666,    0,  666,  666,
  666,  666,  666,  666,    0,  666,  666,  666,  666,    0,
  666,    0,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
    0,  666,  666,  666,  666,    0,  666,  666,  666,  666,
  666,    0,  666,  666,  666,  666,  666,  319,    0,    0,
  319,    0,  319,  319,  319,  319,    0,  319,    0,    0,
    0,    0,    0,    0,    0,  319,  319,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  319,  319,    0,  319,
  319,  319,    0,    0,    0,    0,  319,  319,    0,  319,
  319,    0,  319,    0,    0,  319,  319,  319,  319,  319,
  319,  319,    0,    0,    0,    0,  319,  319,  319,    0,
  319,  319,  319,    0,  319,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  319,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  319,    0,  319,  319,  319,  319,
  319,  319,    0,  319,  319,  319,  319,    0,  319,    0,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  319,    0,  319,
  319,  319,  319,    0,  319,  319,  319,  319,  319,    0,
  319,  319,  319,  319,  319,  119,    0,    0,  120,    0,
  121,  122,  123,  124,    0,  125,    0,    0,    0,    0,
    0,    0,    0,  126,  127,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  128,  129,    0,  130,  131,  132,
    0,    0,    0,    0,  133,  134,    0,  135,  136,    0,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  146,  147,    0,  148,  149,
  150,    0,  151,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  153,  154,  155,  156,  157,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
  170,  171,  172,    0,  173,  174,  175,  176,  177,  178,
    0,  179,  180,  181,  182,    0,  183,    0,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,    0,  202,  203,  204,
  205,    0,  206,  207,  208,  209,  210,    0,  211,  212,
  213,  214,  215,
};
static int yycheck[] = {                                       9,
    4,   72,   17,  118,    0,   62,   16,   17,   81,   19,
   71,  105,   78,  655,   70,  484,  485,  701,   76,   63,
   71,  498,  778,   64,   16,   96,  820,  102,  535,  998,
  535,   75,  998,  106,  535, 1064,   77,  548,  104,  405,
 1031,  358,   66,  100,  102,  108,  531,  484,  485,   59,
   60, 1106,   62,   63,   64,   65,   66,  101, 1066, 1112,
  905,   71,   72,   73,  945,   75,  110,   77,   78, 1106,
   80,   81,   82,   83,  502,   99,  813, 1067,  987, 1106,
  733, 1106,   92,  107,   94,   95,   96,  923,   98,   99,
  100,  101,  928,  103,  104,  105,  106,  107,  108, 1106,
  110,  825,   94, 1241, 1313,  527, 1016,  500,  722,  756,
  721,  103,  480, 1094, 1032,  512, 1015, 1334, 1106,  916,
  351,  511, 1077, 1090, 1419,  256,   41,  963, 1385,    0,
 1464,   44,    0,    0,  970, 1701,  820, 1626,  455, 1459,
    0,  878, 1644,    0,  541,   42,   43,    0,   45,   45,
   47,   44,    0,    0,    0,    0, 1583,  251,   44, 1586,
 1115,   63,    0,   40,   45,   45,    0,    0,   40, 1340,
    0, 1126,   45,   41,  225,    0,  247,  228,  281, 1070,
   41,   44, 1477,   63,  250,  226,   45, 1129,   59, 1446,
  843,   59,   59,   41,   44,   41,   44,   44,   40,   59,
  279,   41,   59,   41,  248,    0,   59,    0,  249,    0,
  234,   59,   59,   59,   59,  225,  226,  227,  228, 1083,
  451,   59,  232,   41,  234,   59,   59,  242,    0,   59,
  298, 1076,  242,   44,   59,  227, 1191,  247,  248,  249,
  250,  251,    0,    0,    0,  360,  256,    0,   61,    0,
   44,  242, 1660,    0,   44,    0,  767,   40, 1074,   44,
  316,  273,    0,    0,   59,   41,   59,  371,   59, 1698,
   41,    0,   41,   40,  344,   44,  303,    0,    0,   41,
   63,   59,  280,   61,  298,  298,  394,   59,   41,  394,
    0,  347,   40,   94,   91,   44,   63,  263,   61,  262,
  264,   59,   59,   59,   41,  264,   59,   44,   59,  319,
  264,  816,   59,  315,   59,    0,  801, 1001,  825,  257,
  825,   59,   59,  268,  825, 1902,  379,  406,  264,  563,
   59,   41,  809,  446,  339,  262,   59,   59,  978,  979,
  257,  265,  457,  309, 1313,  396,  712, 1313,  399,   59,
    0,  828,    0,  587,  320,  997,   41,  362, 1645,   44,
 1002, 1003,    0,  420,  730,  375,  317,  764, 1945,  854,
   44,  317,  351,  383,   59,  299, 1671,  315,  431,   44,
  277, 1065,  409,  424, 1121,  282,  396, 1203, 1355,  399,
    0,  499,  330,  444,  450,  405,  406,    0, 1234, 1235,
 1827,  262,    0,   41, 1831,  510,   44, 1727,  845,   59,
  420,   59,  417,  330,  424,  378,  375, 1154, 1032,  433,
  433,   59,  262, 1304, 1334, 1335,  227, 1382,  443,  444,
 1717,  446,  430,  443,  461,  505,  446,  447,  402,  375,
 1276,   44,  444,   41,  262,  457, 1741,  315,  402,   59,
  501,  378,  418,  264,   58,  446,   59,  560, 1072,   63,
  511,   59,  513,  426,  515,  569,  537,  518,  336,  479,
  480, 1879,  528,  539,  530, 1613, 1394, 1734,  275, 1696,
 2029,  427, 1911, 1740,  297, 1742,  336, 1429, 1430,  545,
  336,  501, 1663, 1664,  538,  552,  441, 1378,  336,  370,
  262,  511, 1393,  513,  483,  515,  547, 2073,  518, 1419,
  551,  379,  580,  262,  593,  442,    0,  378, 1735,  297,
 1173,    0,   42,  317, 1360,  297, 1390,  537,  538,  539,
  306, 1669,  317, 2035,  297,  306,  449,  547,  378,  272,
  550,  551,  552, 1012,  386,  555,  379,  449,  277,  297,
  422,  555,  445,  449,  277,  388,  352,  443, 1500,  297,
  378,  438,   41,  431,  427,   44,  400, 1477,  449,  449,
 1406, 1387,  344, 1564, 1908,   59,  449,  445, 2005,  896,
   59,  452,  453,  336,    0,  375, 1200,  904,  344,    0,
  449,  338,  452,  453,  509,  452,  453,  442,  445,  445,
 1214,  732, 1216,  476,  361,  400,  344,  445,  401, 2175,
  401, 1048,    0,  364,  264,  445,  378,  476,  489,  336,
  445,  379,  344,  370,  420,   41,  336,  301,   44,  378,
  315, 1476,  427,  402, 1891, 1892,  301, 1482,  375, 1144,
 1960,  509, 1326,   59,  492, 1940,  656, 1616,   59,  396,
 1616,  336,  399,   41,  264, 1295, 2222, 2146, 1024,  655,
  528,  528,  324,  894,  535, 1874,  449,  711,  415,  710,
  721,   59,    0, 1890,  310,  528,  509,  315,  719, 1190,
 1417,  578,  449, 1650,  725,   41,  283, 1198,   44,  747,
 1427,  701,  445,  497,  441,  528, 2245, 2246,  336,   42,
  710,  711,  712, 1345,   47,  576,  721, 1349, 1505,  719,
  751, 2203, 1354,   41,  724,  725, 1084,  315,  774, 1156,
  730, 1702,  732, 1113, 1623,  766,  722,  778,  769, 2295,
 1947,   59,   41,  505,  315,   44, 1347,  298,  336,  389,
  260,  751,  272, 1661, 1500,  303, 1483,  803, 1395,  496,
 1143,  509,   61,    0,  280,  492,  766,  297, 1075,  769,
  445, 1671,  818,  334,  509,  375, 2315,  505,  778,  516,
  528,  846, 1386,  334,  825,  262,  379, 1732, 1206,  389,
  300,  379,  529,  528,  264,  388, 1696,  268,  846,  260,
  388, 1188,  848,  455,   41,  370,  264,  276,  277,  276,
    0,  258,  281,  322,  344,  284,  336,  445,  493,  445,
  820,  276,   59,  262,  824,  825,  428,    0,  297,  284,
  830,    0,   59,    0,  509, 1735, 2318,  408, 1673,  300,
    0, 1741, 2381,  431,  375, 2092, 2093,  893, 2330,  442,
  443,   41,  395,  528,  900,  901,  303,  445,  452,  453,
  376,  409,  903,  264,  338,  452,  453, 1910,  411,   59,
  276,  277,  433,  444,   41,  281, 1775,   44,  284,  259,
  276,  509,  433, 1384, 2091, 1844,   59, 1930,  359,  269,
   59,  297,   59, 1525, 1875,  257,  370,    0,  273,   59,
  528,  378,  371,  903,  371,  375,  257,    0, 1889, 2065,
 2066,  959,  421,  461,  430, 1874,  509,  375, 1874,  428,
  316,  509,  396,  392,  489,  399,   93,  273,  315,  398,
  396,  447,  400,  304,  305,  528,  950,  315,  991,  378,
  528,  415,  928, 1617,  277,  304,  305,  549,   41,  282,
  950,  270,   42,   43,  556,   45,   59,   47,  336,  427,
  306, 1593,  409,  432,  315,  371,   59,  441,  330,    0,
  535,  300, 1013,  348, 1015,  505, 1017,  296,  964,  330,
  427,  447,   44, 2111,  383,  384,  392,  426, 1896, 1401,
 1890,  991,  398,  998,  309,  375,  392,  315,  297,  276,
    0, 1001,  348,   44,   42,   43,   44,   45,   46,   47,
 1044,  576, 1043, 1013,  461, 1015,  408, 1017,  336,  348,
 2065, 2066,  496,  275, 1024, 1066,  432, 1058,   59, 1060,
  344,   93, 1032, 1074,    0, 1462,  432, 1083, 2065, 2066,
 1940,   41,  516, 1043, 1044,  319, 1032, 1947, 2065, 2066,
 2065, 2066,   93,   91, 1100,  529,  402,  400, 1058,   59,
 1060, 1066,  304,  305, 1110, 1065, 1478,  445, 2065, 2066,
 1070,  442, 1113,  483, 1074, 1140,  298, 1720,  315,  394,
 1723,    0, 2062,  442, 1084, 1503, 1072, 2065, 2066,  341,
  327,  560, 1140,   59,  371, 1966,  297, 1811,  261,  336,
 1141,    0,  512, 1144,  264, 1153, 1941,  276,  277,  257,
  449,  457,  334, 1113,  429,  392, 1162, 2316, 1183, 1184,
 1185,  398, 1170,  396,    0,  315,  270,  445,   44,   42,
   43,   44,   45,   46,   47, 1183, 1184, 1185,  452,  453,
   59, 1141,  379,  259, 1144,  348,  336,  348, 1201, 1567,
  528,  388,  296,  269,  560,  432,  596,    0, 1189, 2358,
   59, 2360, 1203, 2362, 1164,  338, 2209,  315, 1475,  336,
 1164, 2327, 2328, 1204,  447, 2374,   40,   93,   91, 1906,
 1907,    0,  330,   59, 1643, 1644, 1645,  277,  449, 1189,
  300, 2091,  282,  563,  431,    0,   44,  370,    0,    0,
  442, 1201,  371, 1203, 1204, 2203,    0,  265,  445,  370,
  528,    0, 1212, 1213, 1200,  375,   59,  587, 1212,    0,
    0, 2047,  315,  396,  449,   44,  399, 1954, 1214,  389,
 1216,    0, 1733,    0,  401, 2061, 2217,    0,  348,  277,
   59,  299,  415,  336,  282,   93,  271,   41,  409,  452,
  453,  476,  395,  319,   59,  445, 1888,   59,   59,  375,
  285,  371, 1689, 1738, 1691,   59, 1280, 1435,  441, 2288,
   59,  319,  509, 1629, 1327,  333, 1632,  375,   59,   59,
 1280,  260, 2327, 2328,   42,   43,   44,   45,   46,   47,
   59,  528,   59,  259,    0,  456,   59,  449,  264,    0,
 2327, 2328,    0,  269,  329,  318, 1347,  338, 1313, 1736,
 2327, 2328, 2327, 2328, 1811,  315, 1811, 1485,  331,  509,
 1811,  300,    0,  496,  476,  258, 1326, 1327,  261,  393,
 2327, 2328,  357,   91,  303,  396,  336,    0,  528, 1339,
 1340,  354, 1347,  516, 1390,  264, 1387,   40,    0, 2327,
 2328,  375,  445,   59,  415,    0,  529, 2316,   59,  383,
 2316,   59,   40,   41,  277,  396,   44, 2151,  399,  282,
  303,  276,  260,  463,  464,  465,  466,  467,  468,  469,
  470,   59,    0,   61,  415, 1844,  375, 1387,  264,   41,
    0,  404,   44, 1393, 1394,  420,   59,  452,  453, 2358,
 1386, 2360, 2358, 2362, 2360, 1470, 2362,   59,  260,  375,
  441,  316,  300,   91,   59, 2374,  509, 2163, 2374,   44,
  389,  264, 1470,  389,  260,  463,  464,  465,  466,  467,
  468,  469,  470,   42,   43,  528,   45, 1502,   47, 1480,
  409,   59,  377, 1508,    0,  445, 1913, 1493,  300,   59,
    0, 1451,  595, 1484, 1502,    0,  375,  258,  427, 1500,
 1508,  277, 1456,  284,  300,  496,  282,  377, 1468,  270,
  389,    0,    0, 1451,    0,  264,  297, 2151,    0,    0,
 1480,  334,  572, 2309, 1484,  516,    0,  392,   42,   43,
 1468,   45,  461,   47,  333,  435,  297,  264,  529,  375,
 1500,  264,  303,   59,  305,  445,    0, 1675,  598,   59,
  653,  654,  655,  389,   59,   41, 1567,  264,   44,  277,
    0,  315, 2348,  318,  282,    0, 1567,  432,  528,    0,
   59,   59,  375,   59,  572,   61,  331,   59,   59,  456,
  260,  458,  336,  344, 1712,   59,  389,  409,    0, 1633,
  463,  464,  465,  466,  467,  468,  469,  470,  264,  354,
  598,   41,    0, 1563,   44,   59,   41, 1567,    0,   44,
   41, 1634,  367,   44,   44, 1631, 2035, 1745,  298,   59,
  258, 1563, 1623,  484,   59,  379,  375,    0,   59, 1358,
  310,   40, 1361,  494,  388,  273, 1630,  275,  276,  277,
  389,  260,  794,  281,  796,  260,  284,   59,  375,  404,
   41, 1616,  375,   44,  334,  452,  453, 1617,    0,  297,
    0,   59,  389, 1623,  596,  303,  389,   59,  306, 1629,
 1630, 1631, 1632, 1633, 1634,   42,   43,  431,   45,  782,
   47,  300,  785, 1674,  258,  300,   59,  790, 1653,  433,
  793,  445,  333, 1653,  797,   41,  270,    0,   44,  572,
 1660, 1661,   41, 1663, 1664,   44,    0,  445,  277,  375,
  348,    0,   41,  282, 1674,   44,    0,   59,  398,   59,
    0,   40,   61,  389,   46,  598,  367,  516,  408,  303,
   59,  305,   61,  371,  313,  314,   58,   59,  379,   61,
 1746,  484,  485,    0,  505,  463,  464,  465,  466,  467,
  468,  469,  470,  433,  392,  509,   59, 1763,  513,  415,
  398, 1715, 1768,  277,  402,   59, 1894, 2231,  282, 2233,
   59,  409,  258, 2365,  528,   59,  333, 1905,  452,   59,
   41, 1909,   41,   44,   41,   44, 1914,   44,    0,  427,
  276,  277, 1863, 1864,  432,  281,   42,   43,  284,   45,
  352,   47,   59,  264,   42,   43,  313,   45,  297,   47,
  367,  297, 1863, 1864,  315, 1943, 1944,  303, 1946,  457,
 1948,   41,  379,  461,   44,  928,   41,   42,   43,   41,
   45,   41,   47,  385,   44,  387,  276,  277, 1844,   59,
   41,   61, 1802,   44,  947,  276,  277,   59,  951,  425,
  298,  954,   46,  284,  572,  344,  338,  409,  427,  962,
 1802,  964,  333,  352,   58,  968,  969,   61,  408,  972,
  973,  974,  975,  976,  977,  978,  332,  980,   41,  982,
  598,   44,  434,  443,   41,  371,  334,   44,  370,  992,
  993,  994,  995,  996,  997,  435,  385, 1000,  387, 1002,
 1003,  425,  402, 1863, 1864,  445,  392,  394,  336, 1874,
  277, 1876,  398,  427,  396,  282, 1876,  399,  258, 1879,
  409,  492,  560,  409, 1915,  309, 2054, 2055, 2056, 2150,
  270,  371,   41,  415,    0,   44, 1896,    0,  317,   41,
  371,  427,   44,  315,  375,  434,  432,    0,  277,  315,
  398, 1942,  392,  375,  375, 1915,    0,  297,  398,  441,
  408,  392,  497,  303,  258,  305, 1069,  398,  297,  336,
   41,   41,  427,   44,   44,  461,  270,   41,   41,  356,
   44,   44, 1942,    0, 1995,  433, 1993,   41,   41,  425,
   44,   44,  432,   59, 1995,  533,   59,   41,   61,   41,
   44,  432,   44,  297,  344,  532,   59,  530,   61,  303,
  394,  305,  352, 2078,  496,   59,  505,  264, 2029,  276,
  277,  336,  425,   41,   41,   46,   44,   44, 2029,   41,
 1990,  277,   44, 1993,  516, 1995,  282,   58,   59,  277,
   61,  425,   59,   41,  282,  429,   44,  529, 1990,   93,
  344,  376,  409, 2181, 2182, 2183,  440,  277, 2186,  319,
   41,  492,  277,   44,   41,   42,   43,  282,   45, 2029,
   47,  337, 2079,   41,  560,    0,   44,  297,  374,  496,
  420, 2072,   42,   43,  273,   45,   41,   47,  504,   44,
  336,  329,   42,   43,  509,   45,   41,   47, 2104,   44,
  315,  505, 2108,  315, 2325,   41,   41,   41,   44,   44,
   44, 2176, 2072,  325,  371,  327, 1219, 1220, 1221, 2079,
  297, 1224, 1225, 1226,  336, 1228, 1229, 1230, 1231, 1232,
 1233,  306,  460,   41,   59,  392,   44,   44,  445, 1242,
 1243,  398, 1245,  504, 1247,   61, 2367, 1250, 1251, 1252,
 1253,  371, 1255, 1256,   42,   43, 2377,   45, 2379,   47,
   41, 2382, 2163,   44, 2385,  505,  365,  379,  283, 1272,
 2130, 1274,  946,   40,  948,  432,  388,  561,  952,  953,
  264,  955,   40,   42,   43,  388,   45, 1290,   47,  452,
   41, 2151,  258,   44,   40,  258, 1299, 1300,  448,  449,
  450,   40, 2203, 2163,  270,  258,   40,  981,  452,   40,
   40,  505,  275,  276,  277, 2236,   40,   40,  281,  431,
   40,  284,  275,  276,  277,   40,  476,  477,  281,  452,
   40,  284,   40,  445,  297,   40,   40,  303, 2203,  305,
  303,   40, 1345, 2203,  297,  351, 1349,   40,   40,   40,
  303, 1354,   40,   40,   40,   40,   40, 2203,   40, 2280,
   40,   42,   43,   40,   45,   91,   47,  401,   44,   40,
   40, 2231,   46, 2233,   40,  264, 2236,   42,   43,   44,
   45,   46,   47,   61, 2244, 2245, 2246,  435,  531, 2290,
  394,   44,  336, 1396,  439, 1398, 1399,  509,  315,  315,
  277,  419,   46,   61,   40,  282,   40,  264,  371,  337,
  327,   46,  344,  344,  344,  276,  528,  277,  371,  336,
 2280, 2281,  282,  364,  264, 2290,   91,  277, 2282,  392,
  389,  427,  282,  389,  275,  398,  449,  344,  438,  392,
  317,  438,  391,   40,  407,  398,  409,   40,  308,  345,
   91, 2316,   40,   40,  264, 2315,  409,  401,  317,   41,
   42,   43,  379,   45,  427,   47,   40,  317,  402,  432,
  375,  388, 2318, 1224,  427, 1226,   44, 1228, 1229,  432,
 1231, 1232, 1233,  374, 2330,   40,  381,   40,  315,  277,
  442,  379,   41, 2358,  282, 2360,  374, 2362,  461,  277,
  371,  275,   63,  427,  427,  455,  528,   40,  461, 2374,
  314,    0,    0,   40,  431,   44,   40,  439,  277,  445,
  264, 2381, 1525,  282,   40,  337,   44,  317,  445,  317,
   44,   44,   40,  273,    0, 1538, 1539,   40, 1541, 1542,
  340,  340,  537,  297,  409,  378, 1549,  378,  378,  407,
   40,  352,   41,   41,  379,   44,   44,  409,  317,   40,
   40,   40,   44,  388,  362,   41,   41,  317, 1571,    0,
   59,   59,   44,   44, 1577,   41,  277, 1580,   44, 1582,
 1583,   46,   41, 1586,  409, 1588,  318,  348,  377, 1592,
 1593, 1594,  509,   59,   41,  361,  277,  560, 1601,  331,
 1603,  282,   41, 1606, 1607, 1608, 1609,  560,  380, 1612,
   41,  528,  277,   44,  339,  317,  435,  282,  443,  317,
   42,   43,  354,   45,   41,   47,  451,  308,   59,  454,
  339,  456,  457,  458,  459,  367,  461,  443,  266,  493,
  264,  492,  264,  375,  469,  470,   42,   43,  413,   45,
   41,   47,   58,   41,   41,  480,  481,   41,  483,  484,
  485,  264,  445,   40,  591,  490,  491,  492,  493,  494,
  576,  496,  404,  386,  499,  500,  501,  502,  503,  504,
  505,  306,   41,  306,  509,  510,  511,  512,   41,  514,
  515,  516,   40,  518,   40,  277, 1699,  317,   40,   40,
  282,   40,   40,   40,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   40,  550,  551,  552,  553,  554,
  555,   40,  557,  558,  559,  560,    0,  562,   40,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   40,  583,  584,
  585,  586,   40,  588,  589,  590,  591,  592, 1771,  594,
  595,  596,  597,  598, 1777,   40,  291,   41,   40, 1782,
   44,  513,   40,   40,  262,  305, 1789,  302,  426,  296,
  427,  445,   44,   44,  309,   59,  262,  339,  463,  464,
  465,  466,  467,  468,  469,  470,   40,  322,   41,   42,
   43,   44,   45,   44,   47,  325,  383,   41,   42,   43,
  284,   45,  398,   47, 1827,   41,  315,  315, 1831,   41,
  378,  378,  378,  378, 1837, 1838,  325,  325,  327,  327,
  378,  378,  449,  276,  375,  276,  277,  336,  336,  315,
  339,  339,  318,  284,   40,  277,   41,   41,   41,  325,
  282,  327,  317,  378,   41,  331,  297,    0,   44,  265,
  336,   41,  374,  339,  426,  305,   41,   42,   43,  394,
   45,  277,   47,   41,   41, 1888,  282,    0,  354,  270,
  379,  379,  324,  315,  437,  410,  333,  427,  442,  388,
  388,  367,  442,  299,  273,  433,  327,  572,   41,  375,
  425,  334,  378,  379,  429,   42,   43,  432,   45,  298,
   47,  433,  388,  334,  298,  440,   59,   41,   41,   42,
   43,   44,   45,  598,   47,   41,  348,  377,  404,   41,
  371,   41,  431,  431,  459,  279,   59,   60,   61,   62,
  364,  364,   41,   41,  443,  443,  445,  445,   41,   41,
  426,  392,   41,   41,   41,  431, 1969,  398,   41,   41,
   41,   41, 1975, 1976,   41,   41,  442,  443,   41,  445,
   93,   41,   42,   43,   41,   45,   40,   47,   41,  569,
  426,   41,   42,   43,  377,   45,  371,   47, 2001,  569,
  515,  432, 2005,  518,   40,  340, 2009,   41,  457,  333,
  305, 2014, 2015, 2016, 2017, 2018,  442,   59,  290,  426,
  509,  509,   44, 2026,  433,  375,  492,   41,   42,   43,
   41,   45,  509,   47,  570,  509,   44,   40,  315,  528,
  528,  334,  409,  509,  277,  375,  561,  513,  375,  282,
   41,  315,   40,  277,  318,  336,  336, 2060,  282,   59,
   58,  325,  528,  327,   40,  433,  298,  331,   42,   43,
   41,   45,  336,   47,   40,  339,   44,  435,  454,  499,
   41,   42,   43,  336,   45,   41,   47,   41,   42,   43,
  354,   45,  336,   47,   40,  426,  301,  304,  290,  301,
 2103,  408,    0,  367,  333,  375,  375,  318,  408,  264,
   40,  375,  277,  264,  378,  379,  264,  282,  408,   40,
  331,  449,  442,  402,  388,   41,   42,   43,  339,   45,
   44,   47,   41,   41,   42,   43,  339,   45,  435,   47,
  404,   40,  317,  354,   40,  258,   41,  264,  338,  262,
  277,  264,  265,  449,   41,  282,  367,  339,  271,  426,
   41,  449,  426,  276,  277,   41,   41,  431,   41,  282,
   41,  284,  285,   41,   41,  305,   59,   59,  442,  443,
  370,  445,  315,  301,  528,   59,  299,   59,   40,   59,
  303,  304,  305,  404,  327,  308, 2199,   59, 2201,   59,
   59,   59,  315,  336,  317,  318,  396,  370,  321,  399,
  485,  370,  325,   44,  327, 2218,  329,  277,  331,   41,
   41,   41,  282,  336,  337,  415,  339,  277,  492,   41,
    0, 2203,  282,   41,   42,   43,  528,   45, 2241,   47,
    0,  354,  355,  528,  357,  509,  379, 2203, 2203,  513,
  231,  441, 2203,  231,  367,  388,  369, 2203,  371,  372,
  373, 2203,  375,  277,  528,  378,  379,  728,  282, 1641,
  232,   41,  730, 1044,   44,  388,    0, 1024,  407,  392,
   40,   41,  406,    0,   44,  398,  912, 1505,  401,   59,
  264,  404, 1207, 1503,   98, 1164,  409,   82,  431,   59,
 1500,   61,  513,  277, 2307, 2308,  496,  420,  282, 1212,
 1479, 1177,  445,  426,  427, 1931,  277,   41,  431,  432,
   44,  282, 1913,  277,   41, 1404,  516, 1494,  282,  442,
  443,   91,  445,  532,  453,   59, 1895,  854,  451,  529,
 1480,  454,   59,  456,  457,  458,  459,  513,  461,  513,
  463,  464,  465,  466,  467,  468,  469,  470, 2361, 1123,
 1911,  277, 2365, 2220, 2297, 2224,  282,  480,  481,  277,
  483,  484,  485,  830,  282, 2223,  509,  490,  491,  492,
  493,  494, 2244,  496, 1113, 2207,  499,  500,  501,  502,
  503,  504,  505, 1676, 2326,  528,  509,  510,  511,  512,
  513,  514,  515,  516, 1013,  518, 1335,   41,   42,   43,
  518,   45,  503,   47,  832,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548, 1724,  550,  551,  552,
  553,  554,  555, 1180,  557,  558,  559,  560,    0,  562,
  496,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  277,
  583,  584,  585,  586,  282,  588,  589,  590,  591,  592,
   14,  594,  595,  596,  597,  598,  891,  233,   40,   41,
   42,   43,   44,   45,   46,   47,  431, 1172,  258,   41,
   42,   43,  740,   45, 1058,   47,   58,   59,   60,   61,
   62, 2039,  735,  273,  487,  275,  276,  277, 2218,  944,
  291,  281, 1396, 1032,  284, 1990,   41,   42,   43, 1882,
   45,  302,   47, 1359, 1802, 1398, 1883,  297,  309,   91,
 2290,   93,  313,  303, 2216,  315,  306,  756,  318, 1042,
  318, 2203,  276,  277, 1540,  325, 2203,  327,  587, 1364,
  284,  331,  333,  331, 1407, 1611,  336, 1588,   -1,  339,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,  354,   -1,  348,   41,
   42,   43,   -1,   45,   -1,   47,   -1,  367,  315,  367,
   -1,   -1,   -1,   -1,   -1,  375,   -1,  375,  325,  379,
  327,  371,   -1,   -1,   -1,   -1,   -1,   -1,  388,  336,
   -1,   -1,   -1,  394,   -1,   -1,   -1,   -1,   -1,   41,
   42,   43,  392,   45,  404,   47,  404,   -1,  398,   -1,
   -1,   -1,  402,  277,   -1,   -1,   -1,  371,  282,  409,
   -1,   -1,   -1,   -1,  425,   -1,   -1,   -1,  429,    0,
   -1,  431,  379,   -1,   -1,   -1,   -1,  427,  392,   -1,
   -1,  388,  432,  443,  398,  445,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  457,   -1,   -1,
   41,  461,   -1,   44,   -1,   -1,   -1,   -1,  432,   -1,
  262,   -1,  264,  265,  431,   -1,   -1,   -1,   59,  271,
   -1,   -1,  492,   -1,  492,  277,  443,   -1,  445,   -1,
  282,   -1,   -1,  285,   -1,  277,   -1,   -1,   -1,  509,
  282,   -1,   -1,  513,  515,  513,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,  528,   -1,
   -1,   -1,  277,  315,   -1,  317,  318,  282,  492,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,  509,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  560,    0,  354,  355,   -1,  357,   -1,  277,   -1,   -1,
   -1,  528,  282,   42,   43,  367,   45,  369,   47,  371,
  372,  373,   -1,  375,   -1,  277,  378,  379,   -1,   -1,
  282,   -1,   -1,   41,   42,   43,  388,   45,   -1,   47,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   42,   43,   44,   45,   -1,   47,   58,
   59,   60,   61,   62,   -1,  277,   -1,   -1,  420,   -1,
  282,   -1,   -1,   -1,  426,  427,   41,   42,   43,  431,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,  277,
   -1,   41,   42,   43,  282,   45,   -1,   47,  480,  481,
   -1,  483,  484,  485,   -1,  276,  277,   -1,  490,  491,
  492,  493,  494,  284,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  371,  583,  584,  585,  586,  264,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,  277,   -1,
   -1,  392,   -1,  282,   -1,   -1,   -1,  398,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  277,
   -1,   -1,  271,   -1,  282,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,  277,   -1,
   -1,  432,   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,  277,   -1,   -1,   -1,  315,  282,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,  492,   -1,   -1,    0,  354,  355,  277,  357,   -1,
   -1,   -1,  282,   -1,   -1,   41,   42,   43,  367,   45,
  369,   47,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   41,   42,   43,   -1,   45,   -1,   47,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,  277,   -1,  404,   -1,   -1,  282,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   42,   43,   44,
   45,  420,   47,   -1,   -1,   -1,   -1,  426,  427,   41,
   42,   43,  431,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,  572,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   41,   42,   43,  598,   45,   -1,
   47,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,  277,  264,  265,
   -1,   -1,  282,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,  277,  299,   -1,   -1,   -1,  282,  304,  305,
   -1,   -1,  308,   -1,   -1,  277,   -1,   -1,   -1,  315,
  282,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,    0,  354,  355,
  277,  357,   -1,   -1,   -1,  282,   -1,   -1,   41,   42,
   43,  367,   45,  369,   47,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,  277,   -1,  404,   42,
   43,  282,   45,   -1,   47,   58,   59,   60,   61,   62,
   42,   43,   44,   45,  420,   47,   -1,   -1,   -1,   -1,
  426,  427,   41,   42,   43,  431,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   42,   43,  277,   45,   -1,   47,
   -1,  282,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,  277,  583,  584,  585,
  586,  282,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
  277,  264,  265,   -1,   -1,  282,   -1,   -1,  271,  262,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,   -1,   -1,   -1,  277,  299,   -1,   -1,   -1,
  282,  304,  305,   -1,   -1,  308,   -1,   -1,  277,   -1,
   -1,   -1,  315,  282,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
    0,  354,  355,  277,  357,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   42,   43,
   44,   45,   -1,   47,  262,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,  277,
   -1,  404,   -1,   -1,  282,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   42,   43,   44,   45,  420,   47,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  277,
  583,  584,  585,  586,  282,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,  277,  264,  265,   -1,   -1,  282,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  299,
   -1,   -1,   -1,  282,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,  277,  315,   -1,  317,  318,  282,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
 1772, 1773,   -1,   -1,  271,   -1,   -1,   -1, 1780, 1781,
  277, 1783, 1784,   -1,   -1,  282,   -1,   -1,  285, 1791,
 1792, 1793, 1794,   -1, 1796, 1797, 1798, 1799, 1800, 1801,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,  404,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   41,  404,   -1,   44,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   59,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,  284,
  299,   -1,  301,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,  371,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   -1,  392,   59,   60,
   61,   62,   -1,  398,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,  432,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,  492,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   41,  404,   -1,   44,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   59,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,  276,  277,   -1,
   -1,   -1,   -1,   -1,   -1,  284,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,  297,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,  371,   -1,   -1,  388,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   -1,  392,   59,   60,   61,   62,   -1,  398,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,  442,
  443,   -1,  445,  432,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   41,  404,
   -1,   44,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   59,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,  276,  277,   -1,   -1,   -1,   -1,   -1,
   -1,  284,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,  297,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,  371,   -1,
   -1,  388,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,  392,
   59,   60,   61,   62,   -1,  398,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,  442,  443,   -1,  445,  432,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   41,  404,   -1,   44,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   59,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,  276,
  277,   -1,   -1,   -1,   -1,   -1,   -1,  284,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,  371,   -1,   -1,  388,   41,   42,
   43,   44,   45,    0,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,  404,   -1,  392,   59,   60,   61,   62,
   -1,  398,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   93,  442,  443,   -1,  445,  432,   -1,   -1,   -1,   -1,
  451,   -1,   59,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,  276,
  277,   -1,  325,   -1,  327,   -1,  329,  284,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   -1,   -1,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,  371,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   93,  442,
  443,  398,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  432,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,  388,
   43,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,  388,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,  388,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,  388,   43,   44,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,  404,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,    0,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   41,  336,  337,   41,  339,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,  354,
  355,   59,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,  264,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,   -1,  315,   -1,   -1,
  318,   -1,   -1,   -1,  325,  271,  327,  325,   -1,  327,
   -1,  277,   -1,  331,   -1,  336,  282,   -1,  336,  285,
   -1,  339,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,  367,
   -1,   -1,   -1,   -1,   -1,  321,   -1,  375,  379,   -1,
   -1,  379,   -1,  329,   -1,   -1,   -1,  388,   -1,   -1,
  388,  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,  404,   -1,   -1,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   60,   61,   62,
   -1,   -1,   -1,  369,   -1,  371,  372,  373,   -1,   -1,
  431,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  445,  443,   -1,  445,   -1,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,  420,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,  509,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,  528,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,    0,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,   -1,  318,   -1,   -1,   -1,   -1,   -1,  271,  325,
   41,  327,   -1,   44,  277,  331,   -1,   -1,   -1,  282,
  336,   -1,  285,  339,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,  321,  375,
   -1,   -1,   -1,  379,   -1,   -1,  329,   -1,   -1,   -1,
   -1,   -1,  388,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  369,   -1,  371,  372,
  373,   -1,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  443,   -1,  445,
   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,  315,   -1,   -1,  318,   -1,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,
  331,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  375,   -1,   -1,   -1,  379,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   59,
   -1,   61,   -1,  404,   -1,   -1,   -1,   45,   -1,   -1,
   -1,   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  431,   91,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  443,   91,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,    0,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  258,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  258,   -1,   -1,  273,   -1,  275,  276,  277,   -1,   -1,
   -1,  281,    0,   -1,  284,  273,   -1,   41,  276,  277,
   44,   -1,   -1,  281,   -1,   -1,  284,  297,   -1,   -1,
   -1,   41,   -1,  303,   44,   59,  306,   61,   -1,  297,
   -1,   -1,   -1,   -1,  292,  303,   -1,   -1,  306,   59,
   -1,   61,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   -1,   59,  320,   61,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   91,   -1,   -1,  302,   -1,   -1,   -1,   -1,   -1,
  348,  309,   -1,   -1,   -1,  313,  314,   -1,   -1,   -1,
  348,  371,   -1,   -1,  322,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  371,   -1,  333,   -1,   -1,   -1,   -1,
   -1,   -1,  392,   -1,   -1,   -1,  275,   -1,  398,   -1,
   -1,   -1,  402,   -1,  392,   -1,   -1,   -1,   -1,  409,
  398,   -1,  291,   -1,  402,   40,   -1,   -1,   43,   -1,
   45,  409,   -1,  302,   -1,   -1,   -1,  427,   -1,   -1,
  309,   -1,  432,   58,  313,  314,   -1,   -1,   63,  427,
  418,   -1,   -1,  322,  432,   -1,  394,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  333,   -1,  434,  457,   -1,   -1,
   -1,  461,  410,   -1,   -1,   -1,   -1,   -1,   -1,  457,
  448,  449,  450,  461,  452,  453,   -1,  425,   -1,   -1,
   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  471,  472,  473,  474,  475,  476,  477,
  478,  479,   -1,   -1,  258,   -1,   -1,  386,  486,  487,
   -1,  459,   -1,   -1,   -1,  394,   -1,  495,  258,  273,
   -1,   -1,  276,  277,   -1,   -1,   -1,  281,   -1,   -1,
  284,   -1,   -1,  273,   -1,   -1,  276,  277,   -1,   -1,
  258,  281,   -1,  297,  284,   -1,  425,   -1,   -1,  303,
  429,   -1,  306,   -1,   -1,  273,   -1,  297,   -1,  277,
  560,  440,   -1,  303,   -1,   -1,  306,  515,   -1,   -1,
  518,   -1,  560,   -1,   -1,   -1,   -1,   -1,   -1,  297,
  459,  460,   -1,   -1,   -1,  303,   -1,   -1,  306,   -1,
   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,  371,   -1,   -1,   -1,   -1,  515,   -1,  392,  518,
   -1,   -1,  267,   -1,  398,   -1,   -1,   -1,  402,  274,
   -1,   -1,  392,  371,   -1,  409,   -1,   -1,  398,   -1,
   -1,  286,  402,   -1,   -1,   -1,   -1,  292,  293,  409,
   -1,   -1,   -1,  427,   -1,   -1,   -1,   -1,  432,   -1,
   -1,   -1,   -1,   -1,  402,   -1,   -1,  427,   -1,   -1,
   -1,  409,  432,   -1,   -1,  320,   -1,   -1,  323,   -1,
   -1,   -1,   -1,  457,   -1,   -1,   -1,  461,   -1,  427,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  457,   -1,   -1,
   -1,  461,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,  457,
   -1,   -1,   -1,  461,   -1,   -1,   -1,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,  560,   -1,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  560,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,  463,  464,
  465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  484,
  485,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,   -1,   -1,  289,   -1,   -1,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  412,
   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  371,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  412,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  445,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  267,   -1,
   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  371,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  412,   -1,   -1,   -1,   -1,   -1,  418,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,  453,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,  481,   -1,  483,  484,  485,  486,  487,   -1,
  489,  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,
   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,   -1,   63,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,  453,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,  481,   -1,  483,  484,  485,  486,
  487,   -1,  489,  490,  491,   -1,  493,  494,  495,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
  517,  518,   -1,  520,  521,  522,  523,  524,  525,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,
   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   -1,   -1,   -1,   -1,   63,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,
   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,
   -1,   -1,   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,  418,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,  453,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,  481,   -1,  483,  484,  485,  486,  487,   -1,
  489,  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  260,   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,  389,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,
   -1,   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,  485,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  260,
   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,
   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  260,   -1,
   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,
   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,  485,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  260,   -1,   -1,
  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,
   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  260,   -1,   -1,  263,
   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,
   45,   -1,   -1,   -1,   -1,  389,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,   -1,   -1,
  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,
  454,   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,  481,   -1,  483,
  484,  485,  486,  487,   -1,  489,  490,  491,   -1,  493,
  494,  495,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,
  524,  525,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  260,   -1,   -1,  263,   -1,
   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   40,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  389,   -1,   58,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  416,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  484,
  485,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,  260,  594,
  595,  596,  597,  598,  315,  267,   -1,  318,   -1,   -1,
   -1,   -1,  274,   -1,  325,   -1,  327,   -1,   -1,   -1,
  331,   -1,   -1,   -1,  286,  336,   -1,   -1,  339,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,  300,   -1,
   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  320,   -1,
   -1,  323,   -1,   -1,  375,   -1,   -1,   -1,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,  404,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,
   -1,   -1,  443,   63,  445,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  492,   -1,   -1,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,  509,  461,
  462,   -1,  513,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,   -1,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,
   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,   -1,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,  485,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  267,
   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   -1,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  448,  449,  450,  451,  452,  453,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,   -1,  483,  484,  485,
  486,  487,   -1,  489,  490,  491,   -1,  493,  494,  495,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,
  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,
  454,   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,  481,   -1,  483,
  484,  485,  486,  487,   -1,  489,  490,  491,   -1,  493,
  494,  495,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,
  524,  525,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,
   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  445,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,  485,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  317,   -1,   -1,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,
   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,  485,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  267,
   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  389,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,  260,  594,  595,  596,  597,
  598,   -1,  267,  272,   -1,   -1,  275,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  288,
   -1,  286,   -1,  292,   -1,   -1,  295,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,  300,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,
   -1,   -1,  341,  342,  343,   -1,  345,  346,  347,   -1,
  349,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,  360,   -1,  366,  363,  368,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,  397,   -1,
   63,   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  436,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,
   -1,   -1,  471,  472,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  488,
   -1,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  267,   -1,
   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,  453,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,  481,   -1,  483,  484,  485,  486,  487,   -1,
  489,  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   40,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  267,   58,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,  453,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,  481,   -1,  483,  484,  485,  486,
  487,   -1,  489,  490,  491,   -1,  493,  494,  495,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   40,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,   -1,  493,  494,   40,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
  281,  588,  589,  590,  591,  592,  445,  594,  595,  596,
  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   42,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   42,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  293,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   44,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,   45,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,  317,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   58,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  449,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,    0,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,  261,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  272,   -1,  279,  275,   -1,   -1,   -1,   -1,   -1,   -1,
  287,   -1,   -1,   -1,   -1,   -1,  288,  294,   -1,  296,
  292,  298,   -1,  295,   91,   -1,  303,   -1,   -1,   -1,
   -1,   -1,   -1,  310,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  324,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  334,   -1,   -1,
   -1,   -1,    0,  335,   -1,   -1,   -1,   -1,   -1,  341,
  342,  343,   -1,  345,  346,  347,   -1,  349,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  362,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  396,
   -1,   59,   60,   61,   62,  397,  403,   -1,   -1,  406,
   -1,   -1,  409,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   -1,  433,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  436,   -1,   -1,   -1,  445,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,  471,
  472,   -1,   -1,   -1,  271,  482,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,  488,   -1,  285,   -1,
  497,  498,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,  519,   -1,   -1,   -1,   -1,   -1,  315,   -1,
   -1,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   46,   47,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,  262,   -1,   -1,   -1,   91,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,  404,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,    0,   -1,   -1,  426,
   -1,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,  315,  445,   -1,
  318,   -1,   -1,  321,   -1,  272,   -1,  325,  275,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   41,  336,  337,
   44,  339,   -1,   -1,   -1,  292,   -1,   -1,  295,   -1,
   -1,   -1,   -1,   -1,   -1,   59,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,  492,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,    0,  375,   -1,   -1,
  378,  379,  509,   -1,   -1,   -1,  513,   -1,  335,   -1,
  388,   -1,   -1,   -1,  341,  342,  343,   -1,  345,  346,
  347,  528,  349,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,  366,
   44,  368,  420,   -1,   -1,   -1,   -1,   -1,  426,   -1,
   -1,   -1,   -1,  431,   -1,   59,   -1,   -1,   -1,  262,
   -1,   -1,   -1,   -1,  442,  443,   -1,  445,  271,   -1,
  397,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,  414,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  436,
   -1,   -1,  315,   -1,  492,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,  509,   -1,  336,  337,  513,  339,   -1,   -1,    0,
   -1,   -1,   -1,   -1,  471,  472,   -1,   -1,   -1,   -1,
  528,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,    0,
   -1,  488,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,  262,   -1,
   41,   -1,   -1,   44,   -1,  388,   -1,   -1,   -1,   -1,
   -1,  272,   -1,   -1,  275,   -1,   -1,   -1,   59,   -1,
   41,  404,   -1,   44,   -1,   -1,   -1,  288,   -1,   -1,
   -1,  292,   -1,   -1,  295,   -1,   -1,  420,   59,   -1,
   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,   -1,
   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,   -1,  442,
  443,  325,  445,  327,   -1,   -1,   -1,  331,   -1,   -1,
   -1,   -1,  336,   -1,  335,  339,   -1,   -1,  262,   -1,
  341,  342,  343,   -1,  345,  346,  347,   -1,  349,   -1,
  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   -1,  367,   -1,  366,   -1,  368,   -1,  492,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,  509,   -1,   -1,   -1,
  513,  315,   -1,   -1,  318,   -1,  397,   -1,   -1,   41,
  404,  325,   44,  327,   -1,  528,   -1,  331,   -1,   -1,
   -1,   -1,  336,  414,   -1,  339,   -1,   59,   -1,   -1,
   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,
  354,   -1,   -1,   -1,   -1,  436,   -1,   -1,  442,  443,
   -1,  445,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  375,   -1,   -1,  378,  379,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,
  471,  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  404,  262,   -1,   -1,   -1,   -1,   -1,  488,  492,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,  262,  426,   -1,   -1,  509,   -1,  431,   -1,  513,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,  442,  443,
   -1,  445,   -1,   -1,  528,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,
  331,   -1,   -1,   -1,  315,  336,   -1,  318,  339,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,  492,   -1,
  331,   -1,   -1,  354,   -1,  336,   -1,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,  509,  367,   -1,   -1,  513,
   -1,   -1,    0,  354,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,  528,   -1,  367,  388,   -1,   -1,
   -1,   -1,   -1,   -1,  375,   -1,   -1,  378,  379,   -1,
  262,   -1,   -1,  404,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,  426,   -1,   -1,   -1,   -1,
  431,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   -1,  445,  426,   -1,   -1,   -1,   -1,
  431,   -1,   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,
   -1,  442,  443,  325,  445,  327,   -1,   -1,   -1,  331,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  492,  354,   -1,    0,   -1,   -1,   -1,  262,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,  509,   -1,
   -1,  492,  513,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,  528,  509,    0,
   -1,   -1,  513,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,  528,   -1,   -1,
   -1,  315,   -1,   59,  318,   -1,   -1,   -1,   -1,   -1,
   -1,  325,   -1,  327,  426,   -1,   -1,  331,   -1,  431,
   41,   -1,  336,   44,   -1,  339,   -1,   -1,   -1,  272,
  442,  443,  275,  445,   -1,   -1,   -1,    0,   59,   -1,
  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,
   -1,   -1,  295,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   41,   -1,
  492,   44,   -1,   -1,  262,   -1,   -1,   -1,   -1,   -1,
  404,   -1,  335,   -1,   -1,   -1,   59,  509,  341,  342,
  343,  513,  345,  346,  347,   -1,  349,   -1,   -1,   -1,
   -1,   -1,  426,   -1,   -1,   -1,  528,  431,   -1,   -1,
   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,  442,  443,
   -1,  445,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,
  318,   -1,   -1,   -1,   -1,   -1,   -1,  325,   -1,  327,
   -1,   -1,   -1,  331,  397,   -1,   -1,   -1,  336,   -1,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  414,   -1,   -1,   -1,   -1,  354,   -1,  492,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,   -1,   -1,  436,   -1,  509,   -1,  375,   -1,  513,
  378,  379,   -1,   -1,   -1,   -1,  262,   -1,   -1,   -1,
  388,   -1,   -1,    0,  528,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   -1,   -1,   44,  404,   -1,  471,  472,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,  262,   -1,    0,   -1,  488,   -1,   -1,  426,   -1,
   -1,   -1,   -1,  431,   41,   -1,   -1,   44,   -1,  315,
   -1,   -1,  318,   -1,  442,  443,   -1,  445,   -1,  325,
   -1,  327,   59,   -1,   -1,  331,   -1,   -1,   -1,   -1,
  336,   -1,   -1,  339,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,  354,  262,
   -1,   -1,   59,   -1,  325,   -1,  327,   -1,   -1,   -1,
  331,  367,   -1,   -1,  492,  336,   -1,   -1,  339,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  509,  388,  354,   -1,  513,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  404,   -1,
  528,   -1,  315,   -1,  375,  318,   -1,  378,  379,   -1,
   -1,   -1,  325,   -1,  327,   -1,   -1,  388,  331,   -1,
  426,   -1,   -1,  336,   -1,  431,  339,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,  442,  443,    0,  445,
   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,  426,   -1,   -1,   -1,   -1,
  431,   -1,  375,   -1,   -1,  378,  379,   -1,    0,   -1,
   -1,  442,  443,   -1,  445,  388,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,  492,   -1,   -1,   -1,
   -1,  404,   -1,  262,   -1,   -1,   -1,   59,   -1,   -1,
    0,   -1,   -1,  509,   -1,   -1,   -1,  513,   -1,   41,
   -1,   -1,   44,  426,   -1,   -1,   -1,   -1,  431,   -1,
   -1,  492,  528,   -1,   -1,  262,   -1,   59,   -1,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  509,   -1,
   -1,   41,  513,   -1,   44,   -1,  315,   -1,   -1,  318,
   -1,   -1,   -1,   -1,   -1,  262,  325,  528,  327,   59,
   -1,   -1,  331,   -1,   -1,   -1,   -1,  336,   -1,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,  492,
   -1,  318,   -1,   -1,   -1,  354,   -1,   -1,  325,   -1,
  327,   -1,   -1,   -1,  331,   -1,  509,   -1,  367,  336,
  513,   -1,  339,   -1,   -1,   -1,  375,   -1,  315,  378,
  379,  318,   -1,   -1,   -1,  528,   -1,  354,  325,  388,
  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,   -1,  336,
  367,   -1,  339,   -1,   -1,  404,   -1,   -1,  375,   -1,
   -1,  378,  379,    0,   -1,   -1,   -1,  354,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,  426,   -1,   -1,
  367,   -1,  431,   -1,   -1,   -1,   -1,  404,  375,   -1,
   -1,  378,  379,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   41,   -1,   -1,   44,   -1,  426,
   -1,   -1,   -1,   -1,  431,   -1,   -1,  404,   -1,   -1,
  262,   -1,   59,   -1,   -1,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  426,
   -1,   -1,   -1,  492,  431,   -1,   -1,   -1,   -1,   -1,
  262,   -1,   -1,   -1,   -1,  442,  443,    0,  445,   -1,
  509,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  492,  318,   -1,   -1,  528,
   -1,   -1,  262,  325,   -1,  327,   -1,   -1,   -1,  331,
   -1,   -1,  509,   -1,  336,   -1,  513,  339,   41,   -1,
   -1,   44,   -1,  315,   -1,  492,  318,   -1,   -1,   -1,
   -1,  528,  354,  325,   -1,  327,   59,   -1,   -1,  331,
   -1,   -1,  509,   -1,  336,  367,  513,  339,   -1,   -1,
   -1,   -1,   -1,  375,   -1,  315,  378,  379,  318,   -1,
   -1,  528,  354,   -1,   -1,  325,  388,  327,   -1,   -1,
    0,  331,   -1,   -1,   -1,  367,  336,   -1,   -1,  339,
   -1,   -1,  404,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,  388,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  426,   -1,   -1,  367,   -1,  431,
   -1,   41,  404,   -1,   44,  375,    0,   -1,  378,  379,
  442,  443,   -1,  445,   -1,   -1,   -1,   -1,  388,   59,
   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,  404,  262,   -1,   -1,   -1,   -1,
  442,  443,   -1,  445,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,
  492,  431,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   -1,  445,   -1,  509,   -1,   -1,
   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  492,  318,   -1,   -1,   -1,   -1,  528,   -1,  325,   -1,
  327,   -1,   -1,   -1,  331,   -1,   -1,  509,   -1,  336,
   -1,  513,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  492,   -1,   -1,   -1,  528,  354,    0,  262,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  509,
  367,   -1,   -1,  513,   -1,   -1,   -1,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,  528,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,  315,   -1,   -1,  318,   -1,   59,   -1,   -1,
   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,  331,  426,
   -1,   -1,   -1,  336,  431,   -1,  339,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   -1,  445,   -1,
   -1,  354,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  492,   -1,   59,  262,   -1,
   -1,  404,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,
   -1,   -1,  509,   -1,   -1,  325,  513,  327,   -1,   -1,
   -1,  331,   -1,  426,   -1,   -1,  336,   -1,  431,  339,
   -1,  528,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   -1,  445,   -1,  354,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,   -1,  318,   -1,   -1,  367,   -1,   -1,
   -1,  325,   -1,  327,   -1,  375,   -1,  331,  378,  379,
   -1,   -1,  336,   -1,   -1,  339,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  492,
  354,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,   -1,  509,   -1,   -1,   -1,
  513,  375,   -1,   -1,  378,  379,  426,   -1,   -1,   -1,
  262,  431,   -1,   -1,  388,  528,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,  442,  443,
   -1,  445,  492,  325,   -1,  327,   -1,   -1,   -1,  331,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,  509,
   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  528,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,  492,   -1,
   -1,   -1,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
  260,   -1,   -1,   -1,   -1,  509,  388,   -1,   -1,  513,
   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,
   -1,   -1,  404,  325,  528,  327,   -1,   -1,   -1,  331,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,  298,   -1,
   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,
  310,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   -1,  445,   -1,  367,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  375,  334,   -1,   -1,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  492,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  509,   -1,  431,
   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,  398,   -1,
   -1,  443,   -1,  445,   -1,   -1,  528,   -1,  408,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  492,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,  509,   -1,  469,
  470,  513,   -1,   -1,   -1,  260,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,  528,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,  298,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,  310,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,  334,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  398,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  408,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  433,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,  270,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,   -1,   -1,   -1,
   -1,   -1,  305,   -1,   -1,   -1,  309,  310,   -1,  312,
   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  328,   -1,   -1,   -1,   -1,
   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  350,   -1,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  362,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,  390,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,  408,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  423,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
   -1,  444,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,  506,  507,  508,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  270,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,   -1,
   -1,   -1,   -1,   -1,  305,   -1,   -1,   -1,  309,  310,
   -1,  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,   -1,   -1,
   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  350,
   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  362,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,  390,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,  408,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  423,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  444,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,  506,  507,  508,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,  270,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,   -1,   -1,   -1,   -1,   -1,  305,   -1,   -1,   -1,
  309,  310,   -1,  312,   -1,   -1,  315,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,
   -1,   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  350,   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  362,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  389,  390,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,  408,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  423,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  444,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,  506,  507,  508,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,  270,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  309,  310,   -1,  312,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  328,   -1,   -1,   -1,   -1,   -1,  334,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  350,   -1,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  362,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  389,  390,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  423,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  433,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,  506,
  507,  508,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,
   -1,  281,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  292,   -1,   -1,  295,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,
   -1,  341,  342,  343,   -1,  345,  346,  347,   -1,  349,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,  368,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  436,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,  488,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,   -1,  292,
   -1,   -1,  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,  342,
  343,   -1,  345,  346,  347,   -1,  349,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  436,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,  488,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  272,   -1,   -1,  275,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  292,   -1,   -1,  295,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,
   -1,   -1,   -1,   -1,   -1,  341,  342,  343,   -1,  345,
  346,  347,   -1,  349,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  366,   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  436,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,  488,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  272,   -1,   -1,  275,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  292,   -1,   -1,  295,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,
   -1,   -1,  341,  342,  343,   -1,  345,  346,  347,   -1,
  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,  368,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  284,   -1,   -1,   -1,  436,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,  488,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,  284,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,  313,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,  325,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  394,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  429,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  339,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,  362,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
  417,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  378,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  292,   -1,   -1,  295,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,
  342,  343,   -1,  345,  346,  347,   -1,  349,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  397,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  414,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,  436,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,  471,
  472,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,  488,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  451,   -1,   -1,  454,  455,  456,  457,  458,  459,
  460,  461,  462,  463,  464,  465,  466,  467,  468,  469,
  470,  471,  472,  473,  474,  475,   -1,   -1,  478,  479,
  480,  481,  482,  483,  484,  485,  486,  487,  488,  489,
  490,  491,  492,  493,  494,  495,  496,  497,  498,  499,
  500,  501,  502,  503,  504,  505,  506,  507,  508,  509,
  510,  511,  512,  513,  514,  515,  516,  517,  518,  519,
  520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,  549,
  550,  551,  552,  553,  554,  555,  556,  557,  558,  559,
  560,  561,  562,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,  582,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  592,  593,  594,  595,  596,  597,  598,  451,
   -1,   -1,  454,  455,  456,  457,  458,  459,   -1,  461,
  462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
  472,  473,  474,  475,   -1,   -1,  478,  479,  480,  481,
  482,  483,  484,  485,  486,  487,  488,  489,  490,  491,
  492,  493,  494,  495,  496,  497,  498,  499,  500,  501,
  502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
  512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
  522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
  552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
  562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
  592,  593,  594,  595,  596,  597,  598,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,
};
static int yyctable[] = {                                     -1,
  782,  814,   -1,  484,  766,   -1,  485,  766,   -1,  485,
  764,   -1,  954, 1130,   -1, 1054,  700,   -1, 1060,  715,
   -1,  990, 1252,   -1,  991, 1253,   -1,  992, 1254,   -1,
 1302, 1032,   -1,  782,  809,   -1,  152,  793,   -1,
};
#define YYFINAL 22
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 598
#if YYDEBUG
static char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,
"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ACTIVE","ADD","AFTER","ALL","ALTER","AND","ANY",
"AS","ASC","AT","AVG","AUTO","BEFORE","BEGIN","BETWEEN","BLOB","BY","CAST",
"CHARACTER","CHECK","COLLATE","COMMA","COMMIT","COMMITTED","COMPUTED",
"CONCATENATE","CONDITIONAL","CONSTRAINT","CONTAINING","COUNT","CREATE",
"CSTRING","CURRENT","CURSOR","DATABASE","DATE","DB_KEY","KW_DEBUG","DECIMAL",
"DECLARE","DEFAULT","KW_DELETE","DESC","DISTINCT","DO","DOMAIN","DROP","ELSE",
"END","ENTRY_POINT","EQL","ESCAPE","EXCEPTION","EXECUTE","EXISTS","EXIT",
"EXTERNAL","FILTER","FOR","FOREIGN","FROM","FULL","FUNCTION","GDSCODE","GEQ",
"GENERATOR","GEN_ID","GRANT","GROUP","GTR","HAVING","IF","KW_IN","INACTIVE",
"INNER","INPUT_TYPE","INDEX","INSERT","INTEGER","INTO","IS","ISOLATION","JOIN",
"KEY","KW_CHAR","KW_DEC","KW_DOUBLE","KW_FILE","KW_FLOAT","KW_INT","KW_LONG",
"KW_NULL","KW_NUMERIC","KW_UPPER","KW_VALUE","LENGTH","LPAREN","LEFT","LEQ",
"LEVEL","LIKE","LSS","MANUAL","MAXIMUM","MAX_SEGMENT","MERGE","MINIMUM",
"MODULE_NAME","NAMES","NATIONAL","NATURAL","NCHAR","NEQ","NO","NOT","NOT_GTR",
"NOT_LSS","OF","ON","ONLY","OPTION","OR","ORDER","OUTER","OUTPUT_TYPE",
"OVERFLOW","PAGE","PAGES","KW_PAGE_SIZE","PARAMETER","PASSWORD","PLAN",
"POSITION","POST_EVENT","PRECISION","PRIMARY","PRIVILEGES","PROCEDURE",
"PROTECTED","READ","REAL","REFERENCES","RESERVING","RETAIN","RETURNING_VALUES",
"RETURNS","REVOKE","RIGHT","RPAREN","ROLLBACK","SEGMENT","SELECT","SET",
"SHADOW","KW_SHARED","SINGULAR","KW_SIZE","SMALLINT","SNAPSHOT","SOME","SORT",
"SQLCODE","STABILITY","STARTING","STATISTICS","SUB_TYPE","SUSPEND","SUM",
"TABLE","THEN","TO","TRANSACTION","TRIGGER","UNCOMMITTED","UNION","UNIQUE",
"UPDATE","USER","VALUES","VARCHAR","VARIABLE","VARYING","VERSION","VIEW","WAIT",
"WHEN","WHERE","WHILE","WITH","WORK","WRITE","FLOAT_NUMBER","NUMBER","NUMERIC",
"SYMBOL","STRING","INTRODUCER","ACTION","ADMIN","CASCADE","FREE_IT","RESTRICT",
"ROLE","COLUMN","TYPE","EXTRACT","YEAR","MONTH","DAY","HOUR","MINUTE","SECOND",
"WEEKDAY","YEARDAY","TIME","TIMESTAMP","CURRENT_DATE","CURRENT_TIME",
"CURRENT_TIMESTAMP","NUMBER64BIT","SCALEDINT","CURRENT_USER","CURRENT_ROLE",
"KW_BREAK","SUBSTRING","RECREATE","KW_DESCRIPTOR","FIRST","SKIP",
"CURRENT_CONNECTION","CURRENT_TRANSACTION","BIGINT","CASE","NULLIF","COALESCE",
"USING","NULLS","LAST","ROW_COUNT","LOCK","SAVEPOINT","RELEASE","STATEMENT",
"LEAVE","INSERTING","UPDATING","DELETING","BACKUP","KW_DIFFERENCE","OPEN",
"CLOSE","FETCH","ROWS","BLOCK","IIF","SCALAR_ARRAY","CROSS","NEXT","SEQUENCE",
"RESTART","BOTH","COLLATION","COMMENT","BIT_LENGTH","CHAR_LENGTH",
"CHARACTER_LENGTH","LEADING","KW_LOWER","OCTET_LENGTH","TRAILING","TRIM",
"RETURNING","KW_IGNORE","LIMBO","UNDO","REQUESTS","TIMEOUT","ABS","ACCENT",
"ACOS","ALWAYS","ASCII_CHAR","ASCII_VAL","ASIN","ATAN","ATAN2","BIN_AND",
"BIN_OR","BIN_SHL","BIN_SHR","BIN_XOR","CEIL","CONNECT","COS","COSH","COT",
"DATEADD","DATEDIFF","DECODE","DISCONNECT","EXP","FLOOR","GEN_UUID","GENERATED",
"GLOBAL","HASH","INSENSITIVE","LIST","LN","LOG","LOG10","LPAD","MATCHED",
"MATCHING","MAXVALUE","MILLISECOND","MINVALUE","MOD","OVERLAY","PAD","PI",
"PLACING","POWER","PRESERVE","RAND","RECURSIVE","REPLACE","REVERSE","ROUND",
"RPAD","SENSITIVE","SIGN","SIN","SINH","SPACE","SQRT","START","TAN","TANH",
"TEMPORARY","TRUNC","WEEK",
};
static char *yyrule[] = {
"$accept : top",
"top : statement",
"top : statement ';'",
"statement : alter",
"statement : blob_io",
"statement : comment",
"statement : commit",
"statement : create",
"statement : create_or_alter",
"statement : declare",
"statement : delete",
"statement : drop",
"statement : grant",
"statement : insert",
"statement : merge",
"statement : exec_procedure",
"statement : exec_block",
"statement : recreate",
"statement : revoke",
"statement : rollback",
"statement : savepoint",
"statement : select",
"statement : set",
"statement : update",
"statement : update_or_insert",
"statement : KW_DEBUG signed_short_integer",
"grant : GRANT privileges ON table_noise simple_table_name TO non_role_grantee_list grant_option",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO non_role_grantee_list grant_option",
"grant : GRANT role_name_list TO role_grantee_list role_admin_option",
"table_noise : TABLE",
"table_noise :",
"privileges : ALL",
"privileges : ALL PRIVILEGES",
"privileges : privilege_list",
"privilege_list : privilege",
"privilege_list : privilege_list ',' privilege",
"proc_privileges : EXECUTE",
"privilege : SELECT",
"privilege : INSERT",
"privilege : KW_DELETE",
"privilege : UPDATE column_parens_opt",
"privilege : REFERENCES column_parens_opt",
"grant_option : WITH GRANT OPTION",
"grant_option :",
"role_admin_option : WITH ADMIN OPTION",
"role_admin_option :",
"simple_proc_name : symbol_procedure_name",
"revoke : REVOKE rev_grant_option privileges ON table_noise simple_table_name FROM non_role_grantee_list",
"revoke : REVOKE rev_grant_option proc_privileges ON PROCEDURE simple_proc_name FROM non_role_grantee_list",
"revoke : REVOKE rev_admin_option role_name_list FROM role_grantee_list",
"rev_grant_option : GRANT OPTION FOR",
"rev_grant_option :",
"rev_admin_option : ADMIN OPTION FOR",
"rev_admin_option :",
"non_role_grantee_list : grantee_list",
"non_role_grantee_list : user_grantee_list",
"grantee_list : grantee",
"grantee_list : grantee_list ',' grantee",
"grantee_list : grantee_list ',' user_grantee",
"grantee_list : user_grantee_list ',' grantee",
"grantee : PROCEDURE symbol_procedure_name",
"grantee : TRIGGER symbol_trigger_name",
"grantee : VIEW symbol_view_name",
"grantee : ROLE symbol_role_name",
"user_grantee_list : user_grantee",
"user_grantee_list : user_grantee_list ',' user_grantee",
"user_grantee : symbol_user_name",
"user_grantee : USER symbol_user_name",
"user_grantee : GROUP symbol_user_name",
"role_name_list : role_name",
"role_name_list : role_name_list ',' role_name",
"role_name : symbol_role_name",
"role_grantee_list : role_grantee",
"role_grantee_list : role_grantee_list ',' role_grantee",
"role_grantee : symbol_user_name",
"role_grantee : USER symbol_user_name",
"declare : DECLARE declare_clause",
"declare_clause : FILTER filter_decl_clause",
"declare_clause : EXTERNAL FUNCTION udf_decl_clause",
"udf_decl_clause : symbol_UDF_name arg_desc_list1 RETURNS return_value1 ENTRY_POINT sql_string MODULE_NAME sql_string",
"udf_data_type : simple_type",
"udf_data_type : BLOB",
"udf_data_type : CSTRING '(' pos_short_integer ')' charset_clause",
"arg_desc_list1 :",
"arg_desc_list1 : arg_desc_list",
"arg_desc_list1 : '(' arg_desc_list ')'",
"arg_desc_list : arg_desc",
"arg_desc_list : arg_desc_list ',' arg_desc",
"arg_desc : init_data_type udf_data_type param_mechanism",
"param_mechanism :",
"param_mechanism : BY KW_DESCRIPTOR",
"param_mechanism : BY SCALAR_ARRAY",
"param_mechanism : KW_NULL",
"return_value1 : return_value",
"return_value1 : '(' return_value ')'",
"return_value : init_data_type udf_data_type return_mechanism",
"return_value : PARAMETER pos_short_integer",
"return_mechanism :",
"return_mechanism : BY KW_VALUE",
"return_mechanism : BY KW_DESCRIPTOR",
"return_mechanism : FREE_IT",
"return_mechanism : BY KW_DESCRIPTOR FREE_IT",
"filter_decl_clause : symbol_filter_name INPUT_TYPE blob_filter_subtype OUTPUT_TYPE blob_filter_subtype ENTRY_POINT sql_string MODULE_NAME sql_string",
"blob_filter_subtype : symbol_blob_subtype_name",
"blob_filter_subtype : signed_short_integer",
"create : CREATE create_clause",
"create_clause : EXCEPTION exception_clause",
"create_clause : unique_opt order_direction INDEX symbol_index_name ON simple_table_name index_definition",
"create_clause : PROCEDURE procedure_clause",
"create_clause : TABLE table_clause",
"create_clause : GLOBAL TEMPORARY TABLE gtt_table_clause",
"create_clause : TRIGGER trigger_clause",
"create_clause : VIEW view_clause",
"create_clause : GENERATOR generator_clause",
"create_clause : SEQUENCE generator_clause",
"create_clause : DATABASE db_clause",
"create_clause : DOMAIN domain_clause",
"create_clause : SHADOW shadow_clause",
"create_clause : ROLE role_clause",
"create_clause : COLLATION collation_clause",
"recreate : RECREATE recreate_clause",
"recreate_clause : PROCEDURE rprocedure_clause",
"recreate_clause : TABLE rtable_clause",
"recreate_clause : GLOBAL TEMPORARY TABLE gtt_recreate_clause",
"recreate_clause : VIEW rview_clause",
"recreate_clause : TRIGGER rtrigger_clause",
"recreate_clause : EXCEPTION rexception_clause",
"create_or_alter : CREATE OR ALTER replace_clause",
"replace_clause : PROCEDURE replace_procedure_clause",
"replace_clause : TRIGGER replace_trigger_clause",
"replace_clause : EXCEPTION replace_exception_clause",
"exception_clause : symbol_exception_name sql_string",
"rexception_clause : symbol_exception_name sql_string",
"replace_exception_clause : symbol_exception_name sql_string",
"alter_exception_clause : symbol_exception_name sql_string",
"unique_opt : UNIQUE",
"unique_opt :",
"index_definition : column_list",
"index_definition : column_parens",
"index_definition : computed_by '(' begin_trigger value end_trigger ')'",
"shadow_clause : pos_short_integer manual_auto conditional sql_string first_file_length sec_shadow_files",
"manual_auto : MANUAL",
"manual_auto : AUTO",
"manual_auto :",
"conditional :",
"conditional : CONDITIONAL",
"first_file_length :",
"first_file_length : LENGTH equals long_integer page_noise",
"sec_shadow_files :",
"sec_shadow_files : db_file_list",
"db_file_list : db_file",
"db_file_list : db_file_list db_file",
"domain_clause : column_def_name as_opt data_type begin_trigger domain_default_opt end_default_opt domain_constraint_clause collate_clause",
"as_opt : AS",
"as_opt :",
"domain_default : DEFAULT begin_trigger default_value",
"domain_default_opt : domain_default",
"domain_default_opt :",
"domain_constraint_clause : domain_constraint_list",
"domain_constraint_clause :",
"domain_constraint_list : domain_constraint_def",
"domain_constraint_list : domain_constraint_list domain_constraint_def",
"domain_constraint_def : domain_constraint",
"domain_constraint : null_constraint",
"domain_constraint : check_constraint",
"null_constraint : NOT KW_NULL",
"check_constraint : CHECK begin_trigger '(' search_condition ')' end_trigger",
"generator_clause : symbol_generator_name",
"role_clause : symbol_role_name",
"collation_clause : symbol_collation_name FOR symbol_character_set_name collation_sequence_definition collation_attribute_list_opt collation_specific_attribute_opt",
"collation_sequence_definition : FROM symbol_collation_name",
"collation_sequence_definition : FROM EXTERNAL '(' sql_string ')'",
"collation_sequence_definition :",
"collation_attribute_list_opt :",
"collation_attribute_list_opt : collation_attribute_list",
"collation_attribute_list : collation_attribute",
"collation_attribute_list : collation_attribute_list collation_attribute",
"collation_attribute : collation_pad_attribute",
"collation_attribute : collation_case_attribute",
"collation_attribute : collation_accent_attribute",
"collation_pad_attribute : NO PAD",
"collation_pad_attribute : PAD SPACE",
"collation_case_attribute : CASE SENSITIVE",
"collation_case_attribute : CASE INSENSITIVE",
"collation_accent_attribute : ACCENT SENSITIVE",
"collation_accent_attribute : ACCENT INSENSITIVE",
"collation_specific_attribute_opt :",
"collation_specific_attribute_opt : sql_string",
"db_clause : db_name db_initial_desc1 db_rem_desc1",
"equals :",
"equals : '='",
"db_name : sql_string",
"db_initial_desc1 :",
"db_initial_desc1 : db_initial_desc",
"db_initial_desc : db_initial_option",
"db_initial_desc : db_initial_desc db_initial_option",
"db_initial_option : KW_PAGE_SIZE equals pos_short_integer",
"db_initial_option : LENGTH equals long_integer page_noise",
"db_initial_option : USER sql_string",
"db_initial_option : PASSWORD sql_string",
"db_initial_option : SET NAMES sql_string",
"db_rem_desc1 :",
"db_rem_desc1 : db_rem_desc",
"db_rem_desc : db_rem_option",
"db_rem_desc : db_rem_desc db_rem_option",
"db_rem_option : db_file",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name",
"db_rem_option : KW_DIFFERENCE KW_FILE sql_string",
"db_file : file1 sql_string file_desc1",
"file1 : KW_FILE",
"file_desc1 :",
"file_desc1 : file_desc",
"file_desc : file_clause",
"file_desc : file_desc file_clause",
"file_clause : STARTING file_clause_noise long_integer",
"file_clause : LENGTH equals long_integer page_noise",
"file_clause_noise :",
"file_clause_noise : AT",
"file_clause_noise : AT PAGE",
"page_noise :",
"page_noise : PAGE",
"page_noise : PAGES",
"table_clause : simple_table_name external_file '(' table_elements ')'",
"rtable_clause : simple_table_name external_file '(' table_elements ')'",
"gtt_table_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_recreate_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_scope : ON COMMIT PRESERVE ROWS",
"gtt_scope : ON COMMIT KW_DELETE ROWS",
"gtt_scope :",
"external_file : EXTERNAL KW_FILE sql_string",
"external_file : EXTERNAL sql_string",
"external_file :",
"table_elements : table_element",
"table_elements : table_elements ',' table_element",
"table_element : column_def",
"table_element : table_constraint_definition",
"column_def : column_def_name data_type_or_domain domain_default_opt end_default_opt column_constraint_clause collate_clause",
"column_def : column_def_name non_array_type def_computed",
"column_def : column_def_name def_computed",
"def_computed : computed_clause '(' begin_trigger value end_trigger ')'",
"computed_clause : computed_by",
"computed_clause : GENERATED ALWAYS AS",
"computed_by : COMPUTED BY",
"computed_by : COMPUTED",
"data_type_or_domain : data_type begin_trigger",
"data_type_or_domain : simple_column_name begin_string",
"collate_clause : COLLATE symbol_collation_name",
"collate_clause :",
"column_def_name : simple_column_name",
"simple_column_def_name : simple_column_name",
"data_type_descriptor : init_data_type data_type",
"data_type_descriptor : TYPE OF column_def_name",
"data_type_descriptor : column_def_name",
"init_data_type :",
"default_value : constant",
"default_value : current_user",
"default_value : current_role",
"default_value : internal_info",
"default_value : null_value",
"default_value : datetime_value_expression",
"column_constraint_clause :",
"column_constraint_clause : column_constraint_list",
"column_constraint_list : column_constraint_def",
"column_constraint_list : column_constraint_list column_constraint_def",
"column_constraint_def : constraint_name_opt column_constraint",
"column_constraint : null_constraint",
"column_constraint : check_constraint",
"column_constraint : REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"column_constraint : UNIQUE constraint_index_opt",
"column_constraint : PRIMARY KEY constraint_index_opt",
"table_constraint_definition : constraint_name_opt table_constraint",
"constraint_name_opt : CONSTRAINT symbol_constraint_name",
"constraint_name_opt :",
"table_constraint : unique_constraint",
"table_constraint : primary_constraint",
"table_constraint : referential_constraint",
"table_constraint : check_constraint",
"unique_constraint : UNIQUE column_parens constraint_index_opt",
"primary_constraint : PRIMARY KEY column_parens constraint_index_opt",
"referential_constraint : FOREIGN KEY column_parens REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"constraint_index_opt : USING order_direction INDEX symbol_index_name",
"constraint_index_opt :",
"referential_trigger_action : update_rule",
"referential_trigger_action : delete_rule",
"referential_trigger_action : delete_rule update_rule",
"referential_trigger_action : update_rule delete_rule",
"referential_trigger_action :",
"update_rule : ON UPDATE referential_action",
"delete_rule : ON KW_DELETE referential_action",
"referential_action : CASCADE",
"referential_action : SET DEFAULT",
"referential_action : SET KW_NULL",
"referential_action : NO ACTION",
"procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"rprocedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"replace_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"alter_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"input_parameters : '(' input_proc_parameters ')'",
"input_parameters :",
"output_parameters : RETURNS '(' output_proc_parameters ')'",
"output_parameters :",
"input_proc_parameters : input_proc_parameter",
"input_proc_parameters : input_proc_parameters ',' input_proc_parameter",
"input_proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause begin_trigger default_par_opt end_default_opt",
"output_proc_parameters : proc_parameter",
"output_proc_parameters : output_proc_parameters ',' proc_parameter",
"proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause",
"default_par_opt : DEFAULT begin_trigger default_value",
"default_par_opt : '=' begin_trigger default_value",
"default_par_opt :",
"local_declaration_list : local_declarations",
"local_declaration_list :",
"local_declarations : local_declaration",
"local_declarations : local_declarations local_declaration",
"local_declaration : stmt_start_line stmt_start_column DECLARE var_decl_opt local_declaration_item ';'",
"local_declaration_item : var_declaration_item",
"local_declaration_item : cursor_declaration_item",
"var_declaration_item : column_def_name domain_or_non_array_type collate_clause var_init_opt",
"var_decl_opt : VARIABLE",
"var_decl_opt :",
"var_init_opt : DEFAULT default_value",
"var_init_opt : '=' default_value",
"var_init_opt :",
"cursor_declaration_item : symbol_cursor_name CURSOR FOR '(' select ')'",
"proc_block : proc_statement",
"proc_block : full_proc_block",
"full_proc_block : stmt_start_line stmt_start_column BEGIN full_proc_block_body END",
"full_proc_block_body : proc_statements",
"full_proc_block_body : proc_statements excp_hndl_statements",
"full_proc_block_body :",
"proc_statements : proc_block",
"proc_statements : proc_statements proc_block",
"proc_statement : stmt_start_line stmt_start_column simple_proc_statement ';'",
"proc_statement : stmt_start_line stmt_start_column complex_proc_statement",
"stmt_start_line :",
"stmt_start_column :",
"simple_proc_statement : assignment",
"simple_proc_statement : insert",
"simple_proc_statement : merge",
"simple_proc_statement : update",
"simple_proc_statement : update_or_insert",
"simple_proc_statement : delete",
"simple_proc_statement : singleton_select",
"simple_proc_statement : exec_procedure",
"simple_proc_statement : exec_sql",
"simple_proc_statement : exec_into",
"simple_proc_statement : exec_function",
"simple_proc_statement : excp_statement",
"simple_proc_statement : raise_statement",
"simple_proc_statement : post_event",
"simple_proc_statement : cursor_statement",
"simple_proc_statement : breakleave",
"simple_proc_statement : SUSPEND",
"simple_proc_statement : EXIT",
"complex_proc_statement : if_then_else",
"complex_proc_statement : while",
"complex_proc_statement : for_select",
"complex_proc_statement : for_exec_into",
"excp_statement : EXCEPTION symbol_exception_name",
"excp_statement : EXCEPTION symbol_exception_name value",
"raise_statement : EXCEPTION",
"exec_sql : EXECUTE STATEMENT value",
"for_select : label_opt FOR select INTO variable_list cursor_def DO proc_block",
"for_exec_into : label_opt FOR EXECUTE STATEMENT value INTO variable_list DO proc_block",
"exec_into : EXECUTE STATEMENT value INTO variable_list",
"if_then_else : IF '(' search_condition ')' THEN proc_block ELSE proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block",
"post_event : POST_EVENT value event_argument_opt",
"event_argument_opt :",
"singleton_select : select INTO variable_list",
"variable : ':' symbol_variable_name",
"variable_list : variable",
"variable_list : column_name",
"variable_list : variable_list ',' column_name",
"variable_list : variable_list ',' variable",
"while : label_opt WHILE '(' search_condition ')' DO proc_block",
"label_opt : symbol_label_name ':'",
"label_opt :",
"breakleave : KW_BREAK",
"breakleave : LEAVE",
"breakleave : LEAVE symbol_label_name",
"cursor_def : AS CURSOR symbol_cursor_name",
"cursor_def :",
"excp_hndl_statements : excp_hndl_statement",
"excp_hndl_statements : excp_hndl_statements excp_hndl_statement",
"excp_hndl_statement : WHEN errors DO proc_block",
"errors : err",
"errors : errors ',' err",
"err : SQLCODE signed_short_integer",
"err : GDSCODE symbol_gdscode_name",
"err : EXCEPTION symbol_exception_name",
"err : ANY",
"cursor_statement : open_cursor",
"cursor_statement : fetch_cursor",
"cursor_statement : close_cursor",
"open_cursor : OPEN symbol_cursor_name",
"close_cursor : CLOSE symbol_cursor_name",
"fetch_cursor : FETCH fetch_opt symbol_cursor_name INTO variable_list",
"fetch_opt :",
"exec_procedure : EXECUTE PROCEDURE symbol_procedure_name proc_inputs proc_outputs_opt",
"proc_inputs : value_list",
"proc_inputs : '(' value_list ')'",
"proc_inputs :",
"proc_outputs_opt : RETURNING_VALUES variable_list",
"proc_outputs_opt : RETURNING_VALUES '(' variable_list ')'",
"proc_outputs_opt :",
"exec_block : EXECUTE BLOCK block_input_params output_parameters AS local_declaration_list full_proc_block",
"block_input_params : '(' block_parameters ')'",
"block_input_params :",
"block_parameters : block_parameter",
"block_parameters : block_parameters ',' block_parameter",
"block_parameter : proc_parameter '=' parameter",
"view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"rview_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"begin_string :",
"begin_trigger :",
"end_trigger :",
"end_default_opt :",
"check_opt : WITH CHECK OPTION",
"check_opt :",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"trigger_active : ACTIVE",
"trigger_active : INACTIVE",
"trigger_active :",
"trigger_type : trigger_type_prefix trigger_type_suffix",
"trigger_type : ON trigger_db_type",
"trigger_db_type : CONNECT",
"trigger_db_type : DISCONNECT",
"trigger_db_type : TRANSACTION START",
"trigger_db_type : TRANSACTION COMMIT",
"trigger_db_type : TRANSACTION ROLLBACK",
"trigger_type_prefix : BEFORE",
"trigger_type_prefix : AFTER",
"trigger_type_suffix : INSERT",
"trigger_type_suffix : UPDATE",
"trigger_type_suffix : KW_DELETE",
"trigger_type_suffix : INSERT OR UPDATE",
"trigger_type_suffix : INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR INSERT",
"trigger_type_suffix : UPDATE OR KW_DELETE",
"trigger_type_suffix : KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR UPDATE",
"trigger_type_suffix : INSERT OR UPDATE OR KW_DELETE",
"trigger_type_suffix : INSERT OR KW_DELETE OR UPDATE",
"trigger_type_suffix : UPDATE OR INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR INSERT OR UPDATE",
"trigger_type_suffix : KW_DELETE OR UPDATE OR INSERT",
"trigger_position : POSITION nonneg_short_integer",
"trigger_position :",
"trigger_action : AS begin_trigger local_declaration_list full_proc_block",
"alter : ALTER alter_clause",
"alter_clause : EXCEPTION alter_exception_clause",
"alter_clause : TABLE simple_table_name alter_ops",
"alter_clause : TRIGGER alter_trigger_clause",
"alter_clause : PROCEDURE alter_procedure_clause",
"alter_clause : DATABASE init_alter_db alter_db",
"alter_clause : DOMAIN alter_column_name alter_domain_ops",
"alter_clause : INDEX alter_index_clause",
"alter_clause : SEQUENCE alter_sequence_clause",
"alter_clause : EXTERNAL FUNCTION alter_udf_clause",
"alter_domain_ops : alter_domain_op",
"alter_domain_ops : alter_domain_ops alter_domain_op",
"alter_domain_op : SET domain_default end_trigger",
"alter_domain_op : ADD CONSTRAINT check_constraint",
"alter_domain_op : ADD check_constraint",
"alter_domain_op : DROP DEFAULT",
"alter_domain_op : DROP CONSTRAINT",
"alter_domain_op : TO simple_column_name",
"alter_domain_op : TYPE init_data_type non_array_type",
"alter_ops : alter_op",
"alter_ops : alter_ops ',' alter_op",
"alter_op : DROP simple_column_name drop_behaviour",
"alter_op : DROP CONSTRAINT symbol_constraint_name",
"alter_op : ADD column_def",
"alter_op : ADD table_constraint_definition",
"alter_op : col_opt simple_column_name POSITION pos_short_integer",
"alter_op : col_opt alter_column_name TO simple_column_name",
"alter_op : col_opt alter_col_name TYPE alter_data_type_or_domain",
"alter_op : col_opt alter_col_name SET domain_default end_trigger",
"alter_op : col_opt alter_col_name DROP DEFAULT",
"alter_column_name : keyword_or_column",
"keyword_or_column : valid_symbol_name",
"keyword_or_column : ADMIN",
"keyword_or_column : COLUMN",
"keyword_or_column : EXTRACT",
"keyword_or_column : YEAR",
"keyword_or_column : MONTH",
"keyword_or_column : DAY",
"keyword_or_column : HOUR",
"keyword_or_column : MINUTE",
"keyword_or_column : SECOND",
"keyword_or_column : TIME",
"keyword_or_column : TIMESTAMP",
"keyword_or_column : CURRENT_DATE",
"keyword_or_column : CURRENT_TIME",
"keyword_or_column : CURRENT_TIMESTAMP",
"keyword_or_column : CURRENT_USER",
"keyword_or_column : CURRENT_ROLE",
"keyword_or_column : RECREATE",
"keyword_or_column : CURRENT_CONNECTION",
"keyword_or_column : CURRENT_TRANSACTION",
"keyword_or_column : BIGINT",
"keyword_or_column : CASE",
"keyword_or_column : RELEASE",
"keyword_or_column : ROW_COUNT",
"keyword_or_column : SAVEPOINT",
"keyword_or_column : OPEN",
"keyword_or_column : CLOSE",
"keyword_or_column : FETCH",
"keyword_or_column : ROWS",
"keyword_or_column : USING",
"keyword_or_column : CROSS",
"keyword_or_column : BIT_LENGTH",
"keyword_or_column : BOTH",
"keyword_or_column : CHAR_LENGTH",
"keyword_or_column : CHARACTER_LENGTH",
"keyword_or_column : COMMENT",
"keyword_or_column : LEADING",
"keyword_or_column : KW_LOWER",
"keyword_or_column : OCTET_LENGTH",
"keyword_or_column : TRAILING",
"keyword_or_column : TRIM",
"keyword_or_column : CONNECT",
"keyword_or_column : DISCONNECT",
"keyword_or_column : GLOBAL",
"keyword_or_column : INSENSITIVE",
"keyword_or_column : RECURSIVE",
"keyword_or_column : SENSITIVE",
"keyword_or_column : START",
"col_opt : ALTER",
"col_opt : ALTER COLUMN",
"alter_data_type_or_domain : non_array_type",
"alter_data_type_or_domain : simple_column_name",
"alter_col_name : simple_column_name",
"drop_behaviour : RESTRICT",
"drop_behaviour : CASCADE",
"drop_behaviour :",
"alter_index_clause : symbol_index_name ACTIVE",
"alter_index_clause : symbol_index_name INACTIVE",
"alter_sequence_clause : symbol_generator_name RESTART WITH signed_long_integer",
"alter_sequence_clause : symbol_generator_name RESTART WITH NUMBER64BIT",
"alter_sequence_clause : symbol_generator_name RESTART WITH '-' NUMBER64BIT",
"alter_udf_clause : symbol_UDF_name entry_op module_op",
"entry_op : ENTRY_POINT sql_string",
"entry_op :",
"module_op : MODULE_NAME sql_string",
"module_op :",
"init_alter_db :",
"alter_db : db_alter_clause",
"alter_db : alter_db db_alter_clause",
"db_alter_clause : ADD db_file_list",
"db_alter_clause : ADD KW_DIFFERENCE KW_FILE sql_string",
"db_alter_clause : DROP KW_DIFFERENCE KW_FILE",
"db_alter_clause : BEGIN BACKUP",
"db_alter_clause : END BACKUP",
"alter_trigger_clause : symbol_trigger_name trigger_active new_trigger_type trigger_position begin_trigger new_trigger_action end_trigger",
"new_trigger_type : trigger_type",
"new_trigger_type :",
"new_trigger_action : trigger_action",
"new_trigger_action :",
"drop : DROP drop_clause",
"drop_clause : EXCEPTION symbol_exception_name",
"drop_clause : INDEX symbol_index_name",
"drop_clause : PROCEDURE symbol_procedure_name",
"drop_clause : TABLE symbol_table_name",
"drop_clause : TRIGGER symbol_trigger_name",
"drop_clause : VIEW symbol_view_name",
"drop_clause : FILTER symbol_filter_name",
"drop_clause : DOMAIN symbol_domain_name",
"drop_clause : EXTERNAL FUNCTION symbol_UDF_name",
"drop_clause : SHADOW pos_short_integer",
"drop_clause : ROLE symbol_role_name",
"drop_clause : GENERATOR symbol_generator_name",
"drop_clause : SEQUENCE symbol_generator_name",
"drop_clause : COLLATION symbol_collation_name",
"data_type : non_array_type",
"data_type : array_type",
"domain_or_non_array_type : domain_or_non_array_type_name",
"domain_or_non_array_type : domain_or_non_array_type_name NOT KW_NULL",
"domain_or_non_array_type_name : non_array_type",
"domain_or_non_array_type_name : domain_type",
"domain_type : TYPE OF symbol_column_name",
"domain_type : symbol_column_name",
"non_array_type : simple_type",
"non_array_type : blob_type",
"array_type : non_charset_simple_type '[' array_spec ']'",
"array_type : character_type '[' array_spec ']' charset_clause",
"array_spec : array_range",
"array_spec : array_spec ',' array_range",
"array_range : signed_long_integer",
"array_range : signed_long_integer ':' signed_long_integer",
"simple_type : non_charset_simple_type",
"simple_type : character_type charset_clause",
"non_charset_simple_type : national_character_type",
"non_charset_simple_type : numeric_type",
"non_charset_simple_type : float_type",
"non_charset_simple_type : BIGINT",
"non_charset_simple_type : integer_keyword",
"non_charset_simple_type : SMALLINT",
"non_charset_simple_type : DATE",
"non_charset_simple_type : TIME",
"non_charset_simple_type : TIMESTAMP",
"integer_keyword : INTEGER",
"integer_keyword : KW_INT",
"blob_type : BLOB blob_subtype blob_segsize charset_clause",
"blob_type : BLOB '(' unsigned_short_integer ')'",
"blob_type : BLOB '(' unsigned_short_integer ',' signed_short_integer ')'",
"blob_type : BLOB '(' ',' signed_short_integer ')'",
"blob_segsize : SEGMENT KW_SIZE unsigned_short_integer",
"blob_segsize :",
"blob_subtype : SUB_TYPE signed_short_integer",
"blob_subtype : SUB_TYPE symbol_blob_subtype_name",
"blob_subtype :",
"charset_clause : CHARACTER SET symbol_character_set_name",
"charset_clause :",
"national_character_type : national_character_keyword '(' pos_short_integer ')'",
"national_character_type : national_character_keyword",
"national_character_type : national_character_keyword VARYING '(' pos_short_integer ')'",
"character_type : character_keyword '(' pos_short_integer ')'",
"character_type : character_keyword",
"character_type : varying_keyword '(' pos_short_integer ')'",
"varying_keyword : VARCHAR",
"varying_keyword : CHARACTER VARYING",
"varying_keyword : KW_CHAR VARYING",
"character_keyword : CHARACTER",
"character_keyword : KW_CHAR",
"national_character_keyword : NCHAR",
"national_character_keyword : NATIONAL CHARACTER",
"national_character_keyword : NATIONAL KW_CHAR",
"numeric_type : KW_NUMERIC prec_scale",
"numeric_type : decimal_keyword prec_scale",
"prec_scale :",
"prec_scale : '(' signed_long_integer ')'",
"prec_scale : '(' signed_long_integer ',' signed_long_integer ')'",
"decimal_keyword : DECIMAL",
"decimal_keyword : KW_DEC",
"float_type : KW_FLOAT precision_opt",
"float_type : KW_LONG KW_FLOAT precision_opt",
"float_type : REAL",
"float_type : KW_DOUBLE PRECISION",
"precision_opt : '(' nonneg_short_integer ')'",
"precision_opt :",
"set : set_transaction",
"set : set_generator",
"set : set_statistics",
"set_generator : SET GENERATOR symbol_generator_name TO signed_long_integer",
"set_generator : SET GENERATOR symbol_generator_name TO NUMBER64BIT",
"set_generator : SET GENERATOR symbol_generator_name TO '-' NUMBER64BIT",
"savepoint : set_savepoint",
"savepoint : release_savepoint",
"savepoint : undo_savepoint",
"set_savepoint : SAVEPOINT symbol_savepoint_name",
"release_savepoint : RELEASE SAVEPOINT symbol_savepoint_name release_only_opt",
"release_only_opt : ONLY",
"release_only_opt :",
"undo_savepoint : ROLLBACK optional_work TO optional_savepoint symbol_savepoint_name",
"optional_savepoint : SAVEPOINT",
"optional_savepoint :",
"commit : COMMIT optional_work optional_retain",
"rollback : ROLLBACK optional_work optional_retain",
"optional_work : WORK",
"optional_work :",
"optional_retain : RETAIN opt_snapshot",
"optional_retain :",
"opt_snapshot : SNAPSHOT",
"opt_snapshot :",
"set_transaction : SET TRANSACTION tran_opt_list_m",
"tran_opt_list_m : tran_opt_list",
"tran_opt_list_m :",
"tran_opt_list : tran_opt",
"tran_opt_list : tran_opt_list tran_opt",
"tran_opt : access_mode",
"tran_opt : lock_wait",
"tran_opt : isolation_mode",
"tran_opt : tra_misc_options",
"tran_opt : tra_timeout",
"tran_opt : tbl_reserve_options",
"access_mode : READ ONLY",
"access_mode : READ WRITE",
"lock_wait : WAIT",
"lock_wait : NO WAIT",
"isolation_mode : ISOLATION LEVEL iso_mode",
"isolation_mode : iso_mode",
"iso_mode : snap_shot",
"iso_mode : READ UNCOMMITTED version_mode",
"iso_mode : READ COMMITTED version_mode",
"snap_shot : SNAPSHOT",
"snap_shot : SNAPSHOT TABLE",
"snap_shot : SNAPSHOT TABLE STABILITY",
"version_mode : VERSION",
"version_mode : NO VERSION",
"version_mode :",
"tra_misc_options : NO AUTO UNDO",
"tra_misc_options : KW_IGNORE LIMBO",
"tra_misc_options : RESTART REQUESTS",
"tra_timeout : LOCK TIMEOUT nonneg_short_integer",
"tbl_reserve_options : RESERVING restr_list",
"lock_type : KW_SHARED",
"lock_type : PROTECTED",
"lock_type :",
"lock_mode : READ",
"lock_mode : WRITE",
"restr_list : restr_option",
"restr_list : restr_list ',' restr_option",
"restr_option : table_list table_lock",
"table_lock : FOR lock_type lock_mode",
"table_lock :",
"table_list : simple_table_name",
"table_list : table_list ',' simple_table_name",
"set_statistics : SET STATISTICS INDEX symbol_index_name",
"comment : COMMENT ON ddl_type0 IS ddl_desc",
"comment : COMMENT ON ddl_type1 symbol_ddl_name IS ddl_desc",
"comment : COMMENT ON ddl_type2 symbol_ddl_name ddl_subname IS ddl_desc",
"ddl_type0 : DATABASE",
"ddl_type1 : DOMAIN",
"ddl_type1 : TABLE",
"ddl_type1 : VIEW",
"ddl_type1 : PROCEDURE",
"ddl_type1 : TRIGGER",
"ddl_type1 : EXTERNAL FUNCTION",
"ddl_type1 : FILTER",
"ddl_type1 : EXCEPTION",
"ddl_type1 : GENERATOR",
"ddl_type1 : SEQUENCE",
"ddl_type1 : INDEX",
"ddl_type1 : ROLE",
"ddl_type1 : CHARACTER SET",
"ddl_type1 : COLLATION",
"ddl_type2 : COLUMN",
"ddl_type2 : PARAMETER",
"ddl_subname : '.' symbol_ddl_name",
"ddl_desc : sql_string",
"ddl_desc : KW_NULL",
"select : select_expr for_update_clause lock_clause",
"for_update_clause : FOR UPDATE for_update_list",
"for_update_clause :",
"for_update_list : OF column_list",
"for_update_list :",
"lock_clause : WITH LOCK",
"lock_clause :",
"select_expr : with_clause select_expr_body order_clause rows_clause",
"with_clause : WITH RECURSIVE with_list",
"with_clause : WITH with_list",
"with_clause :",
"with_list : with_item",
"with_list : with_item ',' with_list",
"with_item : symbol_table_alias_name derived_column_list AS '(' select_expr ')'",
"column_select : with_clause select_expr_body order_clause rows_clause",
"column_singleton : with_clause select_expr_body order_clause rows_clause",
"select_expr_body : query_term",
"select_expr_body : select_expr_body UNION distinct_noise query_term",
"select_expr_body : select_expr_body UNION ALL query_term",
"query_term : query_spec",
"query_spec : SELECT limit_clause distinct_clause select_list from_clause where_clause group_clause having_clause plan_clause",
"limit_clause : first_clause skip_clause",
"limit_clause : first_clause",
"limit_clause : skip_clause",
"limit_clause :",
"first_clause : FIRST long_integer",
"first_clause : FIRST '(' value ')'",
"first_clause : FIRST parameter",
"skip_clause : SKIP long_integer",
"skip_clause : SKIP '(' value ')'",
"skip_clause : SKIP parameter",
"distinct_clause : DISTINCT",
"distinct_clause : all_noise",
"select_list : select_items",
"select_list : '*'",
"select_items : select_item",
"select_items : select_items ',' select_item",
"select_item : value",
"select_item : value as_noise symbol_item_alias_name",
"as_noise : AS",
"as_noise :",
"from_clause : FROM from_list",
"from_list : table_reference",
"from_list : from_list ',' table_reference",
"table_reference : joined_table",
"table_reference : table_primary",
"table_primary : table_proc",
"table_primary : derived_table",
"table_primary : '(' joined_table ')'",
"derived_table : '(' select_expr ')' as_noise correlation_name derived_column_list",
"correlation_name : symbol_table_alias_name",
"correlation_name :",
"derived_column_list : '(' alias_list ')'",
"derived_column_list :",
"alias_list : symbol_item_alias_name",
"alias_list : alias_list ',' symbol_item_alias_name",
"joined_table : cross_join",
"joined_table : natural_join",
"joined_table : qualified_join",
"cross_join : table_reference CROSS JOIN table_primary",
"natural_join : table_reference NATURAL join_type JOIN table_primary",
"qualified_join : table_reference join_type JOIN table_reference join_specification",
"join_specification : join_condition",
"join_specification : named_columns_join",
"join_condition : ON search_condition",
"named_columns_join : USING '(' column_list ')'",
"table_proc : symbol_procedure_name table_proc_inputs as_noise symbol_table_alias_name",
"table_proc : symbol_procedure_name table_proc_inputs",
"table_proc_inputs : '(' value_list ')'",
"table_proc_inputs :",
"table_name : simple_table_name",
"table_name : symbol_table_name as_noise symbol_table_alias_name",
"simple_table_name : symbol_table_name",
"join_type : INNER",
"join_type : LEFT outer_noise",
"join_type : RIGHT outer_noise",
"join_type : FULL outer_noise",
"join_type :",
"outer_noise : OUTER",
"outer_noise :",
"group_clause : GROUP BY group_by_list",
"group_clause :",
"group_by_list : group_by_item",
"group_by_list : group_by_list ',' group_by_item",
"group_by_item : value",
"having_clause : HAVING search_condition",
"having_clause :",
"where_clause : WHERE search_condition",
"where_clause :",
"plan_clause : PLAN plan_expression",
"plan_clause :",
"plan_expression : plan_type '(' plan_item_list ')'",
"plan_type : JOIN",
"plan_type : SORT MERGE",
"plan_type : MERGE",
"plan_type : SORT",
"plan_type :",
"plan_item_list : plan_item",
"plan_item_list : plan_item ',' plan_item_list",
"plan_item : table_or_alias_list access_type",
"plan_item : plan_expression",
"table_or_alias_list : symbol_table_name",
"table_or_alias_list : symbol_table_name table_or_alias_list",
"access_type : NATURAL",
"access_type : INDEX '(' index_list ')'",
"access_type : ORDER symbol_index_name extra_indices_opt",
"index_list : symbol_index_name",
"index_list : symbol_index_name ',' index_list",
"extra_indices_opt : INDEX '(' index_list ')'",
"extra_indices_opt :",
"order_clause : ORDER BY order_list",
"order_clause :",
"order_list : order_item",
"order_list : order_list ',' order_item",
"order_item : value order_direction nulls_clause",
"order_direction : ASC",
"order_direction : DESC",
"order_direction :",
"nulls_clause : NULLS nulls_placement",
"nulls_clause :",
"nulls_placement : FIRST",
"nulls_placement : LAST",
"rows_clause : ROWS value",
"rows_clause : ROWS value TO value",
"rows_clause :",
"insert : INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' returning_clause",
"insert : INSERT INTO simple_table_name ins_column_parens_opt select_expr returning_clause",
"insert : INSERT INTO simple_table_name DEFAULT VALUES returning_clause",
"merge : MERGE INTO table_name USING table_reference ON search_condition merge_when_clause",
"merge_when_clause : merge_when_matched_clause merge_when_not_matched_clause",
"merge_when_clause : merge_when_not_matched_clause merge_when_matched_clause",
"merge_when_clause : merge_when_matched_clause",
"merge_when_clause : merge_when_not_matched_clause",
"merge_when_matched_clause : WHEN MATCHED THEN merge_update_specification",
"merge_when_not_matched_clause : WHEN NOT MATCHED THEN merge_insert_specification",
"merge_update_specification : UPDATE SET assignments",
"merge_insert_specification : INSERT ins_column_parens_opt VALUES '(' value_list ')'",
"delete : delete_searched",
"delete : delete_positioned",
"delete_searched : KW_DELETE FROM table_name where_clause plan_clause order_clause rows_clause returning_clause",
"delete_positioned : KW_DELETE FROM table_name cursor_clause",
"update : update_searched",
"update : update_positioned",
"update_searched : UPDATE table_name SET assignments where_clause plan_clause order_clause rows_clause returning_clause",
"update_positioned : UPDATE table_name SET assignments cursor_clause",
"update_or_insert : UPDATE OR INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' update_or_insert_matching_opt returning_clause",
"update_or_insert_matching_opt : MATCHING ins_column_parens",
"update_or_insert_matching_opt :",
"returning_clause : RETURNING value_list",
"returning_clause : RETURNING value_list INTO variable_list",
"returning_clause :",
"cursor_clause : WHERE CURRENT OF symbol_cursor_name",
"assignments : assignment",
"assignments : assignments ',' assignment",
"assignment : update_column_name '=' value",
"exec_function : udf",
"exec_function : non_aggregate_function",
"blob_io : READ BLOB simple_column_name FROM simple_table_name filter_clause_io segment_clause_io",
"blob_io : INSERT BLOB simple_column_name INTO simple_table_name filter_clause_io segment_clause_io",
"filter_clause_io : FILTER FROM blob_subtype_value_io TO blob_subtype_value_io",
"filter_clause_io : FILTER TO blob_subtype_value_io",
"filter_clause_io :",
"blob_subtype_value_io : blob_subtype_io",
"blob_subtype_value_io : parameter",
"blob_subtype_io : signed_short_integer",
"segment_clause_io : MAX_SEGMENT segment_length_io",
"segment_clause_io :",
"segment_length_io : unsigned_short_integer",
"segment_length_io : parameter",
"column_parens_opt : column_parens",
"column_parens_opt :",
"column_parens : '(' column_list ')'",
"column_list : simple_column_name",
"column_list : column_list ',' simple_column_name",
"ins_column_parens_opt : ins_column_parens",
"ins_column_parens_opt :",
"ins_column_parens : '(' ins_column_list ')'",
"ins_column_list : update_column_name",
"ins_column_list : ins_column_list ',' update_column_name",
"column_name : simple_column_name",
"column_name : symbol_table_alias_name '.' symbol_column_name",
"column_name : symbol_table_alias_name '.' '*'",
"simple_column_name : symbol_column_name",
"update_column_name : simple_column_name",
"update_column_name : symbol_table_alias_name '.' symbol_column_name",
"search_condition : predicate",
"search_condition : search_condition OR search_condition",
"search_condition : search_condition AND search_condition",
"search_condition : NOT search_condition",
"predicate : comparison_predicate",
"predicate : distinct_predicate",
"predicate : between_predicate",
"predicate : like_predicate",
"predicate : in_predicate",
"predicate : null_predicate",
"predicate : quantified_predicate",
"predicate : exists_predicate",
"predicate : containing_predicate",
"predicate : starting_predicate",
"predicate : singular_predicate",
"predicate : trigger_action_predicate",
"predicate : '(' search_condition ')'",
"comparison_predicate : value '=' value",
"comparison_predicate : value '<' value",
"comparison_predicate : value '>' value",
"comparison_predicate : value GEQ value",
"comparison_predicate : value LEQ value",
"comparison_predicate : value NOT_GTR value",
"comparison_predicate : value NOT_LSS value",
"comparison_predicate : value NEQ value",
"quantified_predicate : value '=' ALL '(' column_select ')'",
"quantified_predicate : value '<' ALL '(' column_select ')'",
"quantified_predicate : value '>' ALL '(' column_select ')'",
"quantified_predicate : value GEQ ALL '(' column_select ')'",
"quantified_predicate : value LEQ ALL '(' column_select ')'",
"quantified_predicate : value NOT_GTR ALL '(' column_select ')'",
"quantified_predicate : value NOT_LSS ALL '(' column_select ')'",
"quantified_predicate : value NEQ ALL '(' column_select ')'",
"quantified_predicate : value '=' some '(' column_select ')'",
"quantified_predicate : value '<' some '(' column_select ')'",
"quantified_predicate : value '>' some '(' column_select ')'",
"quantified_predicate : value GEQ some '(' column_select ')'",
"quantified_predicate : value LEQ some '(' column_select ')'",
"quantified_predicate : value NOT_GTR some '(' column_select ')'",
"quantified_predicate : value NOT_LSS some '(' column_select ')'",
"quantified_predicate : value NEQ some '(' column_select ')'",
"some : SOME",
"some : ANY",
"distinct_predicate : value IS DISTINCT FROM value",
"distinct_predicate : value IS NOT DISTINCT FROM value",
"between_predicate : value BETWEEN value AND value",
"between_predicate : value NOT BETWEEN value AND value",
"like_predicate : value LIKE value",
"like_predicate : value NOT LIKE value",
"like_predicate : value LIKE value ESCAPE value",
"like_predicate : value NOT LIKE value ESCAPE value",
"in_predicate : value KW_IN in_predicate_value",
"in_predicate : value NOT KW_IN in_predicate_value",
"containing_predicate : value CONTAINING value",
"containing_predicate : value NOT CONTAINING value",
"starting_predicate : value STARTING value",
"starting_predicate : value NOT STARTING value",
"starting_predicate : value STARTING WITH value",
"starting_predicate : value NOT STARTING WITH value",
"exists_predicate : EXISTS '(' select_expr ')'",
"singular_predicate : SINGULAR '(' select_expr ')'",
"null_predicate : value IS KW_NULL",
"null_predicate : value IS NOT KW_NULL",
"trigger_action_predicate : INSERTING",
"trigger_action_predicate : UPDATING",
"trigger_action_predicate : DELETING",
"in_predicate_value : table_subquery",
"in_predicate_value : '(' value_list ')'",
"table_subquery : '(' column_select ')'",
"value : column_name",
"value : array_element",
"value : function",
"value : u_constant",
"value : parameter",
"value : variable",
"value : cast_specification",
"value : case_expression",
"value : next_value_expression",
"value : udf",
"value : '-' value",
"value : '+' value",
"value : value '+' value",
"value : value CONCATENATE value",
"value : value COLLATE symbol_collation_name",
"value : value '-' value",
"value : value '*' value",
"value : value '/' value",
"value : '(' value ')'",
"value : '(' column_singleton ')'",
"value : current_user",
"value : current_role",
"value : internal_info",
"value : DB_KEY",
"value : symbol_table_alias_name '.' DB_KEY",
"value : KW_VALUE",
"value : datetime_value_expression",
"value : null_value",
"datetime_value_expression : CURRENT_DATE",
"datetime_value_expression : CURRENT_TIME sec_precision_opt",
"datetime_value_expression : CURRENT_TIMESTAMP sec_precision_opt",
"sec_precision_opt : '(' nonneg_short_integer ')'",
"sec_precision_opt :",
"array_element : column_name '[' value_list ']'",
"value_list_opt : value_list",
"value_list_opt :",
"value_list : value",
"value_list : value_list ',' value",
"constant : u_constant",
"constant : '-' u_numeric_constant",
"u_numeric_constant : NUMERIC",
"u_numeric_constant : NUMBER",
"u_numeric_constant : FLOAT_NUMBER",
"u_numeric_constant : NUMBER64BIT",
"u_numeric_constant : SCALEDINT",
"u_constant : u_numeric_constant",
"u_constant : sql_string",
"u_constant : DATE STRING",
"u_constant : TIME STRING",
"u_constant : TIMESTAMP STRING",
"parameter : '?'",
"current_user : USER",
"current_user : CURRENT_USER",
"current_role : CURRENT_ROLE",
"internal_info : CURRENT_CONNECTION",
"internal_info : CURRENT_TRANSACTION",
"internal_info : GDSCODE",
"internal_info : SQLCODE",
"internal_info : ROW_COUNT",
"sql_string : STRING",
"sql_string : INTRODUCER STRING",
"signed_short_integer : nonneg_short_integer",
"signed_short_integer : '-' neg_short_integer",
"nonneg_short_integer : NUMBER",
"neg_short_integer : NUMBER",
"pos_short_integer : nonneg_short_integer",
"unsigned_short_integer : NUMBER",
"signed_long_integer : long_integer",
"signed_long_integer : '-' long_integer",
"long_integer : NUMBER",
"function : aggregate_function",
"function : non_aggregate_function",
"non_aggregate_function : numeric_value_function",
"non_aggregate_function : string_value_function",
"non_aggregate_function : system_function_expression",
"aggregate_function : COUNT '(' '*' ')'",
"aggregate_function : COUNT '(' all_noise value ')'",
"aggregate_function : COUNT '(' DISTINCT value ')'",
"aggregate_function : SUM '(' all_noise value ')'",
"aggregate_function : SUM '(' DISTINCT value ')'",
"aggregate_function : AVG '(' all_noise value ')'",
"aggregate_function : AVG '(' DISTINCT value ')'",
"aggregate_function : MINIMUM '(' all_noise value ')'",
"aggregate_function : MINIMUM '(' DISTINCT value ')'",
"aggregate_function : MAXIMUM '(' all_noise value ')'",
"aggregate_function : MAXIMUM '(' DISTINCT value ')'",
"aggregate_function : LIST '(' all_noise value delimiter_opt ')'",
"aggregate_function : LIST '(' DISTINCT value delimiter_opt ')'",
"delimiter_opt : ',' delimiter_value",
"delimiter_opt :",
"delimiter_value : sql_string",
"delimiter_value : parameter",
"delimiter_value : variable",
"numeric_value_function : extract_expression",
"numeric_value_function : length_expression",
"extract_expression : EXTRACT '(' timestamp_part FROM value ')'",
"length_expression : bit_length_expression",
"length_expression : char_length_expression",
"length_expression : octet_length_expression",
"bit_length_expression : BIT_LENGTH '(' value ')'",
"char_length_expression : CHAR_LENGTH '(' value ')'",
"char_length_expression : CHARACTER_LENGTH '(' value ')'",
"octet_length_expression : OCTET_LENGTH '(' value ')'",
"system_function_expression : system_function_std_syntax '(' value_list_opt ')'",
"system_function_expression : system_function_special_syntax",
"system_function_std_syntax : ABS",
"system_function_std_syntax : ACOS",
"system_function_std_syntax : ASCII_CHAR",
"system_function_std_syntax : ASCII_VAL",
"system_function_std_syntax : ASIN",
"system_function_std_syntax : ATAN",
"system_function_std_syntax : ATAN2",
"system_function_std_syntax : BIN_AND",
"system_function_std_syntax : BIN_OR",
"system_function_std_syntax : BIN_SHL",
"system_function_std_syntax : BIN_SHR",
"system_function_std_syntax : BIN_XOR",
"system_function_std_syntax : CEIL",
"system_function_std_syntax : COS",
"system_function_std_syntax : COSH",
"system_function_std_syntax : COT",
"system_function_std_syntax : EXP",
"system_function_std_syntax : FLOOR",
"system_function_std_syntax : GEN_UUID",
"system_function_std_syntax : HASH",
"system_function_std_syntax : LEFT",
"system_function_std_syntax : LN",
"system_function_std_syntax : LOG",
"system_function_std_syntax : LOG10",
"system_function_std_syntax : LPAD",
"system_function_std_syntax : MAXVALUE",
"system_function_std_syntax : MINVALUE",
"system_function_std_syntax : MOD",
"system_function_std_syntax : PI",
"system_function_std_syntax : POSITION",
"system_function_std_syntax : POWER",
"system_function_std_syntax : RAND",
"system_function_std_syntax : REPLACE",
"system_function_std_syntax : REVERSE",
"system_function_std_syntax : RIGHT",
"system_function_std_syntax : ROUND",
"system_function_std_syntax : RPAD",
"system_function_std_syntax : SIGN",
"system_function_std_syntax : SIN",
"system_function_std_syntax : SINH",
"system_function_std_syntax : SQRT",
"system_function_std_syntax : TAN",
"system_function_std_syntax : TANH",
"system_function_std_syntax : TRUNC",
"system_function_special_syntax : DATEADD '(' value timestamp_part TO value ')'",
"system_function_special_syntax : DATEADD '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part FROM value TO value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value FOR value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value ')'",
"system_function_special_syntax : POSITION '(' value KW_IN value ')'",
"string_value_function : substring_function",
"string_value_function : trim_function",
"string_value_function : KW_UPPER '(' value ')'",
"string_value_function : KW_LOWER '(' value ')'",
"substring_function : SUBSTRING '(' value FROM value string_length_opt ')'",
"string_length_opt : FOR value",
"string_length_opt :",
"trim_function : TRIM '(' trim_specification value FROM value ')'",
"trim_function : TRIM '(' value FROM value ')'",
"trim_function : TRIM '(' trim_specification FROM value ')'",
"trim_function : TRIM '(' value ')'",
"trim_specification : BOTH",
"trim_specification : TRAILING",
"trim_specification : LEADING",
"udf : symbol_UDF_call_name '(' value_list ')'",
"udf : symbol_UDF_call_name '(' ')'",
"cast_specification : CAST '(' value AS data_type_descriptor ')'",
"case_expression : case_abbreviation",
"case_expression : case_specification",
"case_abbreviation : NULLIF '(' value ',' value ')'",
"case_abbreviation : IIF '(' search_condition ',' value ',' value ')'",
"case_abbreviation : COALESCE '(' value ',' value_list ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ',' value ')'",
"case_specification : simple_case",
"case_specification : searched_case",
"simple_case : CASE case_operand simple_when_clause END",
"simple_case : CASE case_operand simple_when_clause ELSE case_result END",
"simple_when_clause : WHEN when_operand THEN case_result",
"simple_when_clause : simple_when_clause WHEN when_operand THEN case_result",
"searched_case : CASE searched_when_clause END",
"searched_case : CASE searched_when_clause ELSE case_result END",
"searched_when_clause : WHEN search_condition THEN case_result",
"searched_when_clause : searched_when_clause WHEN search_condition THEN case_result",
"when_operand : value",
"case_operand : value",
"case_result : value",
"decode_pairs : value ',' value",
"decode_pairs : decode_pairs ',' value ',' value",
"next_value_expression : NEXT KW_VALUE FOR symbol_generator_name",
"next_value_expression : GEN_ID '(' symbol_generator_name ',' value ')'",
"timestamp_part : YEAR",
"timestamp_part : MONTH",
"timestamp_part : DAY",
"timestamp_part : HOUR",
"timestamp_part : MINUTE",
"timestamp_part : SECOND",
"timestamp_part : MILLISECOND",
"timestamp_part : WEEK",
"timestamp_part : WEEKDAY",
"timestamp_part : YEARDAY",
"all_noise : ALL",
"all_noise :",
"distinct_noise : DISTINCT",
"distinct_noise :",
"null_value : KW_NULL",
"symbol_UDF_call_name : SYMBOL",
"symbol_UDF_name : valid_symbol_name",
"symbol_blob_subtype_name : valid_symbol_name",
"symbol_character_set_name : valid_symbol_name",
"symbol_collation_name : valid_symbol_name",
"symbol_column_name : valid_symbol_name",
"symbol_constraint_name : valid_symbol_name",
"symbol_cursor_name : valid_symbol_name",
"symbol_domain_name : valid_symbol_name",
"symbol_exception_name : valid_symbol_name",
"symbol_filter_name : valid_symbol_name",
"symbol_gdscode_name : valid_symbol_name",
"symbol_generator_name : valid_symbol_name",
"symbol_index_name : valid_symbol_name",
"symbol_item_alias_name : valid_symbol_name",
"symbol_label_name : valid_symbol_name",
"symbol_ddl_name : valid_symbol_name",
"symbol_procedure_name : valid_symbol_name",
"symbol_role_name : valid_symbol_name",
"symbol_table_alias_name : valid_symbol_name",
"symbol_table_name : valid_symbol_name",
"symbol_trigger_name : valid_symbol_name",
"symbol_user_name : valid_symbol_name",
"symbol_variable_name : valid_symbol_name",
"symbol_view_name : valid_symbol_name",
"symbol_savepoint_name : valid_symbol_name",
"valid_symbol_name : SYMBOL",
"valid_symbol_name : non_reserved_word",
"non_reserved_word : ACTION",
"non_reserved_word : CASCADE",
"non_reserved_word : FREE_IT",
"non_reserved_word : RESTRICT",
"non_reserved_word : ROLE",
"non_reserved_word : TYPE",
"non_reserved_word : KW_BREAK",
"non_reserved_word : KW_DESCRIPTOR",
"non_reserved_word : SUBSTRING",
"non_reserved_word : COALESCE",
"non_reserved_word : LAST",
"non_reserved_word : LEAVE",
"non_reserved_word : LOCK",
"non_reserved_word : NULLIF",
"non_reserved_word : NULLS",
"non_reserved_word : STATEMENT",
"non_reserved_word : INSERTING",
"non_reserved_word : UPDATING",
"non_reserved_word : DELETING",
"non_reserved_word : FIRST",
"non_reserved_word : SKIP",
"non_reserved_word : BLOCK",
"non_reserved_word : BACKUP",
"non_reserved_word : KW_DIFFERENCE",
"non_reserved_word : IIF",
"non_reserved_word : SCALAR_ARRAY",
"non_reserved_word : WEEKDAY",
"non_reserved_word : YEARDAY",
"non_reserved_word : SEQUENCE",
"non_reserved_word : NEXT",
"non_reserved_word : RESTART",
"non_reserved_word : COLLATION",
"non_reserved_word : RETURNING",
"non_reserved_word : KW_IGNORE",
"non_reserved_word : LIMBO",
"non_reserved_word : UNDO",
"non_reserved_word : REQUESTS",
"non_reserved_word : TIMEOUT",
"non_reserved_word : ABS",
"non_reserved_word : ACCENT",
"non_reserved_word : ACOS",
"non_reserved_word : ALWAYS",
"non_reserved_word : ASCII_CHAR",
"non_reserved_word : ASCII_VAL",
"non_reserved_word : ASIN",
"non_reserved_word : ATAN",
"non_reserved_word : ATAN2",
"non_reserved_word : BIN_AND",
"non_reserved_word : BIN_OR",
"non_reserved_word : BIN_SHL",
"non_reserved_word : BIN_SHR",
"non_reserved_word : BIN_XOR",
"non_reserved_word : CEIL",
"non_reserved_word : COS",
"non_reserved_word : COSH",
"non_reserved_word : COT",
"non_reserved_word : DATEADD",
"non_reserved_word : DATEDIFF",
"non_reserved_word : DECODE",
"non_reserved_word : EXP",
"non_reserved_word : FLOOR",
"non_reserved_word : GEN_UUID",
"non_reserved_word : GENERATED",
"non_reserved_word : HASH",
"non_reserved_word : LIST",
"non_reserved_word : LN",
"non_reserved_word : LOG",
"non_reserved_word : LOG10",
"non_reserved_word : LPAD",
"non_reserved_word : MATCHED",
"non_reserved_word : MATCHING",
"non_reserved_word : MAXVALUE",
"non_reserved_word : MILLISECOND",
"non_reserved_word : MINVALUE",
"non_reserved_word : MOD",
"non_reserved_word : OVERLAY",
"non_reserved_word : PAD",
"non_reserved_word : PI",
"non_reserved_word : PLACING",
"non_reserved_word : POWER",
"non_reserved_word : PRESERVE",
"non_reserved_word : RAND",
"non_reserved_word : REPLACE",
"non_reserved_word : REVERSE",
"non_reserved_word : ROUND",
"non_reserved_word : RPAD",
"non_reserved_word : SIGN",
"non_reserved_word : SIN",
"non_reserved_word : SINH",
"non_reserved_word : SPACE",
"non_reserved_word : SQRT",
"non_reserved_word : TAN",
"non_reserved_word : TANH",
"non_reserved_word : TEMPORARY",
"non_reserved_word : TRUNC",
"non_reserved_word : WEEK",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif

//
// YYPOSN is user-defined text position type.
//
#ifndef YYPOSN
#define YYPOSN int
#endif

#ifdef YYREDUCEPOSNFUNC
#define YYCALLREDUCEPOSN(e)   \
	if(reduce_posn) {     \
	  YYREDUCEPOSNFUNC(yyps->pos, &(yyps->psp)[1-yym], &(yyps->vsp)[1-yym], \
			   yym, yyps->psp - yyps->ps, yychar, yyposn, e);       \
	  reduce_posn = 0;    \
	}

#ifndef YYCALLREDUCEPOSNARG
#define YYCALLREDUCEPOSNARG yyps->val
#endif


#define YYPOSNARG(n) ((yyps->psp)[1-yym+(n)-1])
#define YYPOSNOUT    (yyps->pos)
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEVAL
#define YYDELETEVAL(v, n) 
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEPOSN
#define YYDELETEPOSN(v, n) 
#endif

#define yyclearin (yychar=(-1))

#define yyerrok (yyps->errflag=0)

#ifndef YYSTACKGROWTH
#define YYSTACKGROWTH 16
#endif

#ifndef YYDEFSTACKSIZE
#define YYDEFSTACKSIZE 12
#endif

#ifdef YYDEBUG
int yydebug;
#endif

int yynerrs;

/* These value/posn are taken from the lexer */
YYSTYPE yylval;
YYPOSN  yyposn;

/* These value/posn of the root non-terminal are returned to the caller */
YYSTYPE yyretlval;
YYPOSN  yyretposn;

#define YYABORT  goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#define YYVALID         do { if (yyps->save)          goto yyvalid; } while(0)
#define YYVALID_NESTED  do { if (yyps->save && \
                                 yyps->save->save==0) goto yyvalid; } while(0)

struct yyparsestate {
  yyparsestate *save;        // Previously saved parser state
  int           state;
  int           errflag;
  Yshort       *ssp;         // state stack pointer
  YYSTYPE      *vsp;         // value stack pointer
  YYPOSN       *psp;         // position stack pointer
  YYSTYPE       val;         // value as returned by actions
  YYPOSN        pos;         // position as returned by universal action
  Yshort       *ss;          // state stack base
  YYSTYPE      *vs;          // values stack base
  YYPOSN       *ps;          // position stack base
  int           lexeme;      // index of the conflict lexeme in the lexical queue
  unsigned int  stacksize;   // current maximum stack size
  Yshort        ctry;        // index in yyctable[] for this conflict
};

// Current parser state
static yyparsestate *yyps=0;

// yypath!=NULL: do the full parse, starting at *yypath parser state.
static yyparsestate *yypath=0;

// Base of the lexical value queue
static YYSTYPE *yylvals=0;

// Current posistion at lexical value queue
static YYSTYPE *yylvp=0;

// End position of lexical value queue
static YYSTYPE *yylve=0;

// The last allocated position at the lexical value queue
static YYSTYPE *yylvlim=0;

// Base of the lexical position queue
static YYPOSN *yylpsns=0;

// Current posistion at lexical position queue
static YYPOSN *yylpp=0;

// End position of lexical position queue
static YYPOSN *yylpe=0;

// The last allocated position at the lexical position queue
static YYPOSN *yylplim=0;

// Current position at lexical token queue
static Yshort *yylexp=0;

static Yshort *yylexemes=0;

//
// For use in generated program
//
#define yytrial (yyps->save)
#define yyvsp   (yyps->vsp)
#define yyval   (yyps->val)
#define yydepth (yyps->ssp - yyps->ss)


//
// Local prototypes.
//
int dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous);

int  YYLex1(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous);
int  yyexpand();
void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size);
void YYPCopy(YYPOSN  *to, YYPOSN  *from, int size);
void YYMoreStack(yyparsestate *yyps);
yyparsestate *YYNewState(int size);
void YYFreeState(yyparsestate *p);




/*
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		lex.c
 *	DESCRIPTION:	Lexical routine
 *
 */


void LEX_dsql_init (void)
{
/**************************************
 *
 *	L E X _ d s q l _ i n i t
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX for processing.  This is called only once
 *	per session.
 *
 **************************************/
	for (const TOK* token = KEYWORD_getTokens(); token->tok_string; ++token)
	{
		DSQL_SYM symbol = FB_NEW_RPT(*DSQL_permanent_pool, 0) dsql_sym;
		symbol->sym_string = (TEXT *) token->tok_string;
		symbol->sym_length = strlen(token->tok_string);
		symbol->sym_type = SYM_keyword;
		symbol->sym_keyword = token->tok_ident;
		symbol->sym_version = token->tok_version;
		dsql_str* str = FB_NEW_RPT(*DSQL_permanent_pool, symbol->sym_length) dsql_str;
		str->str_length = symbol->sym_length;
		strncpy((char*)str->str_data, (char*)symbol->sym_string, symbol->sym_length);
		symbol->sym_object = (void *) str;
		HSHD_insert(symbol);
	}
}


void LEX_string (
	const TEXT* string,
	USHORT	length,
	SSHORT	character_set)
{
/**************************************
 *
 *	L E X _ s t r i n g
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX to process a string.
 *
 **************************************/

	lex.line_start = lex.ptr = string;
	lex.end = string + length;
	lex.lines = 1;
	lex.att_charset = character_set;
	lex.line_start_bk = lex.line_start;
	lex.lines_bk = lex.lines;
	lex.param_number = 1;
	lex.prev_keyword = -1;
#ifdef DSQL_DEBUG
	if (DSQL_debug & 32)
		dsql_trace("Source DSQL string:\n%.*s", (int)length, string);
#endif
}


static const TEXT* lex_position (void)
{
/**************************************
 *
 *	l e x _ p o s i t i o n
 *
 **************************************
 *
 * Functional description
 *	Return the current position of LEX 
 *	in the input string.
 *
 **************************************/

	return lex.ptr;
}


#ifdef NOT_USED_OR_REPLACED
static bool long_int(dsql_nod* string,
					 SLONG *long_value)
{
/*************************************
 *
 *	l o n g _ i n t
 * 
 *************************************
 *
 * Functional description
 *	checks for all digits in the
 *	number and return an atol().
 *
 *************************************/

	for (const UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; 
		 classes(*p) & CHR_DIGIT; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	*long_value = atol(((dsql_str*) string)->str_data);

	return true;
}
#endif

static dsql_fld* make_field (dsql_nod* field_name)
{
/**************************************
 *
 *	m a k e _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Make a field block of given name.
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	if (field_name == NULL)
	{
		dsql_fld* field =
			FB_NEW_RPT(*tdsql->getDefaultPool(), sizeof (INTERNAL_FIELD_NAME)) dsql_fld;
		strcpy (field->fld_name, INTERNAL_FIELD_NAME);
		return field;
	}
	const dsql_str* string = (dsql_str*) field_name->nod_arg[1];
	dsql_fld* field =
		FB_NEW_RPT(*tdsql->getDefaultPool(), strlen ((SCHAR*) string->str_data)) dsql_fld;
	strcpy (field->fld_name, (TEXT*) string->str_data);
	field->fld_type_of_name = NULL;
	field->fld_explicit_collation = false;
	field->fld_not_nullable = false;
	field->fld_full_domain = false;

	return field;
}


static dsql_fil* make_file()
{
/**************************************
 *
 *	m a k e _ f i l e 
 *
 **************************************
 *
 * Functional description
 *	Make a file block
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();
		   
	dsql_fil* temp_file = FB_NEW(*tdsql->getDefaultPool()) dsql_fil;

	return temp_file;
}


static dsql_nod* make_list (dsql_nod* node)
{
/**************************************
 *
 *	m a k e _ l i s t
 *
 **************************************
 *
 * Functional description
 *	Collapse nested list nodes into single list.
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	if (node)
	{
		DsqlNodStack stack;
		stack_nodes(node, stack);
		USHORT l = stack.getCount();

		const dsql_nod* old = node;
		node = FB_NEW_RPT(*tdsql->getDefaultPool(), l) dsql_nod;
		node->nod_count = l;
		node->nod_type = nod_list;
		node->nod_line = (USHORT) lex.lines_bk;
		node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
		if (MemoryPool::blk_type(old) == dsql_type_nod)
		{
			node->nod_flags = old->nod_flags;
		}
		dsql_nod** ptr = node->nod_arg + node->nod_count;

		while (stack.hasData())
			*--ptr = stack.pop();
	}

	return node;
}


static dsql_nod* make_parameter (void)
{
/**************************************
 *
 *	m a k e _ p a r a m e t e r
 *
 **************************************
 *
 * Functional description
 *	Make parameter node
 *	Any change should also be made to function below
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), e_par_count) dsql_nod;
	node->nod_type = nod_parameter;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = e_par_count;
	node->nod_arg[e_par_index] = (dsql_nod*)(IPTR) lex.param_number++;

	return node;
}


static dsql_nod* make_node (NOD_TYPE	type,
						   int count,
						   ...)
{
/**************************************
 *
 *	m a k e _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type.
 *	Any change should also be made to function below
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


static dsql_nod* make_flag_node (NOD_TYPE	type,
								SSHORT	flag,
								int		count,
								...)
{
/**************************************
 *
 *	m a k e _ f l a g _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type. Set flag field
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_flags = flag;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


static void prepare_console_debug (int level, int *yydeb)
{
/*************************************
 *
 *	p r e p a r e _ c o n s o l e _ d e b u g
 * 
 *************************************
 *
 * Functional description
 *	Activate debug info. In WinNT, redirect the standard
 *	output so one can see the generated information.
 *	Feel free to add your platform specific code.
 *
 *************************************/
#ifdef DSQL_DEBUG
	DSQL_debug = level;
#endif
	if (level >> 8)
		*yydeb = level >> 8;
}

#ifdef NOT_USED_OR_REPLACED
static bool short_int(dsql_nod* string,
					  SLONG *long_value,
					  SSHORT range)
{
/*************************************
 *
 *	s h o r t _ i n t
 * 
 *************************************
 *
 * Functional description
 *	is the string a valid representation 
 *	of a positive short int?
 *
 *************************************/

	if (((dsql_str*) string)->str_length > 5) {
		return false;
	}

	for (UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; 
		classes(*p) & CHR_DIGIT; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	/* there are 5 or fewer digits, it's value may still be greater
	 * than 32767... */

	SCHAR buf[10];	
	buf[0] = ((dsql_str*) string)->str_data[0];
	buf[1] = ((dsql_str*) string)->str_data[1];
	buf[2] = ((dsql_str*) string)->str_data[2];
	buf[3] = ((dsql_str*) string)->str_data[3];
	buf[4] = ((dsql_str*) string)->str_data[4];
	buf[5] = '\0';

	*long_value = atoi (buf);

	bool return_value;

	switch (range) 
	{
		case POSITIVE:
			return_value = *long_value > SHRT_POS_MAX;
			break;
		case NEGATIVE:
			return_value = *long_value > SHRT_NEG_MAX;
			break;
		case UNSIGNED:
			return_value = *long_value > SHRT_UNSIGNED_MAX;
			break;
	}
	return !return_value;
}
#endif

static void stack_nodes (dsql_nod*	node,
						 DsqlNodStack& stack)
{
/**************************************
 *
 *	s t a c k _ n o d e s
 *
 **************************************
 *
 * Functional description
 *	Assist in turning a tree of misc nodes into a clean list.
 *
 **************************************/
	if (node->nod_type != nod_list)
	{
		stack.push(node);
		return;
	}

	/* To take care of cases where long lists of nodes are in a chain
	   of list nodes with exactly one entry, this algorithm will look
	   for a pattern of repeated list nodes with two entries, the first
	   being a list node and the second being a non-list node.   Such
	   a list will be reverse linked, and then re-reversed, stacking the
	   non-list nodes in the process.   The purpose of this is to avoid
	   massive recursion of this function. */

	dsql_nod* start_chain = node;
	dsql_nod* end_chain = NULL;
	dsql_nod* curr_node = node;
	dsql_nod* next_node = node->nod_arg[0];
	while ( curr_node->nod_count == 2 &&
			curr_node->nod_arg[0]->nod_type == nod_list &&
			curr_node->nod_arg[1]->nod_type != nod_list &&
			next_node->nod_arg[0]->nod_type == nod_list &&
			next_node->nod_arg[1]->nod_type != nod_list)
	{

		/* pattern was found so reverse the links and go to next node */

		dsql_nod* save_link = next_node->nod_arg[0];
		next_node->nod_arg[0] = curr_node;
		curr_node = next_node;
		next_node = save_link;
		end_chain = curr_node;
	}

	/* see if any chain was found */

	if (end_chain)
	{

		/* first, handle the rest of the nodes */
		/* note that next_node still points to the first non-pattern node */

		stack_nodes (next_node, stack);

		/* stack the non-list nodes and reverse the chain on the way back */
		
		curr_node = end_chain;
		while (true)
		{
			stack.push(curr_node->nod_arg[1]);
			if ( curr_node == start_chain)
				break;
			dsql_nod* save_link = curr_node->nod_arg[0];
			curr_node->nod_arg[0] = next_node;
			next_node = curr_node;
			curr_node = save_link;
		}
		return;
	}

	dsql_nod** ptr = node->nod_arg;
	for (const dsql_nod* const* const end = ptr + node->nod_count; ptr < end; ptr++)
		stack_nodes (*ptr, stack);
}

inline static int yylex (
	USHORT	client_dialect,
	USHORT	db_dialect,
	USHORT	parser_version,
	bool* stmt_ambiguous)
{
	lex.prev_keyword =
		lex.yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
	return lex.prev_keyword;
}

int LexerState::yylex (
	USHORT	client_dialect,
	USHORT	db_dialect,
	USHORT	parser_version,
	bool* stmt_ambiguous)
{
/**************************************
 *
 *	y y l e x
 *
 **************************************
 *
 * Functional description: lexer.
 *
 **************************************/
	UCHAR	tok_class;
	char  string[MAX_TOKEN_LEN];
	SSHORT	c;

	/* Find end of white space and skip comments */

	for (;;)
	{
		if (ptr >= end)
			return -1;

		c = *ptr++;

		/* Process comments */

		if (c == '\n') {
			lines++;
			line_start = ptr;
			continue;
		}

		if ((c == '-') && (*ptr == '-'))
		{
			
			/* single-line */
			
			ptr++;
			while (ptr < end) {
				if ((c = *ptr++) == '\n') {
					lines++;
					line_start = ptr /* + 1*/; /* CVC: +1 left out. */
					break;
				}
			}
			if (ptr >= end)
				return -1;
			continue;
		}
		else if ((c == '/') && (*ptr == '*'))
		{
			
			/* multi-line */
			
			const TEXT& start_block = ptr[-1];
			ptr++;
			while (ptr < end) {
				if ((c = *ptr++) == '*') {
					if (*ptr == '/')
						break;
				}
				if (c == '\n') {
					lines++;
					line_start = ptr /* + 1*/; /* CVC: +1 left out. */

				}
			}
			if (ptr >= end)
			{
				// I need this to report the correct beginning of the block,
				// since it's not a token really.
				last_token = &start_block;
				yyerror("unterminated block comment");
				return -1;
			}
			ptr++;
			continue;
		}

		tok_class = classes(c);

		if (!(tok_class & CHR_WHITE))
			break;
	}

	/* Depending on tok_class of token, parse token */

	last_token = ptr - 1;

	if (tok_class & CHR_INTRODUCER)
	{
		/* The Introducer (_) is skipped, all other idents are copied
		 * to become the name of the character set
		 */
		char* p = string;
		for (; ptr < end && classes(*ptr) & CHR_IDENT; ptr++)
		{
			if (ptr >= end)
				return -1;
			check_copy_incr(p, UPPER7(*ptr), string);
		}
		
		check_bound(p, string);
		*p = 0;

		/* make a string value to hold the name, the name 
		 * is resolved in pass1_constant */

		yylval = (dsql_nod*) (MAKE_string(string, p - string))->str_data;

		return INTRODUCER;
	}

	/* parse a quoted string, being sure to look for double quotes */

	if (tok_class & CHR_QUOTE)
	{
		char* buffer = string;
		size_t buffer_len = sizeof (string);
		const char* buffer_end = buffer + buffer_len - 1;
		char* p;
		for (p = buffer; ; ++p)
		{
			if (ptr >= end)
			{
				if (buffer != string)
					gds__free (buffer);
				yyerror("unterminated string");
				return -1;
			}
			// Care about multi-line constants and identifiers
			if (*ptr == '\n') {
				lines++;
				line_start = ptr + 1;
			}
			/* *ptr is quote - if next != quote we're at the end */
			if ((*ptr == c) && ((++ptr == end) || (*ptr != c)))
				break;
			if (p > buffer_end)
			{
				char* const new_buffer = (char*) gds__alloc (2 * buffer_len);
			/* FREE: at outer block */
				if (!new_buffer)		/* NOMEM: */
				{
					if (buffer != string)
						gds__free (buffer);
					return -1;
				}
				memcpy (new_buffer, buffer, buffer_len);
				if (buffer != string)
					gds__free (buffer);
				buffer = new_buffer;
				p = buffer + buffer_len;
				buffer_len = 2 * buffer_len;
				buffer_end = buffer + buffer_len - 1;
			}
			*p = *ptr++;
		}
		if (c == '"')
		{
			*stmt_ambiguous = true; /* string delimited by double quotes could be
					**   either a string constant or a SQL delimited
					**   identifier, therefore marks the SQL
					**   statement as ambiguous  */
			if (client_dialect == SQL_DIALECT_V6_TRANSITION)
			{
				if (buffer != string)
					gds__free (buffer);
				yyabandon (-104, isc_invalid_string_constant);
			}
			else if (client_dialect >= SQL_DIALECT_V6)
			{
				if ((p - buffer) >= MAX_TOKEN_LEN)
				{
					if (buffer != string)
						gds__free (buffer);
					yyabandon (-104, isc_token_too_long);
				}
				yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
				dsql_str* delimited_id_str = (dsql_str*) yylval;
				delimited_id_str->str_flags |= STR_delimited_id;
				if (buffer != string)
					gds__free (buffer);
				return SYMBOL;
			}
		}
		yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
		if (buffer != string)
			gds__free (buffer);
		return STRING;
	}
												 
/* 
 * Check for a numeric constant, which starts either with a digit or with
 * a decimal point followed by a digit.
 * 
 * This code recognizes the following token types:
 * 
 * NUMBER: string of digits which fits into a 32-bit integer
 * 
 * NUMBER64BIT: string of digits whose value might fit into an SINT64,
 *   depending on whether or not there is a preceding '-', which is to
 *   say that "9223372036854775808" is accepted here.
 *
 * SCALEDINT: string of digits and a single '.', where the digits
 *   represent a value which might fit into an SINT64, depending on
 *   whether or not there is a preceding '-'.
 *
 * FLOAT: string of digits with an optional '.', and followed by an "e"
 *   or "E" and an optionally-signed exponent.
 *
 * NOTE: we swallow leading or trailing blanks, but we do NOT accept
 *   embedded blanks:
 *
 * Another note: c is the first character which need to be considered,
 *   ptr points to the next character.
 */

	fb_assert(ptr <= end);

	if ((tok_class & CHR_DIGIT) ||
		((c == '.') && (ptr < end) && (classes(*ptr) & CHR_DIGIT)))
	{
		/* The following variables are used to recognize kinds of numbers. */

		bool have_error	 = false;	/* syntax error or value too large */
		bool have_digit	 = false;	/* we've seen a digit			  */
		bool have_decimal   = false;	/* we've seen a '.'				*/
		bool have_exp	   = false;	/* digit ... [eE]				  */
		bool have_exp_sign  = false; /* digit ... [eE] {+-]			 */
		bool have_exp_digit = false; /* digit ... [eE] ... digit		*/
		FB_UINT64 number		= 0;
		FB_UINT64 limit_by_10	= MAX_SINT64 / 10;

		for (--ptr ; ptr < end ; ptr++)
		{
			c = *ptr;
			if (have_exp_digit && (! (classes(c) & CHR_DIGIT)))
				/* First non-digit after exponent and digit terminates
				 the token. */
				break;
			else if (have_exp_sign && (! (classes(c) & CHR_DIGIT)))
			{
				/* only digits can be accepted after "1E-" */
				have_error = true;
				break;
			}
			else if (have_exp)
			{
				/* We've seen e or E, but nothing beyond that. */
				if ( ('-' == c) || ('+' == c) )
					have_exp_sign = true;
				else if ( classes(c) & CHR_DIGIT )
					/* We have a digit: we haven't seen a sign yet,
					but it's too late now. */
					have_exp_digit = have_exp_sign  = true;
				else
				{
					/* end of the token */
					have_error = true;
					break;
				}
			}
			else if ('.' == c)
			{
				if (!have_decimal)
					have_decimal = true;
				else
				{
					have_error = true;
					break;
				}
			}
			else if (classes(c) & CHR_DIGIT)
			{
				/* Before computing the next value, make sure there will be
				   no overflow.  */

				have_digit = true;

				if (number >= limit_by_10)
				{
				/* possibility of an overflow */
					if ((number > limit_by_10) || (c > '8'))
					{
						have_error = true;
						break;
					}
				}
				number = number * 10 + (c - '0');
			}
			else if ( (('E' == c) || ('e' == c)) && have_digit )
				have_exp = true;
			else
				/* Unexpected character: this is the end of the number. */
				break;
		}

		/* We're done scanning the characters: now return the right kind
		   of number token, if any fits the bill. */

		if (!have_error)
		{
			fb_assert(have_digit);

			if (have_exp_digit)
			{
				yylval = (dsql_nod*) MAKE_string(last_token, ptr - last_token);
				last_token_bk = last_token;
				line_start_bk = line_start;
				lines_bk = lines;

				return FLOAT_NUMBER;
			}
			else if (!have_exp)
			{

				/* We should return some kind (scaled-) integer type
				   except perhaps in dialect 1. */

				if (!have_decimal && (number <= MAX_SLONG))
				{
					yylval = (dsql_nod*) (IPTR) number;
					//printf ("parse.y %p %d\n", yylval, number);
					return NUMBER;
				}
				else
				{
					/* We have either a decimal point with no exponent
					   or a string of digits whose value exceeds MAX_SLONG:
					   the returned type depends on the client dialect,
					   so warn of the difference if the client dialect is
					   SQL_DIALECT_V6_TRANSITION.
					*/

					if (SQL_DIALECT_V6_TRANSITION == client_dialect)
					{
						/* Issue a warning about the ambiguity of the numeric
						 * numeric literal.  There are multiple calls because
						 * the message text exceeds the 119-character limit
						 * of our message database.
						 */
						ERRD_post_warning( isc_dsql_warning_number_ambiguous,
							   isc_arg_string,
							   ERR_string( last_token, ptr - last_token ),
							   isc_arg_end );
						ERRD_post_warning( isc_dsql_warning_number_ambiguous1,
							   isc_arg_end );
					}

					yylval = (dsql_nod*) MAKE_string(last_token, ptr - last_token);

					last_token_bk = last_token;
					line_start_bk = line_start;
					lines_bk = lines;

					if (client_dialect < SQL_DIALECT_V6_TRANSITION)
						return FLOAT_NUMBER;
					else if (have_decimal)
						return SCALEDINT;
					else
						return NUMBER64BIT;
				}
			} /* else if (!have_exp) */
		} /* if (!have_error) */

		/* we got some kind of error or overflow, so don't recognize this
		 * as a number: just pass it through to the next part of the lexer.
		 */
	}

	/* Restore the status quo ante, before we started our unsuccessful
	   attempt to recognize a number. */
	ptr = last_token;
	c   = *ptr++;
	/* We never touched tok_class, so it doesn't need to be restored. */

	/* end of number-recognition code */


	if (tok_class & CHR_LETTER)
	{
		char* p = string;
		check_copy_incr(p, UPPER (c), string);
		for (; ptr < end && classes(*ptr) & CHR_IDENT; ptr++)
		{
			if (ptr >= end)
				return -1;
			check_copy_incr(p, UPPER (*ptr), string);
		}

		check_bound(p, string);
		*p = 0;
		dsql_sym* sym =
			HSHD_lookup (NULL, (TEXT *) string, (SSHORT)(p - string), SYM_keyword, parser_version);
		if (sym && (sym->sym_keyword != COMMENT || prev_keyword == -1))
		{
			yylval = (dsql_nod*) sym->sym_object;
			last_token_bk = last_token;
			line_start_bk = line_start;
			lines_bk = lines;
			return sym->sym_keyword;
		}
		yylval = (dsql_nod*) MAKE_string(string, p - string);
		last_token_bk = last_token;
		line_start_bk = line_start;
		lines_bk = lines;
		return SYMBOL;
	}

	/* Must be punctuation -- test for double character punctuation */

	if (last_token + 1 < end)
	{
		dsql_sym* sym =
			HSHD_lookup (NULL, last_token, (SSHORT) 2, SYM_keyword, (USHORT) parser_version);
		if (sym)
		{
			++ptr;
			return sym->sym_keyword;
		}
	}
		
	/* Single character punctuation are simply passed on */

	return (UCHAR) c;
}


static void yyerror_detailed(const TEXT* error_string, int yychar, YYSTYPE&, YYPOSN&)
{
/**************************************
 *
 *	y y e r r o r _ d e t a i l e d
 *
 **************************************
 *
 * Functional description
 *	Print a syntax error.
 *
 **************************************/
	const TEXT* line_start = lex.line_start;
	SLONG lines = lex.lines;
	if (lex.last_token < lex.line_start)
	{
		line_start = lex.line_start_bk;
		lines--;
	}

	if (yychar < 1)
		ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104,
			isc_arg_gds, isc_command_end_err2,	/* Unexpected end of command */
			isc_arg_number, lines,
			isc_arg_number, (SLONG) (lex.last_token - line_start + 1),
			isc_arg_end);
	else
	{
		ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104,
			/* Token unknown - line %d, column %d */
			isc_arg_gds, isc_dsql_token_unk_err,
			isc_arg_number, (SLONG) lines,
			isc_arg_number, (SLONG) (lex.last_token - line_start + 1), /*CVC: +1*/
			/* Show the token */
			isc_arg_gds, isc_random,
			isc_arg_cstring, (int) (lex.ptr - lex.last_token), lex.last_token,
			isc_arg_end);
	}
}


// The argument passed to this function is ignored. Therefore, messages like
// "syntax error" and "yacc stack overflow" are never seen.
static void yyerror(const TEXT* error_string)
{
	YYSTYPE errt_value =  0;
	YYPOSN errt_posn = -1;
	yyerror_detailed(error_string, -1, errt_value, errt_posn);
}


static void yyabandon (SLONG		sql_code,
					   ISC_STATUS	error_symbol)
{
/**************************************
 *
 *	y y a b a n d o n
 *
 **************************************
 *
 * Functional description
 *	Abandon the parsing outputting the supplied string
 *
 **************************************/

	ERRD_post (isc_sqlerr, isc_arg_number, sql_code,
		isc_arg_gds, error_symbol, isc_arg_end);
}


//
// Parser function
//
int dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous) {
  int yym, yyn, yystate, yychar, yynewerrflag;
  yyparsestate *yyerrctx = NULL;
  int reduce_posn;

#if YYDEBUG
  char *yys;
  
  if ((yys = getenv("YYDEBUG"))) {
    yyn = *yys;
    if (yyn >= '0' && yyn <= '9')
      yydebug = yyn - '0'; 
  }
#endif
  
  yyps = YYNewState(YYDEFSTACKSIZE);
  yyps->save = 0;
  yynerrs = 0;
  yyps->errflag = 0;
  yychar = (-1);
  
  yyps->ssp = yyps->ss;
  yyps->vsp = yyps->vs;
  yyps->psp = yyps->ps;
  *(yyps->ssp) = yystate = 0;
  

  //
  // Main parsing loop
  //
 yyloop:
  if ((yyn = yydefred[yystate])) {
    goto yyreduce;
  }

  //
  // Read one token
  //
  if (yychar < 0) {
    if ((yychar = YYLex1(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) yychar = 0;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, reading %d (%s)", 
	     int(yydepth), yytrial, yystate, yychar, yys);
#ifdef YYDBPR
      printf("<");
      YYDBPR(yylval);
      printf(">");
#endif
      printf("\n"); 
    }
#endif
  }

  //
  // Do we have a conflict?
  //
  if ((yyn = yycindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    int ctry;

    if (yypath) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d: following successful trial parse\n", 
	       int(yydepth), yytrial, yystate);
      }
#endif
      // Switch to the next conflict context
      yyparsestate *save = yypath;
      yypath = save->save;
      ctry = save->ctry;
      if (save->state != yystate) 
        goto yyabort;
      YYFreeState(save); 

    } else {

#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d. ", 
	       int(yydepth), yytrial, yystate);
        if(yyps->save) {
          printf("ALREADY in conflict. Continue trial parse.");
        } else {
          printf("Start trial parse.");
        }
        printf("\n");
      }
#endif
      yyparsestate *save = YYNewState(yyps->ssp - yyps->ss);
      save->save    = yyps->save;
      save->state   = yystate;
      save->errflag = yyps->errflag;
      save->ssp     = save->ss + (yyps->ssp - yyps->ss);
      save->vsp     = save->vs + (yyps->vsp - yyps->vs);
      save->psp     = save->ps + (yyps->psp - yyps->ps);
      memcpy (save->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(save->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(save->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      ctry = yytable[yyn];
      if (yyctable[ctry] == -1) {
#if YYDEBUG
        if (yydebug && yychar >= 0)
          printf("yydebug[%p]: backtracking 1 token\n", yytrial);
#endif
        ctry++; 
      }
      save->ctry = ctry;
      if (!yyps->save) {
        // If this is a first conflict in the stack, start saving lexemes
        if (!yylexemes) {
          yylexemes = new Yshort[YYSTACKGROWTH];
          yylvals = new YYSTYPE[YYSTACKGROWTH];
          yylvlim = yylvals + YYSTACKGROWTH; 
          yylpsns = new YYPOSN[YYSTACKGROWTH];
          yylplim = yylpsns + YYSTACKGROWTH; 
        }
        if (yylvp == yylve) {
          yylvp = yylve = yylvals;
	  yylpp = yylpe = yylpsns;
          yylexp = yylexemes;
          if (yychar >= 0) {
            *yylve++ = yylval;
            *yylpe++ = yyposn;
            *yylexp = yychar;
            yychar = -1; 
          } 
        } 
      }
      if (yychar >= 0) {
        yylvp--, yylpp--, yylexp--;
        yychar = -1; 
      }
      save->lexeme = yylvp - yylvals;
      yyps->save = save; 
    }
    if (yytable[yyn] == ctry) {
#if YYDEBUG
      if (yydebug)
        printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
               int(yydepth), yytrial, yystate, yyctable[ctry]);
#endif
      if (yychar < 0)
        yylvp++, yylpp++, yylexp++;
      yychar = -1;
      if (yyps->errflag > 0) --yyps->errflag;
      yystate = yyctable[ctry];
      goto yyshift; 
    } else {
      yyn = yyctable[ctry];
      goto yyreduce; 
    } 
  }

  //
  // Is action a shift?
  //
  if ((yyn = yysindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
             int(yydepth), yytrial, yystate, yytable[yyn]);
#endif
    yychar = (-1);
    if (yyps->errflag > 0)  --yyps->errflag;
    yystate = yytable[yyn];
  yyshift:
    if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
      YYMoreStack(yyps);
    }
    *++(yyps->ssp) = yystate;
    *++(yyps->vsp) = yylval;
    *++(yyps->psp) = yyposn;
    goto yyloop;
  }
  if ((yyn = yyrindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    yyn = yytable[yyn];
    goto yyreduce;
  }

  //
  // Action: error
  //
  if (yyps->errflag) goto yyinrecovery;
  yynewerrflag = 1;
  goto yyerrhandler;
yyerrlab:
  yynewerrflag = 0;
yyerrhandler:
  while (yyps->save) { 
    int ctry; 
    yyparsestate *save = yyps->save;
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
             int(yydepth), yytrial, yystate, yyps->save->state, int(yylvp - yylvals - yyps->save->lexeme));
#endif
    // Memorize most forward-looking error state in case
    // it's really an error.
    if(yyerrctx==NULL || yyerrctx->lexeme<yylvp-yylvals) {
      // Free old saved error context state
      if(yyerrctx) YYFreeState(yyerrctx);
      // Create and fill out new saved error context state
      yyerrctx = YYNewState(yyps->ssp - yyps->ss);
      yyerrctx->save = yyps->save;
      yyerrctx->state = yystate;
      yyerrctx->errflag = yyps->errflag;
      yyerrctx->ssp = yyerrctx->ss + (yyps->ssp - yyps->ss);
      yyerrctx->vsp = yyerrctx->vs + (yyps->vsp - yyps->vs);
      yyerrctx->psp = yyerrctx->ps + (yyps->psp - yyps->ps);
      memcpy (yyerrctx->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(yyerrctx->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(yyerrctx->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      yyerrctx->lexeme = yylvp - yylvals;
    }
    yylvp  = yylvals   + save->lexeme;
    yylpp  = yylpsns   + save->lexeme;
    yylexp = yylexemes + save->lexeme;
    yychar = -1;
    yyps->ssp = yyps->ss + (save->ssp - save->ss);
    yyps->vsp = yyps->vs + (save->vsp - save->vs);
    yyps->psp = yyps->ps + (save->psp - save->ps);
    memcpy (yyps->ss, save->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
    YYSCopy(yyps->vs, save->vs,  yyps->vsp - yyps->vs + 1);
    YYPCopy(yyps->ps, save->ps,  yyps->psp - yyps->ps + 1);
    ctry = ++save->ctry;
    yystate = save->state;
    // We tried shift, try reduce now
    if ((yyn = yyctable[ctry]) >= 0) {
      goto yyreduce;
    }
    yyps->save = save->save;
    YYFreeState(save);
    //
    // Nothing left on the stack -- error
    //
    if (!yyps->save) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%p]: trial parse FAILED, entering ERROR mode\n", 
	       yytrial);
      }
#endif
      // Restore state as it was in the most forward-advanced error
      yylvp  = yylvals   + yyerrctx->lexeme;
      yylpp  = yylpsns   + yyerrctx->lexeme;
      yylexp = yylexemes + yyerrctx->lexeme;
      yychar = yylexp[-1];
      yylval = yylvp[-1];
      yyposn = yylpp[-1];
      yyps->ssp = yyps->ss + (yyerrctx->ssp - yyerrctx->ss);
      yyps->vsp = yyps->vs + (yyerrctx->vsp - yyerrctx->vs);
      yyps->psp = yyps->ps + (yyerrctx->psp - yyerrctx->ps);
      memcpy (yyps->ss, yyerrctx->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      YYSCopy(yyps->vs, yyerrctx->vs,  yyps->vsp - yyps->vs + 1);
      YYPCopy(yyps->ps, yyerrctx->ps,  yyps->psp - yyps->ps + 1);
      yystate = yyerrctx->state;
      YYFreeState(yyerrctx);
      yyerrctx = NULL;
    }
    yynewerrflag = 1; 
  }
  if (yynewerrflag) {
#ifdef YYERROR_DETAILED
    yyerror_detailed("syntax error", yychar, yylval, yyposn);
#else
    yyerror("syntax error");
#endif
  }
  ++yynerrs;
 yyinrecovery:
  if (yyps->errflag < 3) {
    yyps->errflag = 3;
    for (;;) {
      if ((yyn = yysindex[*(yyps->ssp)]) && 
	  (yyn += YYERRCODE) >= 0 &&
          yyn <= YYTABLESIZE && 
	  yycheck[yyn] == YYERRCODE) {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: state %d, ERROR recovery shifts to state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp), yytable[yyn]);
#endif
        /* Use label yyerrlab, so that compiler does not warn */
        if(yyps->errflag != yyps->errflag) goto yyerrlab;
        yystate = yytable[yyn];
        goto yyshift; 
      } else {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: ERROR recovery discards state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp));
#endif
        if (yyps->ssp <= yyps->ss) {
	  goto yyabort;
	}
	if(!yytrial) {
	  YYDELETEVAL(yyps->vsp[0],1);
	  YYDELETEPOSN(yyps->psp[0],1);
	}
        --(yyps->ssp);
        --(yyps->vsp);
        --(yyps->psp);
      }
    }
  } else {
    if (yychar == 0) goto yyabort;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, ERROR recovery discards token %d (%s)\n",
             int(yydepth), yytrial, yystate, yychar, yys); 
    }
#endif
    if(!yytrial) {
      YYDELETEVAL(yylval,0);
      YYDELETEPOSN(yyposn,0);
    }
    yychar = (-1);
    goto yyloop;
  }

  //
  // Reduce the rule
  //
yyreduce:
  yym = yylen[yyn];
#if YYDEBUG
  if (yydebug) {
    printf("yydebug[%d,%p]: state %d, reducing by rule %d (%s)",
           int(yydepth), yytrial, yystate, yyn, yyrule[yyn]);
#ifdef YYDBPR
    if (yym) {
      int i;
      printf("<");
      for (i=yym; i>0; i--) {
        if (i!=yym) printf(", ");
        YYDBPR((yyps->vsp)[1-i]);
      }
      printf(">");
    }
#endif
    printf("\n");
  }
#endif
  if (yyps->ssp + 1 - yym >= yyps->ss + yyps->stacksize) {
    YYMoreStack(yyps);
  }

  /* default action - assign last argument as in standard yacc */
  yyps->val = yyvsp[1 - yym];

  /* default reduced position is NULL -- no position at all.
     no position will be assigned at trial time and if no position handling is present */
  memset(&yyps->pos, 0, sizeof(yyps->pos));

  reduce_posn = TRUE;

  switch (yyn) {

case 1:
  if (!yytrial)
{ DSQL_parse = yyvsp[0]; }
break;
case 2:
  if (!yytrial)
{ DSQL_parse = yyvsp[-1]; }
break;
case 25:
  if (!yytrial)
{ prepare_console_debug ((IPTR) yyvsp[0], &yydebug);
			  yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 26:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 27:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 28:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					make_list(yyvsp[-3]), make_list(yyvsp[-1]), NULL, yyvsp[0]); }
break;
case 31:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 32:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 33:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 35:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 36:
  if (!yytrial)
{ yyval = make_list (make_node (nod_execute, (int) 0, NULL)); }
break;
case 37:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) 0, NULL); }
break;
case 38:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) 0, NULL); }
break;
case 39:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) 0, NULL); }
break;
case 40:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) 1, yyvsp[0]); }
break;
case 41:
  if (!yytrial)
{ yyval = make_node (nod_references, (int) 1, yyvsp[0]); }
break;
case 42:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 43:
  if (!yytrial)
{ yyval = NULL; }
break;
case 44:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 45:
  if (!yytrial)
{ yyval = NULL; }
break;
case 46:
  if (!yytrial)
{ yyval = make_node (nod_procedure_name, (int) 1, yyvsp[0]); }
break;
case 47:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 48:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 49:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					make_list(yyvsp[-2]), make_list(yyvsp[0]), NULL, yyvsp[-3]); }
break;
case 50:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 51:
  if (!yytrial)
{ yyval = NULL; }
break;
case 52:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 53:
  if (!yytrial)
{ yyval = NULL; }
break;
case 57:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 58:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 59:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 60:
  if (!yytrial)
{ yyval = make_node (nod_proc_obj, (int) 1, yyvsp[0]); }
break;
case 61:
  if (!yytrial)
{ yyval = make_node (nod_trig_obj, (int) 1, yyvsp[0]); }
break;
case 62:
  if (!yytrial)
{ yyval = make_node (nod_view_obj, (int) 1, yyvsp[0]); }
break;
case 63:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 65:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 66:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 67:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 2, yyvsp[0], NULL); }
break;
case 68:
  if (!yytrial)
{ yyval = make_node (nod_user_group, (int) 1, yyvsp[0]); }
break;
case 70:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 71:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 73:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 74:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 75:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 76:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 77:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 78:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 79:
  if (!yytrial)
{ yyval = make_node (nod_def_udf, (int) e_udf_count, 
				yyvsp[-7], yyvsp[-2], yyvsp[0], make_list (yyvsp[-6]), yyvsp[-4]); }
break;
case 81:
  if (!yytrial)
{ lex.g_field->fld_dtype = dtype_blob; }
break;
case 82:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_cstring; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-2]; }
break;
case 83:
  if (!yytrial)
{ yyval = NULL; }
break;
case 85:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 87:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 88:
  if (!yytrial)
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 89:
  if (!yytrial)
{ yyval = NULL; }
break;
case 90:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_descriptor); }
break;
case 91:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_scalar_array); }
break;
case 92:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_ref_with_null); }
break;
case 94:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 95:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 96:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
				NULL, MAKE_const_slong ((IPTR) yyvsp[0]));}
break;
case 97:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_reference); }
break;
case 98:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_value); }
break;
case 99:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_descriptor); }
break;
case 100:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * Jrd::FUN_reference); }
break;
case 101:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * Jrd::FUN_descriptor); }
break;
case 102:
  if (!yytrial)
{ yyval = make_node (nod_def_filter, (int) e_filter_count, 
						yyvsp[-8], yyvsp[-6], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 103:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 104:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 105:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 106:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 107:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 108:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 109:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 110:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 111:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 112:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 113:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 114:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 115:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 116:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 117:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 118:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 119:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 120:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 121:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 122:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 123:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 124:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 125:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 126:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 127:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 128:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 129:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 130:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 131:
  if (!yytrial)
{ yyval = make_node (nod_def_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 132:
  if (!yytrial)
{ yyval = make_node (nod_redef_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 133:
  if (!yytrial)
{ yyval = make_node (nod_replace_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 134:
  if (!yytrial)
{ yyval = make_node (nod_mod_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 135:
  if (!yytrial)
{ yyval = make_node (nod_unique, 0, NULL); }
break;
case 136:
  if (!yytrial)
{ yyval = NULL; }
break;
case 137:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 139:
  if (!yytrial)
{ yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 140:
  if (!yytrial)
{ yyval = make_node (nod_def_shadow, (int) e_shadow_count,
				 yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], make_list (yyvsp[0])); }
break;
case 141:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 142:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 143:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 144:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 145:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 146:
  if (!yytrial)
{ yyval = (dsql_nod*) 0;}
break;
case 147:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 148:
  if (!yytrial)
{ yyval = NULL; }
break;
case 151:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 152:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
										  yyvsp[-7], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 153:
  if (!yytrial)
{ yyval = NULL; }
break;
case 154:
  if (!yytrial)
{ yyval = NULL; }
break;
case 155:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 157:
  if (!yytrial)
{ yyval = NULL; }
break;
case 159:
  if (!yytrial)
{ yyval = NULL; }
break;
case 161:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 162:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, NULL, yyvsp[0]);}
break;
case 165:
  if (!yytrial)
{ yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 166:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count,
					NULL, NULL, yyvsp[-2], NULL, yyvsp[0]); }
break;
case 167:
  if (!yytrial)
{ yyval = make_node (nod_def_generator, (int) e_gen_count, yyvsp[0]); }
break;
case 168:
  if (!yytrial)
{ yyval = make_node (nod_def_role, (int) 1, yyvsp[0]); }
break;
case 169:
  if (!yytrial)
{ yyval = make_node (nod_def_collation, 
						(int) e_def_coll_count, yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 170:
  if (!yytrial)
{ yyval = make_node(nod_collation_from, 1, yyvsp[0]); }
break;
case 171:
  if (!yytrial)
{ yyval = make_node(nod_collation_from_external, 1, yyvsp[-1]); }
break;
case 172:
  if (!yytrial)
{ yyval = NULL; }
break;
case 173:
  if (!yytrial)
{ yyval = NULL; }
break;
case 176:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 180:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 181:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 182:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 183:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 184:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 185:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 186:
  if (!yytrial)
{ yyval = NULL; }
break;
case 187:
  if (!yytrial)
{ yyval = make_node(nod_collation_specific_attr, 1,
				MAKE_constant((dsql_str*)yyvsp[0], CONSTANT_STRING)); }
break;
case 188:
  if (!yytrial)
{ yyval = make_node (nod_def_database, (int) e_cdb_count,
				 yyvsp[-2], make_list(yyvsp[-1]), make_list (yyvsp[0]));}
break;
case 191:
  if (!yytrial)
{ yyval = (dsql_nod*) yyvsp[0]; }
break;
case 192:
  if (!yytrial)
{yyval = NULL;}
break;
case 195:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 196:
  if (!yytrial)
{ yyval = make_node (nod_page_size, 1, yyvsp[0]);}
break;
case 197:
  if (!yytrial)
{ yyval = make_node (nod_file_length, 1, yyvsp[-1]);}
break;
case 198:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 1, yyvsp[0]);}
break;
case 199:
  if (!yytrial)
{ yyval = make_node (nod_password, 1, yyvsp[0]);}
break;
case 200:
  if (!yytrial)
{ yyval = make_node (nod_lc_ctype, 1, yyvsp[0]);}
break;
case 201:
  if (!yytrial)
{yyval = NULL;}
break;
case 204:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 206:
  if (!yytrial)
{ yyval = make_node (nod_dfl_charset, 1, yyvsp[0]);}
break;
case 207:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, 1, yyvsp[0]); }
break;
case 208:
  if (!yytrial)
{ lex.g_file->fil_name = (dsql_str*) yyvsp[-1];
			  yyval = (dsql_nod*) make_node (nod_file_desc, (int) 1,
						(dsql_nod*) lex.g_file); }
break;
case 209:
  if (!yytrial)
{ lex.g_file  = make_file();}
break;
case 214:
  if (!yytrial)
{ lex.g_file->fil_start = (IPTR) yyvsp[0];}
break;
case 215:
  if (!yytrial)
{ lex.g_file->fil_length = (IPTR) yyvsp[-1];}
break;
case 222:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 223:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 224:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 225:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 226:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_PRESERVE_ROWS; }
break;
case 227:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 228:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 229:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 230:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 231:
  if (!yytrial)
{ yyval = NULL; }
break;
case 233:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 236:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0], yyvsp[-4], NULL); }
break;
case 237:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-2], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 238:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-1], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 239:
  if (!yytrial)
{ 
			lex.g_field->fld_flags |= FLD_computed;
			yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 244:
  if (!yytrial)
{ yyval = NULL; }
break;
case 245:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
											yyvsp[-1], NULL, NULL, NULL, NULL); }
break;
case 246:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 247:
  if (!yytrial)
{ yyval = NULL; }
break;
case 248:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 249:
  if (!yytrial)
{ lex.g_field = make_field (yyvsp[0]);
				  yyval = (dsql_nod*) lex.g_field; }
break;
case 250:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 251:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				yyval = yyvsp[0];
			}
break;
case 252:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				((dsql_fld*) yyvsp[0])->fld_full_domain = true;
				yyval = yyvsp[0];
			}
break;
case 253:
  if (!yytrial)
{ lex.g_field = make_field (NULL);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 260:
  if (!yytrial)
{ yyval = NULL; }
break;
case 263:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 264:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 267:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count,
						make_node (nod_list, (int) 1, lex.g_field_name), yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 268:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, NULL, yyvsp[0]); }
break;
case 269:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, NULL, yyvsp[0]); }
break;
case 270:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 271:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 272:
  if (!yytrial)
{ yyval = NULL ;}
break;
case 277:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, yyvsp[-1], yyvsp[0]); }
break;
case 278:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, yyvsp[-1], yyvsp[0]); }
break;
case 279:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count, yyvsp[-5], yyvsp[-3], 
					 yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 280:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					NULL, yyvsp[-2], yyvsp[0], NULL, NULL); }
break;
case 281:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 282:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], NULL);}
break;
case 283:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, NULL, yyvsp[0]);}
break;
case 284:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], yyvsp[-1]); }
break;
case 285:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[-1], yyvsp[0]);}
break;
case 286:
  if (!yytrial)
{ yyval = NULL;}
break;
case 287:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 288:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 289:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_CASCADE, (int) e_ref_trig_action_count, NULL);}
break;
case 290:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_DEFAULT, (int) e_ref_trig_action_count, NULL);}
break;
case 291:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_NULL, (int) e_ref_trig_action_count, NULL);}
break;
case 292:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_NONE, (int) e_ref_trig_action_count, NULL);}
break;
case 293:
  if (!yytrial)
{ yyval = make_node (nod_def_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 294:
  if (!yytrial)
{ yyval = make_node (nod_redef_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 295:
  if (!yytrial)
{ yyval = make_node (nod_replace_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 296:
  if (!yytrial)
{ yyval = make_node (nod_mod_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 297:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 298:
  if (!yytrial)
{ yyval = NULL; }
break;
case 299:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 300:
  if (!yytrial)
{ yyval = NULL; }
break;
case 302:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 303:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-5], yyvsp[-1], yyvsp[0], NULL, yyvsp[-3], NULL, NULL); }
break;
case 305:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 306:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-2], NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 307:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 308:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 309:
  if (!yytrial)
{ yyval = NULL; }
break;
case 310:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 311:
  if (!yytrial)
{ yyval = NULL; }
break;
case 313:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 314:
  if (!yytrial)
{
				yyval = yyvsp[-1];
				yyval->nod_line = (IPTR) yyvsp[-5];
				yyval->nod_column = (IPTR) yyvsp[-4];
			}
break;
case 317:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-3], yyvsp[0], NULL, NULL, yyvsp[-1], NULL, NULL); }
break;
case 318:
  if (!yytrial)
{ yyval = NULL; }
break;
case 319:
  if (!yytrial)
{ yyval = NULL; }
break;
case 320:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 321:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 322:
  if (!yytrial)
{ yyval = NULL; }
break;
case 323:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_EXPLICIT,
				(int) e_cur_count, yyvsp[-5], yyvsp[-1], NULL, NULL); }
break;
case 326:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]);
			}
break;
case 327:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[0]), NULL); }
break;
case 328:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[-1]), make_list (yyvsp[0])); }
break;
case 329:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, NULL, NULL);}
break;
case 331:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 332:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-3], yyvsp[-2], yyvsp[-1]);
			}
break;
case 333:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-2], yyvsp[-1], yyvsp[0]);
			}
break;
case 334:
  if (!yytrial)
{ yyval = (dsql_nod*) (IPTR) lex.lines_bk; }
break;
case 335:
  if (!yytrial)
{ 
			const USHORT column = (lex.last_token_bk - lex.line_start_bk + 1);
			yyval = (dsql_nod*) (IPTR) column;
		}
break;
case 352:
  if (!yytrial)
{ yyval = make_node (nod_return, (int) e_rtn_count, NULL); }
break;
case 353:
  if (!yytrial)
{ yyval = make_node (nod_exit, 0, NULL); }
break;
case 358:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[0], NULL); }
break;
case 359:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[-1], yyvsp[0]); }
break;
case 360:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, NULL, NULL); }
break;
case 361:
  if (!yytrial)
{ yyval = make_node (nod_exec_sql, (int) e_exec_sql_count, yyvsp[0]); }
break;
case 362:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-5],
					  make_list (yyvsp[-3]), yyvsp[-2], yyvsp[0], yyvsp[-7]); }
break;
case 363:
  if (!yytrial)
{ yyval = make_node (nod_exec_into, (int) e_exec_into_count, yyvsp[-4], yyvsp[0], make_list (yyvsp[-2]), yyvsp[-8]); }
break;
case 364:
  if (!yytrial)
{ yyval = make_node (nod_exec_into, (int) e_exec_into_count, yyvsp[-2], NULL, make_list (yyvsp[0]), NULL); }
break;
case 365:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 366:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 367:
  if (!yytrial)
{ yyval = make_node (nod_post, (int) e_pst_count, yyvsp[-1], yyvsp[0]); }
break;
case 368:
  if (!yytrial)
{ yyval = NULL; }
break;
case 369:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-2],
					  make_list (yyvsp[0]), NULL, NULL, NULL); }
break;
case 370:
  if (!yytrial)
{ yyval = make_node (nod_var_name, (int) e_vrn_count, 
							yyvsp[0]); }
break;
case 373:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 374:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 375:
  if (!yytrial)
{ yyval = make_node (nod_while, (int) e_while_count, yyvsp[-3], yyvsp[0], yyvsp[-6]); }
break;
case 376:
  if (!yytrial)
{ yyval = make_node (nod_label, (int) e_label_count, yyvsp[-1], NULL); }
break;
case 377:
  if (!yytrial)
{ yyval = NULL; }
break;
case 378:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 379:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 380:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count,
				make_node (nod_label, (int) e_label_count, yyvsp[0], NULL)); }
break;
case 381:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_FOR,
				(int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 382:
  if (!yytrial)
{ yyval = NULL; }
break;
case 384:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 385:
  if (!yytrial)
{ yyval = make_node (nod_on_error, (int) e_err_count,
					make_list (yyvsp[-2]), yyvsp[0]); }
break;
case 387:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 388:
  if (!yytrial)
{ yyval = make_node (nod_sqlcode, 1, yyvsp[0]); }
break;
case 389:
  if (!yytrial)
{ yyval = make_node (nod_gdscode, 1, yyvsp[0]); }
break;
case 390:
  if (!yytrial)
{ yyval = make_node (nod_exception, 1, yyvsp[0]); }
break;
case 391:
  if (!yytrial)
{ yyval = make_node (nod_default, 1, NULL); }
break;
case 395:
  if (!yytrial)
{ yyval = make_node (nod_cursor_open, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 396:
  if (!yytrial)
{ yyval = make_node (nod_cursor_close, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 397:
  if (!yytrial)
{ yyval = make_node (nod_cursor_fetch, (int) e_cur_stmt_count, yyvsp[-2], yyvsp[-3], make_list (yyvsp[0])); }
break;
case 398:
  if (!yytrial)
{ yyval = NULL; }
break;
case 399:
  if (!yytrial)
{ yyval = make_node (nod_exec_procedure, (int) e_exe_count,
					yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 400:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 401:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 402:
  if (!yytrial)
{ yyval = NULL; }
break;
case 403:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 404:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 405:
  if (!yytrial)
{ yyval = NULL; }
break;
case 406:
  if (!yytrial)
{ yyval = make_node (nod_exec_block,
						  (int) e_exe_blk_count, 
					          yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], make_node (nod_all, (int) 0, NULL)); }
break;
case 407:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 408:
  if (!yytrial)
{ yyval = NULL; }
break;
case 410:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 411:
  if (!yytrial)
{ yyval = make_node (nod_param_val, e_prm_val_count, yyvsp[-2], yyvsp[0]); }
break;
case 412:
  if (!yytrial)
{ yyval = make_node (nod_def_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 413:
  if (!yytrial)
{ yyval = make_node (nod_redef_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 414:
  if (!yytrial)
{ lex.beginning = lex_position(); }
break;
case 415:
  if (!yytrial)
{ lex.beginning = lex.last_token; }
break;
case 416:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_string(lex.beginning,
					lex_position() - lex.beginning); }
break;
case 417:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_string(lex.beginning, 
					(yychar <= 0 ? lex_position() : lex.last_token) - lex.beginning); 
			}
break;
case 418:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 419:
  if (!yytrial)
{ yyval = 0; }
break;
case 420:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 421:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 422:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 423:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 424:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 425:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 426:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 427:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 428:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 429:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 430:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 431:
  if (!yytrial)
{ yyval = NULL; }
break;
case 432:
  if (!yytrial)
{ yyval = MAKE_trigger_type (yyvsp[-1], yyvsp[0]); }
break;
case 433:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 434:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_CONNECT); }
break;
case 435:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_DISCONNECT); }
break;
case 436:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_START); }
break;
case 437:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_COMMIT); }
break;
case 438:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_ROLLBACK); }
break;
case 439:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 440:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 441:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 0, 0)); }
break;
case 442:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 0, 0)); }
break;
case 443:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 0, 0)); }
break;
case 444:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 0)); }
break;
case 445:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 0)); }
break;
case 446:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 0)); }
break;
case 447:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 0)); }
break;
case 448:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 0)); }
break;
case 449:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 0)); }
break;
case 450:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 3)); }
break;
case 451:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 2)); }
break;
case 452:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 3)); }
break;
case 453:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 1)); }
break;
case 454:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 2)); }
break;
case 455:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 1)); }
break;
case 456:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 457:
  if (!yytrial)
{ yyval = NULL; }
break;
case 458:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) e_trg_act_count, yyvsp[-1], yyvsp[0]); }
break;
case 459:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 460:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 461:
  if (!yytrial)
{ yyval = make_node (nod_mod_relation, (int) e_alt_count, 
						yyvsp[-1], make_list (yyvsp[0])); }
break;
case 462:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 463:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 464:
  if (!yytrial)
{ yyval = make_node (nod_mod_database, (int) e_adb_count,
				make_list (yyvsp[0])); }
break;
case 465:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain, (int) e_alt_count,
										  yyvsp[-1], make_list (yyvsp[0])); }
break;
case 466:
  if (!yytrial)
{ yyval = make_node (nod_mod_index, (int) e_mod_idx_count, yyvsp[0]); }
break;
case 467:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 468:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 470:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 471:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 472:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 473:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 474:
  if (!yytrial)
{yyval = make_node (nod_del_default, (int) 0, NULL); }
break;
case 475:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, NULL); }
break;
case 476:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 477:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain_type, 2, yyvsp[-1]); }
break;
case 479:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 480:
  if (!yytrial)
{ yyval = make_node (nod_del_field, 2, yyvsp[-1], yyvsp[0]); }
break;
case 481:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, yyvsp[0]);}
break;
case 482:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 483:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 484:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_pos, 2, yyvsp[-2],
				MAKE_const_slong((IPTR) yyvsp[0])); }
break;
case 485:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_name, 2, yyvsp[-2], yyvsp[0]); }
break;
case 486:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], yyvsp[0], NULL); }
break;
case 487:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-3], NULL,
					make_node(nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0])); }
break;
case 488:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], NULL,
					make_node(nod_del_default, (int) 0, NULL)); }
break;
case 489:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 538:
  if (!yytrial)
{ yyval = NULL; }
break;
case 539:
  if (!yytrial)
{ yyval = NULL; }
break;
case 540:
  if (!yytrial)
{ yyval = NULL; }
break;
case 541:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
					yyvsp[0], NULL, NULL, NULL, NULL); }
break;
case 542:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 543:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 544:
  if (!yytrial)
{ yyval = make_node (nod_cascade, 0, NULL); }
break;
case 545:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 546:
  if (!yytrial)
{ yyval = make_node (nod_idx_active, 1, yyvsp[-1]); }
break;
case 547:
  if (!yytrial)
{ yyval = make_node (nod_idx_inactive, 1, yyvsp[-1]); }
break;
case 548:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 549:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 550:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-4],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 551:
  if (!yytrial)
{ yyval = make_node(nod_mod_udf, e_mod_udf_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 552:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 553:
  if (!yytrial)
{ yyval = NULL; }
break;
case 554:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 555:
  if (!yytrial)
{ yyval = NULL; }
break;
case 556:
  if (!yytrial)
{ yyval = NULL; }
break;
case 558:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 559:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 560:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, (int) 1, yyvsp[0]); }
break;
case 561:
  if (!yytrial)
{ yyval = make_node (nod_drop_difference, (int) 0, NULL); }
break;
case 562:
  if (!yytrial)
{ yyval = make_node (nod_begin_backup, (int) 0, NULL); }
break;
case 563:
  if (!yytrial)
{ yyval = make_node (nod_end_backup, (int) 0, NULL); }
break;
case 564:
  if (!yytrial)
{ yyval = make_node (nod_mod_trigger, (int) e_trg_count,
				yyvsp[-6], NULL, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 566:
  if (!yytrial)
{ yyval = NULL; }
break;
case 568:
  if (!yytrial)
{ yyval = NULL; }
break;
case 569:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 570:
  if (!yytrial)
{ yyval = make_node (nod_del_exception, 1, yyvsp[0]); }
break;
case 571:
  if (!yytrial)
{ yyval = make_node (nod_del_index, (int) 1, yyvsp[0]); }
break;
case 572:
  if (!yytrial)
{ yyval = make_node (nod_del_procedure, (int) 1, yyvsp[0]); }
break;
case 573:
  if (!yytrial)
{ yyval = make_node (nod_del_relation, (int) 1, yyvsp[0]); }
break;
case 574:
  if (!yytrial)
{ yyval = make_node (nod_del_trigger, (int) 1, yyvsp[0]); }
break;
case 575:
  if (!yytrial)
{ yyval = make_node (nod_del_view, (int) 1, yyvsp[0]); }
break;
case 576:
  if (!yytrial)
{ yyval = make_node (nod_del_filter, (int) 1, yyvsp[0]); }
break;
case 577:
  if (!yytrial)
{ yyval = make_node (nod_del_domain, (int) 1, yyvsp[0]); }
break;
case 578:
  if (!yytrial)
{ yyval = make_node (nod_del_udf, (int) 1, yyvsp[0]); }
break;
case 579:
  if (!yytrial)
{ yyval = make_node (nod_del_shadow, (int) 1, yyvsp[0]); }
break;
case 580:
  if (!yytrial)
{ yyval = make_node (nod_del_role, (int) 1, yyvsp[0]); }
break;
case 581:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 582:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 583:
  if (!yytrial)
{ yyval = make_node (nod_del_collation, (int) 1, yyvsp[0]); }
break;
case 587:
  if (!yytrial)
{ lex.g_field->fld_not_nullable = true; }
break;
case 590:
  if (!yytrial)
{ lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data; }
break;
case 591:
  if (!yytrial)
{
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				lex.g_field->fld_full_domain = true;
			}
break;
case 594:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-1]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-3]; }
break;
case 595:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-2]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-4]; }
break;
case 597:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 598:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] < 1)
			 		yyval = make_node (nod_list, (int) 2, 
					MAKE_const_slong ((IPTR) yyvsp[0]),
					MAKE_const_slong (1));
				  else
			 		yyval = make_node (nod_list, (int) 2, 
			   		MAKE_const_slong (1),
					MAKE_const_slong ((IPTR) yyvsp[0]) ); }
break;
case 599:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, 
			 	MAKE_const_slong ((IPTR) yyvsp[-2]),
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 605:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "BIGINT",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "BIGINT",
					isc_arg_end);
			lex.g_field->fld_dtype = dtype_int64; 
			lex.g_field->fld_length = sizeof (SINT64); 
			}
break;
case 606:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_long; 
			lex.g_field->fld_length = sizeof (SLONG); 
			}
break;
case 607:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_short; 
			lex.g_field->fld_length = sizeof (SSHORT); 
			}
break;
case 608:
  if (!yytrial)
{ 
			*stmt_ambiguous = true;
			if (client_dialect <= SQL_DIALECT_V5)
				{
				/* Post warning saying that DATE is equivalent to TIMESTAMP */
					ERRD_post_warning (isc_sqlwarn, isc_arg_number, (SLONG) 301, 
											   isc_arg_warning, isc_dtype_renamed, isc_arg_end);
				lex.g_field->fld_dtype = dtype_timestamp; 
				lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
				}
			else if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				yyabandon (-104, isc_transitional_date);
			else
				{
				lex.g_field->fld_dtype = dtype_sql_date; 
				lex.g_field->fld_length = sizeof (ULONG);
				}
			}
break;
case 609:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			lex.g_field->fld_dtype = dtype_sql_time; 
			lex.g_field->fld_length = sizeof (SLONG);
			}
break;
case 610:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_timestamp; 
			lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
			}
break;
case 613:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			}
break;
case 614:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_sub_type = 0;
			}
break;
case 615:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 616:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = 80;
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 617:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[0];
		  	}
break;
case 618:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT) 80;
		  	}
break;
case 619:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[0];
			}
break;
case 620:
  if (!yytrial)
{
			lex.g_field->fld_sub_type_name = yyvsp[0];
			}
break;
case 621:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT) 0;
			}
break;
case 622:
  if (!yytrial)
{
			lex.g_field->fld_character_set = yyvsp[0];
			}
break;
case 624:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 625:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = 1; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 626:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_varying; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 627:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			}
break;
case 628:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = 1; 
			}
break;
case 629:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_varying; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			}
break;
case 638:
  if (!yytrial)
{ 
			  lex.g_field->fld_sub_type = dsc_num_type_numeric;
			}
break;
case 639:
  if (!yytrial)
{  
			   lex.g_field->fld_sub_type = dsc_num_type_decimal;
			   if (lex.g_field->fld_dtype == dtype_short)
				{
				lex.g_field->fld_dtype = dtype_long;
				lex.g_field->fld_length = sizeof (SLONG);
				}
			}
break;
case 640:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_long; 
				lex.g_field->fld_length = sizeof (SLONG); 
			lex.g_field->fld_precision = 9;
				}
break;
case 641:
  if (!yytrial)
{		 
			if ( ((IPTR) yyvsp[-1] < 1) || ((IPTR) yyvsp[-1] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision most be between 1 and 18. */ 
			if ((IPTR) yyvsp[-1] > 9)
				{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect	 >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect	 <= SQL_DIALECT_V5) ) )
					ERRD_post (isc_sqlerr,
					   isc_arg_number, (SLONG) -817,
					   isc_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   isc_arg_number, (SLONG) db_dialect,
					   isc_arg_end);
				if (client_dialect <= SQL_DIALECT_V5)
					{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double);
					}
				else
					{
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
					{
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					isc_arg_end );

					}
				lex.g_field->fld_dtype = dtype_int64;
				lex.g_field->fld_length = sizeof (SINT64);
					}
				}
			else 
				if ((IPTR) yyvsp[-1] < 5)
					{
					lex.g_field->fld_dtype = dtype_short; 
					lex.g_field->fld_length = sizeof (SSHORT); 
					}
				else
					{
					lex.g_field->fld_dtype = dtype_long; 
					lex.g_field->fld_length = sizeof (SLONG); 
					}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 642:
  if (!yytrial)
{ 
			if ( ((IPTR) yyvsp[-3] < 1) || ((IPTR) yyvsp[-3] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision should be between 1 and 18 */ 
			if (((IPTR) yyvsp[-1] > (IPTR) yyvsp[-3]) || ((IPTR) yyvsp[-1] < 0))
				yyabandon (-842, isc_scale_nogt);
				/* Scale must be between 0 and precision */
			if ((IPTR) yyvsp[-3] > 9)
				{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect	 >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect	 <= SQL_DIALECT_V5) ) )
					ERRD_post (isc_sqlerr,
					   isc_arg_number, (SLONG) -817,
					   isc_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   isc_arg_number, (SLONG) db_dialect,
					   isc_arg_end);
				if (client_dialect <= SQL_DIALECT_V5)
					{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double); 
					}
				else
					{
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				  {
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					isc_arg_end );
				  }
				  /* client_dialect >= SQL_DIALECT_V6 */
				lex.g_field->fld_dtype = dtype_int64;
				lex.g_field->fld_length = sizeof (SINT64);
					}
				}
			else
				{
				if ((IPTR) yyvsp[-3] < 5)
					{
					lex.g_field->fld_dtype = dtype_short; 
					lex.g_field->fld_length = sizeof (SSHORT); 
					}
				else
					{
					lex.g_field->fld_dtype = dtype_long; 
					lex.g_field->fld_length = sizeof (SLONG); 
					}
				}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_scale = - (SSHORT)(IPTR) yyvsp[-1];
			}
break;
case 645:
  if (!yytrial)
{ 
			if ((IPTR) yyvsp[0] > 7)
				{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double); 
				}
			else
				{
				lex.g_field->fld_dtype = dtype_real; 
				lex.g_field->fld_length = sizeof (float);
				}
			}
break;
case 646:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_double; 
			lex.g_field->fld_length = sizeof (double); 
			}
break;
case 647:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_real; 
			lex.g_field->fld_length = sizeof (float); 
			}
break;
case 648:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_double; 
			lex.g_field->fld_length = sizeof (double); 
			}
break;
case 649:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 650:
  if (!yytrial)
{ yyval = 0; }
break;
case 654:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 655:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 656:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 660:
  if (!yytrial)
{ yyval = make_node (nod_user_savepoint, 1, yyvsp[0]); }
break;
case 661:
  if (!yytrial)
{ yyval = make_node (nod_release_savepoint, 2, yyvsp[-1], yyvsp[0]); }
break;
case 662:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 663:
  if (!yytrial)
{ yyval = 0; }
break;
case 664:
  if (!yytrial)
{ yyval = make_node (nod_undo_savepoint, 1, yyvsp[0]); }
break;
case 667:
  if (!yytrial)
{ yyval = make_node (nod_commit, e_commit_count, yyvsp[0]); }
break;
case 668:
  if (!yytrial)
{ yyval = make_node (nod_rollback, e_rollback_count, yyvsp[0]); }
break;
case 671:
  if (!yytrial)
{ yyval = make_node (nod_retain, 0, NULL); }
break;
case 672:
  if (!yytrial)
{ yyval = NULL; }
break;
case 674:
  if (!yytrial)
{ yyval = NULL; }
break;
case 675:
  if (!yytrial)
{yyval = make_node (nod_trans, 1, make_list (yyvsp[0])); }
break;
case 677:
  if (!yytrial)
{ yyval = NULL; }
break;
case 679:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 686:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_ONLY, (int) 0, NULL); }
break;
case 687:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_WRITE, (int) 0, NULL); }
break;
case 688:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_WAIT, (int) 0, NULL); }
break;
case 689:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_NO_WAIT, (int) 0, NULL); }
break;
case 690:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 692:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 693:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 694:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 695:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONCURRENCY, 0, NULL); }
break;
case 696:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 697:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 698:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_VERSION, 0, NULL); }
break;
case 699:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_NO_VERSION, 0, NULL); }
break;
case 700:
  if (!yytrial)
{ yyval = 0; }
break;
case 701:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_NO_AUTO_UNDO, 0, NULL); }
break;
case 702:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_IGNORE_LIMBO, 0, NULL); }
break;
case 703:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_RESTART_REQUESTS, 0, NULL); }
break;
case 704:
  if (!yytrial)
{ yyval = make_node(nod_lock_timeout, 1, MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 705:
  if (!yytrial)
{ yyval = make_node (nod_reserve, 1, make_list (yyvsp[0])); }
break;
case 706:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_SHARED; }
break;
case 707:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_PROTECTED ; }
break;
case 708:
  if (!yytrial)
{ yyval = (dsql_nod*) 0; }
break;
case 709:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_READ; }
break;
case 710:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_WRITE; }
break;
case 712:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 713:
  if (!yytrial)
{ yyval = make_node (nod_table_lock, (int) 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 714:
  if (!yytrial)
{ yyval = make_flag_node (nod_lock_mode, (SSHORT) ((SSHORT)(IPTR) yyvsp[-1] | (SSHORT)(IPTR) yyvsp[0]), (SSHORT) 0, NULL); }
break;
case 715:
  if (!yytrial)
{ yyval = 0; }
break;
case 717:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 718:
  if (!yytrial)
{ yyval = make_node (nod_set_statistics, (int) e_stat_count, yyvsp[0]); }
break;
case 719:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-2], NULL, NULL, yyvsp[0]); }
break;
case 720:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-3], yyvsp[-2], NULL, yyvsp[0]); }
break;
case 721:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]); }
break;
case 722:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_database); }
break;
case 723:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_domain); }
break;
case 724:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 725:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_view); }
break;
case 726:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 727:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_trigger); }
break;
case 728:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_udf); }
break;
case 729:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_blob_filter); }
break;
case 730:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_exception); }
break;
case 731:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 732:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 733:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_index); }
break;
case 734:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_role); }
break;
case 735:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_charset); }
break;
case 736:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_collation); }
break;
case 737:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 738:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 739:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 741:
  if (!yytrial)
{ yyval = NULL; }
break;
case 742:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) e_select_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 743:
  if (!yytrial)
{ yyval = make_node (nod_for_update, (int) e_fpd_count, yyvsp[0]); }
break;
case 744:
  if (!yytrial)
{ yyval = NULL; }
break;
case 745:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 746:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 747:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 748:
  if (!yytrial)
{ yyval = NULL; }
break;
case 749:
  if (!yytrial)
{ yyval = make_node (nod_select_expr, (int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 750:
  if (!yytrial)
{ yyval = make_flag_node (nod_with, NOD_UNION_RECURSIVE, 1, make_list(yyvsp[0])); }
break;
case 751:
  if (!yytrial)
{ yyval = make_node (nod_with, 1, make_list(yyvsp[0])); }
break;
case 752:
  if (!yytrial)
{ yyval = NULL; }
break;
case 754:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 755:
  if (!yytrial)
{ yyval = make_node (nod_derived_table, (int) e_derived_table_count, yyvsp[-1], yyvsp[-5], yyvsp[-4], NULL); }
break;
case 756:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 757:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE | NOD_SELECT_EXPR_SINGLETON,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 759:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-3], yyvsp[0]); }
break;
case 760:
  if (!yytrial)
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 762:
  if (!yytrial)
{ yyval = make_node (nod_query_spec, (int) e_qry_count, 
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 763:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], yyvsp[-1]); }
break;
case 764:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, NULL, yyvsp[0]); }
break;
case 765:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], NULL); }
break;
case 766:
  if (!yytrial)
{ yyval = 0; }
break;
case 767:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 768:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 769:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 770:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 771:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 772:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 773:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 774:
  if (!yytrial)
{ yyval = 0; }
break;
case 775:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 776:
  if (!yytrial)
{ yyval = 0; }
break;
case 778:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 780:
  if (!yytrial)
{ yyval = make_node (nod_alias, 2, yyvsp[-2], yyvsp[0]); }
break;
case 783:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 785:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 790:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 791:
  if (!yytrial)
{ yyval = make_node(nod_derived_table, (int) e_derived_table_count, yyvsp[-4], yyvsp[-1], yyvsp[0], NULL); }
break;
case 793:
  if (!yytrial)
{ yyval = NULL; }
break;
case 794:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 795:
  if (!yytrial)
{ yyval = NULL; }
break;
case 797:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 801:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-3],
				make_node (nod_join_inner, (int) 0, NULL), yyvsp[0], NULL); }
break;
case 802:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-2], yyvsp[0],
					make_node (nod_flag, 0, NULL)); }
break;
case 803:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 806:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 807:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 808:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-3], yyvsp[0], yyvsp[-2]); }
break;
case 809:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 810:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 811:
  if (!yytrial)
{ yyval = NULL; }
break;
case 813:
  if (!yytrial)
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[-2], yyvsp[0]); }
break;
case 814:
  if (!yytrial)
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[0], NULL); }
break;
case 815:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 816:
  if (!yytrial)
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 817:
  if (!yytrial)
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 818:
  if (!yytrial)
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 819:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 822:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 823:
  if (!yytrial)
{ yyval = NULL; }
break;
case 825:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 827:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 828:
  if (!yytrial)
{ yyval = NULL; }
break;
case 829:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 830:
  if (!yytrial)
{ yyval = NULL; }
break;
case 831:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 832:
  if (!yytrial)
{ yyval = NULL; }
break;
case 833:
  if (!yytrial)
{ yyval = make_node (nod_plan_expr, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 834:
  if (!yytrial)
{ yyval = 0; }
break;
case 835:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 836:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 837:
  if (!yytrial)
{ yyval = 0; }
break;
case 838:
  if (!yytrial)
{ yyval = 0; }
break;
case 840:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 841:
  if (!yytrial)
{ yyval = make_node (nod_plan_item, 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 844:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 845:
  if (!yytrial)
{ yyval = make_node (nod_natural, (int) 0, NULL); }
break;
case 846:
  if (!yytrial)
{ yyval = make_node (nod_index, 1, make_list (yyvsp[-1])); }
break;
case 847:
  if (!yytrial)
{ yyval = make_node (nod_index_order, 2, yyvsp[-1], yyvsp[0]); }
break;
case 849:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 850:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 851:
  if (!yytrial)
{ yyval = 0; }
break;
case 852:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 853:
  if (!yytrial)
{ yyval = 0; }
break;
case 855:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 856:
  if (!yytrial)
{ yyval = make_node (nod_order, (int) e_order_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 857:
  if (!yytrial)
{ yyval = 0; }
break;
case 858:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 859:
  if (!yytrial)
{ yyval = 0; }
break;
case 860:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 861:
  if (!yytrial)
{ yyval = 0; }
break;
case 862:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_FIRST); }
break;
case 863:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_LAST); }
break;
case 864:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count, NULL, yyvsp[0]); }
break;
case 865:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count,
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)),
				make_node (nod_add, 2,
					make_node (nod_subtract, 2, yyvsp[0], yyvsp[-2]),
					MAKE_const_slong (1))); }
break;
case 866:
  if (!yytrial)
{ yyval = NULL; }
break;
case 867:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count, 
				yyvsp[-6], yyvsp[-5], make_list (yyvsp[-2]), NULL, yyvsp[0]); }
break;
case 868:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], yyvsp[-2], NULL, yyvsp[-1], yyvsp[0]); }
break;
case 869:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], NULL, NULL, NULL, yyvsp[0]); }
break;
case 870:
  if (!yytrial)
{
			yyval = make_node(nod_merge, e_mrg_count, yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]);
		}
break;
case 871:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[-1], yyvsp[0]); }
break;
case 872:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], yyvsp[-1]); }
break;
case 873:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], NULL); }
break;
case 874:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, NULL, yyvsp[0]); }
break;
case 875:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 876:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 877:
  if (!yytrial)
{ yyval = make_node(nod_merge_update, e_mrg_update_count, make_list(yyvsp[0])); }
break;
case 878:
  if (!yytrial)
{ yyval = make_node(nod_merge_insert, e_mrg_insert_count, make_list(yyvsp[-4]), make_list(yyvsp[-1])); }
break;
case 881:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0]); }
break;
case 882:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-1], NULL, NULL, NULL, NULL, yyvsp[0], NULL); }
break;
case 885:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-7], make_list (yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0], NULL); }
break;
case 886:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-3], make_list (yyvsp[-1]), NULL, NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 887:
  if (!yytrial)
{
			yyval = make_node (nod_update_or_insert, (int) e_upi_count,
				yyvsp[-7], make_list (yyvsp[-6]), make_list (yyvsp[-3]), yyvsp[-1], yyvsp[0]);
		}
break;
case 888:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 889:
  if (!yytrial)
{ yyval = NULL; }
break;
case 890:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[0]), NULL); }
break;
case 891:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[-2]), make_list (yyvsp[0])); }
break;
case 892:
  if (!yytrial)
{ yyval = NULL; }
break;
case 893:
  if (!yytrial)
{ yyval = make_node (nod_cursor, (int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 895:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 896:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], yyvsp[-2]); }
break;
case 897:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 898:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 899:
  if (!yytrial)
{ yyval = make_node (nod_get_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 900:
  if (!yytrial)
{ yyval = make_node (nod_put_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 901:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 902:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, NULL, yyvsp[0]); }
break;
case 903:
  if (!yytrial)
{ yyval = NULL; }
break;
case 906:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 907:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 908:
  if (!yytrial)
{ yyval = NULL; }
break;
case 909:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 912:
  if (!yytrial)
{ yyval = NULL; }
break;
case 913:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 915:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 917:
  if (!yytrial)
{ yyval = NULL; }
break;
case 918:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 920:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 922:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 923:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], NULL); }
break;
case 924:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 926:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 928:
  if (!yytrial)
{ yyval = make_node (nod_or, 2, yyvsp[-2], yyvsp[0]); }
break;
case 929:
  if (!yytrial)
{ yyval = make_node (nod_and, 2, yyvsp[-2], yyvsp[0]); }
break;
case 930:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, yyvsp[0]); }
break;
case 943:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 944:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2, yyvsp[-2], yyvsp[0]); }
break;
case 945:
  if (!yytrial)
{ yyval = make_node (nod_lss, 2, yyvsp[-2], yyvsp[0]); }
break;
case 946:
  if (!yytrial)
{ yyval = make_node (nod_gtr, 2, yyvsp[-2], yyvsp[0]); }
break;
case 947:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 948:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 949:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 950:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 951:
  if (!yytrial)
{ yyval = make_node (nod_neq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 952:
  if (!yytrial)
{ yyval = make_node (nod_eql_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 953:
  if (!yytrial)
{ yyval = make_node (nod_lss_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 954:
  if (!yytrial)
{ yyval = make_node (nod_gtr_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 955:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 956:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 957:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 958:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 959:
  if (!yytrial)
{ yyval = make_node (nod_neq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 960:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 961:
  if (!yytrial)
{ yyval = make_node (nod_lss_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 962:
  if (!yytrial)
{ yyval = make_node (nod_gtr_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 963:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 964:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 965:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 966:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 967:
  if (!yytrial)
{ yyval = make_node (nod_neq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 970:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_equiv, 2, yyvsp[-4], yyvsp[0])); }
break;
case 971:
  if (!yytrial)
{ yyval = make_node (nod_equiv, 2, yyvsp[-5], yyvsp[0]); }
break;
case 972:
  if (!yytrial)
{ yyval = make_node (nod_between, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 973:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_between, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 974:
  if (!yytrial)
{ yyval = make_node (nod_like, 2, yyvsp[-2], yyvsp[0]); }
break;
case 975:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 2, yyvsp[-3], yyvsp[0])); }
break;
case 976:
  if (!yytrial)
{ yyval = make_node (nod_like, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 977:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 978:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-2], yyvsp[0]); }
break;
case 979:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_eql_any, 2, yyvsp[-3], yyvsp[0])); }
break;
case 980:
  if (!yytrial)
{ yyval = make_node (nod_containing, 2, yyvsp[-2], yyvsp[0]); }
break;
case 981:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_containing, 2, yyvsp[-3], yyvsp[0])); }
break;
case 982:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-2], yyvsp[0]); }
break;
case 983:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-3], yyvsp[0])); }
break;
case 984:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-3], yyvsp[0]); }
break;
case 985:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-4], yyvsp[0])); }
break;
case 986:
  if (!yytrial)
{ yyval = make_node (nod_exists, 1, yyvsp[-1]); }
break;
case 987:
  if (!yytrial)
{ yyval = make_node (nod_singular, 1, yyvsp[-1]); }
break;
case 988:
  if (!yytrial)
{ yyval = make_node (nod_missing, 1, yyvsp[-2]); }
break;
case 989:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_missing, 1, yyvsp[-3])); }
break;
case 990:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (1)); }
break;
case 991:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (2)); }
break;
case 992:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (3)); }
break;
case 994:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 995:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1006:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1007:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1008:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_add2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_add, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1009:
  if (!yytrial)
{ yyval = make_node (nod_concatenate, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1010:
  if (!yytrial)
{ yyval = make_node (nod_collate, (int) e_coll_count, (dsql_nod*) yyvsp[0], yyvsp[-2]); }
break;
case 1011:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_subtract2, 2, yyvsp[-2], yyvsp[0]);
			  else 
				  yyval = make_node (nod_subtract, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1012:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				   yyval = make_node (nod_multiply2, 2, yyvsp[-2], yyvsp[0]);
			  else
				   yyval = make_node (nod_multiply, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1013:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_divide2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_divide, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1014:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1015:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1019:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, NULL); }
break;
case 1020:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, yyvsp[-2]); }
break;
case 1021:
  if (!yytrial)
{ 
			  yyval = make_node (nod_dom_value, 0, NULL);
						}
break;
case 1024:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			yyval = make_node (nod_current_date, 0, NULL);
			}
break;
case 1025:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			yyval = make_node (nod_current_time, 1, yyvsp[0]);
			}
break;
case 1026:
  if (!yytrial)
{ yyval = make_node (nod_current_timestamp, 1, yyvsp[0]); }
break;
case 1027:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[-1]); }
break;
case 1028:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1029:
  if (!yytrial)
{ yyval = make_node (nod_array, (int) e_ary_count, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 1031:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1033:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1035:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1036:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 1037:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 1038:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DOUBLE); }
break;
case 1039:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1040:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1042:
  if (!yytrial)
{ yyval = MAKE_str_constant ((dsql_str*) yyvsp[0], lex.att_charset); }
break;
case 1043:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DATE);
			}
break;
case 1044:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIME);
			}
break;
case 1045:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIMESTAMP); }
break;
case 1046:
  if (!yytrial)
{ yyval = make_parameter (); }
break;
case 1047:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1048:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1049:
  if (!yytrial)
{ yyval = make_node (nod_current_role, 0, NULL); }
break;
case 1050:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_connection_id)); }
break;
case 1051:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_transaction_id)); }
break;
case 1052:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_gdscode)); }
break;
case 1053:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_sqlcode)); }
break;
case 1054:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_rows_affected)); }
break;
case 1055:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1056:
  if (!yytrial)
{ ((dsql_str*) yyvsp[0])->str_charset = (TEXT *) yyvsp[-1];
			  yyval = yyvsp[0]; }
break;
case 1058:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1059:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_POS_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1060:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_NEG_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1061:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] == 0)
				yyabandon (-842, isc_expec_positive);
				/* Positive number expected */
			  yyval = yyvsp[0];}
break;
case 1062:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_UNSIGNED_MAX)
				yyabandon (-842, isc_expec_ushort);
				/* Unsigned short integer expected */
			  yyval = yyvsp[0];}
break;
case 1064:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1065:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 1071:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 0, NULL); }
break;
case 1072:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 1, yyvsp[-1]); }
break;
case 1073:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_count,
									   NOD_AGG_DISTINCT, 1, yyvsp[-1]); }
break;
case 1074:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_total2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_total, 1, yyvsp[-1]);
			}
break;
case 1075:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_total2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_total,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1076:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_average2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_average, 1, yyvsp[-1]);
			}
break;
case 1077:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_average2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_average,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1078:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1079:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1080:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1081:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1082:
  if (!yytrial)
{ yyval = make_node (nod_agg_list, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1083:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_list, NOD_AGG_DISTINCT, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1084:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1085:
  if (!yytrial)
{ yyval = MAKE_str_constant (MAKE_cstring(","), lex.att_charset); }
break;
case 1086:
  if (!yytrial)
{ yyval = MAKE_str_constant ((dsql_str*) yyvsp[0], lex.att_charset); }
break;
case 1091:
  if (!yytrial)
{ yyval = make_node (nod_extract, (int) e_extract_count, yyvsp[-3], yyvsp[-1]); }
break;
case 1095:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_bit), yyvsp[-1]); }
break;
case 1096:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1097:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1098:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_octet), yyvsp[-1]); }
break;
case 1099:
  if (!yytrial)
{ yyval = make_node(nod_sys_function, e_sysfunc_count, yyvsp[-3], make_list(yyvsp[-1])); }
break;
case 1145:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-6], make_node(nod_list, 3, yyvsp[-4], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1146:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-3], yyvsp[-5], yyvsp[-1]));
		}
break;
case 1147:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1148:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1149:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-9], make_node(nod_list, 4, yyvsp[-7], yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1150:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1151:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-5], make_node(nod_list, 2, yyvsp[-3], yyvsp[-1]));
		}
break;
case 1154:
  if (!yytrial)
{ yyval = make_node (nod_upcase, 1, yyvsp[-1]); }
break;
case 1155:
  if (!yytrial)
{ yyval = make_node (nod_lowcase, 1, yyvsp[-1]); }
break;
case 1156:
  if (!yytrial)
{ yyval = make_node (nod_substr, (int) e_substr_count, yyvsp[-4],
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)), yyvsp[-1]); }
break;
case 1157:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1158:
  if (!yytrial)
{ yyval = MAKE_const_slong (SHRT_POS_MAX); }
break;
case 1159:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]); }
break;
case 1160:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, 
				MAKE_const_slong (blr_trim_both), yyvsp[-3], yyvsp[-1]); }
break;
case 1161:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-3], NULL, yyvsp[-1]); }
break;
case 1162:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count,
				MAKE_const_slong (blr_trim_both), NULL, yyvsp[-1]); }
break;
case 1163:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_both); }
break;
case 1164:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_trailing); }
break;
case 1165:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_leading); }
break;
case 1166:
  if (!yytrial)
{ yyval = make_node (nod_udf, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1167:
  if (!yytrial)
{ yyval = make_node (nod_udf, 1, yyvsp[-2]); }
break;
case 1168:
  if (!yytrial)
{ yyval = make_node (nod_cast, (int) e_cast_count, yyvsp[-1], yyvsp[-3]); }
break;
case 1171:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, 
				make_node (nod_list, 2, make_node (nod_eql, 2, yyvsp[-3], yyvsp[-1]), 
				make_node (nod_null, 0, NULL)), yyvsp[-3]); }
break;
case 1172:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, 
				make_node (nod_list, 2, yyvsp[-5], yyvsp[-3]), yyvsp[-1]); }
break;
case 1173:
  if (!yytrial)
{ yyval = make_node (nod_coalesce, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1174:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-3], make_list(yyvsp[-1]), make_node(nod_null, 0, NULL)); }
break;
case 1175:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-5], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1178:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-2], make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1179:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-4], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1180:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1181:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1182:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1183:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1184:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1185:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1189:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1190:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-4], make_node(nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1191:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[0],
						MAKE_const_slong(1));
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[0],
						MAKE_const_slong(1));
			}
break;
case 1192:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[-3], yyvsp[-1]);
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[-3], yyvsp[-1]);
			}
break;
case 1193:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_year); }
break;
case 1194:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_month); }
break;
case 1195:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_day); }
break;
case 1196:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_hour); }
break;
case 1197:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_minute); }
break;
case 1198:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_second); }
break;
case 1199:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_millisecond); }
break;
case 1200:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_week); }
break;
case 1201:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_weekday); }
break;
case 1202:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_yearday); }
break;
case 1207:
  if (!yytrial)
{ yyval = make_node (nod_null, 0, NULL); }
break;

  default:
    break;
  }

#if YYDEBUG && defined(YYDBPR)
  if (yydebug) {
    printf("yydebug[%d]: after reduction, result is ", yytrial);
    YYDBPR(yyps->val);
    printf("\n");
  }
#endif

  // Perform user-defined position reduction
#ifdef YYREDUCEPOSNFUNC
  if(!yytrial) {
    YYCALLREDUCEPOSN(YYREDUCEPOSNFUNCARG);
  }
#endif

  yyps->ssp -= yym;
  yystate = *(yyps->ssp);
  yyps->vsp -= yym;
  yyps->psp -= yym;

  yym = yylhs[yyn];
  if (yystate == 0 && yym == 0) {
#if YYDEBUG
    if (yydebug) {
      printf("yydebug[%d,%p]: after reduction, shifting from state 0 to state %d\n", 
	     int(yydepth), yytrial, YYFINAL);
    }
#endif
    yystate = YYFINAL;
    *++(yyps->ssp) = YYFINAL;
    *++(yyps->vsp) = yyps->val;
    yyretlval = yyps->val;	// return value of root non-terminal to yylval
    *++(yyps->psp) = yyps->pos;
    yyretposn = yyps->pos;	// return value of root position to yyposn
    if (yychar < 0) {
      if ((yychar = YYLex1(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) {
        yychar = 0;
      }
#if YYDEBUG
      if (yydebug) {
        yys = 0;
        if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
        if (!yys) yys = "illegal-symbol";
        printf("yydebug[%d,%p]: state %d, reading %d (%s)\n", 
	       int(yydepth), yytrial, YYFINAL, yychar, yys); 
      }
#endif
    }
    if (yychar == 0) goto yyaccept;
    goto yyloop;
  }

  if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yystate) {
    yystate = yytable[yyn];
  } else {
    yystate = yydgoto[yym];
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: after reduction, shifting from state %d to state %d\n",
           int(yydepth), yytrial, *(yyps->ssp), yystate);
#endif
  if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
    YYMoreStack(yyps);
  }
  *++(yyps->ssp) = yystate;
  *++(yyps->vsp) = yyps->val;
  *++(yyps->psp) = yyps->pos;
  goto yyloop;


  //
  // Reduction declares that this path is valid.
  // Set yypath and do a full parse
  //
yyvalid:
  if (yypath) {
    goto yyabort;
  }
  while (yyps->save) {
    yyparsestate *save = yyps->save;
    yyps->save = save->save;
    save->save = yypath;
    yypath = save;
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: CONFLICT trial successful, backtracking to state %d, %d tokens\n",
           int(yydepth), yytrial, yypath->state, int(yylvp - yylvals - yypath->lexeme));
#endif
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  yychar = -1;
  yyps->ssp = yyps->ss + (yypath->ssp - yypath->ss);
  yyps->vsp = yyps->vs + (yypath->vsp - yypath->vs);
  yyps->psp = yyps->ps + (yypath->psp - yypath->ps);
  memcpy (yyps->ss, yypath->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
  YYSCopy(yyps->vs, yypath->vs,  yyps->vsp - yyps->vs + 1);
  YYPCopy(yyps->ps, yypath->ps,  yyps->psp - yyps->ps + 1);
  yylvp = yylvals + yypath->lexeme;
  yylpp = yylpsns + yypath->lexeme;
  yylexp = yylexemes + yypath->lexeme;
  yystate = yypath->state;
  goto yyloop;


yyabort:
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }

  YYSTYPE *pv;
  for(pv=yyps->vs; pv<yyps->vsp; pv++) {
    YYDELETEVAL(*pv,2);
  }

  YYPOSN *pp;
  for(pp=yyps->ps; pp<yyps->psp; pp++) {
    YYDELETEPOSN(*pp,2);
  }

  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (1);


yyaccept:
  if (yyps->save) goto yyvalid;
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (0);
}


int YYLex1(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous) {
  if(yylvp<yylve) {
    yylval = *yylvp++;
    yyposn = *yylpp++;
    return *yylexp++;
  } else {
    if(yyps->save) {
      if(yylvp==yylvlim) {
	yyexpand();
      }
      *yylexp = yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
      *yylvp++ = yylval;
      yylve++;
      *yylpp++ = yyposn;
      yylpe++;
      return *yylexp++;
    } else {
      return yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
    }
  }
}

int yyexpand() {
  int p = yylvp-yylvals;
  int s = yylvlim-yylvals;
  s += YYSTACKGROWTH;
  { Yshort  *tl = yylexemes; 
    YYSTYPE *tv = yylvals;
    YYPOSN  *tp = yylpsns;
    yylvals = new YYSTYPE[s];
    yylpsns = new YYPOSN[s];
    yylexemes = new Yshort[s];
    memcpy(yylexemes, tl, (s-YYSTACKGROWTH)*sizeof(Yshort));
    YYSCopy(yylvals, tv, s-YYSTACKGROWTH);
    YYPCopy(yylpsns, tp, s-YYSTACKGROWTH);
    delete[] tl;
    delete[] tv;
    delete[] tp;
  }
  yylvp = yylve = yylvals + p;
  yylvlim = yylvals + s;
  yylpp = yylpe = yylpsns + p;
  yylplim = yylpsns + s;
  yylexp = yylexemes + p;
  return 0;
}

void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYPCopy(YYPOSN *to, YYPOSN *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYMoreStack(yyparsestate *yyps) {
  int p = yyps->ssp - yyps->ss;                               
  Yshort  *tss = yyps->ss;
  YYSTYPE *tvs = yyps->vs;
  YYPOSN  *tps = yyps->ps;
  yyps->ss = new Yshort [yyps->stacksize + YYSTACKGROWTH];   
  yyps->vs = new YYSTYPE[yyps->stacksize + YYSTACKGROWTH];  
  yyps->ps = new YYPOSN [yyps->stacksize + YYSTACKGROWTH];  
  memcpy(yyps->ss, tss, yyps->stacksize * sizeof(Yshort));  
  YYSCopy(yyps->vs, tvs, yyps->stacksize);                  
  YYPCopy(yyps->ps, tps, yyps->stacksize);                  
  yyps->stacksize += YYSTACKGROWTH;                           
  delete[] tss;
  delete[] tvs;
  delete[] tps;
  yyps->ssp = yyps->ss + p;                                   
  yyps->vsp = yyps->vs + p;                                   
  yyps->psp = yyps->ps + p;                                   
}

yyparsestate *YYNewState(int size) {
  yyparsestate *p = new yyparsestate;
  p->stacksize = size+4;
  p->ss = new Yshort [size + 4];
  p->vs = new YYSTYPE[size + 4];
  p->ps = new YYPOSN [size + 4];
  memset(&p->vs[0], 0, (size+4)*sizeof(YYSTYPE));
  memset(&p->ps[0], 0, (size+4)*sizeof(YYPOSN));
  return p;
}

void YYFreeState(yyparsestate *p) {
  delete[] p->ss;
  delete[] p->vs;
  delete[] p->ps;
  delete p;
}
